CREATE TABLE `egw_access_log` (
  `sessionid` varchar(128) NOT NULL default '',
  `loginid` varchar(64) NOT NULL default '',
  `ip` varchar(40) NOT NULL default '',
  `li` int(11) NOT NULL default '0',
  `lo` int(11) default '0',
  `account_id` int(11) NOT NULL default '0'
) TYPE=MyISAM;
CREATE TABLE `egw_accounts` (
  `account_id` int(11) NOT NULL auto_increment,
  `account_lid` varchar(64) NOT NULL default '',
  `account_pwd` varchar(100) NOT NULL default '',
  `account_firstname` varchar(50) default NULL,
  `account_lastname` varchar(50) default NULL,
  `account_lastlogin` int(11) default NULL,
  `account_lastloginfrom` varchar(255) default NULL,
  `account_lastpwd_change` int(11) default NULL,
  `account_status` char(1) NOT NULL default 'A',
  `account_expires` int(11) default NULL,
  `account_type` char(1) default NULL,
  `person_id` int(11) default NULL,
  `account_primary_group` int(11) NOT NULL default '0',
  `account_email` varchar(100) default NULL,
  `account_challenge` varchar(100) default NULL,
  `account_response` varchar(100) default NULL,
  PRIMARY KEY  (`account_id`),
  UNIQUE KEY `egw_accounts_account_lid` (`account_lid`)
) TYPE=MyISAM AUTO_INCREMENT=6;
INSERT INTO `egw_accounts` VALUES (1,'Default','d41d8cd98f00b204e9800998ecf8427e','Default','Group',NULL,NULL,NULL,'A',-1,'g',NULL,0,NULL,NULL,NULL),(2,'Admins','d41d8cd98f00b204e9800998ecf8427e','Admin','Group',NULL,NULL,NULL,'A',-1,'g',NULL,0,NULL,NULL,NULL),(3,'NoGroup','d41d8cd98f00b204e9800998ecf8427e','No','Rights',NULL,NULL,NULL,'A',-1,'g',NULL,0,NULL,NULL,NULL),(4,'anonymous','294de3557d9d00b3d2d8a1e6aab028cf','SiteMgr','User',NULL,NULL,NULL,'A',-1,'u',NULL,-3,NULL,NULL,NULL),(5,'@@ADMIN_LOGIN@@','@@ADMIN_PASSWD@@','fadmin','ladmin',1155707302,'127.0.0.1',NULL,'A',-1,'u',NULL,-2,NULL,NULL,NULL);
CREATE TABLE `egw_acl` (
  `acl_appname` varchar(50) NOT NULL default '',
  `acl_location` varchar(255) NOT NULL default '',
  `acl_account` int(11) NOT NULL default '0',
  `acl_rights` int(11) default NULL,
  PRIMARY KEY  (`acl_appname`,`acl_location`,`acl_account`),
  KEY `egw_acl_account` (`acl_account`),
  KEY `egw_acl_location_account` (`acl_location`,`acl_account`),
  KEY `egw_acl_appname_account` (`acl_appname`,`acl_account`)
) TYPE=MyISAM;
INSERT INTO `egw_acl` VALUES ('resources','run',-1,1),('resources','L1',-1,399),('sitemgr','run',-2,1),('sitemgr','L2',-2,1),('sitemgr-link','run',-1,1),('phpgw_group','-3',4,1),('sitemgr-link','run',4,1),('phpgwapi','anonymous',4,1),('sitemgr','L3',-2,3),('sitemgr','L3',-1,1),('sitemgr','L3',4,1),('sitemgr','L4',-2,3),('sitemgr','L4',-1,1),('sitemgr','L4',4,1),('sitemgr','L5',-2,3),('sitemgr','L5',-1,1),('sitemgr','L5',4,1),('addressbook','run',-1,1),('calendar','run',-1,1),('infolog','run',-1,1),('felamimail','run',-1,1),('preferences','run',-1,1),('home','run',-1,1),('manual','run',-1,1),('admin','run',-2,1),('preferences','run',-2,1),('home','run',-2,1),('notifywindow','run',-2,1),('bookmarks','run',-2,1),('developer_tools','run',-2,1),('emailadmin','run',-2,1),('etemplate','run',-2,1),('filemanager','run',-2,1),('mydms','run',-2,1),('news_admin','run',-2,1),('phpbrain','run',-2,1),('phpsysinfo','run',-2,1),('polls','run',-2,1),('registration','run',-2,1),('sambaadmin','run',-2,1),('workflow','run',-2,1),('addressbook','run',-2,1),('calendar','run',-2,1),('felamimail','run',-2,1),('infolog','run',-2,1),('projectmanager','run',-2,1),('resources','run',-2,1),('timesheet','run',-2,1),('wiki','run',-2,1),('sitemgr-link','run',-2,1),('phpgw_group','-2',5,1),('preferences','changepassword',5,1),('phpgw_group','-1',5,1);
CREATE TABLE `egw_addressbook` (
  `id` int(11) NOT NULL auto_increment,
  `lid` varchar(32) default NULL,
  `tid` char(1) default NULL,
  `owner` bigint(20) default NULL,
  `access` varchar(7) default NULL,
  `cat_id` varchar(32) default NULL,
  `fn` varchar(64) default NULL,
  `n_family` varchar(64) default NULL,
  `n_given` varchar(64) default NULL,
  `n_middle` varchar(64) default NULL,
  `n_prefix` varchar(64) default NULL,
  `n_suffix` varchar(64) default NULL,
  `sound` varchar(64) default NULL,
  `bday` varchar(32) default NULL,
  `note` text,
  `tz` varchar(8) default NULL,
  `geo` varchar(32) default NULL,
  `url` varchar(128) default NULL,
  `pubkey` text,
  `org_name` varchar(64) default NULL,
  `org_unit` varchar(64) default NULL,
  `title` varchar(64) default NULL,
  `adr_one_street` varchar(64) default NULL,
  `adr_one_locality` varchar(64) default NULL,
  `adr_one_region` varchar(64) default NULL,
  `adr_one_postalcode` varchar(64) default NULL,
  `adr_one_countryname` varchar(64) default NULL,
  `adr_one_type` varchar(32) default NULL,
  `label` text,
  `adr_two_street` varchar(64) default NULL,
  `adr_two_locality` varchar(64) default NULL,
  `adr_two_region` varchar(64) default NULL,
  `adr_two_postalcode` varchar(64) default NULL,
  `adr_two_countryname` varchar(64) default NULL,
  `adr_two_type` varchar(32) default NULL,
  `tel_work` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_home` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_voice` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_fax` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_msg` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_cell` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_pager` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_bbs` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_modem` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_car` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_isdn` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_video` varchar(40) NOT NULL default '+1 (000) 000-0000',
  `tel_prefer` varchar(32) default NULL,
  `email` varchar(64) default NULL,
  `email_type` varchar(32) default 'INTERNET',
  `email_home` varchar(64) default NULL,
  `email_home_type` varchar(32) default 'INTERNET',
  `last_mod` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `egw_addressbook_tid_owner_access_n_family_n_given_email` (`tid`,`owner`,`access`,`n_family`,`n_given`,`email`),
  KEY `egw_addressbook_tid_cat_id_owner_access_n_family_n_given_email` (`tid`,`cat_id`,`owner`,`access`,`n_family`,`n_given`,`email`)
) TYPE=MyISAM;
CREATE TABLE `egw_addressbook_extra` (
  `contact_id` int(11) NOT NULL default '0',
  `contact_owner` bigint(20) default NULL,
  `contact_name` varchar(255) NOT NULL default '',
  `contact_value` text,
  PRIMARY KEY  (`contact_id`,`contact_name`)
) TYPE=MyISAM;
CREATE TABLE `egw_api_content_history` (
  `sync_appname` varchar(60) NOT NULL default '',
  `sync_contentid` varchar(60) NOT NULL default '',
  `sync_added` datetime default NULL,
  `sync_modified` datetime default NULL,
  `sync_deleted` datetime default NULL,
  `sync_id` int(11) NOT NULL auto_increment,
  `sync_guid` varchar(120) NOT NULL default '',
  `sync_changedby` int(11) NOT NULL default '0',
  PRIMARY KEY  (`sync_id`),
  KEY `egw_api_content_history_sync_added` (`sync_added`),
  KEY `egw_api_content_history_sync_modified` (`sync_modified`),
  KEY `egw_api_content_history_sync_deleted` (`sync_deleted`),
  KEY `egw_api_content_history_sync_guid` (`sync_guid`),
  KEY `egw_api_content_history_sync_changedby` (`sync_changedby`),
  KEY `egw_api_content_history_sync_appname_sync_contentid` (`sync_appname`,`sync_contentid`)
) TYPE=MyISAM;
CREATE TABLE `egw_app_sessions` (
  `sessionid` varchar(128) NOT NULL default '',
  `loginid` int(11) NOT NULL default '0',
  `app` varchar(25) NOT NULL default '',
  `location` varchar(128) NOT NULL default '',
  `content` longtext,
  `session_dla` bigint(20) default NULL,
  PRIMARY KEY  (`sessionid`,`loginid`,`app`,`location`)
) TYPE=MyISAM;
CREATE TABLE `egw_applications` (
  `app_id` int(11) NOT NULL auto_increment,
  `app_name` varchar(25) NOT NULL default '',
  `app_enabled` int(11) NOT NULL default '0',
  `app_order` int(11) NOT NULL default '0',
  `app_tables` text,
  `app_version` varchar(20) NOT NULL default '0.0',
  PRIMARY KEY  (`app_id`),
  UNIQUE KEY `egw_applications_name` (`app_name`),
  KEY `egw_applications_enabled_order` (`app_enabled`,`app_order`)
) TYPE=MyISAM AUTO_INCREMENT=30;
INSERT INTO `egw_applications` VALUES (1,'phpgwapi',3,1,'egw_config,egw_applications,egw_acl,egw_accounts,egw_preferences,egw_sessions,egw_app_sessions,egw_access_log,egw_hooks,egw_languages,egw_lang,egw_nextid,egw_categories,egw_addressbook,egw_addressbook_extra,egw_log,egw_log_msg,egw_interserv,egw_vfs,egw_history_log,egw_async,egw_api_content_history,phpgw_vfs2_mimetypes,phpgw_vfs2_files,phpgw_vfs2_customfields,phpgw_vfs2_quota,phpgw_vfs2_shares,phpgw_vfs2_versioning,phpgw_vfs2_customfields_data,phpgw_vfs2_prefixes,egw_contentmap,egw_syncmldevinfo,egw_syncmlsummary,egw_links','1.2.104'),(2,'admin',1,1,'','1.2'),(3,'preferences',2,1,'','1.2'),(4,'home',1,1,'','1.2'),(5,'notifywindow',2,1,'','1.2'),(6,'bookmarks',1,12,'egw_bookmarks','1.2'),(7,'developer_tools',1,61,'','1.2'),(8,'emailadmin',2,10,'egw_emailadmin','1.2.001'),(9,'etemplate',1,60,'egw_etemplate','1.2'),(10,'filemanager',1,6,'','1.2'),(11,'mydms',1,5,'phpgw_mydms_ACLs,phpgw_mydms_DocumentContent,phpgw_mydms_Documents,phpgw_mydms_Folders,phpgw_mydms_GroupMembers,phpgw_mydms_Groups,phpgw_mydms_Notify,phpgw_mydms_DocumentLinks,phpgw_mydms_Sessions,phpgw_mydms_UserImages,phpgw_mydms_Users,phpgw_mydms_KeywordCategories,phpgw_mydms_Keywords','1.2.000'),(12,'news_admin',1,16,'egw_news,egw_news_export','1.2'),(13,'phpbrain',1,25,'phpgw_kb_articles,phpgw_kb_comment,phpgw_kb_questions,phpgw_kb_ratings,phpgw_kb_related_art,phpgw_kb_search,phpgw_kb_files,phpgw_kb_urls','1.0.5'),(14,'phpsysinfo',2,99,'','1.2_2.5.2rc1'),(15,'polls',1,17,'phpgw_polls_data,phpgw_polls_desc,phpgw_polls_user,phpgw_polls_settings','1.0.0'),(16,'registration',2,40,'egw_reg_accounts,egw_reg_fields','1.2'),(17,'sambaadmin',1,99,'','1.2.000'),(18,'workflow',1,10,'egw_wf_activities,egw_wf_activity_roles,egw_wf_instance_activities,egw_wf_instances,egw_wf_processes,egw_wf_roles,egw_wf_instance_supplements,egw_wf_transitions,egw_wf_user_roles,egw_wf_workitems,egw_wf_process_config,egw_wf_activity_agents,egw_wf_agent_mail_smtp','1.2.01.006'),(19,'addressbook',1,4,'','1.2'),(20,'calendar',1,3,'egw_cal,egw_cal_holidays,egw_cal_repeats,egw_cal_user,egw_cal_extra,egw_cal_dates','1.2.001'),(21,'felamimail',1,2,'egw_felamimail_cache,egw_felamimail_folderstatus,egw_felamimail_displayfilter','1.2'),(22,'infolog',1,5,'egw_infolog,egw_infolog_extra','1.2.003'),(23,'projectmanager',1,5,'egw_pm_projects,egw_pm_extra,egw_pm_elements,egw_pm_constraints,egw_pm_milestones,egw_pm_roles,egw_pm_members,egw_pm_pricelist,egw_pm_prices','0.5.005'),(24,'resources',1,5,'egw_resources,egw_resources_extra','1.2'),(25,'sitemgr',1,14,'egw_sitemgr_pages,egw_sitemgr_pages_lang,egw_sitemgr_categories_state,egw_sitemgr_categories_lang,egw_sitemgr_modules,egw_sitemgr_blocks,egw_sitemgr_blocks_lang,egw_sitemgr_content,egw_sitemgr_content_lang,egw_sitemgr_active_modules,egw_sitemgr_properties,egw_sitemgr_sites,egw_sitemgr_notifications,egw_sitemgr_notify_messages','1.2'),(26,'timesheet',1,5,'egw_timesheet','0.2.001'),(27,'wiki',1,11,'egw_wiki_links,egw_wiki_pages,egw_wiki_rate,egw_wiki_interwiki,egw_wiki_sisterwiki,egw_wiki_remote_pages','1.2'),(28,'sitemgr-link',1,9,'','1.2'),(29,'manual',4,5,'','1.2');
CREATE TABLE `egw_async` (
  `async_id` varchar(255) NOT NULL default '',
  `async_next` int(11) NOT NULL default '0',
  `async_times` varchar(255) NOT NULL default '',
  `async_method` varchar(80) NOT NULL default '',
  `async_data` text,
  `async_account_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`async_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_bookmarks` (
  `bm_id` int(11) NOT NULL auto_increment,
  `bm_owner` int(11) default NULL,
  `bm_access` varchar(255) default NULL,
  `bm_url` varchar(255) default NULL,
  `bm_name` varchar(255) default NULL,
  `bm_desc` text,
  `bm_keywords` varchar(255) default NULL,
  `bm_category` int(11) default NULL,
  `bm_rating` int(11) default NULL,
  `bm_info` varchar(255) default NULL,
  `bm_visits` int(11) default NULL,
  PRIMARY KEY  (`bm_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_cal` (
  `cal_id` int(11) NOT NULL auto_increment,
  `cal_uid` varchar(255) NOT NULL default '',
  `cal_owner` int(11) NOT NULL default '0',
  `cal_category` varchar(30) default NULL,
  `cal_modified` bigint(20) default NULL,
  `cal_priority` smallint(6) NOT NULL default '2',
  `cal_public` smallint(6) NOT NULL default '1',
  `cal_title` varchar(255) NOT NULL default '1',
  `cal_description` text,
  `cal_location` varchar(255) default NULL,
  `cal_reference` int(11) NOT NULL default '0',
  `cal_modifier` int(11) default NULL,
  `cal_non_blocking` smallint(6) default '0',
  PRIMARY KEY  (`cal_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_cal_dates` (
  `cal_id` int(11) NOT NULL default '0',
  `cal_start` bigint(20) NOT NULL default '0',
  `cal_end` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`cal_id`,`cal_start`)
) TYPE=MyISAM;
CREATE TABLE `egw_cal_extra` (
  `cal_id` int(11) NOT NULL default '0',
  `cal_extra_name` varchar(40) NOT NULL default '',
  `cal_extra_value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`cal_id`,`cal_extra_name`)
) TYPE=MyISAM;
CREATE TABLE `egw_cal_holidays` (
  `hol_id` int(11) NOT NULL auto_increment,
  `hol_locale` char(2) NOT NULL default '',
  `hol_name` varchar(50) NOT NULL default '',
  `hol_mday` bigint(20) NOT NULL default '0',
  `hol_month_num` bigint(20) NOT NULL default '0',
  `hol_occurence` bigint(20) NOT NULL default '0',
  `hol_dow` bigint(20) NOT NULL default '0',
  `hol_observance_rule` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`hol_id`),
  KEY `egw_cal_holidays_hol_locale` (`hol_locale`)
) TYPE=MyISAM AUTO_INCREMENT=16;
INSERT INTO `egw_cal_holidays` VALUES (1,'US','Martin Luther King\\\'s Birthday',0,1,3,1,0),(2,'US','New Year\\\'s Day',1,1,0,0,1),(3,'US','Inauguration Day',20,1,0,0,0),(4,'US','Presidents Day',0,2,3,1,0),(5,'US','Armed Forces Day',0,5,3,6,0),(6,'US','Memorial Day',0,5,99,1,0),(7,'US','Flag Day',14,6,0,0,0),(8,'US','Independence Day',4,7,0,0,1),(9,'US','Labor Day',0,9,1,1,0),(10,'US','Columbus Day',0,10,2,1,0),(11,'US','Halloween',31,10,0,0,1),(12,'US','Thanksgiving Day',0,11,4,4,0),(13,'US','Veterans Day',11,11,0,0,1),(14,'US','Christmas Day',25,12,0,0,1),(15,'US','New Year\\\'s Eve',31,12,0,0,0);
CREATE TABLE `egw_cal_repeats` (
  `cal_id` int(11) NOT NULL default '0',
  `recur_type` smallint(6) NOT NULL default '0',
  `recur_enddate` bigint(20) default NULL,
  `recur_interval` smallint(6) default '1',
  `recur_data` smallint(6) default '1',
  `recur_exception` text,
  PRIMARY KEY  (`cal_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_cal_user` (
  `cal_id` int(11) NOT NULL default '0',
  `cal_recur_date` bigint(20) NOT NULL default '0',
  `cal_user_type` char(1) NOT NULL default 'u',
  `cal_user_id` int(11) NOT NULL default '0',
  `cal_status` char(1) default 'A',
  `cal_quantity` int(11) default '1',
  PRIMARY KEY  (`cal_id`,`cal_recur_date`,`cal_user_type`,`cal_user_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_categories` (
  `cat_id` int(11) NOT NULL auto_increment,
  `cat_main` int(11) NOT NULL default '0',
  `cat_parent` int(11) NOT NULL default '0',
  `cat_level` smallint(6) NOT NULL default '0',
  `cat_owner` int(11) NOT NULL default '0',
  `cat_access` varchar(7) default NULL,
  `cat_appname` varchar(50) NOT NULL default '',
  `cat_name` varchar(150) NOT NULL default '',
  `cat_description` varchar(255) NOT NULL default '',
  `cat_data` text,
  `last_mod` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`cat_id`),
  KEY `egw_categories_appname_owner_parent_level` (`cat_appname`,`cat_owner`,`cat_parent`,`cat_level`)
) TYPE=MyISAM AUTO_INCREMENT=6;
INSERT INTO `egw_categories` VALUES (1,0,0,0,-1,'public','resources','General resources','This category has been added by setup',NULL,1155704665),(2,2,0,0,-1,'public','sitemgr','Default Website','This website has been added by setup',NULL,1155704665),(3,2,2,1,-1,'public','sitemgr','other','one more','0',1155704666),(4,2,2,1,-1,'public','sitemgr','sample','sample category','0',1155704666),(5,2,4,2,-1,'public','sitemgr','sub-sample','just a sub for sample','0',1155704666);
CREATE TABLE `egw_config` (
  `config_app` varchar(50) NOT NULL default '',
  `config_name` varchar(255) NOT NULL default '',
  `config_value` text,
  PRIMARY KEY  (`config_app`,`config_name`)
) TYPE=MyISAM;
INSERT INTO `egw_config` VALUES ('phpgwapi','site_title','eGroupWare'),('phpgwapi','hostname','@@BASE_URL_HOST@@'),('phpgwapi','webserver_url','/@@BASE_URL_PATH@@'),('phpgwapi','temp_dir','/tmp'),('phpgwapi','files_dir','/tmp'),('phpgwapi','backup_dir','/tmp'),('phpgwapi','tz_offset','7'),('phpgwapi','usecookies','True'),('phpgwapi','system_charset','iso-8859-1'),('phpgwapi','sessions_checkip','True'),('phpgwapi','image_type','1'),('phpgwapi','asyncservice','fallback'),('bookmarks','mail_footer','\\n\\n--\\nThis was sent from eGroupWare\\nhttp://www.egroupware.org\\n'),('registration','display_tos','True'),('registration','activate_account','email'),('registration','username_is','choice'),('registration','password_is','choice'),('registration','use_challenge','True'),('phpgwapi','auto_load_holidays','True'),('phpgwapi','holidays_url_path','localhost'),('phpgwapi','lang_ctimes','a:1:{s:2:\"en\";a:28:{s:11:\"addressbook\";i:1155703464;s:5:\"admin\";i:1155703424;s:9:\"bookmarks\";i:1155703469;s:8:\"calendar\";i:1155703460;s:15:\"developer_tools\";i:1155703427;s:10:\"emailadmin\";i:1155703461;s:9:\"etemplate\";i:1155703432;s:10:\"felamimail\";i:1155703467;s:11:\"filemanager\";i:1155703424;s:4:\"home\";i:1155703423;s:7:\"infolog\";i:1155703470;s:6:\"manual\";i:1155703461;s:5:\"mydms\";i:1155703426;s:10:\"news_admin\";i:1155703468;s:8:\"phpbrain\";i:1155703436;s:8:\"phpgwapi\";i:1155703453;s:10:\"phpsysinfo\";i:1155703429;s:5:\"polls\";i:1155703427;s:11:\"preferences\";i:1155703460;s:14:\"projectmanager\";i:1155703466;s:12:\"registration\";i:1155703471;s:9:\"resources\";i:1155703469;s:10:\"sambaadmin\";i:1155703432;s:7:\"sitemgr\";i:1155703433;s:12:\"sitemgr-link\";i:1155703434;s:9:\"timesheet\";i:1155703433;s:4:\"wiki\";i:1155703423;s:8:\"workflow\";i:1155703462;}}'),('phpgwapi','mail_server','@@BASE_URL_HOST@@'),('phpgwapi','mail_server_type','imap'),('phpgwapi','mail_login_type','standard'),('phpgwapi','mail_suffix','@@BASE_URL_HOST@@'),('phpgwapi','smtp_server','@@BASE_URL_HOST@@'),('phpgwapi','smtp_port','25'),('phpgwapi','auth_type','sql'),('phpgwapi','account_repository','sql'),('phpgwapi','sql_encryption_type','md5'),('phpgwapi','auto_create_expire','604800'),('phpgwapi','acl_default','deny'),('phpgwapi','ldap_encryption_type','des'),('phpgwapi','mcrypt_algo','tripledes'),('phpgwapi','mcrypt_mode','cbc'),('phpgwapi','file_repository','sql'),('phpgwapi','file_store_contents','filesystem'),('phpgwapi','max_access_log_age','90'),('phpgwapi','block_time','30'),('phpgwapi','num_unsuccessful_id','3'),('phpgwapi','num_unsuccessful_ip','3'),('phpgwapi','install_id','f443bdabf4adcd7eab4eb1ae2711b2e2'),('phpgwapi','sessions_timeout','14400'),('phpgwapi','sessions_app_timeout','86400'),('calendar','horizont','1158385715');
CREATE TABLE `egw_contentmap` (
  `map_id` varchar(128) NOT NULL default '',
  `map_guid` varchar(100) NOT NULL default '',
  `map_locuid` varchar(100) NOT NULL default '',
  `map_timestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  `map_expired` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`map_id`,`map_guid`,`map_locuid`),
  KEY `egw_contentmap_map_expired` (`map_expired`),
  KEY `egw_contentmap_map_id_map_locuid` (`map_id`,`map_locuid`)
) TYPE=MyISAM;
CREATE TABLE `egw_emailadmin` (
  `ea_profile_id` int(11) NOT NULL auto_increment,
  `ea_smtp_server` varchar(80) default NULL,
  `ea_smtp_type` int(11) default NULL,
  `ea_smtp_port` int(11) default NULL,
  `ea_smtp_auth` char(3) default NULL,
  `ea_editforwardingaddress` char(3) default NULL,
  `ea_smtp_ldap_server` varchar(80) default NULL,
  `ea_smtp_ldap_basedn` varchar(200) default NULL,
  `ea_smtp_ldap_admindn` varchar(200) default NULL,
  `ea_smtp_ldap_adminpw` varchar(30) default NULL,
  `ea_smtp_ldap_use_default` char(3) default NULL,
  `ea_imap_server` varchar(80) default NULL,
  `ea_imap_type` int(11) default NULL,
  `ea_imap_port` int(11) default NULL,
  `ea_imap_login_type` varchar(20) default NULL,
  `ea_imap_tsl_auth` char(3) default NULL,
  `ea_imap_tsl_encryption` char(3) default NULL,
  `ea_imap_enable_cyrus` char(3) default NULL,
  `ea_imap_admin_user` varchar(40) default NULL,
  `ea_imap_admin_pw` varchar(40) default NULL,
  `ea_imap_enable_sieve` char(3) default NULL,
  `ea_imap_sieve_server` varchar(80) default NULL,
  `ea_imap_sieve_port` int(11) default NULL,
  `ea_description` varchar(200) default NULL,
  `ea_default_domain` varchar(100) default NULL,
  `ea_organisation_name` varchar(100) default NULL,
  `ea_user_defined_accounts` char(3) default NULL,
  `ea_imapoldcclient` char(3) default NULL,
  `ea_order` int(11) default NULL,
  `ea_appname` varchar(80) default NULL,
  `ea_group` varchar(80) default NULL,
  PRIMARY KEY  (`ea_profile_id`)
) TYPE=MyISAM AUTO_INCREMENT=2;
INSERT INTO `egw_emailadmin` VALUES (1,'@@BASE_URL_HOST@@',1,25,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'@@BASE_URL_HOST@@',2,143,'standard',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'default profile (created by setup)','@@BASE_URL_HOST@@',NULL,NULL,NULL,NULL,'','0');
CREATE TABLE `egw_etemplate` (
  `et_name` varchar(80) NOT NULL default '',
  `et_template` varchar(20) NOT NULL default '',
  `et_lang` varchar(5) NOT NULL default '',
  `et_group` int(11) NOT NULL default '0',
  `et_version` varchar(20) NOT NULL default '',
  `et_data` text,
  `et_size` varchar(128) default NULL,
  `et_style` text,
  `et_modified` int(11) NOT NULL default '0',
  PRIMARY KEY  (`et_name`,`et_template`,`et_lang`,`et_group`,`et_version`)
) TYPE=MyISAM;
INSERT INTO `egw_etemplate` VALUES ('resources.add','','',0,'','a:1:{i:0;a:5:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:3:{i:0;a:0:{}i:1;a:1:{s:1:\"A\";a:2:{s:4:\"type\";s:8:\"template\";s:4:\"name\";s:19:\"resources.edit_tabs\";}}i:2;a:1:{s:1:\"A\";a:2:{s:4:\"type\";s:8:\"template\";s:4:\"name\";s:21:\"resources.add_buttons\";}}}s:4:\"rows\";i:2;s:4:\"cols\";i:1;s:4:\"size\";s:4:\"100%\";}}','100%','',1094579218),('resources.add_buttons','','',0,'','a:1:{i:0;a:5:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:1:{s:1:\"C\";s:4:\"100%\";}i:1;a:3:{s:1:\"A\";a:4:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:4:\"Save\";s:4:\"name\";s:4:\"save\";s:4:\"help\";s:21:\"Saves entry and exits\";}s:1:\"B\";a:3:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:6:\"Cancel\";s:4:\"name\";s:6:\"cancel\";}s:1:\"C\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"align\";s:5:\"right\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:3;s:4:\"size\";s:4:\"100%\";}}','100%','',1094579498),('resources.admin','','',0,'','a:1:{i:0;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:3:{i:0;a:0:{}i:1;a:1:{s:1:\"A\";a:3:{s:4:\"type\";s:8:\"checkbox\";s:5:\"label\";s:55:\"Don\'t use vfs (this will need a symlink --> see README)\";s:4:\"name\";s:12:\"dont_use_vfs\";}}i:2;a:1:{s:1:\"A\";a:4:{s:4:\"type\";s:4:\"hbox\";s:4:\"size\";s:1:\"2\";i:1;a:3:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:4:\"Save\";s:4:\"name\";s:4:\"save\";}i:2;a:3:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:6:\"Cancel\";s:4:\"name\";s:6:\"cancel\";}}}}s:4:\"rows\";i:2;s:4:\"cols\";i:1;}}',NULL,'',1109673054),('resources.edit','','',0,'','a:1:{i:0;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:5:{i:0;a:1:{s:1:\"A\";s:3:\"700\";}i:1;a:1:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:3:\"msg\";}}i:2;a:1:{s:1:\"A\";a:5:{s:4:\"type\";s:4:\"hbox\";s:4:\"size\";s:1:\"3\";i:1;a:5:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Name\";s:4:\"name\";s:4:\"name\";s:4:\"help\";s:16:\"Name of resource\";s:6:\"needed\";s:1:\"1\";}i:2;a:3:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:16:\"Inventory number\";s:4:\"name\";s:16:\"inventory_number\";}i:3;a:7:{s:4:\"type\";s:6:\"select\";s:5:\"label\";s:8:\"Category\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:6:\"cat_id\";s:6:\"needed\";s:1:\"1\";s:4:\"help\";s:44:\"Which category does this resource belong to?\";s:5:\"align\";s:5:\"right\";}}}i:3;a:1:{s:1:\"A\";a:2:{s:4:\"type\";s:8:\"template\";s:4:\"name\";s:19:\"resources.edit_tabs\";}}i:4;a:1:{s:1:\"A\";a:2:{s:4:\"type\";s:8:\"template\";s:4:\"name\";s:22:\"resources.edit_buttons\";}}}s:4:\"rows\";i:4;s:4:\"cols\";i:1;}}',NULL,'',1109000980),('resources.edit_buttons','','',0,'','a:1:{i:0;a:5:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:1:{s:1:\"C\";s:4:\"100%\";}i:1;a:3:{s:1:\"A\";a:4:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:4:\"Save\";s:4:\"name\";s:4:\"save\";s:4:\"help\";s:21:\"Saves entry and exits\";}s:1:\"B\";a:3:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:6:\"Cancel\";s:7:\"onclick\";s:15:\"window.close();\";}s:1:\"C\";a:5:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:6:\"Delete\";s:5:\"align\";s:5:\"right\";s:4:\"name\";s:6:\"delete\";s:7:\"onclick\";s:61:\"return confirm(\'Do you really want do delte this resource?\');\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:3;s:4:\"size\";s:4:\"100%\";}}','100%','',1093597552),('resources.edit_pictures','','',0,'','a:1:{i:0;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:4:{i:0;a:3:{s:2:\"c1\";s:3:\"nmr\";s:2:\"c2\";s:3:\"nmr\";s:2:\"c3\";s:3:\"nmr\";}i:1;a:3:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:26:\"Use general resources icon\";s:5:\"align\";s:5:\"right\";}s:1:\"B\";a:3:{s:4:\"type\";s:5:\"radio\";s:4:\"size\";s:7:\"gen_src\";s:4:\"name\";s:11:\"picture_src\";}s:1:\"C\";a:3:{s:4:\"type\";s:6:\"select\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:12:\"gen_src_list\";}}i:2;a:3:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:23:\"Use the category\'s icon\";s:5:\"align\";s:5:\"right\";}s:1:\"B\";a:3:{s:4:\"type\";s:5:\"radio\";s:4:\"size\";s:7:\"cat_src\";s:4:\"name\";s:11:\"picture_src\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}}i:3;a:3:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:15:\"Use own picture\";s:5:\"align\";s:5:\"right\";}s:1:\"B\";a:3:{s:4:\"type\";s:5:\"radio\";s:4:\"size\";s:7:\"own_src\";s:4:\"name\";s:11:\"picture_src\";}s:1:\"C\";a:2:{s:4:\"type\";s:4:\"file\";s:4:\"name\";s:8:\"own_file\";}}}s:4:\"rows\";i:3;s:4:\"cols\";i:3;}}',NULL,'',1108638846),('resources.edit_tabs','','',0,'','a:1:{i:0;a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:3:{i:0;a:3:{s:2:\"c1\";s:7:\"row_off\";s:1:\"A\";s:3:\"700\";s:2:\"h2\";s:4:\"100%\";}i:1;a:3:{s:1:\"A\";a:5:{s:4:\"type\";s:3:\"tab\";s:4:\"span\";s:3:\"all\";s:5:\"label\";s:40:\"General|Description|Picture|Links|Custom\";s:4:\"name\";s:34:\"general|page|pictures|links|custom\";s:4:\"help\";s:164:\"General informations about resource|Informations about the location of resource|Prizeing information for booking or buying|Web-Page of resource|Pictures or resource\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}}i:2;a:3:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:4:\"span\";s:3:\"all\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}}}s:4:\"rows\";i:2;s:4:\"cols\";i:3;s:4:\"size\";s:4:\",380\";s:7:\"options\";a:1:{i:1;s:3:\"380\";}}}',',380','',1116664222),('resources.edit_tabs.accessories','','',0,'','a:1:{i:0;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:0:{}i:1;a:1:{s:1:\"A\";a:3:{s:4:\"type\";s:9:\"nextmatch\";s:4:\"name\";s:2:\"nm\";s:4:\"size\";s:19:\"resources.show.rows\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:1;}}',NULL,'',1109668181),('resources.edit_tabs.custom','','',0,'','a:1:{i:0;a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:3:{i:0;a:1:{s:2:\"c1\";s:4:\",top\";}i:1;a:1:{s:1:\"A\";a:1:{s:4:\"type\";s:12:\"customfields\";}}i:2;a:1:{s:1:\"A\";a:1:{s:4:\"type\";s:5:\"label\";}}}s:4:\"rows\";i:2;s:4:\"cols\";i:1;s:4:\"size\";s:7:\"700,380\";s:7:\"options\";a:2:{i:0;s:3:\"700\";i:1;s:3:\"380\";}}}','700,380','',1131988154),('resources.edit_tabs.general','','',0,'','a:1:{i:0;a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:9:{i:0;a:2:{s:1:\"C\";s:2:\"10\";s:2:\"h8\";s:4:\"100%\";}i:1;a:4:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:19:\"Description (short)\";}s:1:\"B\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"50,100\";s:4:\"name\";s:17:\"short_description\";s:4:\"help\";s:29:\"Short description of resource\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"D\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:29:\"Short description of resource\";}}i:2;a:4:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:8:\"Location\";}s:1:\"B\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"50,100\";s:4:\"name\";s:8:\"location\";s:4:\"help\";s:20:\"Location of resource\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"D\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:28:\"Where to find this resource?\";}}i:3;a:4:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:19:\"Storage information\";}s:1:\"B\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"50,100\";s:4:\"name\";s:12:\"storage_info\";s:4:\"help\";s:25:\"Information about storage\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"D\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:25:\"Information about storage\";}}i:4;a:4:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:8:\"Quantity\";}s:1:\"B\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:4:\"5,10\";s:4:\"name\";s:8:\"quantity\";s:4:\"help\";s:20:\"Quantity of resource\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"D\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:20:\"Quantity of resource\";}}i:5;a:4:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:7:\"Useable\";}s:1:\"B\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:4:\"5,10\";s:4:\"name\";s:7:\"useable\";s:4:\"help\";s:29:\"How many of them are useable?\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"D\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:38:\"How many of the resources are useable?\";}}i:6;a:4:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:8:\"Bookable\";}s:1:\"B\";a:3:{s:4:\"type\";s:8:\"checkbox\";s:4:\"name\";s:8:\"bookable\";s:4:\"help\";s:21:\"Is resource bookable?\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"D\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:26:\"Is this resource bookable?\";}}i:7;a:4:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:7:\"Buyable\";s:8:\"disabled\";s:1:\"1\";}s:1:\"B\";a:4:{s:4:\"type\";s:8:\"checkbox\";s:4:\"name\";s:7:\"buyable\";s:4:\"help\";s:20:\"Is resource buyable?\";s:8:\"disabled\";s:1:\"1\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"D\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:25:\"Is this resource buyable?\";s:8:\"disabled\";s:1:\"1\";}}i:8;a:4:{s:1:\"A\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"D\";a:1:{s:4:\"type\";s:5:\"label\";}}}s:4:\"rows\";i:8;s:4:\"cols\";i:4;s:4:\"size\";s:7:\"700,380\";s:7:\"options\";a:2:{i:0;s:3:\"700\";i:1;s:3:\"380\";}}}','700,380','',1093597682),('resources.edit_tabs.links','','',0,'','a:1:{i:0;a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:6:{i:0;a:7:{s:1:\"A\";s:3:\"100\";s:2:\"c1\";s:2:\"th\";s:2:\"c2\";s:3:\"row\";s:2:\"c3\";s:2:\"th\";s:2:\"c4\";s:11:\"row_off,top\";s:2:\"h4\";s:3:\"164\";s:2:\"h5\";s:4:\"100%\";}i:1;a:2:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:4:\"span\";s:3:\"all\";s:5:\"label\";s:16:\"Create new links\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}i:2;a:2:{s:1:\"A\";a:3:{s:4:\"type\";s:7:\"link-to\";s:4:\"span\";s:3:\"all\";s:4:\"name\";s:7:\"link_to\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}i:3;a:2:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:4:\"span\";s:3:\"all\";s:5:\"label\";s:14:\"Existing links\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}i:4;a:2:{s:1:\"A\";a:3:{s:4:\"type\";s:9:\"link-list\";s:4:\"span\";s:3:\"all\";s:4:\"name\";s:7:\"link_to\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}i:5;a:2:{s:1:\"A\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}}s:4:\"rows\";i:5;s:4:\"cols\";i:2;s:4:\"size\";s:7:\"700,380\";s:7:\"options\";a:2:{i:0;s:3:\"700\";i:1;s:3:\"380\";}}}','700,380','',1109248913),('resources.edit_tabs.page','','',0,'','a:1:{i:0;a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:1:{s:2:\"c1\";s:4:\",top\";}i:1;a:1:{s:1:\"A\";a:4:{s:4:\"type\";s:8:\"htmlarea\";s:4:\"name\";s:16:\"long_description\";s:4:\"help\";s:26:\"Web-Site for this resource\";s:4:\"size\";s:94:\"width: 690px; height :365px;,ContextMenu,ColorChooser,FontChooser,SearchReplace,InsertDateTime\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:1;s:4:\"size\";s:8:\"100%,380\";s:7:\"options\";a:2:{i:0;s:4:\"100%\";i:1;s:3:\"380\";}}}','100%,380','',1093599237),('resources.edit_tabs.pictures','','',0,'','a:1:{i:0;a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:3:{i:0;a:2:{s:2:\"c1\";s:4:\",top\";s:2:\"h2\";s:4:\"100%\";}i:1;a:1:{s:1:\"A\";a:4:{s:4:\"type\";s:4:\"hbox\";s:4:\"size\";s:1:\"2\";i:1;a:4:{s:4:\"type\";s:4:\"vbox\";s:4:\"size\";s:1:\"2\";i:1;a:2:{s:4:\"type\";s:5:\"image\";s:4:\"name\";s:16:\"resource_picture\";}i:2;a:1:{s:4:\"type\";s:5:\"label\";}}i:2;a:4:{s:4:\"type\";s:8:\"groupbox\";s:4:\"size\";s:1:\"1\";i:1;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:4:{i:0;a:0:{}i:1;a:3:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:26:\"Use general resources icon\";s:5:\"align\";s:5:\"right\";}s:1:\"B\";a:3:{s:4:\"type\";s:5:\"radio\";s:4:\"size\";s:7:\"gen_src\";s:4:\"name\";s:11:\"picture_src\";}s:1:\"C\";a:3:{s:4:\"type\";s:6:\"select\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:12:\"gen_src_list\";}}i:2;a:3:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:23:\"Use the category\'s icon\";s:5:\"align\";s:5:\"right\";}s:1:\"B\";a:3:{s:4:\"type\";s:5:\"radio\";s:4:\"size\";s:7:\"cat_src\";s:4:\"name\";s:11:\"picture_src\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}}i:3;a:3:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:15:\"Use own picture\";s:5:\"align\";s:5:\"right\";}s:1:\"B\";a:3:{s:4:\"type\";s:5:\"radio\";s:4:\"size\";s:7:\"own_src\";s:4:\"name\";s:11:\"picture_src\";}s:1:\"C\";a:2:{s:4:\"type\";s:4:\"file\";s:4:\"name\";s:8:\"own_file\";}}}s:4:\"rows\";i:3;s:4:\"cols\";i:3;}s:5:\"label\";s:14:\"picture source\";}}}i:2;a:1:{s:1:\"A\";a:1:{s:4:\"type\";s:5:\"label\";}}}s:4:\"rows\";i:2;s:4:\"cols\";i:1;s:4:\"size\";s:7:\"700,380\";s:7:\"options\";a:2:{i:0;s:3:\"700\";i:1;s:3:\"380\";}}}','700,380','',1131048665),('resources.resource_select','','',0,'','a:1:{i:0;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:0:{}i:1;a:1:{s:1:\"A\";a:3:{s:4:\"type\";s:9:\"nextmatch\";s:4:\"size\";s:29:\"resources.resource_select.row\";s:4:\"name\";s:2:\"nm\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:1;}}',NULL,'',1118567281),('resources.resource_select.header','','',0,'','a:1:{i:0;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:0:{}i:1;a:2:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"image\";s:4:\"name\";s:6:\"navbar\";s:5:\"label\";s:16:\"Select resources\";}s:1:\"B\";a:3:{s:4:\"type\";s:5:\"label\";s:4:\"name\";s:4:\"$msg\";s:7:\"no_lang\";s:1:\"1\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:2;}}',NULL,'',1118502303),('resources.resource_select.row','','',0,'','a:1:{i:0;a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:2:{s:2:\"c1\";s:4:\",top\";s:1:\"A\";s:4:\"100%\";}i:1;a:2:{s:1:\"A\";a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:3:{i:0;a:2:{s:2:\"c1\";s:2:\"th\";s:1:\"D\";s:2:\"3%\";}i:1;a:4:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:4:\"Name\";}s:1:\"B\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:8:\"Category\";}s:1:\"C\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:8:\"Quantity\";}s:1:\"D\";a:1:{s:4:\"type\";s:5:\"label\";}}i:2;a:4:{s:1:\"A\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"C\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"D\";a:2:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:6:\"select\";}}}s:4:\"rows\";i:2;s:4:\"cols\";i:4;s:4:\"size\";s:4:\"100%\";s:7:\"options\";a:1:{i:0;s:4:\"100%\";}}s:1:\"B\";a:6:{s:4:\"type\";s:4:\"grid\";i:1;a:1:{s:4:\"type\";s:5:\"label\";}s:4:\"data\";a:4:{i:0;a:1:{s:2:\"c1\";s:2:\"th\";}i:1;a:1:{s:1:\"A\";a:5:{s:4:\"type\";s:4:\"grid\";s:5:\"align\";s:6:\"center\";s:4:\"data\";a:2:{i:0;a:0:{}i:1;a:2:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:4:\"span\";s:5:\"0,big\";s:5:\"label\";s:9:\"Selection\";}s:1:\"B\";a:4:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:6:\"delete\";s:4:\"name\";s:16:\"delete_selection\";s:5:\"label\";s:15:\"clear selection\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:2;}}i:2;a:1:{s:1:\"A\";a:4:{s:4:\"type\";s:6:\"select\";s:4:\"size\";s:3:\"13+\";s:4:\"name\";s:9:\"selectbox\";s:4:\"span\";s:5:\"0,sel\";}}i:3;a:1:{s:1:\"A\";a:4:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:5:\"Close\";s:5:\"align\";s:6:\"center\";s:4:\"name\";s:9:\"btn_close\";}}}s:4:\"rows\";i:3;s:4:\"cols\";i:1;s:7:\"options\";a:0:{}}}}s:4:\"rows\";i:1;s:4:\"cols\";i:2;s:4:\"size\";s:4:\"100%\";s:7:\"options\";a:1:{i:0;s:4:\"100%\";}}}','100%','',1118505003),('resources.resource_select.row','','',0,'1.0.0.001','a:1:{i:0;a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:2:{s:2:\"c1\";s:4:\",top\";s:1:\"A\";s:4:\"100%\";}i:1;a:2:{s:1:\"A\";a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:3:{i:0;a:2:{s:2:\"c1\";s:2:\"th\";s:1:\"D\";s:2:\"3%\";}i:1;a:4:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:4:\"Name\";}s:1:\"B\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:8:\"Category\";}s:1:\"C\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:8:\"Quantity\";}s:1:\"D\";a:1:{s:4:\"type\";s:5:\"label\";}}i:2;a:4:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:4:\"name\";s:12:\"${row}[name]\";s:7:\"no_lang\";s:1:\"1\";}s:1:\"B\";a:3:{s:4:\"type\";s:10:\"select-cat\";s:4:\"name\";s:14:\"${row}[cat_id]\";s:8:\"readonly\";s:1:\"1\";}s:1:\"C\";a:10:{s:4:\"type\";s:4:\"hbox\";s:7:\"no_lang\";s:1:\"1\";s:4:\"data\";a:2:{i:0;a:0:{}i:1;a:3:{s:1:\"A\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"1,,2\";}s:1:\"B\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:2:\"of\";}s:1:\"C\";a:3:{s:4:\"type\";s:5:\"label\";s:4:\"name\";s:15:\"${row}[useable]\";s:7:\"no_lang\";s:1:\"1\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:3;s:4:\"size\";s:1:\"3\";i:1;a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"1,,2\";s:4:\"name\";s:19:\"${row}[default_qty]\";}i:2;a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:2:\"of\";}i:3;a:3:{s:4:\"type\";s:5:\"label\";s:4:\"name\";s:15:\"${row}[useable]\";s:7:\"no_lang\";s:1:\"1\";}s:7:\"options\";a:1:{i:0;s:1:\"3\";}}s:1:\"D\";a:6:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:6:\"select\";s:7:\"onclick\";s:88:\"addOption(\'$row_cont[name]\',$row_cont[res_id],this.id,$row_cont[useable]); return false;\";s:6:\"needed\";s:1:\"1\";s:5:\"label\";s:15:\"select resource\";s:4:\"name\";s:6:\"${row}\";}}}s:4:\"rows\";i:2;s:4:\"cols\";i:4;s:4:\"size\";s:4:\"100%\";s:7:\"options\";a:1:{i:0;s:4:\"100%\";}}s:1:\"B\";a:6:{s:4:\"type\";s:4:\"grid\";i:1;a:1:{s:4:\"type\";s:5:\"label\";}s:4:\"data\";a:4:{i:0;a:1:{s:2:\"c1\";s:2:\"th\";}i:1;a:1:{s:1:\"A\";a:5:{s:4:\"type\";s:4:\"grid\";s:5:\"align\";s:6:\"center\";s:4:\"data\";a:2:{i:0;a:0:{}i:1;a:2:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:4:\"span\";s:5:\"0,big\";s:5:\"label\";s:9:\"Selection\";}s:1:\"B\";a:5:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:6:\"delete\";s:5:\"label\";s:15:\"clear selection\";s:7:\"onclick\";s:38:\"removeSelectedOptions(); return false;\";s:6:\"needed\";s:1:\"1\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:2;}}i:2;a:1:{s:1:\"A\";a:5:{s:4:\"type\";s:6:\"select\";s:4:\"size\";s:3:\"13+\";s:4:\"name\";s:9:\"selectbox\";s:4:\"span\";s:5:\"0,sel\";s:7:\"no_lang\";s:1:\"1\";}}i:3;a:1:{s:1:\"A\";a:4:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:5:\"Close\";s:5:\"align\";s:6:\"center\";s:7:\"onclick\";s:31:\"oneLineSubmit();window.close();\";}}}s:4:\"rows\";i:3;s:4:\"cols\";i:1;s:7:\"options\";a:0:{}}}}s:4:\"rows\";i:1;s:4:\"cols\";i:2;s:4:\"size\";s:4:\"100%\";s:7:\"options\";a:1:{i:0;s:4:\"100%\";}}}','100%','',1126031297),('resources.resource_selectbox','','',0,'','a:1:{i:0;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:1:{s:2:\"c1\";s:7:\",bottom\";}i:1;a:2:{s:1:\"A\";a:4:{s:4:\"type\";s:6:\"select\";s:4:\"size\";s:3:\"14+\";s:4:\"name\";s:9:\"resources\";s:7:\"no_lang\";s:1:\"1\";}s:1:\"B\";a:6:{s:4:\"type\";s:6:\"button\";s:7:\"onclick\";s:160:\"window.open(egw::link(\'/index.php\',\'menuaction=resources.ui_resources.select\'),\'\',\'dependent=yes,width=600,height=450,scrollbars=yes,status=yes\'); return false;\";s:5:\"label\";s:13:\"Add resources\";s:4:\"size\";s:6:\"navbar\";s:6:\"needed\";s:1:\"1\";s:4:\"name\";s:5:\"popup\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:2;}}',NULL,'',1118520536),('resources.show','','',0,'','a:1:{i:0;a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:4:{i:0;a:1:{s:1:\"A\";s:4:\"100%\";}i:1;a:1:{s:1:\"A\";a:4:{s:4:\"type\";s:9:\"nextmatch\";s:4:\"size\";s:19:\"resources.show.rows\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:2:\"nm\";}}i:2;a:1:{s:1:\"A\";a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:4:{s:1:\"D\";s:2:\"1%\";s:1:\"E\";s:4:\"47px\";s:1:\"C\";s:2:\"1%\";s:1:\"B\";s:2:\"1%\";}i:1;a:5:{s:1:\"A\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"B\";a:8:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:19:\"bookable,trans16x16\";s:5:\"label\";s:23:\"book selected resources\";s:4:\"help\";s:23:\"book selected resources\";s:5:\"align\";s:5:\"right\";s:7:\"onclick\";s:312:\"var resources = js_btn_book_selected(this.form); if(resources == false) { return false; } else { window.open(egw::link(\'/index.php\',\'menuaction=calendar.uiforms.edit\')+\'&participants=\'+resources,\'\',\'dependent=yes,width=750,height=400,location=no,menubar=no,toolbar=no,scrollbars=yes,status=yes\'); return false; }\";s:6:\"needed\";s:1:\"1\";s:4:\"name\";s:17:\"btn_book_selected\";}s:1:\"C\";a:8:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:25:\"Show calendar of resource\";s:4:\"size\";s:19:\"calendar,trans16x16\";s:4:\"name\";s:16:\"btn_cal_selected\";s:4:\"help\";s:25:\"Show calendar of resource\";s:5:\"align\";s:5:\"right\";s:7:\"onclick\";s:216:\"var resources = js_btn_book_selected(this.form); if(resources == false) { return false; } else { location=egw::link(\'/index.php\',\'menuaction=calendar.uiviews.planner\')+\'&sortby=user&owner=\'+resources; return false; }\";s:6:\"needed\";s:1:\"1\";}s:1:\"D\";a:8:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:6:\"delete\";s:5:\"label\";s:25:\"delete selected resources\";s:4:\"name\";s:19:\"btn_delete_selected\";s:4:\"help\";s:25:\"delete selected resources\";s:5:\"align\";s:5:\"right\";s:7:\"onclick\";s:170:\"var resources = js_btn_book_selected(this.form); if(resources == false) { return false; } else { return confirm(\'Do you really want do delete the selected resources?\'); }\";s:6:\"needed\";s:1:\"1\";}s:1:\"E\";a:5:{s:4:\"type\";s:4:\"vbox\";s:4:\"size\";s:1:\"3\";i:1;a:1:{s:4:\"type\";s:5:\"label\";}i:2;a:6:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:9:\"arrow_ltr\";s:5:\"label\";s:19:\"select/deselect all\";s:4:\"help\";s:19:\"select/deselect all\";s:7:\"onclick\";s:76:\"toggle_all(this.form,form::name(\'nm[rows][checkbox][]\'),true); return false;\";s:6:\"needed\";s:1:\"1\";}i:3;a:1:{s:4:\"type\";s:5:\"label\";}}}}s:4:\"rows\";i:1;s:4:\"cols\";i:5;s:7:\"options\";a:1:{i:0;s:4:\"100%\";}s:4:\"size\";s:4:\"100%\";}}i:3;a:1:{s:1:\"A\";a:5:{s:4:\"type\";s:4:\"hbox\";s:4:\"size\";s:1:\"3\";i:1;a:4:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:3:\"Add\";s:7:\"onclick\";s:206:\"window.open(egw::link(\'/index.php\',\'menuaction=resources.ui_resources.edit\'),\'\',\'dependent=yes,width=800,height=600,location=no,menubar=no,toolbar=no,scrollbars=yes,status=yes\'); return false; return false;\";s:4:\"name\";s:3:\"add\";}i:2;a:4:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:13:\"Add accessory\";s:4:\"name\";s:7:\"add_sub\";s:7:\"onclick\";s:235:\"window.open(egw::link(\'/index.php\',\'menuaction=resources.ui_resources.edit&content=0&accessory_of=$cont[view_accs_of]\'),\'\',\'dependent=yes,width=800,height=600,location=no,menubar=no,toolbar=no,scrollbars=yes,status=yes\'); return false;\";}i:3;a:3:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:4:\"Back\";s:4:\"name\";s:4:\"back\";}}}}s:4:\"rows\";i:3;s:4:\"cols\";i:1;s:4:\"size\";s:4:\"100%\";s:7:\"options\";a:1:{i:0;s:4:\"100%\";}}}','100%','',1129668596),('resources.show.actions','','',0,'','a:1:{i:0;a:5:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:3:{i:0;a:3:{s:1:\"F\";s:2:\"3%\";s:2:\"c1\";s:3:\"nmh\";s:2:\"c2\";s:3:\"nmr\";}i:1;a:6:{s:1:\"A\";a:3:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:4:\"Name\";s:4:\"name\";s:4:\"name\";}s:1:\"B\";a:3:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:17:\"Short description\";s:4:\"name\";s:17:\"short_description\";}s:1:\"C\";a:3:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:7:\"Useable\";s:4:\"name\";s:7:\"useable\";}s:1:\"D\";a:3:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:8:\"Category\";s:4:\"name\";s:6:\"cat_id\";}s:1:\"E\";a:3:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:8:\"Location\";s:4:\"name\";s:8:\"location\";}s:1:\"F\";a:3:{s:4:\"type\";s:8:\"template\";s:5:\"align\";s:5:\"right\";s:4:\"name\";s:29:\"resources.show.actions_header\";}}i:2;a:6:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:12:\"${row}[name]\";}s:1:\"B\";a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:25:\"${row}[short_description]\";}s:1:\"C\";a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:14:\"${row}[usable]\";}s:1:\"D\";a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:16:\"${row}[category]\";}s:1:\"E\";a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:16:\"${row}[location]\";}s:1:\"F\";a:3:{s:4:\"type\";s:6:\"button\";s:5:\"align\";s:5:\"right\";s:4:\"name\";s:20:\"lukas[$row_cont[id]]\";}}}s:4:\"rows\";i:2;s:4:\"cols\";i:6;s:4:\"size\";s:4:\"100%\";}}','100%','',1098891355),('resources.show.actions_header','','',0,'','a:1:{i:0;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:0:{}i:1;a:2:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:6:\"Action\";}s:1:\"B\";a:3:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:9:\"check.png\";s:4:\"name\";s:30:\"javascript:check_all(\'select\')\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:2;}}',NULL,'',1094025049),('resources.show.rows','','',0,'','a:1:{i:0;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:3:{i:0;a:4:{s:1:\"C\";s:2:\"3%\";s:2:\"c1\";s:3:\"nmh\";s:2:\"c2\";s:7:\"nmr,top\";s:1:\"F\";s:2:\"5%\";}i:1;a:6:{s:1:\"A\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"B\";a:4:{s:4:\"type\";s:4:\"vbox\";s:4:\"size\";s:1:\"2\";i:1;a:3:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:4:\"Name\";s:4:\"name\";s:4:\"name\";}i:2;a:3:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:17:\"Short description\";s:4:\"name\";s:17:\"short_description\";}}s:1:\"C\";a:4:{s:4:\"type\";s:4:\"vbox\";s:4:\"size\";s:1:\"2\";i:1;a:4:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:7:\"Useable\";s:4:\"name\";s:7:\"useable\";s:4:\"help\";s:36:\"How many of this resource are usable\";}i:2;a:4:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:8:\"Quantity\";s:4:\"name\";s:8:\"quantity\";s:4:\"help\";s:32:\"How many of this resource exists\";}}s:1:\"D\";a:4:{s:4:\"type\";s:4:\"vbox\";s:4:\"size\";s:1:\"2\";i:1;a:3:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:8:\"Category\";s:4:\"name\";s:6:\"cat_id\";}i:2;a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:13:\"Administrator\";}}s:1:\"E\";a:4:{s:4:\"type\";s:4:\"vbox\";s:4:\"size\";s:1:\"2\";i:1;a:3:{s:4:\"type\";s:20:\"nextmatch-sortheader\";s:5:\"label\";s:8:\"Location\";s:4:\"name\";s:8:\"location\";}i:2;a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:18:\"Storage Inforation\";}}s:1:\"F\";a:7:{s:4:\"type\";s:4:\"hbox\";s:4:\"size\";s:1:\"4\";i:1;a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:7:\"Actions\";}i:2;a:1:{s:4:\"type\";s:5:\"label\";}i:3;a:2:{s:4:\"type\";s:5:\"label\";s:6:\"needed\";s:1:\"1\";}s:5:\"align\";s:5:\"right\";i:4;a:11:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:9:\"check.png\";s:5:\"label\";s:9:\"Check all\";s:5:\"align\";s:5:\"right\";s:4:\"name\";s:9:\"check_all\";s:4:\"help\";s:9:\"Check all\";i:1;a:1:{s:4:\"type\";s:5:\"label\";}i:2;a:1:{s:4:\"type\";s:5:\"label\";}i:3;a:1:{s:4:\"type\";s:5:\"label\";}s:6:\"needed\";s:1:\"1\";s:7:\"onclick\";s:76:\"toggle_all(this.form,form::name(\'nm[rows][checkbox][]\'),true); return false;\";}}}i:2;a:6:{s:1:\"A\";a:5:{s:4:\"type\";s:6:\"button\";s:5:\"align\";s:6:\"center\";s:4:\"name\";s:21:\"${row}[picture_thumb]\";s:4:\"size\";s:24:\"$row_cont[picture_thumb]\";s:7:\"onclick\";s:216:\"window.open(egw::link(\'/index.php\',\'menuaction=resources.ui_resources.show&res_id=$row_cont[res_id]\'),\'\',\'dependent=yes,width=800,height=600,location=no,menubar=no,toolbar=no,scrollbars=yes,status=yes\');return false;\";}s:1:\"B\";a:4:{s:4:\"type\";s:4:\"vbox\";s:4:\"size\";s:1:\"2\";i:1;a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:12:\"${row}[name]\";}i:2;a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:25:\"${row}[short_description]\";}}s:1:\"C\";a:5:{s:4:\"type\";s:4:\"vbox\";s:4:\"size\";s:1:\"2\";s:5:\"align\";s:5:\"right\";i:1;a:4:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:5:\"align\";s:5:\"right\";s:4:\"name\";s:15:\"${row}[useable]\";}i:2;a:4:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:5:\"align\";s:5:\"right\";s:4:\"name\";s:16:\"${row}[quantity]\";}}s:1:\"D\";a:4:{s:4:\"type\";s:4:\"vbox\";s:4:\"size\";s:1:\"2\";i:1;a:4:{s:4:\"type\";s:10:\"select-cat\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:14:\"${row}[cat_id]\";s:8:\"readonly\";s:1:\"1\";}i:2;a:4:{s:4:\"type\";s:14:\"select-account\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:13:\"${row}[admin]\";s:8:\"readonly\";s:1:\"1\";}}s:1:\"E\";a:4:{s:4:\"type\";s:4:\"vbox\";s:4:\"size\";s:1:\"2\";i:1;a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:16:\"${row}[location]\";}i:2;a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:20:\"${row}[storage_info]\";}}s:1:\"F\";a:7:{s:4:\"type\";s:4:\"grid\";s:5:\"align\";s:5:\"right\";s:4:\"data\";a:3:{i:0;a:0:{}i:1;a:4:{s:1:\"A\";a:7:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:19:\"bookable,trams16x16\";s:5:\"label\";s:18:\"Book this resource\";s:5:\"align\";s:6:\"center\";s:4:\"help\";s:18:\"Book this resource\";s:7:\"onclick\";s:214:\"window.open(egw::link(\'/index.php\',\'menuaction=calendar.uiforms.edit&participants=r$cont[res_id]\'),\'\',\'dependent=yes,width=750,height=400,location=no,menubar=no,toolbar=no,scrollbars=yes,status=yes\'); return false;\";s:4:\"name\";s:23:\"bookable[$cont[res_id]]\";}s:1:\"B\";a:7:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:15:\"edit,trans16x16\";s:5:\"label\";s:4:\"Edit\";s:5:\"align\";s:6:\"center\";s:4:\"help\";s:15:\"Edit this entry\";s:7:\"onclick\";s:213:\"window.open(egw::link(\'/index.php\',\'menuaction=resources.ui_resources.edit&res_id=$cont[res_id]\'),\'\',\'dependent=yes,width=800,height=600,location=no,menubar=no,toolbar=no,scrollbars=yes,status=yes\'); return false;\";s:4:\"name\";s:19:\"edit[$cont[res_id]]\";}s:1:\"C\";a:7:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:14:\"new,trans16x16\";s:5:\"label\";s:38:\"Create new accessory for this resource\";s:5:\"align\";s:6:\"center\";s:4:\"name\";s:22:\"new_acc[$cont[res_id]]\";s:4:\"help\";s:38:\"Create new accessory for this resource\";s:7:\"onclick\";s:228:\"window.open(egw::link(\'/index.php\',\'menuaction=resources.ui_resources.edit&res_id=0&accessory_of=$cont[res_id]\'),\'\',\'dependent=yes,width=800,height=600,location=no,menubar=no,toolbar=no,scrollbars=yes,status=yes\'); return false;\";}s:1:\"D\";a:7:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:15:\"view,trans16x16\";s:5:\"label\";s:4:\"View\";s:5:\"align\";s:5:\"right\";s:4:\"name\";s:19:\"view[$cont[res_id]]\";s:4:\"help\";s:15:\"View this entry\";s:7:\"onclick\";s:213:\"window.open(egw::link(\'/index.php\',\'menuaction=resources.ui_resources.show&res_id=$cont[res_id]\'),\'\',\'dependent=yes,width=800,height=600,location=no,menubar=no,toolbar=no,scrollbars=yes,status=yes\'); return false;\";}}i:2;a:4:{s:1:\"A\";a:7:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:19:\"calendar,trans16x16\";s:5:\"label\";s:25:\"Show calendar of resource\";s:5:\"align\";s:6:\"center\";s:4:\"help\";s:25:\"Show calendar of resource\";s:4:\"name\";s:23:\"calendar[$cont[res_id]]\";s:7:\"onclick\";s:118:\"location=egw::link(\'/index.php\',\'menuaction=calendar.uiviews.planner&sortby=user&owner=r$cont[res_id]\'); return false;\";}s:1:\"B\";a:7:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:6:\"Delete\";s:5:\"align\";s:6:\"center\";s:4:\"name\";s:21:\"delete[$cont[res_id]]\";s:4:\"help\";s:17:\"Delete this entry\";s:7:\"onclick\";s:61:\"return confirm(\'Do you really want do delte this resource?\');\";s:4:\"size\";s:17:\"delete,trans16x16\";}s:1:\"C\";a:6:{s:4:\"type\";s:6:\"button\";s:4:\"size\";s:19:\"view_acc,trans16x16\";s:5:\"label\";s:34:\"View accessories for this resource\";s:5:\"align\";s:6:\"center\";s:4:\"name\";s:23:\"view_acc[$cont[res_id]]\";s:4:\"help\";s:34:\"View accessories for this resource\";}s:1:\"D\";a:4:{s:4:\"type\";s:8:\"checkbox\";s:5:\"align\";s:5:\"right\";s:4:\"name\";s:10:\"checkbox[]\";s:4:\"size\";s:13:\"$cont[res_id]\";}}}s:4:\"rows\";i:2;s:4:\"cols\";i:4;s:4:\"name\";s:6:\"${row}\";s:7:\"options\";a:0:{}}}}s:4:\"rows\";i:2;s:4:\"cols\";i:6;}}',NULL,'',1108922292),('resources.showdetails','','',0,'','a:1:{i:0;a:6:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:8:{i:0;a:8:{s:2:\"c1\";s:3:\"nmh\";s:1:\"B\";s:4:\"100%\";s:2:\"c5\";s:2:\"th\";s:2:\"h3\";s:2:\"1%\";s:2:\"c6\";s:11:\"row_off,top\";s:1:\"A\";s:3:\"43%\";s:2:\"h1\";s:5:\"240px\";s:2:\"h5\";s:10:\",@!link_to\";}i:1;a:2:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"image\";s:4:\"name\";s:16:\"resource_picture\";s:5:\"align\";s:6:\"center\";}s:1:\"B\";a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:9:{i:0;a:1:{s:2:\"c5\";s:4:\",top\";}i:1;a:2:{s:1:\"A\";a:3:{s:4:\"type\";s:5:\"label\";s:4:\"size\";s:1:\"b\";s:5:\"label\";s:5:\"Name:\";}s:1:\"B\";a:4:{s:4:\"type\";s:5:\"label\";s:4:\"size\";s:1:\"b\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:4:\"name\";}}i:2;a:2:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:17:\"Inventory number:\";}s:1:\"B\";a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:16:\"inventory_number\";}}i:3;a:2:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:9:\"Category:\";}s:1:\"B\";a:3:{s:4:\"type\";s:10:\"select-cat\";s:4:\"name\";s:6:\"cat_id\";s:8:\"readonly\";s:1:\"1\";}}i:4;a:2:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:13:\"Responsible: \";}s:1:\"B\";a:3:{s:4:\"type\";s:14:\"select-account\";s:4:\"name\";s:9:\"cat_admin\";s:8:\"readonly\";s:1:\"1\";}}i:5;a:2:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:10:\"Quantity: \";}s:1:\"B\";a:2:{s:4:\"type\";s:5:\"label\";s:4:\"name\";s:8:\"quantity\";}}i:6;a:2:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:8:\"Useable:\";}s:1:\"B\";a:2:{s:4:\"type\";s:5:\"label\";s:4:\"name\";s:7:\"useable\";}}i:7;a:2:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:9:\"Location:\";}s:1:\"B\";a:3:{s:4:\"type\";s:5:\"label\";s:7:\"no_lang\";s:1:\"1\";s:4:\"name\";s:8:\"location\";}}i:8;a:2:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:20:\"Storage information:\";}s:1:\"B\";a:2:{s:4:\"type\";s:5:\"label\";s:4:\"name\";s:12:\"storage_info\";}}}s:4:\"rows\";i:8;s:4:\"cols\";i:2;}}i:2;a:2:{s:1:\"A\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}i:3;a:2:{s:1:\"A\";a:4:{s:4:\"type\";s:4:\"html\";s:4:\"span\";s:1:\"2\";s:4:\"name\";s:11:\"description\";s:8:\"readonly\";s:1:\"1\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}i:4;a:2:{s:1:\"A\";a:1:{s:4:\"type\";s:5:\"label\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}i:5;a:2:{s:1:\"A\";a:6:{s:4:\"type\";s:5:\"label\";s:4:\"span\";s:1:\"2\";s:4:\"data\";a:2:{i:0;a:1:{s:1:\"A\";s:4:\"100%\";}i:1;a:4:{s:1:\"A\";a:2:{s:4:\"type\";s:5:\"label\";s:5:\"label\";s:13:\"Related links\";}s:1:\"B\";a:6:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:17:\"Buy this resource\";s:5:\"align\";s:5:\"right\";s:4:\"size\";s:7:\"buyable\";s:4:\"help\";s:17:\"Buy this resource\";s:4:\"name\";s:11:\"btn_buyable\";}s:1:\"C\";a:4:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:18:\"Book this resource\";s:4:\"name\";s:12:\"btn_bookable\";s:4:\"size\";s:8:\"bookable\";}s:1:\"D\";a:5:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:4:\"edit\";s:4:\"name\";s:8:\"btn_edit\";s:4:\"size\";s:4:\"edit\";s:4:\"help\";s:4:\"edit\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:4;s:5:\"label\";s:13:\"Related links\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}i:6;a:2:{s:1:\"A\";a:4:{s:4:\"type\";s:9:\"link-list\";s:4:\"span\";s:3:\"all\";s:4:\"name\";s:7:\"link_to\";s:8:\"readonly\";s:1:\"1\";}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}i:7;a:2:{s:1:\"A\";a:8:{s:4:\"type\";s:4:\"hbox\";s:5:\"label\";s:6:\"Cancel\";s:4:\"span\";s:1:\"2\";s:4:\"size\";s:1:\"2\";i:1;a:9:{s:4:\"type\";s:4:\"hbox\";s:5:\"label\";s:4:\"Edit\";s:4:\"span\";s:1:\"2\";s:4:\"name\";s:8:\"btn_edit\";s:4:\"size\";s:1:\"4\";i:1;a:5:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:4:\"Edit\";s:4:\"span\";s:1:\"2\";s:4:\"name\";s:8:\"btn_edit\";s:4:\"help\";s:16:\"Buy this article\";}i:2;a:3:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:6:\"Cancel\";s:7:\"onclick\";s:14:\"window.close()\";}i:3;a:6:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:8:\"Calendar\";s:4:\"span\";s:1:\"2\";s:4:\"name\";s:12:\"btn_calendar\";s:4:\"help\";s:25:\"Show calendar of resource\";s:7:\"onclick\";s:111:\"opener.location=egw::link(\'/index.php\',\'menuaction=calendar.uiviews.month&owner=r$cont[res_id]\'); return false;\";}i:4;a:5:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:4:\"Book\";s:7:\"onclick\";s:200:\"window.open(egw::link(\'/index.php\',\'menuaction=calendar.uiforms.edit&participants=r$cont[res_id]\'),\'\',\'dependent=yes,width=750,height=400,location=no,menubar=no,toolbar=no,scrollbars=yes,status=yes\');\";s:4:\"name\";s:8:\"btn_book\";s:4:\"help\";s:18:\"Book this resource\";}}i:2;a:4:{s:4:\"type\";s:4:\"hbox\";s:4:\"size\";s:1:\"1\";s:5:\"align\";s:5:\"right\";i:1;a:4:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:6:\"Delete\";s:7:\"onclick\";s:61:\"return confirm(\'Do you really want do delte this resource?\');\";s:4:\"name\";s:10:\"btn_delete\";}}i:3;a:1:{s:4:\"type\";s:5:\"label\";}i:4;a:4:{s:4:\"type\";s:6:\"button\";s:5:\"label\";s:6:\"Delete\";s:4:\"name\";s:10:\"btn_delete\";s:5:\"align\";s:5:\"right\";}}s:1:\"B\";a:1:{s:4:\"type\";s:5:\"label\";}}}s:4:\"rows\";i:7;s:4:\"cols\";i:2;s:4:\"size\";s:7:\"750,480\";s:7:\"options\";a:2:{i:0;s:3:\"750\";i:1;s:3:\"480\";}}}','750,480','',1129667646),('.resources','','##',0,'','a:1:{i:0;a:4:{s:4:\"type\";s:4:\"grid\";s:4:\"data\";a:2:{i:0;a:0:{}i:1;a:1:{s:1:\"A\";a:1:{s:4:\"type\";s:5:\"label\";}}}s:4:\"rows\";i:1;s:4:\"cols\";i:1;}}','','',1153034846);
CREATE TABLE `egw_felamimail_cache` (
  `fmail_accountid` int(11) NOT NULL default '0',
  `fmail_hostname` varchar(60) NOT NULL default '',
  `fmail_accountname` varchar(128) NOT NULL default '',
  `fmail_foldername` varchar(128) NOT NULL default '',
  `fmail_uid` int(11) NOT NULL default '0',
  `fmail_subject` text,
  `fmail_striped_subject` text,
  `fmail_sender_name` varchar(120) default NULL,
  `fmail_sender_address` varchar(120) default NULL,
  `fmail_to_name` varchar(120) default NULL,
  `fmail_to_address` varchar(120) default NULL,
  `fmail_date` bigint(20) default NULL,
  `fmail_size` int(11) default NULL,
  `fmail_attachments` varchar(120) default NULL,
  PRIMARY KEY  (`fmail_accountid`,`fmail_hostname`,`fmail_accountname`,`fmail_foldername`,`fmail_uid`)
) TYPE=MyISAM;
CREATE TABLE `egw_felamimail_displayfilter` (
  `fmail_filter_accountid` int(11) NOT NULL default '0',
  `fmail_filter_data` text,
  PRIMARY KEY  (`fmail_filter_accountid`)
) TYPE=MyISAM;
CREATE TABLE `egw_felamimail_folderstatus` (
  `fmail_accountid` int(11) NOT NULL default '0',
  `fmail_hostname` varchar(60) NOT NULL default '',
  `fmail_accountname` varchar(128) NOT NULL default '',
  `fmail_foldername` varchar(128) NOT NULL default '',
  `fmail_messages` int(11) default NULL,
  `fmail_recent` int(11) default NULL,
  `fmail_unseen` int(11) default NULL,
  `fmail_uidnext` int(11) default NULL,
  `fmail_uidvalidity` int(11) default NULL,
  PRIMARY KEY  (`fmail_accountid`,`fmail_hostname`,`fmail_accountname`,`fmail_foldername`)
) TYPE=MyISAM;
CREATE TABLE `egw_history_log` (
  `history_id` int(11) NOT NULL auto_increment,
  `history_record_id` int(11) NOT NULL default '0',
  `history_appname` varchar(64) NOT NULL default '',
  `history_owner` int(11) NOT NULL default '0',
  `history_status` char(2) NOT NULL default '',
  `history_new_value` text,
  `history_timestamp` timestamp NOT NULL,
  `history_old_value` text,
  PRIMARY KEY  (`history_id`),
  KEY `egw_history_log_appname_record_id_status_timestamp` (`history_appname`,`history_record_id`,`history_status`,`history_timestamp`)
) TYPE=MyISAM;
CREATE TABLE `egw_hooks` (
  `hook_id` int(11) NOT NULL auto_increment,
  `hook_appname` varchar(255) default NULL,
  `hook_location` varchar(255) default NULL,
  `hook_filename` varchar(255) default NULL,
  PRIMARY KEY  (`hook_id`)
) TYPE=MyISAM AUTO_INCREMENT=130;
INSERT INTO `egw_hooks` VALUES (1,'admin','acl_manager','hook_acl_manager.inc.php'),(2,'admin','add_def_pref','hook_add_def_pref.inc.php'),(3,'admin','admin','hook_admin.inc.php'),(4,'admin','after_navbar','hook_after_navbar.inc.php'),(5,'admin','config','hook_config.inc.php'),(6,'admin','deleteaccount','hook_deleteaccount.inc.php'),(7,'admin','view_user','admin.uiaccounts.edit_view_user_hook'),(8,'admin','edit_user','admin.uiaccounts.edit_view_user_hook'),(9,'admin','group_manager','admin.uiaccounts.edit_group_hook'),(10,'admin','sidebox_menu','hook_sidebox_menu.inc.php'),(11,'preferences','deleteaccount','hook_deleteaccount.inc.php'),(12,'preferences','config','hook_config.inc.php'),(13,'preferences','preferences','hook_preferences.inc.php'),(14,'preferences','settings','hook_settings.inc.php'),(15,'preferences','edit_user','preferences.uisettings.edit_user'),(16,'home','hasUpdates','home.updates.hasUpdates'),(17,'home','showUpdates','home.updates.showUpdates'),(18,'notifywindow','home','hook_home.inc.php'),(19,'bookmarks','admin','hook_admin.inc.php'),(20,'bookmarks','preferences','hook_preferences.inc.php'),(21,'bookmarks','sidebox_menu','hook_sidebox_menu.inc.php'),(22,'emailadmin','admin','hook_admin.inc.php'),(23,'etemplate','sidebox_menu','hook_sidebox_menu.inc.php'),(24,'filemanager','deleteaccount','hook_deleteaccount.inc.php'),(25,'filemanager','settings','hook_settings.inc.php'),(26,'filemanager','sidebox_menu','hook_sidebox_menu.inc.php'),(27,'filemanager','preferences','hook_preferences.inc.php'),(28,'mydms','sidebox_menu','hook_sidebox_menu.inc.php'),(29,'news_admin','admin','hook_admin.inc.php'),(30,'news_admin','home','hook_home.inc.php'),(31,'news_admin','sidebox_menu','hook_sidebox_menu.inc.php'),(32,'news_admin','settings','hook_settings.inc.php'),(33,'news_admin','preferences','hook_preferences.inc.php'),(34,'phpbrain','about','hook_about.inc.php'),(35,'phpbrain','admin','hook_admin.inc.php'),(36,'phpbrain','add_def_pref','hook_add_def_pref.inc.php'),(37,'phpbrain','config','hook_config.inc.php'),(38,'phpbrain','preferences','hook_preferences.inc.php'),(39,'phpbrain','settings','hook_settings.inc.php'),(40,'phpbrain','sidebox_menu','hook_sidebox_menu.inc.php'),(41,'phpbrain','deleteaccount','hook_deleteaccount.inc.php'),(42,'phpsysinfo','admin','hook_admin.inc.php'),(43,'polls','admin','hook_admin.inc.php'),(44,'polls','sidebox_menu','hook_sidebox_menu.inc.php'),(45,'registration','admin','hook_admin.inc.php'),(46,'registration','logout','hook_logout.inc.php'),(47,'sambaadmin','edit_user','hook_edit_user.inc.php'),(48,'sambaadmin','admin','hook_admin.inc.php'),(49,'sambaadmin','changepassword','hook_changepassword.inc.php'),(50,'sambaadmin','addaccount','sambaadmin.bosambaadmin.updateAccount'),(51,'sambaadmin','editaccount','sambaadmin.bosambaadmin.updateAccount'),(52,'sambaadmin','editgroup','sambaadmin.bosambaadmin.updateGroup'),(53,'workflow','about','hook_about.inc.php'),(54,'workflow','admin','hook_admin.inc.php'),(55,'workflow','add_def_pref','hook_add_def_pref.inc.php'),(56,'workflow','config','hook_config.inc.php'),(57,'workflow','manual','hook_manual.inc.php'),(58,'workflow','preferences','hook_preferences.inc.php'),(59,'workflow','settings','hook_settings.inc.php'),(60,'workflow','sidebox_menu','hook_sidebox_menu.inc.php'),(61,'workflow','acl_manager','hook_acl_manager.inc.php'),(62,'workflow','deleteaccount','hook_deleteaccount.inc.php'),(63,'addressbook','admin','hook_admin.inc.php'),(64,'addressbook','add_def_pref','hook_add_def_pref.inc.php'),(65,'addressbook','config_validate','hook_config_validate.inc.php'),(66,'addressbook','home','hook_home.inc.php'),(67,'addressbook','addaccount','hook_addaccount.inc.php'),(68,'addressbook','editaccount','hook_editaccount.inc.php'),(69,'addressbook','deleteaccount','hook_deleteaccount.inc.php'),(70,'addressbook','notifywindow','hook_notifywindow.inc.php'),(71,'addressbook','sidebox_menu','hook_sidebox_menu.inc.php'),(72,'addressbook','preferences','hook_preferences.inc.php'),(73,'calendar','add_def_prefs','hook_add_def_prefs.inc.php'),(74,'calendar','admin','hook_admin.inc.php'),(75,'calendar','deleteaccount','hook_deleteaccount.inc.php'),(76,'calendar','home','hook_home.inc.php'),(77,'calendar','preferences','hook_preferences.inc.php'),(78,'calendar','settings','hook_settings.inc.php'),(79,'calendar','sidebox_menu','calendar.uical.sidebox_menu'),(80,'calendar','search_link','calendar.bocal.search_link'),(81,'felamimail','preferences','hook_preferences.inc.php'),(82,'felamimail','settings','hook_settings.inc.php'),(83,'felamimail','home','hook_home.inc.php'),(84,'felamimail','sidebox_menu','hook_sidebox_menu.inc.php'),(85,'felamimail','notifywindow','hook_notifywindow.inc.php'),(86,'felamimail','addaccount','felamimail.bofelamimail.addAccount'),(87,'felamimail','deleteaccount','felamimail.bofelamimail.deleteAccount'),(88,'felamimail','editaccount','felamimail.bofelamimail.updateAccount'),(89,'felamimail','edit_user','felamimail.bofelamimail.adminMenu'),(90,'infolog','preferences','infolog.admin_prefs_sidebox_hooks.all_hooks'),(91,'infolog','settings','hook_settings.inc.php'),(92,'infolog','admin','infolog.admin_prefs_sidebox_hooks.all_hooks'),(93,'infolog','deleteaccount','hook_deleteaccount.inc.php'),(94,'infolog','home','hook_home.inc.php'),(95,'infolog','addressbook_view','infolog.uiinfolog.hook_view'),(96,'infolog','projects_view','infolog.uiinfolog.hook_view'),(97,'infolog','calendar_view','infolog.uiinfolog.hook_view'),(98,'infolog','infolog','infolog.uiinfolog.hook_view'),(99,'infolog','calendar_include_events','infolog.boinfolog.cal_to_include'),(100,'infolog','calendar_include_todos','infolog.boinfolog.cal_to_include'),(101,'infolog','sidebox_menu','infolog.admin_prefs_sidebox_hooks.all_hooks'),(102,'infolog','search_link','infolog.infolog_link_registry.search_link'),(103,'infolog','pm_custom_app_icons','infolog.boinfolog.pm_icons'),(104,'projectmanager','preferences','projectmanager.pm_admin_prefs_sidebox_hooks.all_hooks'),(105,'projectmanager','settings','projectmanager.pm_admin_prefs_sidebox_hooks.settings'),(106,'projectmanager','admin','projectmanager.pm_admin_prefs_sidebox_hooks.all_hooks'),(107,'projectmanager','sidebox_menu','projectmanager.pm_admin_prefs_sidebox_hooks.all_hooks'),(108,'projectmanager','search_link','projectmanager.boprojectmanager.search_link'),(109,'resources','preferences','resources.resources_hooks.admin_prefs_sidebox'),(110,'resources','admin','resources.resources_hooks.admin_prefs_sidebox'),(111,'resources','sidebox_menu','resources.resources_hooks.admin_prefs_sidebox'),(112,'resources','search_link','resources.resources_hooks.search_link'),(113,'resources','calendar_resources','resources.resources_hooks.calendar_resources'),(114,'sitemgr','preferences','hook_preferences.inc.php'),(115,'sitemgr','about','hook_about.inc.php'),(116,'sitemgr','admin','hook_admin.inc.php'),(117,'sitemgr','sidebox_menu','hook_sidebox_menu.inc.php'),(118,'timesheet','preferences','timesheet.ts_admin_prefs_sidebox_hooks.all_hooks'),(119,'timesheet','settings','timesheet.ts_admin_prefs_sidebox_hooks.settings'),(120,'timesheet','admin','timesheet.ts_admin_prefs_sidebox_hooks.all_hooks'),(121,'timesheet','sidebox_menu','timesheet.ts_admin_prefs_sidebox_hooks.all_hooks'),(122,'timesheet','search_link','timesheet.botimesheet.search_link'),(123,'wiki','admin','hook_admin.inc.php'),(124,'wiki','sidebox_menu','hook_sidebox_menu.inc.php'),(125,'wiki','config_validate','hook_config_validate.inc.php'),(126,'wiki','search_link','wiki.bowiki.search_link'),(127,'manual','admin','manual.uimanualadmin.menu'),(128,'manual','config','manual.uimanualadmin.config'),(129,'manual','config_validate','manual.uimanualadmin.config');
CREATE TABLE `egw_infolog` (
  `info_id` int(11) NOT NULL auto_increment,
  `info_type` varchar(40) NOT NULL default 'task',
  `info_from` varchar(255) default NULL,
  `info_addr` varchar(255) default NULL,
  `info_subject` varchar(255) default NULL,
  `info_des` text,
  `info_owner` int(11) NOT NULL default '0',
  `info_responsible` varchar(255) NOT NULL default '0',
  `info_access` varchar(10) default 'public',
  `info_cat` int(11) NOT NULL default '0',
  `info_datemodified` bigint(20) NOT NULL default '0',
  `info_startdate` bigint(20) NOT NULL default '0',
  `info_enddate` bigint(20) NOT NULL default '0',
  `info_id_parent` int(11) NOT NULL default '0',
  `info_planned_time` int(11) NOT NULL default '0',
  `info_used_time` int(11) NOT NULL default '0',
  `info_status` varchar(40) default 'done',
  `info_confirm` varchar(10) default 'not',
  `info_modifier` int(11) NOT NULL default '0',
  `info_link_id` int(11) NOT NULL default '0',
  `info_priority` smallint(6) default '1',
  `pl_id` int(11) default NULL,
  `info_price` double default NULL,
  `info_percent` smallint(6) default '0',
  `info_datecompleted` bigint(20) default NULL,
  `info_location` varchar(255) default NULL,
  PRIMARY KEY  (`info_id`),
  KEY `egw_infolog_owner_responsible_status_startdate` (`info_owner`,`info_responsible`,`info_status`,`info_startdate`),
  KEY `egw_infolog_id_parent_owner_responsible_status_startdate` (`info_id_parent`,`info_owner`,`info_responsible`,`info_status`,`info_startdate`)
) TYPE=MyISAM;
CREATE TABLE `egw_infolog_extra` (
  `info_id` int(11) NOT NULL default '0',
  `info_extra_name` varchar(32) NOT NULL default '',
  `info_extra_value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`info_id`,`info_extra_name`)
) TYPE=MyISAM;
CREATE TABLE `egw_interserv` (
  `server_id` int(11) NOT NULL auto_increment,
  `server_name` varchar(64) default NULL,
  `server_host` varchar(255) default NULL,
  `server_url` varchar(255) default NULL,
  `trust_level` int(11) default NULL,
  `trust_rel` int(11) default NULL,
  `username` varchar(64) default NULL,
  `password` varchar(255) default NULL,
  `admin_name` varchar(255) default NULL,
  `admin_email` varchar(255) default NULL,
  `server_mode` varchar(16) NOT NULL default 'xmlrpc',
  `server_security` varchar(16) default NULL,
  PRIMARY KEY  (`server_id`)
) TYPE=MyISAM AUTO_INCREMENT=2;
INSERT INTO `egw_interserv` VALUES (1,'eGW demo',NULL,'http://www.egroupware.org/egroupware/xmlrpc.php',99,0,NULL,NULL,NULL,NULL,'xmlrpc',NULL);
CREATE TABLE `egw_lang` (
  `lang` varchar(5) NOT NULL default '',
  `app_name` varchar(32) NOT NULL default 'common',
  `message_id` varchar(128) NOT NULL default '',
  `content` text,
  PRIMARY KEY  (`lang`,`app_name`,`message_id`)
) TYPE=MyISAM;
INSERT INTO `egw_lang` VALUES ('en','addressbook','%1 records imported','%1 records imported'),('en','addressbook','%1 records read (not yet imported, you may go %2back%3 and uncheck test import)','%1 records read (not yet imported, you may go %2back%3 and uncheck Test Import)'),('en','addressbook','(e.g. 1969)','(e.g. 1969)'),('en','addressbook','<b>no conversion type &lt;none&gt; could be located.</b>  please choose a conversion type from the list','<b>No conversion type &lt;none&gt; could be located.</b>  Please choose a conversion type from the list'),('en','addressbook','@-eval() is only availible to admins!!!','@-eval() is only availible to admins!!!'),('en','addressbook','actions','Actions'),('en','addressbook','add a single entry by passing the fields.','Add a single entry by passing the fields.'),('en','addressbook','add custom field','Add Custom Field'),('en','addressbook','address book - vcard in','Address book - VCard in'),('en','addressbook','address book - view','Address book - view'),('en','addressbook','address line 2','Address Line 2'),('en','addressbook','address line 3','Address Line 3'),('en','addressbook','address type','Address Type'),('en','addressbook','addressbook preferences','Addressbook preferences'),('en','addressbook','addressbook-fieldname','Addressbook-Fieldname'),('en','addressbook','addvcard','Add VCard'),('en','addressbook','advanced search','Advanced search'),('en','addressbook','alt. csv import','Alt. CSV Import'),('en','addressbook','are you shure you want to delete this contact?','Are you shure you want to delete this contact?'),('en','addressbook','are you sure you want to delete this field?','Are you sure you want to delete this field?'),('en','addressbook','bbs phone','BBS Phone'),('en','addressbook','blank','Blank'),('en','addressbook','business address type','Business Address Type'),('en','addressbook','business city','Business City'),('en','addressbook','business country','Business Country'),('en','addressbook','business email','Business EMail'),('en','addressbook','business email type','Business EMail Type'),('en','addressbook','business fax','Business Fax'),('en','addressbook','business phone','Business Phone'),('en','addressbook','business state','Business State'),('en','addressbook','business street','Business Street'),('en','addressbook','business zip code','Business Postal Code'),('en','addressbook','car phone','Car Phone'),('en','addressbook','cell phone','Mobile phone'),('en','addressbook','charset of file','Charset of file'),('en','addressbook','choose an icon for this contact type','Choose an icon for this contact type'),('en','addressbook','chosse an etemplate for this contact type','Chosse an eTemplate for this contact type'),('en','addressbook','contact saved','Contact saved'),('en','addressbook','copied by %1, from record #%2.','Copied by %1, from record #%2.'),('en','addressbook','create new links','Create new links'),('en','addressbook','credit','Credit'),('en','addressbook','csv-fieldname','CSV-Fieldname'),('en','addressbook','csv-filename','CSV-Filename'),('en','addressbook','custom','Custom'),('en','addressbook','custom fields','Custom Fields'),('en','addressbook','debug output in browser','Debug output in browser'),('en','addressbook','default filter','Default Filter'),('en','addressbook','delete a single entry by passing the id.','Delete a single entry by passing the id.'),('en','addressbook','do your really want to delete this contact?','Do your really want to delete this contact?'),('en','addressbook','doesn\'t matter','doesn\'t matter'),('en','addressbook','domestic','Domestic'),('en','addressbook','download','Download'),('en','addressbook','download export file (uncheck to debug output in browser)','Download export file (Uncheck to debug output in browser)'),('en','addressbook','download this contact as vcard file','download this contact as vCard file'),('en','addressbook','edit custom field','Edit Custom Field'),('en','addressbook','edit phonenumbers -','Edit Phonenumbers -'),('en','addressbook','email & internet','Email & Internet'),('en','addressbook','empty for all','empty for all'),('en','addressbook','enter the path to the exported file here','Enter the path to the exported file here'),('en','addressbook','existing links','Existing links'),('en','addressbook','export','export'),('en','addressbook','export contacts','Export Contacts'),('en','addressbook','export file name','Export file name'),('en','addressbook','export from addressbook','Export from Addressbook'),('en','addressbook','extra','Extra'),('en','addressbook','fax','Fax'),('en','addressbook','field %1 has been added !','Field %1 has been added !'),('en','addressbook','field %1 has been updated !','Field %1 has been updated !'),('en','addressbook','field name','Field Name'),('en','addressbook','fields to show in address list','Fields to show in address list'),('en','addressbook','fieldseparator','Fieldseparator'),('en','addressbook','full name','Full Name'),('en','addressbook','geo','GEO'),('en','addressbook','global categories','Global Categories'),('en','addressbook','home address type','Home Address Type'),('en','addressbook','home city','Home City'),('en','addressbook','home country','Home Country'),('en','addressbook','home email','Home EMail'),('en','addressbook','home email type','Home EMail Type'),('en','addressbook','home phone','Home Phone'),('en','addressbook','home state','Home State'),('en','addressbook','home street','Home Street'),('en','addressbook','home zip code','Home ZIP Code'),('en','addressbook','icon','Icon'),('en','addressbook','import','Import'),('en','addressbook','import contacts','Import Contacts'),('en','addressbook','import csv-file into addressbook','Import CSV-File into Addressbook'),('en','addressbook','import file','Import File'),('en','addressbook','import from','Import from'),('en','addressbook','import from ldif, csv, or vcard','Import from LDIF, CSV, or VCard'),('en','addressbook','import from outlook','Import from Outlook'),('en','addressbook','import multiple vcard','Import Multiple VCard'),('en','addressbook','import next set','Import next set'),('en','addressbook','import_instructions','In Netscape, open the Addressbook and select <b>Export</b> from the <b>File</b> menu.  The file exported will be in LDIF format.<p>Or, in Outlook, select your Contacts folder, select <b>Import and Export...</b> from the <b>File</b> menu and export your contacts into a comma separated text (CSV) file.  <p>Or, in Palm Desktop 4.0 or greater, visit your addressbook and select <b>Export</b> from the <b>File</b> menu.  The file exported will be in VCard format.'),('en','addressbook','income','Income'),('en','addressbook','international','International'),('en','addressbook','isdn phone','ISDN Phone'),('en','addressbook','label','Label'),('en','addressbook','last modified','last modified'),('en','addressbook','ldif','LDIF'),('en','addressbook','line 2','Line 2'),('en','addressbook','links','Links'),('en','addressbook','list all categories','List all categories'),('en','addressbook','list all customfields','List all customfields'),('en','addressbook','load vcard','Load VCard'),('en','addressbook','mark records as private','Mark records as private'),('en','addressbook','message phone','Message Phone'),('en','addressbook','middle name','Middle Name'),('en','addressbook','mobile','Mobile'),('en','addressbook','mobile phone','Mobile Phone'),('en','addressbook','modem phone','Modem Phone'),('en','addressbook','more ...','More ...'),('en','addressbook','multiple vcard','Multiple VCard'),('en','addressbook','no vcard','No VCard'),('en','addressbook','number','Number'),('en','addressbook','number of records to read (%1)','Number of records to read (%1)'),('en','addressbook','options for type','Options for type'),('en','addressbook','organisation','organisation'),('en','addressbook','other number','Other Number'),('en','addressbook','other phone','Other Phone'),('en','addressbook','parcel','Parcel'),('en','addressbook','please enter a name for that field !','Please enter a name for that field !'),('en','addressbook','pref','pref'),('en','addressbook','prefix','Prefix'),('en','addressbook','public key','Public Key'),('en','addressbook','publish into groups:','Publish into groups:'),('en','addressbook','read a list / search for entries.','Read a list / search for entries.'),('en','addressbook','read a list of entries.','Read a list of entries.'),('en','addressbook','read a single entry by passing the id and fieldlist.','Read a single entry by passing the id and fieldlist.'),('en','addressbook','record access','Record Access'),('en','addressbook','record owner','Record owner'),('en','addressbook','select all','Select all'),('en','addressbook','select the type of conversion','Select the type of conversion'),('en','addressbook','select the type of conversion:','Select the type of conversion:'),('en','addressbook','show','Show'),('en','addressbook','show birthday reminders on main screen','Show birthday reminders on main screen'),('en','addressbook','something went wrong by deleting %1','Something went wrong by deleting %1'),('en','addressbook','something went wrong by deleting this contact','Something went wrong by deleting this contact'),('en','addressbook','something went wrong by reading this contact','something went wrong by reading this contact'),('en','addressbook','something went wrong by saving this contact. errorcode %1','Something went wrong by saving this contact. Errorcode %1'),('en','addressbook','startrecord','Startrecord'),('en','addressbook','successfully imported %1 records into your addressbook.','Successfully imported %1 record(s) into your addressbook.'),('en','addressbook','suffix','Suffix'),('en','addressbook','tel home','tel home'),('en','addressbook','test import (show importable records <u>only</u> in browser)','Test Import (show importable records <u>only</u> in browser)'),('en','addressbook','that field name has been used already !','That field name has been used already !'),('en','addressbook','this person\'s first name was not in the address book.','This person\'s first name was not in the address book.'),('en','addressbook','this person\'s last name was not in the address book.','This person\'s last name was not in the address book.'),('en','addressbook','to many might exceed your execution-time-limit','to many might exceed your execution-time-limit'),('en','addressbook','translation','Translation'),('en','addressbook','update a single entry by passing the fields.','Update a single entry by passing the fields.'),('en','addressbook','use country list','Use Country List'),('en','addressbook','vcards require a first name entry.','VCards require a first name entry.'),('en','addressbook','vcards require a last name entry.','Vcards require a last name entry.'),('en','addressbook','video phone','Video Phone'),('en','addressbook','voice phone','Voice Phone'),('en','addressbook','warning: all contacts found will be deleted!','WARNING: All contacts found will be deleted!'),('en','addressbook','work phone','Work Phone'),('en','addressbook','write (update or add) a single entry by passing the fields.','Write (update or add) a single entry by passing the fields.'),('en','addressbook','you are not permitted to delete contact %1','You are not permitted to delete contact %1'),('en','addressbook','you are not permittet to delete this contact','You are not permittet to delete this contact'),('en','addressbook','you are not permittet to edit this contact','You are not permittet to edit this contact'),('en','addressbook','you are not permittet to view this contact','you are not permittet to view this contact'),('en','addressbook','you must select a vcard. (*.vcf)','You must select a vcard. (*.vcf)'),('en','addressbook','you must select at least 1 column to display','You must select at least 1 column to display'),('en','addressbook','zip_note','<p><b>Note:</b> The file may be a zip file collection of .csv, .vcf, or .ldif files.  However, do not mix file types per import.'),('en','common','address book','Address Book'),('en','common','addressbook','Addressbook'),('en','common','birthday','Birthday'),('en','common','birthdays','Birthdays'),('en','common','business','Business'),('en','common','city','City'),('en','common','company','Company'),('en','common','company name','Company Name'),('en','common','configuration','Configuration'),('en','common','contact','Contact'),('en','common','country','Country'),('en','common','department','Department'),('en','common','fax number','fax number'),('en','common','grant addressbook access','Grant Addressbook Access'),('en','common','pager','Pager'),('en','common','phone number','phone number'),('en','common','phone numbers','Phone Numbers'),('en','common','postal','Postal'),('en','common','state','State'),('en','common','street','Street'),('en','common','today is %1\'s birthday!','Today is %1\'s birthday!'),('en','common','tomorrow is %1\'s birthday.','Tomorrow is %1\'s birthday.'),('en','common','vcard','VCard'),('en','common','zip code','ZIP Code'),('en','common','account has been created','Account has been created'),('en','common','account has been deleted','Account has been deleted'),('en','common','account has been updated','Account has been updated'),('en','common','acl rights','ACL Rights'),('en','common','are you sure you want to delete this category ?','Are you sure you want to delete this category ?'),('en','common','global categories','Global Categories'),('en','common','group has been added','Group has been added'),('en','common','group has been deleted','Group has been deleted'),('en','common','group has been updated','Group has been updated'),('en','common','installed applications','Installed applications'),('en','common','login history','Login History'),('en','common','site configuration','Site configuration'),('en','common','book marks','Book marks'),('en','common','bookmarks','Bookmarks'),('en','common','export bookmarks','Export Bookmarks'),('en','common','import bookmarks','Import bookmarks'),('en','common','custom fields','Custom fields'),('en','common','import csv-file','Import CSV-File'),('en','common','developer_tools','Translation Tools'),('en','common','etemplate','eTemplate'),('en','common','felamimail','FelaMiMail'),('en','common','manage folders','Manage Folders'),('en','common','manage sieve','Manage Sieve scripts'),('en','common','new','New'),('en','common','unread','Unread'),('en','common','filemanager','Filemanager'),('en','common','csv-import','CSV-Import'),('en','common','custom fields, typ and status','Custom fields, type and status'),('en','common','info log','InfoLog'),('en','common','infolog','InfoLog'),('en','common','infolog preferences','InfoLog preferences'),('en','common','manual','Manual / Help'),('en','common','mydms','mydms'),('en','common','configure access permissions','Configure Access Permissions'),('en','common','configure rss exports','Configure RSS exports'),('en','common','news_admin','News Admin'),('en','common','submitted by','Submitted by'),('en','common','have to be approved first','Have to be approved first'),('en','common','knowledge base configuration','Knowledge Base configuration'),('en','common','phpbrain','Knowledge Base'),('en','common','publish articles automatically?','Publish articles automatically?'),('en','common','publish comments automatically?','Publish comments automatically?'),('en','common','publish questions automatically?','Publish questions automatically'),('en','common','%1 email addresses inserted','%1 email addresses inserted'),('en','common','%1 is not executable by the webserver !!!','%1 is not executable by the webserver !!!'),('en','common','%1 manual','%1 manual'),('en','common','%1 start','%1 start'),('en','common','%1choose an other directory%2<br />or make %3 writeable by webserver','%1Choose an other directory%2<br />or make %3 writeable by webserver'),('en','common','%1egroupware%2 is a multi-user, web-based groupware suite written in %3php%4.','%1eGroupWare%2 is a multi-user, web-based groupware suite written in %3PHP%4.'),('en','common','about','About'),('en','common','about %1','About %1'),('en','common','about egroupware','About eGroupware'),('en','common','access','Access'),('en','common','access not permitted','Access not permitted'),('en','common','account is expired','Account is expired'),('en','common','acl','ACL'),('en','common','action','Action'),('en','common','active','Active'),('en','common','add','Add'),('en','common','add %1 category for','Add %1 category for'),('en','common','add category','Add category'),('en','common','add shortcut','Add Shortcut'),('en','common','add sub','Add sub'),('en','common','admin','Admin'),('en','common','administration','Administration'),('en','common','afghanistan','AFGHANISTAN'),('en','common','albania','ALBANIA'),('en','common','algeria','ALGERIA'),('en','common','all','All'),('en','common','all fields','all fields'),('en','common','alphabet','a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z'),('en','common','alternate style-sheet:','Alternate style-sheet:'),('en','common','american samoa','AMERICAN SAMOA'),('en','common','andorra','ANDORRA'),('en','common','angola','ANGOLA'),('en','common','anguilla','ANGUILLA'),('en','common','antarctica','ANTARCTICA'),('en','common','antigua and barbuda','ANTIGUA AND BARBUDA'),('en','common','application','Application'),('en','common','apply','Apply'),('en','common','april','April'),('en','common','are you sure you want to delete these entries ?','Are you sure you want to delete these entries ?'),('en','common','are you sure you want to delete this entry ?','Are you sure you want to delete this entry ?'),('en','common','argentina','ARGENTINA'),('en','common','armenia','ARMENIA'),('en','common','aruba','ARUBA'),('en','common','august','August'),('en','common','australia','AUSTRALIA'),('en','common','austria','AUSTRIA'),('en','common','author','Author'),('en','common','autohide sidebox menu\'s','Autohide Sidebox menu\'s'),('en','common','autohide sidebox menus','Autohide Sidebox menus'),('en','common','automatically hide the sidebox menu\'s?','Automatically hide the Sidebox menu\'s?'),('en','common','automatically hide the sidebox menus?','Automatically hide the Sidebox menus?'),('en','common','autosave default category','Autosave Default Category'),('en','common','azerbaijan','AZERBAIJAN'),('en','common','back','Back'),('en','common','back to user login','Back to user login'),('en','common','background color:','Background color:'),('en','common','backupdir \'%1\' is not writeable by the webserver','backupdir \'%1\' is not writeable by the webserver'),('en','common','bad login or password','Bad login or password'),('en','common','bahamas','BAHAMAS'),('en','common','bahrain','BAHRAIN'),('en','common','bangladesh','BANGLADESH'),('en','common','barbados','BARBADOS'),('en','common','bcc','Bcc'),('en','common','belarus','BELARUS'),('en','common','belgium','BELGIUM'),('en','common','belize','BELIZE'),('en','common','benin','BENIN'),('en','common','bermuda','BERMUDA'),('en','common','bhutan','BHUTAN'),('en','common','blocked, too many attempts','Blocked, too many attempts'),('en','common','bold','Bold'),('en','common','bold.gif','bold.gif'),('en','common','bolivia','BOLIVIA'),('en','common','border','Border'),('en','common','bosnia and herzegovina','BOSNIA AND HERZEGOVINA'),('en','common','botswana','BOTSWANA'),('en','common','bottom','Bottom'),('en','common','bouvet island','BOUVET ISLAND'),('en','common','brazil','BRAZIL'),('en','common','british indian ocean territory','BRITISH INDIAN OCEAN TERRITORY'),('en','common','brunei darussalam','BRUNEI DARUSSALAM'),('en','common','bulgaria','BULGARIA'),('en','common','burkina faso','BURKINA FASO'),('en','common','burundi','BURUNDI'),('en','common','calendar','Calendar'),('en','common','cambodia','CAMBODIA'),('en','common','cameroon','CAMEROON'),('en','common','canada','CANADA'),('en','common','cancel','Cancel'),('en','common','cannot replace %1 because it is a directory','Cannot replace %1 because it is a directory'),('en','common','cant open \'%1\' for %2','Cant open \'%1\' for %2'),('en','common','cape verde','CAPE VERDE'),('en','common','caption','Caption'),('en','common','categories','Categories'),('en','common','categories for','categories for'),('en','common','category','Category'),('en','common','category %1 has been added !','Category %1 has been added !'),('en','common','category %1 has been updated !','Category %1 has been updated !'),('en','common','cayman islands','CAYMAN ISLANDS'),('en','common','cc','Cc'),('en','common','centered','centered'),('en','common','central african republic','CENTRAL AFRICAN REPUBLIC'),('en','common','chad','CHAD'),('en','common','change','Change'),('en','common','charset','iso-8859-1'),('en','common','check installation','Check installation'),('en','common','check now','Check Now'),('en','common','chile','CHILE'),('en','common','china','CHINA'),('en','common','choose a background color','Choose a background color'),('en','common','choose a background color for the icons','Choose a background color for the icons'),('en','common','choose a background image.','Choose a background image.'),('en','common','choose a background style.','Choose a background style.'),('en','common','choose a text color for the icons','Choose a text color for the icons'),('en','common','choose the category','Choose the category'),('en','common','choose the parent category','Choose the parent category'),('en','common','christmas island','CHRISTMAS ISLAND'),('en','common','clear','Clear'),('en','common','clear form','Clear Form'),('en','common','click','Click'),('en','common','click or mouse over to show menus','Click or Mouse Over to show menus'),('en','common','click or mouse over to show menus?','Click or Mouse Over to show menus?'),('en','common','close','Close'),('en','common','close sidebox','Close sidebox'),('en','common','cocos (keeling) islands','COCOS (KEELING) ISLANDS'),('en','common','colombia','COLOMBIA'),('en','common','common preferences','Common preferences'),('en','common','comoros','COMOROS'),('en','common','congo','CONGO'),('en','common','congo, the democratic republic of the','CONGO, THE DEMOCRATIC REPUBLIC OF THE'),('en','common','contacting server...','Contacting Server...'),('en','common','cook islands','COOK ISLANDS'),('en','common','copy','Copy'),('en','common','costa rica','COSTA RICA'),('en','common','cote d ivoire','COTE D IVOIRE'),('en','common','could not contact server. operation timed out!','Could not contact server. Operation Timed Out!'),('en','common','create','Create'),('en','common','created by','Created By'),('en','common','croatia','CROATIA'),('en','common','cuba','CUBA'),('en','common','currency','Currency'),('en','common','current','Current'),('en','common','current users','Current users'),('en','common','cyprus','CYPRUS'),('en','common','czech republic','CZECH REPUBLIC'),('en','common','date','Date'),('en','common','date due','Date Due'),('en','common','december','December'),('en','common','default category','Default Category'),('en','common','default height for the windows','Default height for the windows'),('en','common','default width for the windows','Default width for the windows'),('en','common','delete','Delete'),('en','common','delete row','Delete row'),('en','common','denmark','DENMARK'),('en','common','description','Description'),('en','common','detail','Detail'),('en','common','details','Details'),('en','common','diable the execution a bugfixscript for internet explorer 5.5 and higher to show transparency in png-images?','Diable the execution a bugfixscript for Internet Explorer 5.5 and higher to show transparency in PNG-images?'),('en','common','direction left to right','Direction left to right'),('en','common','disable internet explorer png-image-bugfix','Disable Internet Explorer png-image-bugfix'),('en','common','disable slider effects','Disable slider effects'),('en','common','disable the animated slider effects when showing or hiding menus in the page? opera and konqueror users will probably must want','Disable the animated slider effects when showing or hiding menus in the page? Opera and Konqueror users will probably must want this.'),('en','common','disable the execution a bugfixscript for internet explorer 5.5 and higher to show transparency in png-images?','Disable the execution a bugfixscript for Internet Explorer 5.5 and higher to show transparency in PNG-images?'),('en','common','disabled','Disabled'),('en','common','djibouti','DJIBOUTI'),('en','common','do you also want to delete all subcategories ?','Do you also want to delete all subcategories ?'),('en','common','doctype:','DOCTYPE:'),('en','common','document properties','Document properties'),('en','common','document title:','Document title:'),('en','common','domain','Domain'),('en','common','domain name for mail-address, eg. \"%1\"','domain name for mail-address, eg. \"%1\"'),('en','common','domestic','Domestic'),('en','common','dominica','DOMINICA'),('en','common','dominican republic','DOMINICAN REPUBLIC'),('en','common','done','Done'),('en','common','e-mail','E-Mail'),('en','common','east timor','EAST TIMOR'),('en','common','ecuador','ECUADOR'),('en','common','edit','Edit'),('en','common','edit %1 category for','Edit %1 category for'),('en','common','edit categories','Edit Categories'),('en','common','edit category','Edit category'),('en','common','egroupware api version %1','eGroupWare API version %1'),('en','common','egroupware: login blocked for user \'%1\', ip %2','eGroupWare: login blocked for user \'%1\', IP %2'),('en','common','egypt','EGYPT'),('en','common','el salvador','EL SALVADOR'),('en','common','email','E-Mail'),('en','common','email-address of the user, eg. \"%1\"','email-address of the user, eg. \"%1\"'),('en','common','en','en'),('en','common','enabled','Enabled'),('en','common','end date','End date'),('en','common','end time','End time'),('en','common','entry has been deleted sucessfully','Entry has been deleted sucessfully'),('en','common','entry updated sucessfully','Entry updated sucessfully'),('en','common','equatorial guinea','EQUATORIAL GUINEA'),('en','common','eritrea','ERITREA'),('en','common','error','Error'),('en','common','error creating %1 %2 directory','Error creating %1 %2 directory'),('en','common','error deleting %1 %2 directory','Error deleting %1 %2 directory'),('en','common','error renaming %1 %2 directory','Error renaming %1 %2 directory'),('en','common','estonia','ESTONIA'),('en','common','ethiopia','ETHIOPIA'),('en','common','exact','exact'),('en','common','failed to contact server or invalid response from server. try to relogin. contact admin in case of faliure.','Failed to Contact Server or Invalid Response from Server. Try to relogin. Contact Admin in case of faliure.'),('en','common','falkland islands (malvinas)','FALKLAND ISLANDS (MALVINAS)'),('en','common','faroe islands','FAROE ISLANDS'),('en','common','february','February'),('en','common','fields','Fields'),('en','common','fiji','FIJI'),('en','common','files','Files'),('en','common','filter','Filter'),('en','common','finland','FINLAND'),('en','common','first name','First name'),('en','common','first name of the user, eg. \"%1\"','first name of the user, eg. \"%1\"'),('en','common','first page','First page'),('en','common','firstname','Firstname'),('en','common','fixme!','FIXME!'),('en','common','folder already exists.','Folder already exists.'),('en','common','force selectbox','Force SelectBox'),('en','common','france','FRANCE'),('en','common','french guiana','FRENCH GUIANA'),('en','common','french polynesia','FRENCH POLYNESIA'),('en','common','french southern territories','FRENCH SOUTHERN TERRITORIES'),('en','common','friday','Friday'),('en','common','ftp','FTP'),('en','common','fullname','Fullname'),('en','common','fullscreen mode','Fullscreen mode'),('en','common','gabon','GABON'),('en','common','gambia','GAMBIA'),('en','common','general menu','General Menu'),('en','common','georgia','GEORGIA'),('en','common','german','German'),('en','common','germany','GERMANY'),('en','common','ghana','GHANA'),('en','common','gibraltar','GIBRALTAR'),('en','common','global','Global'),('en','common','global public','Global Public'),('en','common','grant access','Grant Access'),('en','common','greece','GREECE'),('en','common','greenland','GREENLAND'),('en','common','grenada','GRENADA'),('en','common','group','Group'),('en','common','group access','Group Access'),('en','common','group name','group name'),('en','common','group public','Group Public'),('en','common','groups','Groups'),('en','common','groups with permission for %1','Groups with permission for %1'),('en','common','groups without permission for %1','Groups without permission for %1'),('en','common','guadeloupe','GUADELOUPE'),('en','common','guam','GUAM'),('en','common','guatemala','GUATEMALA'),('en','common','guinea','GUINEA'),('en','common','guinea-bissau','GUINEA-BISSAU'),('en','common','guyana','GUYANA'),('en','common','haiti','HAITI'),('en','common','heard island and mcdonald islands','HEARD ISLAND AND MCDONALD ISLANDS'),('en','common','height','Height'),('en','common','help','Help'),('en','common','high','High'),('en','common','highest','Highest'),('en','common','holy see (vatican city state)','HOLY SEE (VATICAN CITY STATE)'),('en','common','home','Home'),('en','common','home email','home email'),('en','common','honduras','HONDURAS'),('en','common','hong kong','HONG KONG'),('en','common','how many icons should be shown in the navbar (top of the page). additional icons go into a kind of pulldown menu, callable by th','How many icons should be shown in the navbar (top of the page). Additional icons go into a kind of pulldown menu, callable by the icon on the far right side of the navbar.'),('en','common','hungary','HUNGARY'),('en','common','iceland','ICELAND'),('en','common','iespell not detected. click ok to go to download page.','ieSpell not detected. Click OK to go to download page.'),('en','common','if the clock is enabled would you like it to update it every second or every minute?','If the clock is enabled would you like it to update it every second or every minute?'),('en','common','if there are some images in the background folder you can choose the one you would like to see.','If there are some images in the background folder you can choose the one you would like to see.'),('en','common','image url','Image URL'),('en','common','india','INDIA'),('en','common','indonesia','INDONESIA'),('en','common','insert \'return false\'','insert \'return false\''),('en','common','insert all %1 addresses of the %2 contacts in %3','Insert all %1 addresses of the %2 contacts in %3'),('en','common','insert column after','Insert column after'),('en','common','insert column before','Insert column before'),('en','common','insert row after','Insert row after'),('en','common','insert row before','Insert row before'),('en','common','international','International'),('en','common','invalid filename','Invalid filename'),('en','common','invalid ip address','Invalid IP address'),('en','common','invalid password','Invalid password'),('en','common','iran, islamic republic of','IRAN, ISLAMIC REPUBLIC OF'),('en','common','iraq','IRAQ'),('en','common','ireland','IRELAND'),('en','common','israel','ISRAEL'),('en','common','it has been more then %1 days since you changed your password','It has been more then %1 days since you changed your password'),('en','common','it is recommended that you run setup to upgrade your tables to the current version','It is recommended that you run setup to upgrade your tables to the current version.'),('en','common','italic','Italic'),('en','common','italic.gif','italic.gif'),('en','common','italy','ITALY'),('en','common','jamaica','JAMAICA'),('en','common','january','January'),('en','common','japan','JAPAN'),('en','common','jordan','JORDAN'),('en','common','july','July'),('en','common','jun','Jun'),('en','common','june','June'),('en','common','justify center','Justify Center'),('en','common','justify full','Justify Full'),('en','common','justify left','Justify Left'),('en','common','justify right','Justify Right'),('en','common','kazakstan','KAZAKSTAN'),('en','common','kenya','KENYA'),('en','common','keywords','Keywords'),('en','common','kiribati','KIRIBATI'),('en','common','korea, democratic peoples republic of','KOREA, DEMOCRATIC PEOPLES REPUBLIC OF'),('en','common','korea, republic of','KOREA, REPUBLIC OF'),('en','common','kuwait','KUWAIT'),('en','common','kyrgyzstan','KYRGYZSTAN'),('en','common','language','Language'),('en','common','language_direction_rtl','language_direction_rtl'),('en','common','lao peoples democratic republic','LAO PEOPLES DEMOCRATIC REPUBLIC'),('en','common','last name','Last name'),('en','common','last name of the user, eg. \"%1\"','last name of the user, eg. \"%1\"'),('en','common','last page','Last page'),('en','common','lastname','Lastname'),('en','common','latvia','LATVIA'),('en','common','ldap-mgr','LDAP-Manager'),('en','common','lebanon','LEBANON'),('en','common','left','Left'),('en','common','lesotho','LESOTHO'),('en','common','liberia','LIBERIA'),('en','common','libyan arab jamahiriya','LIBYAN ARAB JAMAHIRIYA'),('en','common','license','License'),('en','common','liechtenstein','LIECHTENSTEIN'),('en','common','line %1: \'%2\'<br><b>csv data does not match column-count of table %3 ==> ignored</b>','Line %1: \'%2\'<br><b>csv data does not match column-count of table %3 ==> ignored</b>'),('en','common','list','List'),('en','common','list members','List members'),('en','common','lithuania','LITHUANIA'),('en','common','local','Local'),('en','common','login','Login'),('en','common','loginid','LoginID'),('en','common','logout','Logout'),('en','common','low','Low'),('en','common','lowest','Lowest'),('en','common','luxembourg','LUXEMBOURG'),('en','common','macau','MACAU'),('en','common','macedonia, the former yugoslav republic of','MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF'),('en','common','madagascar','MADAGASCAR'),('en','common','mail domain, eg. \"%1\"','mail domain, eg. \"%1\"'),('en','common','main category','Main category'),('en','common','main screen','Main screen'),('en','common','maintainer','Maintainer'),('en','common','malawi','MALAWI'),('en','common','malaysia','MALAYSIA'),('en','common','maldives','MALDIVES'),('en','common','mali','MALI'),('en','common','malta','MALTA'),('en','common','march','March'),('en','common','marshall islands','MARSHALL ISLANDS'),('en','common','martinique','MARTINIQUE'),('en','common','mauritania','MAURITANIA'),('en','common','mauritius','MAURITIUS'),('en','common','max number of icons in navbar','Max number of icons in navbar'),('en','common','may','May'),('en','common','mayotte','MAYOTTE'),('en','common','medium','Medium'),('en','common','menu','Menu'),('en','common','message','Message'),('en','common','mexico','MEXICO'),('en','common','micronesia, federated states of','MICRONESIA, FEDERATED STATES OF'),('en','common','minute','minute'),('en','common','moldova, republic of','MOLDOVA, REPUBLIC OF'),('en','common','monaco','MONACO'),('en','common','monday','Monday'),('en','common','mongolia','MONGOLIA'),('en','common','montserrat','MONTSERRAT'),('en','common','morocco','MOROCCO'),('en','common','mozambique','MOZAMBIQUE'),('en','common','multiple','multiple'),('en','common','myanmar','MYANMAR'),('en','common','name','Name'),('en','common','name of the user, eg. \"%1\"','name of the user, eg. \"%1\"'),('en','common','namibia','NAMIBIA'),('en','common','nauru','NAURU'),('en','common','nepal','NEPAL'),('en','common','netherlands','NETHERLANDS'),('en','common','netherlands antilles','NETHERLANDS ANTILLES'),('en','common','never','Never'),('en','common','new caledonia','NEW CALEDONIA'),('en','common','new entry added sucessfully','New entry added sucessfully'),('en','common','new main category','New main category'),('en','common','new value','New Value'),('en','common','new zealand','NEW ZEALAND'),('en','common','next','Next'),('en','common','next page','Next page'),('en','common','nicaragua','NICARAGUA'),('en','common','niger','NIGER'),('en','common','nigeria','NIGERIA'),('en','common','niue','NIUE'),('en','common','no','No'),('en','common','no entries found, try again ...','no entries found, try again ...'),('en','common','no history for this record','No history for this record'),('en','common','no savant2 template directories were found in:','No Savant2 template directories were found in:'),('en','common','no subject','No Subject'),('en','common','none','None'),('en','common','norfolk island','NORFOLK ISLAND'),('en','common','normal','Normal'),('en','common','northern mariana islands','NORTHERN MARIANA ISLANDS'),('en','common','norway','NORWAY'),('en','common','not assigned','not assigned'),('en','common','note','Note'),('en','common','notes','Notes'),('en','common','notify window','Notify Window'),('en','common','notify your administrator to correct this situation','Notify your Administrator to correct this Situation'),('en','common','november','November'),('en','common','october','October'),('en','common','ok','OK'),('en','common','old value','Old Value'),('en','common','oman','OMAN'),('en','common','on *nix systems please type: %1','On *nix systems please type: %1'),('en','common','on mouse over','On Mouse Over'),('en','common','only private','only private'),('en','common','only yours','only yours'),('en','common','open notify window','Open notify window'),('en','common','open popup window','Open popup window'),('en','common','open sidebox','Open sidebox'),('en','common','ordered list','Ordered List'),('en','common','original','Original'),('en','common','other','Other'),('en','common','overview','Overview'),('en','common','owner','Owner'),('en','common','page','Page'),('en','common','page was generated in %1 seconds','Page was generated in %1 seconds'),('en','common','pakistan','PAKISTAN'),('en','common','palau','PALAU'),('en','common','palestinian territory, occupied','PALESTINIAN TERRITORY, OCCUPIED'),('en','common','panama','PANAMA'),('en','common','papua new guinea','PAPUA NEW GUINEA'),('en','common','paraguay','PARAGUAY'),('en','common','parcel','Parcel'),('en','common','parent category','Parent Category'),('en','common','password','Password'),('en','common','password could not be changed','Password could not be changed'),('en','common','password has been updated','Password has been updated'),('en','common','password must contain at least %1 lowercase letters','Password must contain at least %1 lowercase letters'),('en','common','password must contain at least %1 numbers','Password must contain at least %1 numbers'),('en','common','password must contain at least %1 special charactars','Password must contain at least %1 special charactars'),('en','common','password must contain at least %1 uppercase letters','Password must contain at least %1 uppercase letters'),('en','common','password must have at least %1 characters','Password must have at least %1 characters'),('en','common','path to user and group files has to be outside of the webservers document-root!!!','Path to user and group files HAS TO BE OUTSIDE of the webservers document-root!!!'),('en','common','pattern for search in addressbook','Pattern for Search in Addressbook'),('en','common','pattern for search in calendar','Pattern for Search in Calendar'),('en','common','pattern for search in projects','Pattern for Search in Projects'),('en','common','permissions to the files/users directory','permissions to the files/users directory'),('en','common','personal','Personal'),('en','common','peru','PERU'),('en','common','philippines','PHILIPPINES'),('en','common','phpgwapi','eGroupWare API'),('en','common','pitcairn','PITCAIRN'),('en','common','please %1 by hand','Please %1 by hand'),('en','common','please enter a name','Please enter a name !'),('en','common','please run setup to become current','Please run setup to become current'),('en','common','please select','Please Select'),('en','common','please set your global preferences','Please set your global preferences !'),('en','common','please set your preferences for this application','Please set your preferences for this application !'),('en','common','please wait...','Please Wait...'),('en','common','poland','POLAND'),('en','common','portugal','PORTUGAL'),('en','common','powered by egroupware version %1','Powered by <a href=\"http://www.egroupware.org\">eGroupWare</a> version %1'),('en','common','powered by phpgroupware version %1','Powered by phpGroupWare version %1'),('en','common','preferences','Preferences'),('en','common','preferences for the idots template set','Preferences for the idots template set'),('en','common','previous page','Previous page'),('en','common','primary style-sheet:','Primary style-sheet:'),('en','common','print','Print'),('en','common','priority','Priority'),('en','common','private','Private'),('en','common','programs','Programs'),('en','common','project','Project'),('en','common','public','public'),('en','common','puerto rico','PUERTO RICO'),('en','common','qatar','QATAR'),('en','common','read','Read'),('en','common','read this list of methods.','Read this list of methods.'),('en','common','reading','reading'),('en','common','reject','Reject'),('en','common','remove selected accounts','remove selected accounts'),('en','common','remove shortcut','Remove Shortcut'),('en','common','rename','Rename'),('en','common','replace','Replace'),('en','common','replace with','Replace with'),('en','common','returns a full list of accounts on the system.  warning: this is return can be quite large','Returns a full list of accounts on the system.  Warning: This is return can be quite large'),('en','common','returns an array of todo items','Returns an array of todo items'),('en','common','returns struct of users application access','Returns struct of users application access'),('en','common','reunion','REUNION'),('en','common','right','Right'),('en','common','romania','ROMANIA'),('en','common','russian federation','RUSSIAN FEDERATION'),('en','common','rwanda','RWANDA'),('en','common','saint helena','SAINT HELENA'),('en','common','saint kitts and nevis','SAINT KITTS AND NEVIS'),('en','common','saint lucia','SAINT LUCIA'),('en','common','saint pierre and miquelon','SAINT PIERRE AND MIQUELON'),('en','common','saint vincent and the grenadines','SAINT VINCENT AND THE GRENADINES'),('en','common','samoa','SAMOA'),('en','common','san marino','SAN MARINO'),('en','common','sao tome and principe','SAO TOME AND PRINCIPE'),('en','common','saturday','Saturday'),('en','common','saudi arabia','SAUDI ARABIA'),('en','common','savant2 version differs from savant2 wrapper. <br/>this version: %1 <br/>savants version: %2','Savant2 version differs from Savant2 wrapper. <br/>This version: %1 <br/>Savants version: %2'),('en','common','save','Save'),('en','common','search','Search'),('en','common','search %1 \'%2\'','Search %1 \'%2\''),('en','common','search or select accounts','Search or select accounts'),('en','common','search or select multiple accounts','search or select multiple accounts'),('en','common','second','second'),('en','common','section','Section'),('en','common','select','Select'),('en','common','select all %1 %2 for %3','Select all %1 %2 for %3'),('en','common','select category','Select Category'),('en','common','select date','Select date'),('en','common','select group','Select group'),('en','common','select home email address','Select home email address'),('en','common','select multiple accounts','select multiple accounts'),('en','common','select one','Select one'),('en','common','select the default height for the application windows','Select the default height for the application windows'),('en','common','select the default width for the application windows','Select the default width for the application windows'),('en','common','select user','Select user'),('en','common','select work email address','Select work email address'),('en','common','selection','Selection'),('en','common','send','Send'),('en','common','senegal','SENEGAL'),('en','common','september','September'),('en','common','server %1 has been added','Server %1 has been added'),('en','common','server answered. processing response...','Server answered. Processing response...'),('en','common','server contacted. waiting for response...','Server Contacted. Waiting for response...'),('en','common','server name','Server Name'),('en','common','session has been killed','Session has been killed'),('en','common','setup','Setup'),('en','common','setup main menu','Setup Main Menu'),('en','common','seychelles','SEYCHELLES'),('en','common','show all','show all'),('en','common','show all categorys','Show all categorys'),('en','common','show clock?','Show clock?'),('en','common','show home and logout button in main application bar?','Show home and logout button in main application bar?'),('en','common','show logo\'s on the desktop.','Show logo\'s on the desktop.'),('en','common','show menu','show menu'),('en','common','show page generation time','Show page generation time'),('en','common','show page generation time on the bottom of the page?','Show page generation time on the bottom of the page?'),('en','common','show page generation time?','Show page generation time?'),('en','common','show the logo\'s of egroupware and x-desktop on the desktop.','Show the logo\'s of eGroupware and x-desktop on the desktop.'),('en','common','show_more_apps','Show More Applications'),('en','common','showing %1','showing %1'),('en','common','showing %1 - %2 of %3','showing %1 - %2 of %3'),('en','common','sierra leone','SIERRA LEONE'),('en','common','singapore','SINGAPORE'),('en','common','slovakia','SLOVAKIA'),('en','common','slovenia','SLOVENIA'),('en','common','solomon islands','SOLOMON ISLANDS'),('en','common','somalia','SOMALIA'),('en','common','south africa','SOUTH AFRICA'),('en','common','south georgia and the south sandwich islands','SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS'),('en','common','spain','SPAIN'),('en','common','sri lanka','SRI LANKA'),('en','common','start date','Start date'),('en','common','start time','Start time'),('en','common','start with','start with'),('en','common','starting up...','Starting Up...'),('en','common','status','Status'),('en','common','stretched','stretched'),('en','common','subject','Subject'),('en','common','submit','Submit'),('en','common','substitutions and their meanings:','Substitutions and their meanings:'),('en','common','sudan','SUDAN'),('en','common','sunday','Sunday'),('en','common','suriname','SURINAME'),('en','common','svalbard and jan mayen','SVALBARD AND JAN MAYEN'),('en','common','swaziland','SWAZILAND'),('en','common','sweden','SWEDEN'),('en','common','switzerland','SWITZERLAND'),('en','common','syrian arab republic','SYRIAN ARAB REPUBLIC'),('en','common','table properties','Table properties'),('en','common','taiwan','TAIWAN/TAIPEI'),('en','common','tajikistan','TAJIKISTAN'),('en','common','tanzania, united republic of','TANZANIA, UNITED REPUBLIC OF'),('en','common','text color:','Text color:'),('en','common','thailand','THAILAND'),('en','common','the api is current','The API is current'),('en','common','the api requires an upgrade','The API requires an upgrade'),('en','common','the following applications require upgrades','The following applications require upgrades'),('en','common','the mail server returned','The mail server returned'),('en','common','this application is current','This application is current'),('en','common','this application requires an upgrade','This application requires an upgrade'),('en','common','this name has been used already','This name has been used already !'),('en','common','thursday','Thursday'),('en','common','tiled','tiled'),('en','common','time','Time'),('en','common','time zone','Timezone'),('en','common','time zone offset','Time zone offset'),('en','common','title','Title'),('en','common','to','To'),('en','common','to correct this error for the future you will need to properly set the','To correct this error for the future you will need to properly set the'),('en','common','to go back to the msg list, click <a href= %1 >here</a>','To go back to the msg list, click <a href=\"%1\">here</a>'),('en','common','today','Today'),('en','common','todays date, eg. \"%1\"','todays date, eg. \"%1\"'),('en','common','togo','TOGO'),('en','common','tokelau','TOKELAU'),('en','common','tonga','TONGA'),('en','common','too many unsucessful attempts to login: %1 for the user \'%2\', %3 for the ip %4','Too many unsucessful attempts to login: %1 for the user \'%2\', %3 for the IP %4'),('en','common','top','Top'),('en','common','total','Total'),('en','common','transparant bg for the icons?','Transparant bg for the icons?'),('en','common','trinidad and tobago','TRINIDAD AND TOBAGO'),('en','common','tuesday','Tuesday'),('en','common','tunisia','TUNISIA'),('en','common','turkey','TURKEY'),('en','common','turkmenistan','TURKMENISTAN'),('en','common','turks and caicos islands','TURKS AND CAICOS ISLANDS'),('en','common','tuvalu','TUVALU'),('en','common','type','Type'),('en','common','uganda','UGANDA'),('en','common','ukraine','UKRAINE'),('en','common','underline','Underline'),('en','common','underline.gif','underline.gif'),('en','common','united arab emirates','UNITED ARAB EMIRATES'),('en','common','united kingdom','UNITED KINGDOM'),('en','common','united states','UNITED STATES'),('en','common','united states minor outlying islands','UNITED STATES MINOR OUTLYING ISLANDS'),('en','common','unknown','Unknown'),('en','common','update','Update'),('en','common','update the clock per minute or per second','Update the clock per minute or per second'),('en','common','upload','Upload'),('en','common','upload directory does not exist, or is not writeable by webserver','Upload directory does not exist, or is not writeable by webserver'),('en','common','url','URL'),('en','common','uruguay','URUGUAY'),('en','common','use button to search for','use Button to search for'),('en','common','use button to search for address','use Button to search for Address'),('en','common','use button to search for calendarevent','use Button to search for Calendarevent'),('en','common','use button to search for project','use Button to search for Project'),('en','common','user','User'),('en','common','user accounts','user accounts'),('en','common','user groups','user groups'),('en','common','user openinstance','User Openinstance'),('en','common','username','Username'),('en','common','users','users'),('en','common','users choice','Users Choice'),('en','common','uzbekistan','UZBEKISTAN'),('en','common','vanuatu','VANUATU'),('en','common','venezuela','VENEZUELA'),('en','common','version','Version'),('en','common','viet nam','VIET NAM'),('en','common','view','View'),('en','common','virgin islands, british','VIRGIN ISLANDS, BRITISH'),('en','common','virgin islands, u.s.','VIRGIN ISLANDS, U.S.'),('en','common','wallis and futuna','WALLIS AND FUTUNA'),('en','common','wednesday','Wednesday'),('en','common','welcome','Welcome'),('en','common','western sahara','WESTERN SAHARA'),('en','common','what color should all the blank space on the desktop have','What color should all the blank space on the desktop have'),('en','common','what style would you like the image to have?','What style would you like the image to have?'),('en','common','when you say yes the home and logout buttons are presented as applications in the main top applcation bar.','When you say yes the home and logout buttons are presented as applications in the main top applcation bar.'),('en','common','which groups','Which groups'),('en','common','width','Width'),('en','common','work email','work email'),('en','common','would you like to display the page generation time at the bottom of every window?','Would you like to display the page generation time at the bottom of every window?'),('en','common','writing','writing'),('en','common','written by:','Written by:'),('en','common','year','Year'),('en','common','yemen','YEMEN'),('en','common','yes','Yes'),('en','common','you are required to change your password during your first login','You are required to change your password during your first login'),('en','common','you have not entered a title','You have not entered a title'),('en','common','you have not entered a valid date','You have not entered a valid date'),('en','common','you have not entered a valid time of day','You have not entered a valid time of day'),('en','common','you have not entered participants','You have not entered participants'),('en','common','you have selected an invalid date','You have selected an invalid date !'),('en','common','you have selected an invalid main category','You have selected an invalid main category !'),('en','common','you have successfully logged out','You have successfully logged out'),('en','common','you need to add the webserver user \'%1\' to the group \'%2\'.','You need to add the webserver user \'%1\' to the group \'%2\'.'),('en','common','your message could <b>not</b> be sent!<br>','Your message could <b>not</b> be sent!<br>'),('en','common','your message has been sent','Your message has been sent'),('en','common','your search returned %1 matchs','your search returned %1 matches'),('en','common','your search returned 1 match','your search returned 1 match'),('en','common','your settings have been updated','Your settings have been Updated'),('en','common','yugoslavia','YUGOSLAVIA'),('en','common','zambia','ZAMBIA'),('en','common','zimbabwe','ZIMBABWE'),('en','common','zoom','Zoom'),('en','common','poll settings','Poll settings'),('en','common','polls','Polls'),('en','common','show questions','Show questions'),('en','common','projectmanager','ProjectManager'),('en','common','register','Register'),('en','common','registration','Registration'),('en','common','resources','resources'),('en','common','select resources','Select resources'),('en','common','samba settings','Samba settings'),('en','common','1 day','1 Day'),('en','common','1 hour','1 Hour'),('en','common','1 month','1 Month'),('en','common','1 week','1 Week'),('en','common','as','as'),('en','common','define websites','Define websites'),('en','common','edit categories and permissions','Edit Categories and Permissions'),('en','common','edit individual pages','Edit Individual Pages'),('en','common','edit site header and footer','Edit Site Header and Footer'),('en','common','error accessing page','Error accessing page'),('en','common','forever','Forever'),('en','common','manage pages','Manage Pages'),('en','common','not','not'),('en','common','remember me','remember me'),('en','common','site setup','Site Setup'),('en','common','sitemgr','SiteMgr'),('en','common','sitemgr web content manager','SiteMgr Web Content Manager'),('en','common','there was an error accessing the requested page. either you do not have permission to view this page, or the page does not exist','There was an error accessing the requested page. Either you do not have permission to view this page, or the page does not exist.'),('en','common','web content manager','SiteMgr Web Content Manager'),('en','common','timesheet','TimeSheet'),('en','common','block / unblock hosts','Block / Unblock hosts'),('en','common','lock / unlock pages','Lock / Unlock Pages'),('en','common','wiki','Wiki'),('en','common','/workflow directory does not exist and could not be created, please ask adminstrator to check the global configuration','/workflow directory does not exist and could not be created, please ask adminstrator to check the global configuration'),('en','common','actions right options','Actions Right Options'),('en','common','auto-release on leaving activity','auto-release on leaving activity'),('en','common','base directory does not exist, please ask adminstrator to check the global configuration','Base directory does not exist, please ask adminstrator to check the global configuration'),('en','common','config values','Config values'),('en','common','display please wait message','display please wait message'),('en','common','draw roles','draw roles'),('en','common','graphic options','Graphic options'),('en','common','mail smtp debug','Mail smtp debug'),('en','common','mail smtp local link prefix','Mail smtp local link prefix'),('en','common','mail smtp profile','Mail smtp profile'),('en','common','mail smtp signature','Mail smtp signature'),('en','common','ownership give abort right','ownership give abort right'),('en','common','ownership give exception right','ownership give exception right'),('en','common','ownership give release right','ownership give release right'),('en','common','role give abort right','role give abort right'),('en','common','role give exception right','role give exception right'),('en','common','role give release right','role give release right'),('en','common','running activities options','Running activities options'),('en','common','show activity info zone','show activity info zone'),('en','common','show activity title','show activity title'),('en','common','show instance name','Show instance name'),('en','common','show instance owner','Show instance owner'),('en','common','show multiple submit as select','show multiple submit as select'),('en','common','the /workflow directory does not exist and could not be created. please ask your administrator to check the global configuration','The /workflow directory does not exist and could not be created. Please ask your administrator to check the global configuration'),('en','common','use automatic parsing','use automatic parsing'),('en','common','workflow','Work-Flow'),('en','admin','contact application','Contact application'),('en','admin','contact settings','Contact Settings'),('en','admin','edit custom fields','Edit Custom Fields'),('en','admin','ldap context for contacts','LDAP context for contacts'),('en','admin','ldap host for contacts','LDAP host for contacts'),('en','admin','ldap root dn for contacts','LDAP root dn for contacts'),('en','admin','ldap root pw for contacts','LDAP root pw for contacts'),('en','admin','retrieve contacts','retrieve contacts'),('en','admin','select where you want to store','Select where you want to store'),('en','admin','warning!! ldap is valid only if you are not using contacts for accounts storage!','WARNING!! LDAP is valid only if you are NOT using contacts for accounts storage!'),('en','admin','%1 - %2 of %3 user accounts','%1 - %2 of %3 user accounts'),('en','admin','%1 - %2 of %3 user groups','%1 - %2 of %3 user groups'),('en','admin','%1 acl records of not (longer) existing accounts deleted.','%1 ACL records of not (longer) existing accounts deleted.'),('en','admin','%1 not found or not executable !!!','%1 not found or not executable !!!'),('en','admin','(default no, leave it off if you dont use it)','(default No, leave it off if you dont use it)'),('en','admin','(stored password will not be shown here)','(Stored password will not be shown here)'),('en','admin','(to install new applications use<br><a href=\"setup/\" target=\"setup\">setup</a> [manage applications] !!!)','(To install new applications use<br><a href=\"setup/\" target=\"setup\">Setup</a> [Manage Applications] !!!)'),('en','admin','-  type','-  type'),('en','admin','accesslog and bruteforce defense','AccessLog and BruteForce defense'),('en','admin','account active','Account active'),('en','admin','account list','Account list'),('en','admin','account permissions','Account permissions'),('en','admin','account preferences','Account Preferences'),('en','admin','acl manager','ACL Manager'),('en','admin','action','Action'),('en','admin','activate wysiwyg-editor','activate WYSIWYG-editor'),('en','admin','add a category','add a category'),('en','admin','add a group','add a group'),('en','admin','add a new account.','Add a new account.'),('en','admin','add a subcategory','add a subcategory'),('en','admin','add a user','add a user'),('en','admin','add account','Add account'),('en','admin','add application','Add application'),('en','admin','add auto-created users to this group (\'default\' will be attempted if this is empty.)','Add auto-created users to this group (\'Default\' will be attempted if this is empty.)'),('en','admin','add global category','Add global category'),('en','admin','add global category for %1','Add global category for %1'),('en','admin','add group','Add group'),('en','admin','add new account','Add new account'),('en','admin','add new application','Add new application'),('en','admin','add peer server','Add Peer Server'),('en','admin','add sub-category','Add sub-category'),('en','admin','admin email','Admin Email'),('en','admin','admin email addresses (comma-separated) to be notified about the blocking (empty for no notify)','Admin email addresses (comma-separated) to be notified about the blocking (empty for no notify)'),('en','admin','admin name','Admin Name'),('en','admin','administration','Administration'),('en','admin','admins','Admins'),('en','admin','advanced options','advanced options'),('en','admin','after how many unsuccessful attempts to login, an account should be blocked (default 3) ?','After how many unsuccessful attempts to login, an account should be blocked (default 3) ?'),('en','admin','after how many unsuccessful attempts to login, an ip should be blocked (default 3) ?','After how many unsuccessful attempts to login, an IP should be blocked (default 3) ?'),('en','admin','aliases','Aliases'),('en','admin','all records and account information will be lost!','All records and account information will be lost!'),('en','admin','all users','All Users'),('en','admin','allow anonymous access to this app','Allow anonymous access to this app'),('en','admin','alternate email address','alternate email address'),('en','admin','anonymous user','Anonymous user'),('en','admin','anonymous user (not shown in list sessions)','Anonymous User (not shown in list sessions)'),('en','admin','anonymous user does not exist!','Anonymous user does NOT exist!'),('en','admin','anonymous user has no run-rights for the application!','Anonymous user has NO run-rights for the application!'),('en','admin','appearance','Appearance'),('en','admin','application','Application'),('en','admin','application name','Application name'),('en','admin','application title','Application title'),('en','admin','applications','Applications'),('en','admin','applications list','Applications list'),('en','admin','applies the changes','applies the changes'),('en','admin','are you sure you want to delete the application %1 ?','Are you sure you want to delete the application %1 ?'),('en','admin','are you sure you want to delete this account ?','Are you sure you want to delete this account ?'),('en','admin','are you sure you want to delete this application ?','Are you sure you want to delete this application ?'),('en','admin','are you sure you want to delete this global category ?','Are you sure you want to delete this global category ?'),('en','admin','are you sure you want to delete this group ?','Are you sure you want to delete this group ?'),('en','admin','are you sure you want to delete this server?','Are you sure you want to delete this server?'),('en','admin','are you sure you want to kill this session ?','Are you sure you want to kill this session ?'),('en','admin','async services last executed','Async services last executed'),('en','admin','asynchronous timed services','Asynchronous timed services'),('en','admin','asyncservices not yet installed or other error (%1) !!!','asyncservices not yet installed or other error (%1) !!!'),('en','admin','attempt to use correct mimetype for ftp instead of default \'application/octet-stream\'','Attempt to use correct mimetype for FTP instead of default \'application/octet-stream\''),('en','admin','attribute accountstatus explained','This handles the attribute <b><i>-accountStatus-</i></b> from the QMAIL schema.'),('en','admin','attribute mail explained','This handles the attribute <b><i>-mail-</i></b> from the QMAIL schema and should never be empty. It is also the eGW internal email field.'),('en','admin','attribute mailalternateaddress explained','This handles the attribute <b><i>-mailAlternateAddress-</i></b> from the QMAIL schema and can be handled as virtual maps or aliases.'),('en','admin','attribute mailforwardingaddress explained','This handles the attribute <b><i>-mailForwardingAddress-</i></b> from QMAIL Schema and must not be empty if assigned.'),('en','admin','authentication / accounts','Authentication / Accounts'),('en','admin','auto create account records for authenticated users','Auto create account records for authenticated users'),('en','admin','back to the list','back to the list'),('en','admin','bi-dir passthrough','bi-dir passthrough'),('en','admin','bi-directional','bi-directional'),('en','admin','bottom','bottom'),('en','admin','calculate next run','Calculate next run'),('en','admin','can change password','Can change password'),('en','admin','cancel testjob!','Cancel TestJob!'),('en','admin','categories list','Categories list'),('en','admin','category %1 has been saved !','Category %1 has been saved !'),('en','admin','category list','Category list'),('en','admin','change acl rights','change ACL Rights'),('en','admin','change config settings','Change config settings'),('en','admin','change main screen message','Change main screen message'),('en','admin','check ip address of all sessions','Check IP address of all sessions'),('en','admin','check items to <b>%1</b> to %2 for %3','Check items to <b>%1</b> to %2 for %3'),('en','admin','click to select a color','Click to select a color'),('en','admin','color','Color'),('en','admin','country selection','Country Selection'),('en','admin','create group','Create Group'),('en','admin','creates a new field','creates a new field'),('en','admin','crontab only (recomended)','crontab only (recomended)'),('en','admin','custom fields','Custom fields'),('en','admin','cyrus imap server','Cyrus IMAP Server'),('en','admin','data','Data'),('en','admin','day','Day'),('en','admin','day of week<br>(0-6, 0=sun)','Day of week<br>(0-6, 0=Sun)'),('en','admin','db backup and restore','DB backup and restore'),('en','admin','default','Default'),('en','admin','default file system space per user','Default file system space per user'),('en','admin','default file system space per user/group ?','Default file system space per user/group ?'),('en','admin','deinstall crontab','Deinstall crontab'),('en','admin','delete account','Delete account'),('en','admin','delete all records','Delete All Records'),('en','admin','delete application','Delete application'),('en','admin','delete category','Delete category'),('en','admin','delete group','Delete group'),('en','admin','delete peer server','Delete peer server'),('en','admin','delete the category','delete the category'),('en','admin','delete the group','delete the group'),('en','admin','delete this category','delete this category'),('en','admin','delete this group','delete this group'),('en','admin','delete this user','delete this user'),('en','admin','deletes this field','deletes this field'),('en','admin','deliver extern','deliver extern'),('en','admin','deny access to access log','Deny access to access log'),('en','admin','deny access to application registery','Deny access to application registery'),('en','admin','deny access to applications','Deny access to applications'),('en','admin','deny access to asynchronous timed services','Deny access to asynchronous timed services'),('en','admin','deny access to current sessions','Deny access to current sessions'),('en','admin','deny access to db backup and restore','Deny access to DB backup and restore'),('en','admin','deny access to error log','Deny access to error log'),('en','admin','deny access to global categories','Deny access to global categories'),('en','admin','deny access to groups','Deny access to groups'),('en','admin','deny access to mainscreen message','Deny access to mainscreen message'),('en','admin','deny access to peer servers','Deny access to peer servers'),('en','admin','deny access to phpinfo','Deny access to phpinfo'),('en','admin','deny access to site configuration','Deny access to site configuration'),('en','admin','deny access to user accounts','Deny access to user accounts'),('en','admin','deny all users access to grant other users access to their entries ?','Deny all users access to grant other users access to their entries ?'),('en','admin','description can not exceed 255 characters in length !','Description can not exceed 255 characters in length !'),('en','admin','determines the order the fields are displayed','determines the order the fields are displayed'),('en','admin','disable \"auto completion\" of the login form','Disable \"auto completion\" of the login form'),('en','admin','disable wysiwyg-editor','disable WYSIWYG-editor'),('en','admin','disabled (not recomended)','disabled (not recomended)'),('en','admin','display','Display'),('en','admin','do not delete the category and return back to the list','do NOT delete the category and return back to the list'),('en','admin','do you also want to delete all global subcategories ?','Do you also want to delete all global subcategories ?'),('en','admin','do you want to delete all global subcategories ?','Do you want to delete all global subcategories ?'),('en','admin','do you want to move all global subcategories one level down ?','Do you want to move all global subcategories one level down ?'),('en','admin','each value is a line like <id>[=<label>]','each value is a line like <id>[=<label>]'),('en','admin','each value is a line like id[=label]','each value is a line like id[=label]'),('en','admin','edit account','Edit account'),('en','admin','edit application','Edit application'),('en','admin','edit email settings','edit email settings'),('en','admin','edit global category','Edit global category'),('en','admin','edit global category for %1','Edit global category for %1'),('en','admin','edit group','Edit Group'),('en','admin','edit group acl\'s','edit group ACL\'s'),('en','admin','edit login screen message','Edit login screen message'),('en','admin','edit main screen message','Edit main screen message'),('en','admin','edit peer server','Edit Peer Server'),('en','admin','edit table format','Edit Table format'),('en','admin','edit this category','edit this category'),('en','admin','edit this group','edit this group'),('en','admin','edit this user','edit this user'),('en','admin','edit user','edit user'),('en','admin','edit user account','Edit user account'),('en','admin','email account active','email account active'),('en','admin','email address','email address'),('en','admin','enable debug-messages','Enable debug-messages'),('en','admin','enable the soap service','Enable the soap service'),('en','admin','enable the xmlrpc service','Enable the xmlrpc service'),('en','admin','enabled - hidden from navbar','Enabled - Hidden from navbar'),('en','admin','enabled - popup window','Enabled - Popup Window'),('en','admin','enter a description for the category','enter a description for the category'),('en','admin','enter some random text for app_session <br>encryption (requires mcrypt)','Enter some random text for app_session <br>encryption (requires mcrypt)'),('en','admin','enter the background color for the login page','Enter the background color for the login page'),('en','admin','enter the background color for the site title','Enter the background color for the site title'),('en','admin','enter the full path for temporary files.<br>examples: /tmp, c:\\temp','Enter the full path for temporary files.<br>Examples: /tmp, C:\\TEMP'),('en','admin','enter the full path for users and group files.<br>examples: /files, e:\\files','Enter the full path for users and group files.<br>Examples: /files, E:\\FILES'),('en','admin','enter the hostname of the machine on which this server is running','Enter the hostname of the machine on which this server is running'),('en','admin','enter the location of egroupware\'s url.<br>example: http://www.domain.com/egroupware &nbsp; or &nbsp; /egroupware<br><b>no trail','Enter the location of eGroupWare\'s URL.<br>Example: http://www.domain.com/egroupware &nbsp; or &nbsp; /egroupware<br><b>No trailing slash</b>'),('en','admin','enter the search string. to show all entries, empty this field and press the submit button again','Enter the search string. To show all entries, empty this field and press the SUBMIT button again'),('en','admin','enter the site password for peer servers','Enter the site password for peer servers'),('en','admin','enter the site username for peer servers','Enter the site username for peer servers'),('en','admin','enter the title for your site','Enter the title for your site'),('en','admin','enter the title of your logo','Enter the title of your logo'),('en','admin','enter the url or filename (in phpgwapi/templates/default/images) of your logo','Enter the URL or filename (in phpgwapi/templates/default/images) of your logo'),('en','admin','enter the url where your logo should link to','Enter the url where your logo should link to'),('en','admin','enter your default ftp server','Enter your default FTP server'),('en','admin','enter your default mail domain ( from: user@domain )','Enter your default mail domain ( From: user@domain )'),('en','admin','enter your http proxy server','Enter your HTTP proxy server'),('en','admin','enter your http proxy server port','Enter your HTTP proxy server port'),('en','admin','enter your smtp server hostname or ip address','Enter your SMTP server hostname or IP address'),('en','admin','enter your smtp server port','Enter your SMTP server port'),('en','admin','error canceling timer, maybe there\'s none set !!!','Error canceling timer, maybe there\'s none set !!!'),('en','admin','error setting timer, wrong syntax or maybe there\'s one already running !!!','Error setting timer, wrong syntax or maybe there\'s one already running !!!'),('en','admin','error! no appname found','Error! No appname found'),('en','admin','error: %1 not found or other error !!!','Error: %1 not found or other error !!!'),('en','admin','expires','Expires'),('en','admin','explanation of ldapman','This module has been tested so far for POSTFIX,LDAP,Courier-IMAP and need the schemas  CORE and QMAIL (OID7914). More details about using and configuring this systrem can be found in README.ldapman in the doc folder of ADMIN.'),('en','admin','fallback (after each pageview)','fallback (after each pageview)'),('en','admin','field \'%1\' already exists !!!','Field \'%1\' already exists !!!'),('en','admin','file space','File space'),('en','admin','file space must be an integer','File space must be an integer'),('en','admin','find and register all application hooks','Find and Register all Application Hooks'),('en','admin','for the times above','for the times above'),('en','admin','for the times below (empty values count as \'*\', all empty = every minute)','for the times below (empty values count as \'*\', all empty = every minute)'),('en','admin','force selectbox','Force Selectbox'),('en','admin','forward also to','forward also to'),('en','admin','forward emails to','forward emails to'),('en','admin','forward only','forward only'),('en','admin','group ?','group ?'),('en','admin','group list','Group list'),('en','admin','group manager','Group Manager'),('en','admin','group name','Group Name'),('en','admin','hide php information','hide php information'),('en','admin','home directory','Home directory'),('en','admin','host information','Host information'),('en','admin','hour<br>(0-23)','Hour<br>(0-23)'),('en','admin','how many days should entries stay in the access log, before they get deleted (default 90) ?','How many days should entries stay in the access log, before they get deleted (default 90) ?'),('en','admin','how many minutes should an account or ip be blocked (default 30) ?','How many minutes should an account or IP be blocked (default 30) ?'),('en','admin','icon','Icon'),('en','admin','idle','idle'),('en','admin','if no acl records for user or any group the user is a member of','If no ACL records for user or any group the user is a member of'),('en','admin','if using ldap, do you want to manage homedirectory and loginshell attributes?','If using LDAP, do you want to manage homedirectory and loginshell attributes?'),('en','admin','in mbyte','in MByte'),('en','admin','inbound','inbound'),('en','admin','install crontab','Install crontab'),('en','admin','installed crontab','Installed crontab'),('en','admin','interface','Interface'),('en','admin','ip','IP'),('en','admin','jobs','Jobs'),('en','admin','kill','Kill'),('en','admin','kill session','Kill session'),('en','admin','last %1 logins','Last %1 logins'),('en','admin','last %1 logins for %2','Last %1 logins for %2'),('en','admin','last login','last login'),('en','admin','last login from','last login from'),('en','admin','last time read','Last Time Read'),('en','admin','ldap accounts context','LDAP accounts context'),('en','admin','ldap default homedirectory prefix (e.g. /home for /home/username)','LDAP Default homedirectory prefix (e.g. /home for /home/username)'),('en','admin','ldap default shell (e.g. /bin/bash)','LDAP Default shell (e.g. /bin/bash)'),('en','admin','ldap encryption type','LDAP encryption type'),('en','admin','ldap groups context','LDAP groups context'),('en','admin','ldap host','LDAP host'),('en','admin','ldap root password','LDAP root password'),('en','admin','ldap rootdn','LDAP rootdn'),('en','admin','leave empty for no quota','leave empty for no quota'),('en','admin','leave the category untouched and return back to the list','leave the category untouched and return back to the list'),('en','admin','leave the group untouched and return back to the list','Leave the group untouched and return back to the list'),('en','admin','leaves without saveing','leaves without saveing'),('en','admin','length<br>rows','Length<br>Rows'),('en','admin','list config settings','List config settings'),('en','admin','list current sessions','List current sessions'),('en','admin','list of current users','list of current users'),('en','admin','login message','Login message'),('en','admin','login screen','Login screen'),('en','admin','login shell','Login shell'),('en','admin','login time','Login Time'),('en','admin','loginid','LoginID'),('en','admin','mail settings','Mail settings'),('en','admin','main email-address','Main Email-Address'),('en','admin','main screen message','Main screen message'),('en','admin','manager','Manager'),('en','admin','max length of the input [, length of the inputfield (optional)]','max length of the input [, length of the inputfield (optional)]'),('en','admin','maximum account id (e.g. 65535 or 1000000)','Maximum account id (e.g. 65535 or 1000000)'),('en','admin','maximum entries in click path history','Maximum entries in click path history'),('en','admin','message has been updated','message has been updated'),('en','admin','method','Method'),('en','admin','minimum account id (e.g. 500 or 100, etc.)','Minimum account id (e.g. 500 or 100, etc.)'),('en','admin','minute','Minute'),('en','admin','mode','Mode'),('en','admin','month','Month'),('en','admin','name must not be empty !!!','Name must not be empty !!!'),('en','admin','new group name','New group name'),('en','admin','new name','new name'),('en','admin','new password [ leave blank for no change ]','New password [ Leave blank for no change ]'),('en','admin','next run','Next run'),('en','admin','no algorithms available','no algorithms available'),('en','admin','no alternate email address','no alternate email address'),('en','admin','no jobs in the database !!!','No jobs in the database !!!'),('en','admin','no login history exists for this user','No login history exists for this user'),('en','admin','no matches found','No matches found'),('en','admin','no modes available','no modes available'),('en','admin','no permission to add groups','no permission to add groups'),('en','admin','no permission to add users','no permission to add users'),('en','admin','no permission to create groups','no permission to create groups'),('en','admin','note: ssl available only if php is compiled with curl support','Note: SSL available only if PHP is compiled with curl support'),('en','admin','number of row for a multiline inputfield or line of a multi-select-box','number of row for a multiline inputfield or line of a multi-select-box'),('en','admin','order','Order'),('en','admin','outbound','outbound'),('en','admin','passthrough','passthrough'),('en','admin','password for smtp-authentication','Password for SMTP-authentication'),('en','admin','path information','Path information'),('en','admin','peer server list','Peer server list'),('en','admin','peer servers','Peer servers'),('en','admin','percent of users that logged out','Percent of users that logged out'),('en','admin','percent this user has logged out','Percent this user has logged out'),('en','admin','permission denied','Permission denied'),('en','admin','permissions','Permissions'),('en','admin','permissions this group has','Permissions this group has'),('en','admin','phpinfo','PHP information'),('en','admin','please enter a name','Please enter a name'),('en','admin','please enter a name for that server !','Please enter a name for that server !'),('en','admin','please run setup to become current','Please run setup to become current'),('en','admin','please select','Please Select'),('en','admin','postfix with ldap','Postfix with LDAP'),('en','admin','preferences','Preferences'),('en','admin','primary group','primary Group'),('en','admin','qmaildotmode','qmaildotmode'),('en','admin','quota settings','quota settings'),('en','admin','quota size in mbyte','quota size in MByte'),('en','admin','re-enter password','Re-enter password'),('en','admin','read this list of methods.','Read this list of methods.'),('en','admin','register application hooks','Register application hooks'),('en','admin','remove','remove'),('en','admin','remove all users from this group','Remove all users from this group'),('en','admin','remove all users from this group ?','Remove all users from this group ?'),('en','admin','return to admin mainscreen','return to admin mainscreen'),('en','admin','return to view account','Return to view account'),('en','admin','route all mails to','Route all Mails to'),('en','admin','run asynchronous services','Run Asynchronous services'),('en','admin','save the category','save the category'),('en','admin','save the category and return back to the list','save the category and return back to the list'),('en','admin','saves the changes made and leaves','saves the changes made and leaves'),('en','admin','search accounts','Search accounts'),('en','admin','search categories','Search categories'),('en','admin','search groups','Search groups'),('en','admin','search peer servers','Search peer servers'),('en','admin','security','Security'),('en','admin','select group managers','Select Group Managers'),('en','admin','select permissions this group will have','Select permissions this group will have'),('en','admin','select the parent category. if this is a main category select no category','Select the parent category. If this is a main category select NO CATEGORY'),('en','admin','select users for inclusion','Select users for inclusion'),('en','admin','select where you want to store/retrieve filesystem information','Select where you want to store/retrieve filesystem information'),('en','admin','select where you want to store/retrieve user accounts','Select where you want to store/retrieve user accounts'),('en','admin','select which location this app should appear on the navbar, lowest (left) to highest (right)','Select which location this app should appear on the navbar, lowest (left) to highest (right)'),('en','admin','selectbox','Selectbox'),('en','admin','server %1 has been updated','Server %1 has been updated'),('en','admin','server list','Server List'),('en','admin','server password','Server Password'),('en','admin','server type(mode)','Server Type(mode)'),('en','admin','server url','Server URL'),('en','admin','server username','Server Username'),('en','admin','set preference values.','Set preference values.'),('en','admin','should the login page include a language selectbox (useful for demo-sites) ?','Should the login page include a language selectbox (useful for demo-sites) ?'),('en','admin','show \'powered by\' logo on','Show \'powered by\' logo on'),('en','admin','show access log','Show access log'),('en','admin','show current action','Show current action'),('en','admin','show error log','Show error log'),('en','admin','show phpinfo()','Show phpinfo()'),('en','admin','show session ip address','Show session IP address'),('en','admin','site','Site'),('en','admin','soap','SOAP'),('en','admin','sorry, that group name has already been taken.','Sorry, that group name has already been taken.'),('en','admin','sorry, the above users are still a member of the group %1','Sorry, the above users are still a member of the group %1'),('en','admin','sorry, the follow users are still a member of the group %1','Sorry, the follow users are still a member of the group %1'),('en','admin','sort the entries','sort the entries'),('en','admin','ssl','ssl'),('en','admin','standard','standard'),('en','admin','standard imap server','standard IMAP server'),('en','admin','standard pop3 server','standard POP3 server'),('en','admin','standard smtp-server','standard SMTP-Server'),('en','admin','start testjob!','Start TestJob!'),('en','admin','submit changes','Submit Changes'),('en','admin','submit the search string','Submit the search string'),('en','admin','subtype','Subtype'),('en','admin','template selection','Template Selection'),('en','admin','text entry','Text Entry'),('en','admin','that application name already exists.','That application name already exists.'),('en','admin','that application order must be a number.','That application order must be a number.'),('en','admin','that loginid has already been taken','That loginid has already been taken'),('en','admin','that name has been used already','That name has been used already'),('en','admin','that server name has been used already !','That server name has been used already !'),('en','admin','the api is current','The API is current'),('en','admin','the api requires an upgrade','The API requires an upgrade'),('en','admin','the groups must include the primary group','The groups must include the primary group'),('en','admin','the login and password can not be the same','The login and password can not be the same'),('en','admin','the loginid can not be more then 8 characters','The loginid can not be more then 8 characters'),('en','admin','the name used internaly (<= 20 chars), changeing it makes existing data unavailible','the name used internaly (<= 20 chars), changeing it makes existing data unavailible'),('en','admin','the testjob sends you a mail everytime it is called.','The TestJob sends you a mail everytime it is called.'),('en','admin','the text displayed to the user','the text displayed to the user'),('en','admin','the two passwords are not the same','The two passwords are not the same'),('en','admin','the users bellow are still members of group %1','the users bellow are still members of group %1'),('en','admin','there already is a group with this name. userid\'s can not have the same name as a groupid','There already is a group with this name. Userid\'s can not have the same name as a groupid'),('en','admin','they must be removed before you can continue','They must be removed before you can continue'),('en','admin','this application is current','This application is current'),('en','admin','this application requires an upgrade','This application requires an upgrade'),('en','admin','this category is currently being used by applications as a parent category','This category is currently being used by applications as a parent category.'),('en','admin','timeout for application session data in seconds (default 86400 = 1 day)','Timeout for application session data in seconds (default 86400 = 1 day)'),('en','admin','timeout for sessions in seconds (default 14400 = 4 hours)','Timeout for sessions in seconds (default 14400 = 4 hours)'),('en','admin','times','Times'),('en','admin','top','top'),('en','admin','total records','Total records'),('en','admin','trust level','Trust Level'),('en','admin','trust relationship','Trust Relationship'),('en','admin','type \'%1\' already exists !!!','type \'%1\' already exists !!!'),('en','admin','type of customfield','Type of customfield'),('en','admin','under windows you need to install the asyncservice %1manually%2 or use the fallback mode. fallback means the jobs get only check','Under windows you need to install the asyncservice %1manually%2 or use the fallback mode. Fallback means the jobs get only checked after each page-view !!!'),('en','admin','use cookies to pass sessionid','Use cookies to pass sessionid'),('en','admin','use pure html compliant code (not fully working yet)','Use pure HTML compliant code (not fully working yet)'),('en','admin','use theme','Use theme'),('en','admin','user accounts','User accounts'),('en','admin','user data','User Data'),('en','admin','user for smtp-authentication (leave it empty if no auth required)','User for SMTP-authentication (leave it empty if no auth required)'),('en','admin','user groups','User groups'),('en','admin','userdata','userdata'),('en','admin','users choice','Users Choice'),('en','admin','view access log','View access log'),('en','admin','view account','View account'),('en','admin','view category','View category'),('en','admin','view error log','View error log'),('en','admin','view sessions','View sessions'),('en','admin','view this user','view this user'),('en','admin','view user account','View user account'),('en','admin','who would you like to transfer all records owned by the deleted user to?','Who would you like to transfer ALL records owned by the deleted user to?'),('en','admin','would you like egroupware to cache the egw info array ?','Would you like eGroupWare to cache the egw info array ?'),('en','admin','would you like egroupware to check for a new version<br>when admins login ?','Would you like eGroupWare to check for a new version<br>when admins login ?'),('en','admin','would you like egroupware to check for new application versions when admins login ?','Would you like eGroupWare to check for new application versions when admins login ?'),('en','admin','would you like to automaticaly load new langfiles (at login-time) ?','Would you like to automatically load new langfiles (at login-time) ?'),('en','admin','would you like to show each application\'s upgrade status ?','Would you like to show each application\'s upgrade status ?'),('en','admin','xml-rpc','XML-RPC'),('en','admin','you have entered an invalid expiration date','You have entered an invalid expiration date'),('en','admin','you have to enter a name, to create a new field!!!','You have to enter a name, to create a new field!!!'),('en','admin','you have to enter a name, to create a new type!!!','You have to enter a name, to create a new type!!!'),('en','admin','you must add at least 1 permission or group to this account','You must add at least 1 permission or group to this account'),('en','admin','you must enter a group name.','You must enter a group name.'),('en','admin','you must enter a lastname','You must enter a lastname'),('en','admin','you must enter a loginid','You must enter a loginid'),('en','admin','you must enter an application name and title.','You must enter an application name and title.'),('en','admin','you must enter an application name.','You must enter an application name.'),('en','admin','you must enter an application title.','You must enter an application title.'),('en','admin','you must select a file type','You must select a file type'),('en','admin','you will need to remove the subcategories before you can delete this category','You will need to remove the subcategories before you can delete this category !'),('en','admin','calendar holiday management','Calendar Holiday Management'),('en','admin','calendar settings','Calendar settings'),('en','admin','do you wish to autoload calendar holidays files dynamically?','Do you wish to autoload calendar holidays files dynamically?'),('en','admin','location to autoload from','Location to autoload from'),('en','admin','imap admin password','IMAP admin password'),('en','admin','imap admin user','IMAP admin user'),('en','admin','enter your imap mail server hostname or ip address','Enter your IMAP mail server hostname or IP address'),('en','admin','enter your sieve server hostname or ip address','Enter your SIEVE server hostname or IP address'),('en','admin','enter your sieve server port','Enter your SIEVE server port'),('en','admin','mail server login type','Mail server login type'),('en','admin','organization name','Organization name'),('en','admin','select your mail server type','Select your mail server type'),('en','admin','sieve settings','Sieve settings'),('en','admin','smtp settings','SMTP settings'),('en','admin','use smtp auth','Use SMTP auth'),('en','admin','users can define their own emailaccounts','Users can define their own emailaccounts'),('en','admin','allow anonymous access to the manual, only necessary to act as remote manual','Allow anonymous access to the manual, only necessary to act as remote manual'),('en','admin','install or update the manual-pages','install or update the manual-pages'),('en','admin','remote egroupware url for the manual to use, empty for a local manual, default','Remote eGroupWare URL for the manual to use, empty for a local manual, default'),('en','admin','update url for the local manual, default','Update URL for the local manual, default'),('en','admin','wiki id for the local manual, default 1, 0 to use the wiki to edit the manual pages','Wiki Id for the local manual, default 1, 0 to use the wiki to edit the manual pages'),('en','admin','maintain news','Maintain News'),('en','admin','picture upload (leave the upload directory empty to disable the upload)','Picture upload (leave the upload directory empty to disable the upload)'),('en','admin','00 (disable)','00 (disable)'),('en','admin','13 (ntp)','13 (ntp)'),('en','admin','80 (http)','80 (http)'),('en','admin','datetime port.<br>if using port 13, please set firewall rules appropriately before submitting this page.<br>(port: 13 / host: 12','Datetime port.<br>If using port 13, please set firewall rules appropriately before submitting this page.<br>(Port: 13 / Host: 129.6.15.28)'),('en','admin','phpsysinfo','System information'),('en','admin','view system information','View system information'),('en','admin','voting booth admin','Voting Booth'),('en','admin','activate account','Activate account'),('en','admin','anonymous password','Anonymous password'),('en','admin','days until trial accounts expire','Days until trial accounts expire'),('en','admin','display terms of service?','Display Terms of Service?'),('en','admin','email address to display for support','Email address to display for support'),('en','admin','email address to send notices from','Email address to send notices from'),('en','admin','enable registration?','Enable Registration?'),('en','admin','http password','HTTP Password'),('en','admin','http username','HTTP Username'),('en','admin','immediately','Immediately'),('en','admin','lost password link at login screen?','Lost password link at login screen?'),('en','admin','lost user id link at login screen?','Lost user id link at login screen?'),('en','admin','manage fields','Manage Fields'),('en','admin','password is','Password is'),('en','admin','register link at login screen?','Register link at login screen?'),('en','admin','registration settings','Registration settings'),('en','admin','send email','Send Email'),('en','admin','subject for confirmation email','Subject for confirmation email'),('en','admin','terms of service text','Terms of Service text'),('en','admin','use html','use HTML'),('en','admin','use trial accounts?','Use trial accounts?'),('en','admin','username is','Username is'),('en','admin','check ldap setup (experimental!!!)','check ldap setup (experimental!!!)'),('en','admin','computer group','computer group'),('en','admin','computer ou','computer ou'),('en','admin','homedrive','homedrive'),('en','admin','logonscript','logonscript'),('en','admin','new account defaults','new account defaults'),('en','admin','path to mkntpwd','path to mkntpwd'),('en','admin','profilepath','profilepath'),('en','admin','samba sid','Samba SID'),('en','admin','smb homepath','smb homepath'),('en','admin','(don\'t offer the possibility)','(don\'t offer the possibility)'),('en','admin','after how many days should old versions of a page be removed (0 for never)','After how many days should old versions of a page be removed (0 for never)'),('en','admin','allow anonymous access','allow anonymous access'),('en','admin','anonymous session type','Anonymous Session Type'),('en','admin','anonymous username','anonymous username'),('en','admin','automatically convert pages with wiki-syntax to richtext (if edited)?','Automatically convert pages with wiki-syntax to richtext (if edited)?'),('en','admin','edit with preview','Edit With Preview'),('en','admin','editable','editable'),('en','admin','emailaddress administrator','Emailaddress Administrator'),('en','admin','enable free links','Enable Free Links'),('en','admin','enable wiki links','Enable Wiki Links'),('en','admin','interwikiprefix','InterWikiPrefix'),('en','admin','name wiki home link','name wiki home link'),('en','admin','no never','No never'),('en','admin','no only on request','No only on request'),('en','admin','only if browser supports a richtext-editor','Only if browser supports a richtext-editor'),('en','admin','path of the upload directory (has to be writable by the webserver!)','Path of the upload directory (has to be writable by the webserver!)'),('en','admin','picture upload via richtext editor (leave the upload directory empty to disable the upload)','Picture upload via richtext editor (leave the upload directory empty to disable the upload)'),('en','admin','readonly','readonly'),('en','admin','url of the upload directory','URL of the upload directory'),('en','admin','yes always','Yes always'),('en','admin','a please wait message is shown when loading the activity form usefull for long tasks','a please wait message is shown when loading the activity form usefull for long tasks'),('en','admin','administer instances','Administer instances'),('en','admin','administer processes','Administer processes'),('en','admin','cleanup aborted instances','Cleanup aborted instances'),('en','admin','default settings for processes','Default settings for processes'),('en','admin','draw roles on the graph beside activity name like [that]','draw roles on the graph beside activity name like [that]'),('en','admin','grant access to the administration and development of workflow processes and activities.','Grant access to the administration and development of workflow processes and activities.'),('en','admin','grant access to the administration of workflow elements','Grant access to the administration of workflow elements'),('en','admin','grant access to the administration of workflow instances in monitor screens','Grant access to the administration of workflow instances in monitor screens'),('en','admin','grant access to the cleanup/deletion of workflow aborted instances in monitor screens','Grant access to the cleanup/deletion of workflow aborted instances in monitor screens'),('en','admin','grant access to the monitoring of workflow elements','Grant access to the monitoring of workflow elements'),('en','admin','if automatic parsing is disabled next options will be useless','if automatic parsing is disabled next options will be useless'),('en','admin','if user is in a role for an activity he will have the right to abort the related instance','if user is in a role for an activity he will have the right to abort the related instance'),('en','admin','if user is in a role for an activity he will have the right to exception or resume the related instance','if user is in a role for an activity he will have the right to exception or resume the related instance'),('en','admin','if user is in a role for an activity he will have the right to release (un-assign) the related instance','if user is in a role for an activity he will have the right to release (un-assign) the related instance'),('en','admin','monitoring','Monitoring'),('en','admin','owner of the instance will have the right to abort the instance at any time','owner of the instance will have the right to abort the instance at any time'),('en','admin','owner of the instance will have the right to exception or resume the instance at any time','owner of the instance will have the right to exception or resume the instance at any time'),('en','admin','owner of the instance will have the right to release (un-assign) an activity assigned to an user','owner of the instance will have the right to release (un-assign) an activity assigned to an user'),('en','admin','size of the font used on the graph 12 should be a good default value','size of the font used on the graph 12 should be a good default value'),('en','admin','the instance title is shown on top of the form','the instance title is shown on top of the form'),('en','admin','this will automatically release the instance when leaving an activity without completing','this will automatically release the instance when leaving an activity without completing'),('en','admin','this will display an activity footer when any activity is runned with workflow engine related informations','this will display an activity footer when any activity is runned with workflow engine related informations'),('en','admin','when multiple submit options are avaible we draw a select box with only one submit instead of multiple buttons','when multiple submit options are avaible we draw a select box with only one submit instead of multiple buttons'),('en','admin','workflow configuration','Workflow configuration'),('en','bookmarks','%1 bookmarks have been deleted','%1 bookmarks have been deleted'),('en','bookmarks','%1 bookmarks imported from %2 successfully.','%1 bookmarks imported from %2 successfully.'),('en','bookmarks','(comma separate multiple addresses)','(comma separate multiple addresses)'),('en','bookmarks','<b>note:</b> this currently works with netscape bookmarks only','<b>Note:</b> This currently works with netscape bookmarks only'),('en','bookmarks','all bookmarks','All bookmarks'),('en','bookmarks','and','And'),('en','bookmarks','append this message to mailed bookmarks','Append this message to mailed bookmarks'),('en','bookmarks','ascending','Ascending'),('en','bookmarks','bookmark changed sucessfully','Bookmark changed sucessfully'),('en','bookmarks','bookmark created successfully.','Bookmark created successfully.'),('en','bookmarks','bookmark deleted successfully','Bookmark deleted successfully.'),('en','bookmarks','bookmark not editable','Bookmark not editable'),('en','bookmarks','bookmark not readable','Bookmark not readable'),('en','bookmarks','bookmarks settings','Bookmarks Settings'),('en','bookmarks','change bookmark','Change Bookmark'),('en','bookmarks','close this window to return','close this window to return'),('en','bookmarks','create bookmark','Create bookmark'),('en','bookmarks','create new bookmark','Create new bookmark'),('en','bookmarks','date added','Date added'),('en','bookmarks','date changed','Date Changed'),('en','bookmarks','date last updated','Date last updated'),('en','bookmarks','date last visited','Date last visited'),('en','bookmarks','descending','Descending'),('en','bookmarks','edit bookmark','Edit bookmark'),('en','bookmarks','edit this bookmark','Edit this bookmark'),('en','bookmarks','enter the name of the netscape bookmark file<br>that you want imported into bookmarker below.','Enter the name of the Netscape bookmark file<br>that you want imported into bookmarker below.'),('en','bookmarks','fewer','Fewer'),('en','bookmarks','filter by','Filter by'),('en','bookmarks','found a link you might like','Found a link you might like'),('en','bookmarks','from','From'),('en','bookmarks','from category %1','from category %1'),('en','bookmarks','highest','Highest'),('en','bookmarks','i thought you would be interested in the following link(s):','I thought you would be interested in the following link(s):'),('en','bookmarks','like','like'),('en','bookmarks','list view','list view'),('en','bookmarks','lowest','Lowest'),('en','bookmarks','mail this bookmark','Mail this bookmark'),('en','bookmarks','mail-this-link message sent to %1.','mail-this-link message sent to %1.'),('en','bookmarks','mass update:','Mass update:'),('en','bookmarks','message from','Message from'),('en','bookmarks','more','More'),('en','bookmarks','name','Name'),('en','bookmarks','name is required','Name is required'),('en','bookmarks','netscape bookmark file','Netscape Bookmark File'),('en','bookmarks','netscape bookmark filename is required!','Netscape bookmark filename is required!'),('en','bookmarks','new bookmark','new bookmark'),('en','bookmarks','or','or'),('en','bookmarks','please fill out <b>to e-mail address</b>, <b>subject</b>, and <b>message</b>!','Please fill out <B>To E-Mail Address</B>, <B>Subject</B>, and <B>Message</B>!'),('en','bookmarks','please select the categories to export','Please select the categories to export'),('en','bookmarks','query condition','Query Condition'),('en','bookmarks','rating','Rating'),('en','bookmarks','search for:','Search for:'),('en','bookmarks','select the format you would like to export to','Select the format you would like to export to'),('en','bookmarks','send bookmark','Send bookmark'),('en','bookmarks','sub category','Sub Category'),('en','bookmarks','to address %1 invalid. format must be <strong>user@domain</strong> and domain must exist!','To address %1 invalid. Format must be <strong>user@domain</strong> and domain must exist!'),('en','bookmarks','to e-mail addresses','To E-Mail Addresses'),('en','bookmarks','to which category should the imported folder hierarchy be attached','To which category should the imported folder hierarchy be attached'),('en','bookmarks','total visits','total visits'),('en','bookmarks','tree view','Tree view'),('en','bookmarks','unable to open temp file %1 for import.','Unable to open temp file %1 for import.'),('en','bookmarks','url is required.','URL is required.'),('en','bookmarks','view bookmark','View bookmark'),('en','bookmarks','view this bookmark','View this bookmark'),('en','bookmarks','warning','Warning'),('en','bookmarks','you are viewing this site outside of egroupware','You are viewing this site outside of eGroupWare'),('en','bookmarks','you must select a category','You must select a category'),('en','bookmark','new','New'),('en','calendar','%1 %2 in %3','%1 %2 in %3'),('en','calendar','%1 records imported','%1 records imported'),('en','calendar','%1 records read (not yet imported, you may go back and uncheck test import)','%1 records read (not yet imported, you may go back and uncheck Test Import)'),('en','calendar','<b>please note</b>: the calendar use the holidays of your country, which is set to %1. you can change it in your %2.<br />holida','<b>Please note</b>: The calendar use the holidays of your country, which is set to %1. You can change it in your %2.<br />Holidays are %3 automatic installed from %4. You can changed it in %5.'),('en','calendar','a non blocking event will not conflict with other events','A non blocking event will not conflict with other events'),('en','calendar','accept or reject an invitation','Accept or reject an invitation'),('en','calendar','accepted','Accepted'),('en','calendar','access denied to the calendar of %1 !!!','Access denied to the calendar of %1 !!!'),('en','calendar','action that caused the notify: added, canceled, accepted, rejected, ...','Action that caused the notify: Added, Canceled, Accepted, Rejected, ...'),('en','calendar','actions','Actions'),('en','calendar','add alarm','Add alarm'),('en','calendar','added','Added'),('en','calendar','after current date','After current date'),('en','calendar','alarm','Alarm'),('en','calendar','alarm added','Alarm added'),('en','calendar','alarm deleted','Alarm deleted'),('en','calendar','alarm for %1 at %2 in %3','Alarm for %1 at %2 in %3'),('en','calendar','alarm management','Alarm management'),('en','calendar','alarms','Alarms'),('en','calendar','all categories','All categories'),('en','calendar','all day','all day'),('en','calendar','all events','All events'),('en','calendar','all participants','All participants'),('en','calendar','allows to edit the event again','Allows to edit the event again'),('en','calendar','apply the changes','apply the changes'),('en','calendar','are you sure you want to delete this country ?','Are you sure you want to delete this Country ?'),('en','calendar','are you sure you want to delete this holiday ?','Are you sure you want to delete this holiday ?'),('en','calendar','back half a month','back half a month'),('en','calendar','back one month','back one month'),('en','calendar','before current date','Before current date'),('en','calendar','before the event','before the event'),('en','calendar','birthday','Birthday'),('en','calendar','busy','busy'),('en','calendar','by','by'),('en','calendar','calendar event','Calendar Event'),('en','calendar','calendar menu','Calendar Menu'),('en','calendar','calendar preferences','Calendar preferences'),('en','calendar','calendar-fieldname','calendar-Fieldname'),('en','calendar','can\'t add alarms in the past !!!','Can\'t add alarms in the past !!!'),('en','calendar','canceled','Canceled'),('en','calendar','charset of file','Charset of file'),('en','calendar','close the window','Close the window'),('en','calendar','compose a mail to all participants after the event is saved','compose a mail to all participants after the event is saved'),('en','calendar','copy of:','Copy of:'),('en','calendar','copy this event','Copy this event'),('en','calendar','countries','Countries'),('en','calendar','country','Country'),('en','calendar','create an exception at this recuring event','Create an exception at this recuring event'),('en','calendar','create new links','Create new links'),('en','calendar','csv','CSV'),('en','calendar','csv-fieldname','CSV-Fieldname'),('en','calendar','csv-filename','CSV-Filename'),('en','calendar','daily','Daily'),('en','calendar','days','days'),('en','calendar','days of the week for a weekly repeated event','Days of the week for a weekly repeated event'),('en','calendar','days repeated','days repeated'),('en','calendar','dayview','Dayview'),('en','calendar','default appointment length (in minutes)','default appointment length (in minutes)'),('en','calendar','default calendar filter','Default calendar filter'),('en','calendar','default calendar view','default calendar view'),('en','calendar','default length of newly created events. the length is in minutes, eg. 60 for 1 hour.','Default length of newly created events. The length is in minutes, eg. 60 for 1 hour.'),('en','calendar','default week view','default week view'),('en','calendar','delete series','Delete series'),('en','calendar','delete this alarm','Delete this alarm'),('en','calendar','delete this event','Delete this event'),('en','calendar','delete this exception','Delete this exception'),('en','calendar','delete this series of recuring events','Delete this series of recuring events'),('en','calendar','disinvited','Disinvited'),('en','calendar','display status of events','Display status of events'),('en','calendar','displayed view','displayed view'),('en','calendar','displays your default calendar view on the startpage (page you get when you enter egroupware or click on the homepage icon)?','Displays your default calendar view on the startpage (page you get when you enter eGroupWare or click on the homepage icon)?'),('en','calendar','do you want a weekview with or without weekend?','Do you want a weekview with or without weekend?'),('en','calendar','do you want to be notified about new or changed appointments? you be notified about changes you make yourself.<br>you can limit','Do you want to be notified about new or changed appointments? You be notified about changes you make yourself.<br>You can limit the notifications to certain changes only. Each item includes all the notification listed above it. All modifications include changes of title, description, participants, but no participant responses. If the owner of an event requested any notifcations, he will always get the participant responses like acceptions and rejections too.'),('en','calendar','do you want to receive a regulary summary of your appointsments via email?<br>the summary is sent to your standard email-address','Do you want to receive a regulary summary of your appointsments via email?<br>The summary is sent to your standard email-address on the morning of that day or on Monday for weekly summarys.<br>It is only sent when you have any appointments on that day or week.'),('en','calendar','download','Download'),('en','calendar','download this event as ical','Download this event as iCal'),('en','calendar','duration of the meeting','Duration of the meeting'),('en','calendar','edit exception','Edit exception'),('en','calendar','edit series','Edit series'),('en','calendar','edit this event','Edit this event'),('en','calendar','edit this series of recuring events','Edit this series of recuring events'),('en','calendar','empty for all','empty for all'),('en','calendar','end','End'),('en','calendar','end date/time','End Date/Time'),('en','calendar','enddate','Enddate'),('en','calendar','enddate / -time of the meeting, eg. for more then one day','Enddate / -time of the meeting, eg. for more then one day'),('en','calendar','enddate of the export','Enddate of the export'),('en','calendar','ends','ends'),('en','calendar','error adding the alarm','Error adding the alarm'),('en','calendar','error: importing the ical','Error: importing the iCal'),('en','calendar','error: no participants selected !!!','Error: no participants selected !!!'),('en','calendar','error: saving the event !!!','Error: saving the event !!!'),('en','calendar','error: starttime has to be before the endtime !!!','Error: Starttime has to be before the endtime !!!'),('en','calendar','event copied - the copy can now be edited','Event copied - the copy can now be edited'),('en','calendar','event deleted','Event deleted'),('en','calendar','event details follow','Event Details follow'),('en','calendar','event saved','Event saved'),('en','calendar','event will occupy the whole day','Event will occupy the whole day'),('en','calendar','exception','Exception'),('en','calendar','exceptions','Exceptions'),('en','calendar','existing links','Existing links'),('en','calendar','export','Export'),('en','calendar','extended','Extended'),('en','calendar','extended updates always include the complete event-details. ical\'s can be imported by certain other calendar-applications.','Extended updates always include the complete event-details. iCal\'s can be imported by certain other calendar-applications.'),('en','calendar','fieldseparator','Fieldseparator'),('en','calendar','filename','Filename'),('en','calendar','filename of the download','Filename of the download'),('en','calendar','find free timeslots where the selected participants are availible for the given timespan','Find free timeslots where the selected participants are availible for the given timespan'),('en','calendar','firstname of person to notify','Firstname of person to notify'),('en','calendar','for','for'),('en','calendar','for which views should calendar show distinct lines with a fixed time interval.','For which views should calendar show distinct lines with a fixed time interval.'),('en','calendar','format of event updates','Format of event updates'),('en','calendar','forward half a month','forward half a month'),('en','calendar','forward one month','forward one month'),('en','calendar','four days view','Four days view'),('en','calendar','freebusy: unknow user \'%1\', wrong password or not availible to not loged in users !!!','freebusy: Unknow user \'%1\', wrong password or not availible to not loged in users !!!'),('en','calendar','freetime search','Freetime Search'),('en','calendar','fri','Fri'),('en','calendar','full description','Full description'),('en','calendar','fullname of person to notify','Fullname of person to notify'),('en','calendar','general','General'),('en','calendar','global public and group public','global public and group public'),('en','calendar','global public only','global public only'),('en','calendar','group invitation','Group invitation'),('en','calendar','group planner','Group planner'),('en','calendar','group public only','group public only'),('en','calendar','groupmember(s) %1 not included, because you have no access.','Groupmember(s) %1 not included, because you have no access.'),('en','calendar','h','h'),('en','calendar','here is your requested alarm.','Here is your requested alarm.'),('en','calendar','high priority','high priority'),('en','calendar','holiday','Holiday'),('en','calendar','holiday management','Holiday Management'),('en','calendar','holidays','Holidays'),('en','calendar','hours','hours'),('en','calendar','how far to search (from startdate)','how far to search (from startdate)'),('en','calendar','how many minutes should each interval last?','How many minutes should each interval last?'),('en','calendar','ical','iCal'),('en','calendar','ical / rfc2445','iCal / rfc2445'),('en','calendar','ical export','iCal Export'),('en','calendar','ical file','iCal file'),('en','calendar','ical import','iCal Import'),('en','calendar','ical successful imported','iCal successful imported'),('en','calendar','if checked holidays falling on a weekend, are taken on the monday after.','If checked holidays falling on a weekend, are taken on the monday after.'),('en','calendar','if you dont set a password here, the information is available to everyone, who knows the url!!!','If you dont set a password here, the information is available to everyone, who knows the URL!!!'),('en','calendar','ignore conflict','Ignore conflict'),('en','calendar','import','Import'),('en','calendar','interval','Interval'),('en','calendar','invalid email-address \"%1\" for user %2','Invalid email-address \"%1\" for user %2'),('en','calendar','last','Last'),('en','calendar','lastname of person to notify','Lastname of person to notify'),('en','calendar','length of the time interval','Length of the time interval'),('en','calendar','link to view the event','Link to view the event'),('en','calendar','links','Links'),('en','calendar','links, attachments','Links, Attachments'),('en','calendar','listview','Listview'),('en','calendar','location','Location'),('en','calendar','location, start- and endtimes, ...','Location, Start- and Endtimes, ...'),('en','calendar','mail all participants','mail all participants'),('en','calendar','make freebusy information available to not loged in persons?','Make freebusy information available to not loged in persons?'),('en','calendar','minutes','Minutes'),('en','calendar','modified','Modified'),('en','calendar','mon','Mon'),('en','calendar','monthly','Monthly'),('en','calendar','monthly (by date)','Monthly (by date)'),('en','calendar','monthly (by day)','Monthly (by day)'),('en','calendar','monthview','Monthview'),('en','calendar','new search with the above parameters','new search with the above parameters'),('en','calendar','no events found','No events found'),('en','calendar','no filter','No filter'),('en','calendar','no matches found','no matches found'),('en','calendar','no response','No response'),('en','calendar','non blocking','non blocking'),('en','calendar','notification messages for added events','Notification messages for added events'),('en','calendar','notification messages for canceled events','Notification messages for canceled events'),('en','calendar','notification messages for disinvited participants','Notification messages for disinvited participants'),('en','calendar','notification messages for modified events','Notification messages for modified events'),('en','calendar','notification messages for your alarms','Notification messages for your alarms'),('en','calendar','notification messages for your responses','Notification messages for your responses'),('en','calendar','number of records to read (%1)','Number of records to read (%1)'),('en','calendar','observance rule','Observance Rule'),('en','calendar','occurence','Occurence'),('en','calendar','old startdate','Old Startdate'),('en','calendar','on %1 %2 %3 your meeting request for %4','On %1 %2 %3 your meeting request for %4'),('en','calendar','on all modification, but responses','on all modification, but responses'),('en','calendar','on any time change too','on any time change too'),('en','calendar','on invitation / cancelation only','on invitation / cancelation only'),('en','calendar','on participant responses too','on participant responses too'),('en','calendar','on time change of more than 4 hours too','on time change of more than 4 hours too'),('en','calendar','one month','one month'),('en','calendar','one week','one week'),('en','calendar','one year','one year'),('en','calendar','only the initial date of that recuring event is checked!','Only the initial date of that recuring event is checked!'),('en','calendar','open todo\'s:','open ToDo\'s:'),('en','calendar','overlap holiday','overlap holiday'),('en','calendar','participants','Participants'),('en','calendar','participants disinvited from an event','Participants disinvited from an event'),('en','calendar','participants, resources, ...','Participants, Resources, ...'),('en','calendar','password for not loged in users to your freebusy information?','Password for not loged in users to your freebusy information?'),('en','calendar','people holiday','people holiday'),('en','calendar','permission denied','Permission denied'),('en','calendar','planner by category','Planner by category'),('en','calendar','planner by user','Planner by user'),('en','calendar','please note: you can configure the field assignments after you uploaded the file.','Please note: You can configure the field assignments AFTER you uploaded the file.'),('en','calendar','preselected group for entering the planner','Preselected group for entering the planner'),('en','calendar','previous','previous'),('en','calendar','private and global public','private and global public'),('en','calendar','private and group public','private and group public'),('en','calendar','private only','Private Only'),('en','calendar','re-edit event','Re-Edit event'),('en','calendar','receive email updates','Receive email updates'),('en','calendar','receive summary of appointments','Receive summary of appointments'),('en','calendar','recurrence','Recurrence'),('en','calendar','recurring event','Recurring event'),('en','calendar','rejected','Rejected'),('en','calendar','repeat days','Repeat days'),('en','calendar','repeat the event until which date (empty means unlimited)','repeat the event until which date (empty means unlimited)'),('en','calendar','repeat type','Repeat type'),('en','calendar','repeating event information','Repeating Event Information'),('en','calendar','repeating interval, eg. 2 to repeat every second week','repeating interval, eg. 2 to repeat every second week'),('en','calendar','repetition','Repetition'),('en','calendar','repetitiondetails (or empty)','Repetitiondetails (or empty)'),('en','calendar','reset','Reset'),('en','calendar','resources','Resources'),('en','calendar','rule','Rule'),('en','calendar','sat','Sat'),('en','calendar','saves the changes made','saves the changes made'),('en','calendar','saves the event ignoring the conflict','Saves the event ignoring the conflict'),('en','calendar','scheduling conflict','Scheduling conflict'),('en','calendar','select a %1','select a %1'),('en','calendar','select a time','select a time'),('en','calendar','select resources','Select resources'),('en','calendar','select who should get the alarm','Select who should get the alarm'),('en','calendar','set a year only for one-time / non-regular holidays.','Set a Year only for one-time / non-regular holidays.'),('en','calendar','set new events to private','Set new events to private'),('en','calendar','should invitations you rejected still be shown in your calendar ?<br>you can only accept them later (eg. when your scheduling co','Should invitations you rejected still be shown in your calendar ?<br>You can only accept them later (eg. when your scheduling conflict is removed), if they are still shown in your calendar!'),('en','calendar','should new events created as private by default ?','Should new events created as private by default ?'),('en','calendar','should not loged in persons be able to see your freebusy information? you can set an extra password, different from your normal','Should not loged in persons be able to see your freebusy information? You can set an extra password, different from your normal password, to protect this informations. The freebusy information is in iCal format and only include the times when you are busy. It does not include the event-name, description or locations. The URL to your freebusy information is %1.'),('en','calendar','should the status of the event-participants (accept, reject, ...) be shown in brakets after each participants name ?','Should the status of the event-participants (accept, reject, ...) be shown in brakets after each participants name ?'),('en','calendar','show default view on main screen','show default view on main screen'),('en','calendar','show invitations you rejected','Show invitations you rejected'),('en','calendar','show list of upcoming events','show list of upcoming events'),('en','calendar','show this month','show this month'),('en','calendar','show this week','show this week'),('en','calendar','single event','single event'),('en','calendar','start','Start'),('en','calendar','start date/time','Start Date/Time'),('en','calendar','startdate / -time','Startdate / -time'),('en','calendar','startdate and -time of the search','Startdate and -time of the search'),('en','calendar','startdate of the export','Startdate of the export'),('en','calendar','startrecord','Startrecord'),('en','calendar','status changed','Status changed'),('en','calendar','submit to repository','Submit to Repository'),('en','calendar','sun','Sun'),('en','calendar','tentative','Tentative'),('en','calendar','test import (show importable records <u>only</u> in browser)','Test Import (show importable records <u>only</u> in browser)'),('en','calendar','this day is shown as first day in the week or month view.','This day is shown as first day in the week or month view.'),('en','calendar','this defines the end of your dayview. events after this time, are shown below the dayview.','This defines the end of your dayview. Events after this time, are shown below the dayview.'),('en','calendar','this defines the start of your dayview. events before this time, are shown above the dayview.<br>this time is also used as a def','This defines the start of your dayview. Events before this time, are shown above the dayview.<br>This time is also used as a default starttime for new events.'),('en','calendar','this group that is preselected when you enter the planner. you can change it in the planner anytime you want.','This group that is preselected when you enter the planner. You can change it in the planner anytime you want.'),('en','calendar','this message is sent for canceled or deleted events.','This message is sent for canceled or deleted events.'),('en','calendar','this message is sent for modified or moved events.','This message is sent for modified or moved events.'),('en','calendar','this message is sent to disinvited participants.','This message is sent to disinvited participants.'),('en','calendar','this message is sent to every participant of events you own, who has requested notifcations about new events.<br>you can use cer','This message is sent to every participant of events you own, who has requested notifcations about new events.<br>You can use certain variables which get substituted with the data of the event. The first line is the subject of the email.'),('en','calendar','this message is sent when you accept, tentative accept or reject an event.','This message is sent when you accept, tentative accept or reject an event.'),('en','calendar','this message is sent when you set an alarm for a certain event. include all information you might need.','This message is sent when you set an Alarm for a certain event. Include all information you might need.'),('en','calendar','three month','three month'),('en','calendar','thu','Thu'),('en','calendar','til','til'),('en','calendar','timeframe','Timeframe'),('en','calendar','timeframe to search','Timeframe to search'),('en','calendar','title of the event','Title of the event'),('en','calendar','to many might exceed your execution-time-limit','to many might exceed your execution-time-limit'),('en','calendar','translation','Translation'),('en','calendar','tue','Tue'),('en','calendar','two weeks','two weeks'),('en','calendar','updated','Updated'),('en','calendar','use end date','use end date'),('en','calendar','use the selected time and close the popup','use the selected time and close the popup'),('en','calendar','view this event','View this event'),('en','calendar','views with fixed time intervals','Views with fixed time intervals'),('en','calendar','wed','Wed'),('en','calendar','week','Week'),('en','calendar','weekday starts on','weekday starts on'),('en','calendar','weekdays','Weekdays'),('en','calendar','weekdays to use in search','Weekdays to use in search'),('en','calendar','weekly','Weekly'),('en','calendar','weekview','Weekview'),('en','calendar','weekview with weekend','Weekview with weekend'),('en','calendar','weekview without weekend','Weekview without weekend'),('en','calendar','which events do you want to see when you enter the calendar.','Which events do you want to see when you enter the calendar.'),('en','calendar','which of calendar view do you want to see, when you start calendar ?','Which of calendar view do you want to see, when you start calendar ?'),('en','calendar','whole day','whole day'),('en','calendar','wk','Wk'),('en','calendar','work day ends on','work day ends on'),('en','calendar','work day starts on','work day starts on'),('en','calendar','yearly','Yearly'),('en','calendar','yearview','yearview'),('en','calendar','you can either set a year or a occurence, not both !!!','You can either set a Year or a Occurence, not both !!!'),('en','calendar','you can only set a year or a occurence !!!','You can only set a year or a occurence !!!'),('en','calendar','you do not have permission to read this record!','You do not have permission to read this record!'),('en','calendar','you have a meeting scheduled for %1','You have a meeting scheduled for %1'),('en','calendar','you have been disinvited from the meeting at %1','You have been disinvited from the meeting at %1'),('en','calendar','you need to select an ical file first','You need to select an iCal file first'),('en','calendar','you need to set either a day or a occurence !!!','You need to set either a day or a occurence !!!'),('en','calendar','your meeting scheduled for %1 has been canceled','Your meeting scheduled for %1 has been canceled'),('en','calendar','your meeting that had been scheduled for %1 has been rescheduled to %2','Your meeting that had been scheduled for %1 has been rescheduled to %2'),('en','developer_tools','add','add'),('en','developer_tools','add change','Add change'),('en','developer_tools','add more','Add more'),('en','developer_tools','add new phrase','Add new phrase'),('en','developer_tools','add phrase','add phrase'),('en','developer_tools','allows you to add a single phrase','Allows you to add a single phrase'),('en','developer_tools','application','Application'),('en','developer_tools','back','Back'),('en','developer_tools','cancel','Cancel'),('en','developer_tools','change','Change'),('en','developer_tools','changelog entry has been added','Changelog entry has been added'),('en','developer_tools','changelogs','Changelogs'),('en','developer_tools','clears the internal buffer, all changes made sofar are lost','Clears the internal buffer, all changes made sofar are lost'),('en','developer_tools','create new language file','Create New Language File'),('en','developer_tools','create sgml file','Create SGML file'),('en','developer_tools','developer tools - preferences','Developer tools - preferences'),('en','developer_tools','diary','Diary'),('en','developer_tools','done','done'),('en','developer_tools','download','Download'),('en','developer_tools','download the lang-file to be saved in the apps setup-dir','Download the lang-file to be saved in the apps setup-dir'),('en','developer_tools','edit','Edit'),('en','developer_tools','installed applications','Installed applications'),('en','developer_tools','language file management','Language file management'),('en','developer_tools','list changelogs','List changelogs'),('en','developer_tools','load','Load'),('en','developer_tools','loading source langfile','Loading source langfile'),('en','developer_tools','loading target langfile','Loading target langfile'),('en','developer_tools','loads the selected lang-files, to be modified in the next steps','Loads the selected lang-files, to be modified in the next steps'),('en','developer_tools','message','Message'),('en','developer_tools','message_id in english','message_id in English'),('en','developer_tools','no file','no file'),('en','developer_tools','ok','ok'),('en','developer_tools','original','Original'),('en','developer_tools','phrase in english (or empty if identical)','Phrase in English (or empty if identical)'),('en','developer_tools','preferences','Preferences'),('en','developer_tools','preferences have been updated','Preferences have been updated'),('en','developer_tools','project','Project'),('en','developer_tools','remove','Remove'),('en','developer_tools','removed %1 phrases from the target language, as they are not present in the source language!','Removed %1 phrases from the target language, as they are not present in the source language!'),('en','developer_tools','returns to the application list, not saved changes get lost !!!','Returns to the application list, not saved changes get lost !!!'),('en','developer_tools','revert','Revert'),('en','developer_tools','saves the added/changed translations to an internal buffer, to be used in further steps','Saves the added/changed translations to an internal buffer, to be used in further steps'),('en','developer_tools','search changelogs','Search changelogs'),('en','developer_tools','search for missing phrase','Search for missing phrase'),('en','developer_tools','search new phrases','Search new phrases'),('en','developer_tools','searches the source-code for phrases not in the actual source-lang-file','Searches the source-code for phrases not in the actual source-lang-file'),('en','developer_tools','select project','Select project'),('en','developer_tools','sf project tracker','SF Project tracker'),('en','developer_tools','source language','Source Language'),('en','developer_tools','sourceforge project id','Sourceforge project ID'),('en','developer_tools','sourceforge project tracker','Sourceforge project tracker'),('en','developer_tools','sourceforge project tracker preferences','Sourceforge project tracker preferences'),('en','developer_tools','step','Step'),('en','developer_tools','submit','Submit'),('en','developer_tools','target language','Target Language'),('en','developer_tools','title','Title'),('en','developer_tools','translate','Translate'),('en','developer_tools','translation','Translation'),('en','developer_tools','translation of phrase','Translation of phrase'),('en','developer_tools','update','Update'),('en','developer_tools','update database','Update Database'),('en','developer_tools','updates the translations of both lang-files in your database, so you can verify your work immediately','Updates the translations of both lang-files in your database, so you can verify your work immediately'),('en','developer_tools','version','Version'),('en','developer_tools','write','Write'),('en','developer_tools','write the lang-file to the apps setup-dir','Write the lang-file to the apps setup-dir'),('en','developer_tools','write to lang table','Write to lang table'),('en','developer_tools','writing langfile for \'%1\' ...','Writing langfile for \'%1\' ...'),('en','developer_tools','you have to [save] every manual change in the above fields, before you can go to the next step !!!','You have to [Save] every manual change in the above fields, before you can go to the next step !!!'),('en','developer_tools','you must a version','You must a version'),('en','developer_tools','you must enter a change','You must enter a change'),('en','developer_tools','you must select a project','You must select a project'),('en','developer_tools','you need to set your preferences for this app','You need to set your preferences for this app'),('en','preferences','sf project tracker preferences','SF Project tracker preferences'),('en','preferences','manage emailfilter / vacation','Manage EMailfilter / Vacation'),('en','preferences','%1 - preferences','%1 - Preferences'),('en','preferences','%1 hours','%1 hours'),('en','preferences','12 hour','12 hour'),('en','preferences','24 hour','24 hour'),('en','preferences','a template defines the layout of egroupware and it contains icons for each application.','A template defines the layout of eGroupWare and it contains icons for each application.'),('en','preferences','a theme defines the colors and fonts used by the template.','A theme defines the colors and fonts used by the template.'),('en','preferences','acl grants have been updated','ACL grants have been updated'),('en','preferences','any listing in egw will show you this number of entries or lines per page.<br>to many slow down the page display, to less will c','Any listing in eGroupWare will show you this number of entries or lines per page.<br>Too many slow down the page display, too less will cost you the overview.'),('en','preferences','are you sure you want to delete this category ?','Are you sure you want to delete this category ?'),('en','preferences','change a user password by passing the old and new passwords.  returns true on success, false on failure.','Change a user password by passing the old and new passwords.  Returns TRUE on success, FALSE on failure.'),('en','preferences','change your password','Change your Password'),('en','preferences','change your profile','Change your profile'),('en','preferences','change your settings','Change your Settings'),('en','preferences','click to select a color','Click to select a color'),('en','preferences','color','Color'),('en','preferences','country','Country'),('en','preferences','date format','Date format'),('en','preferences','default','default'),('en','preferences','default application','Default application'),('en','preferences','default preferences','Default Preferences'),('en','preferences','delete categories','Delete Categories'),('en','preferences','description can not exceed 255 characters in length !','Description can not exceed 255 characters in length !'),('en','preferences','do you prefer a 24 hour time format, or a 12 hour one with am/pm attached.','Do you prefer a 24 hour time format, or a 12 hour one with am/pm attached.'),('en','preferences','edit custom fields','edit custom fields'),('en','preferences','enter your new password','Enter your new password'),('en','preferences','enter your old password','Enter your old password'),('en','preferences','error: there was a problem finding the preference file for %1 in %2','Error: There was a problem finding the preference file for %1 in %2'),('en','preferences','failed to change password.  please contact your administrator.','Failed to change password.  Please contact your administrator.'),('en','preferences','forced preferences','Forced Preferences'),('en','preferences','help off','Help off'),('en','preferences','hours','hours'),('en','preferences','how do you like to display accounts','How would you like to display accounts'),('en','preferences','how do you like to select accounts','How would you like to select accounts'),('en','preferences','how many hours are you in front or after the timezone of the server.<br>if you are in the same time zone as the server select 0','How many hours are you in front or after the timezone of the server.<br>If you are in the same time zone as the server select 0 hours, else select your locale date and time.'),('en','preferences','how many icons should be shown in the navbar (top of the page). additional icons go into a kind of pulldown menu, callable by th','How many icons should be shown in the navigation bar at the top of the page. Additional icons go into a pulldown menu, callable by the icon on the far right side of the navbar.'),('en','preferences','how should egroupware display dates for you.','How should eGroupWare display dates for you.'),('en','preferences','icon','Icon'),('en','preferences','icons and text','Icons and text'),('en','preferences','icons only','icons only'),('en','preferences','in which country are you. this is used to set certain defaults for you.','In which country are you. This is used to set certain defaults for you.'),('en','preferences','interface/template selection','Interface/Template Selection'),('en','preferences','language','Language'),('en','preferences','max matches per page','Max matches per page'),('en','preferences','max number of icons in navbar','Max number of icons in navigation bar'),('en','preferences','no default','No default'),('en','preferences','note: this feature does *not* change your email password. this will','note: This feature does *not* change your email password. This will'),('en','preferences','note: this feature does *not* change your email password. this will need to be done manually.','Note: This feature does *not* change your email password. This will need to be done manually.'),('en','preferences','please, select a new theme','Please, select a new theme'),('en','preferences','popup with search','Popup with search'),('en','preferences','re-enter your password','Re-Enter your password'),('en','preferences','read prefs for the specified application.','Read prefs for the specified application.'),('en','preferences','select different theme','Select different Theme'),('en','preferences','select one','Select one'),('en','preferences','select the language of texts and messages within egroupware.<br>some languages may not contain all messages, in that case you wi','Select the language of texts and messages within eGroupWare.<br>Some languages may not contain all messages, in that case you will see an english message.'),('en','preferences','selectbox','Selectbox'),('en','preferences','selectbox with primary group and search','Selectbox with primary group and search'),('en','preferences','set this to your convenience. for security reasons, you might not want to show your loginname in public.','Set this to your liking.  For security reasons, you might not want to show your Username in public.'),('en','preferences','should the number of active sessions be displayed for you all the time.','Should the number of active sessions be displayed for you all the time.'),('en','preferences','should this help messages shown up always, when you enter the preferences or only on request.','Should these help messages always display when modifying preferences, or only on request.'),('en','preferences','show helpmessages by default','Show help messages by default'),('en','preferences','show navigation bar as','Show navigation bar as'),('en','preferences','show number of current users','Show number of current users'),('en','preferences','show text on navigation icons','Show text on navigation icons'),('en','preferences','text only','Text only'),('en','preferences','the default application will be started when you enter egroupware or click on the homepage icon.<br>you can also have more than','The default application will be started when you enter eGroupWare or click on the homepage icon.<br>You can also have more than one application showing up on the homepage, if you don\'t choose a specific application here (has to be configured in the preferences of each application).'),('en','preferences','the old password is not correct','The old password is not correct'),('en','preferences','the selectbox shows all available users (can be very slow on big installs with many users). the popup can search users by name o','The selectbox shows all available users (can be very slow on big installs with many users). The popup can search users by name or group.'),('en','preferences','the two passwords are not the same','The two passwords are not the same'),('en','preferences','theme (colors/fonts) selection','Theme (colors/fonts) Selection'),('en','preferences','this server is located in the %1 timezone','This server is located in the %1 timezone'),('en','preferences','time format','Time format'),('en','preferences','use default','Use default'),('en','preferences','users choice','Users choice'),('en','preferences','when you say yes the home and logout buttons are presented as applications in the main top applcation bar.','When you say yes the home and logout buttons are presented as applications in the main top applcation bar.'),('en','preferences','which currency symbol or name should be used in egroupware.','Which currency symbol or name should be used in eGroupWare.'),('en','preferences','write prefs for the specified application.','Write prefs for the specified application.'),('en','preferences','you can show the applications as icons only, icons with app-name or both.','You can show the applications as icons only, icons with app-name or both.'),('en','preferences','you do not have permission to set acl\'s in this mode!','You do not have permission to set ACL\'s in this mode!'),('en','preferences','you must enter a password','You must enter a password'),('en','preferences','your current theme is: %1','your current theme is: %1'),('en','preferences','your preferences','Your Preferences'),('en','emailadmin','add profile','Add Profile'),('en','emailadmin','admin dn','admin dn'),('en','emailadmin','admin password','admin password'),('en','emailadmin','admin passwort','admin passwort'),('en','emailadmin','admin username','admin username'),('en','emailadmin','advanced options','advanced options'),('en','emailadmin','alternate email address','alternate email address'),('en','emailadmin','cyrus imap server','Cyrus IMAP Server'),('en','emailadmin','cyrus imap server administration','Cyrus IMAP server administration'),('en','emailadmin','default','default'),('en','emailadmin','deliver extern','deliver extern'),('en','emailadmin','do you really want to delete this profile','Do you really want to delete this Profile'),('en','emailadmin','domainname','domainname'),('en','emailadmin','edit email settings','edit email settings'),('en','emailadmin','email account active','email account active'),('en','emailadmin','email address','email address'),('en','emailadmin','enable cyrus imap server administration','enable Cyrus IMAP server administration'),('en','emailadmin','enable sieve','enable Sieve'),('en','emailadmin','enter your default mail domain (from: user@domain)','Enter your default mail domain (from: user@domain)'),('en','emailadmin','forward also to','forward also to'),('en','emailadmin','forward email\'s to','forward email\'s to'),('en','emailadmin','forward only','forward only'),('en','emailadmin','imap server hostname or ip address','IMAP server hostname or ip address'),('en','emailadmin','imap server logintyp','IMAP server login type'),('en','emailadmin','imap server port','IMAP server port'),('en','emailadmin','imap/pop3 server name','IMAP/POP3 server name'),('en','emailadmin','in mbyte','in MByte'),('en','emailadmin','ldap basedn','LDAP basedn'),('en','emailadmin','ldap server','LDAP server'),('en','emailadmin','ldap server accounts dn','LDAP server accounts DN'),('en','emailadmin','ldap server admin dn','LDAP server admin DN'),('en','emailadmin','ldap server admin password','LDAP server admin password'),('en','emailadmin','ldap server hostname or ip address','LDAP server hostname or ip address'),('en','emailadmin','ldap settings','LDAP settings'),('en','emailadmin','leave empty for no quota','leave empty for no quota'),('en','emailadmin','name of organisation','Name of organization'),('en','emailadmin','no alternate email address','no alternate email address'),('en','emailadmin','no forwarding email address','no forwarding email address'),('en','emailadmin','pop3 server hostname or ip address','POP3 server hostname or ip address'),('en','emailadmin','pop3 server port','POP3 server port'),('en','emailadmin','postfix with ldap','Postfix with LDAP'),('en','emailadmin','profile list','Profile List'),('en','emailadmin','profile name','Profile Name'),('en','emailadmin','qmaildotmode','qmaildotmode'),('en','emailadmin','qouta size in mbyte','qouta size in MByte'),('en','emailadmin','quota settings','quota settings'),('en','emailadmin','remove','remove'),('en','emailadmin','select type of imap/pop3 server','Select type of IMAP/POP3 server'),('en','emailadmin','select type of smtp server','Select type of SMTP Server'),('en','emailadmin','sieve server hostname or ip address','Sieve server hostname or ip address'),('en','emailadmin','sieve server port','Sieve server port'),('en','emailadmin','sieve settings','Sieve settings'),('en','emailadmin','smtp server name','SMTP server name'),('en','emailadmin','smtp-server hostname or ip address','SMTP server hostname or IP address'),('en','emailadmin','smtp-server port','SMTP server port'),('en','emailadmin','standard','Standard'),('en','emailadmin','standard imap server','Standard IMAP server'),('en','emailadmin','standard pop3 server','Standard POP3 server'),('en','emailadmin','standard smtp-server','Standard SMTP server'),('en','emailadmin','use ldap defaults','use LDAP defaults'),('en','emailadmin','use smtp auth','Use SMTP auth'),('en','emailadmin','use tls authentication','Use TLS authentication'),('en','emailadmin','use tls encryption','Use TLS encryption'),('en','emailadmin','users can define their own emailaccounts','Users can define their own email accounts'),('en','emailadmin','virtual mail manager','Virtual MAIL ManaGeR'),('en','emailadmin','imap c-client version < 2001','IMAP C-Client Version < 2001'),('en','etemplate','%1 (%2 new) messages writen for application \'%3\' and languages \'%4\'','%1 (%2 new) Messages writen for Application \'%3\' and Languages \'%4\''),('en','etemplate','%1 etemplates deleted','%1 eTemplates deleted'),('en','etemplate','%1 etemplates for application \'%2\' dumped to \'%3\'','%1 eTemplates for Application \'%2\' dumped to \'%3\''),('en','etemplate','%1 etemplates found','%1 eTemplates found'),('en','etemplate','%1 matches on search criteria','%1 matches on search criteria'),('en','etemplate','%1 new etemplates imported for application \'%2\'','%1 new eTemplates imported for Application \'%2\''),('en','etemplate','%s disabled','%s disabled'),('en','etemplate','%s needed','%s needed'),('en','etemplate','%s notranslation','%s NoTranslation'),('en','etemplate','%s onchange','%s onChange'),('en','etemplate','%s readonly','%s readonly'),('en','etemplate','\'%1\' has an invalid format !!!','\'%1\' has an invalid format !!!'),('en','etemplate','\'%1\' is not a valid date !!!','\'%1\' is not a valid date !!!'),('en','etemplate','\'%1\' is not a valid floatingpoint number !!!','\'%1\' is not a valid floatingpoint number !!!'),('en','etemplate','\'%1\' is not a valid integer !!!','\'%1\' is not a valid integer !!!'),('en','etemplate','a pattern to be searched for','a pattern to be searched for'),('en','etemplate','accesskey','Accesskey'),('en','etemplate','accesskeys can also be specified with an & in the label (eg. &name)','Accesskeys can also be specified with an & in the label (eg. &Name)'),('en','etemplate','add a new column (after the existing ones)','Add a new column (after the existing ones)'),('en','etemplate','add a new entry of the selected application','Add a new entry of the selected application'),('en','etemplate','add a new multi-column index','Add a new multi-column index'),('en','etemplate','add column','Add Column'),('en','etemplate','add index','Add Index'),('en','etemplate','add new','Add new'),('en','etemplate','add table','Add Table'),('en','etemplate','advanced search','Advanced search'),('en','etemplate','align','Align'),('en','etemplate','alignment of label and input-field in table-cell','alignment of label and input-field in table-cell'),('en','etemplate','alignment of the v/hbox containing table-cell','Alignment of the V/HBox containing table-cell'),('en','etemplate','all days','all days'),('en','etemplate','all operations save the template!','all operations save the template!'),('en','etemplate','am','am'),('en','etemplate','an indexed column speeds up querys using that column (cost space on the disk !!!)','an indexed column speeds up querys using that column (cost space on the disk !!!)'),('en','etemplate','application','Application'),('en','etemplate','application name needed to write a langfile or dump the etemplates !!!','Application name needed to write a langfile or dump the eTemplates !!!'),('en','etemplate','applies the changes made','applies the changes made'),('en','etemplate','applies the changes to the given version of the template','applies the changes to the given version of the template'),('en','etemplate','attach','Attach'),('en','etemplate','attach file','attach file'),('en','etemplate','baseline','Baseline'),('en','etemplate','blurtext','blurText'),('en','etemplate','border','Border'),('en','etemplate','border-line-thickness for the table-tag','Border-line-thickness for the table-tag'),('en','etemplate','bottom','Bottom'),('en','etemplate','box','Box'),('en','etemplate','box...','Box...'),('en','etemplate','can not have special sql-value null','can not have special SQL-value NULL'),('en','etemplate','cancel','Cancel'),('en','etemplate','cant delete a single widget from a grid !!!','cant delete a single widget from a grid !!!'),('en','etemplate','cant delete the only column of a grid !!!','cant delete the only column of a grid !!!'),('en','etemplate','cant delete the only row in a grid !!!','cant delete the only row in a grid !!!'),('en','etemplate','category','Category'),('en','etemplate','cellpadding for the table-tag','Cellpadding for the table-tag'),('en','etemplate','cells','Cells'),('en','etemplate','cellspacing for the table-tag','Cellspacing for the table-tag'),('en','etemplate','center','Center'),('en','etemplate','check if content should only be displayed but not altered (the content is not send back then!)','check if content should only be displayed but not altered (the content is not send back then!)'),('en','etemplate','check if field has to be filled by user','check if field has to be filled by user'),('en','etemplate','checkbox','Checkbox'),('en','etemplate','class','Class'),('en','etemplate','class, valign','class, Valign'),('en','etemplate','click here to attach the file','click here to attach the file'),('en','etemplate','click here to create the link','click here to create the Link'),('en','etemplate','click here to start the search','Click here to start the search'),('en','etemplate','click here to upload the file','Click here to upload the file'),('en','etemplate','click to order after that criteria','click to order after that criteria'),('en','etemplate','clickable path','clickable path'),('en','etemplate','closes the window without saving the changes','closes the window without saving the changes'),('en','etemplate','column...','Column...'),('en','etemplate','columnname','ColumnName'),('en','etemplate','comment','Comment'),('en','etemplate','confirm','confirm'),('en','etemplate','confirmation message or custom javascript (returning true or false)','confirmation message or custom javascript (returning true or false)'),('en','etemplate','confirmation necesary or custom java-script','confirmation necesary or custom java-script'),('en','etemplate','contains','contains'),('en','etemplate','create a new table for the application','Create a new table for the application'),('en','etemplate','creates an english (\'en\') langfile from label and helptexts (for application in name)','creates an english (\'en\') langfile from label and helptexts (for application in Name)'),('en','etemplate','css class for the table-tag','CSS class for the table-tag'),('en','etemplate','css properties','CSS properties'),('en','etemplate','css-class name for this row, preset: \'nmh\' = nextmatch header, \'nmr\' = alternating nm row, \'nmr0\'+\'nmr1\' nm rows','CSS-class name for this row, preset: \'nmh\' = NextMatch header, \'nmr\' = alternating NM row, \'nmr0\'+\'nmr1\' NM rows'),('en','etemplate','css-class name for this row, preset: \'th\' = header, \'row\' = alternating row, \'row_off\'+\'row_on\' rows','CSS-class name for this row, preset: \'th\' = header, \'row\' = alternating row, \'row_off\'+\'row_on\' rows'),('en','etemplate','css-styles','CSS-styles'),('en','etemplate','custom','custom'),('en','etemplate','custom fields','custom fields'),('en','etemplate','custom javascript for onchange','custom javascript for onChange'),('en','etemplate','cut','Cut'),('en','etemplate','date+time','Date+Time'),('en','etemplate','datum','Datum'),('en','etemplate','day','Day'),('en','etemplate','days','days'),('en','etemplate','db ensures that every row has a unique value in that column','DB ensures that every row has a unique value in that column'),('en','etemplate','db-specific index options (comma-sep.), eg. mysql(fulltext) or mysql(100) for the indexed length of a col','db-specific index options (comma-sep.), eg. mysql(FULLTEXT) or mysql(100) for the indexed length of a col'),('en','etemplate','db-tools','DB-Tools'),('en','etemplate','deck','Deck (internal)'),('en','etemplate','default','Default'),('en','etemplate','delete a single entry by passing the id.','Delete a single entry by passing the id.'),('en','etemplate','delete all selected etemplates, without further inquiry','delete ALL selected eTemplates, WITHOUT further inquiry'),('en','etemplate','delete and cut save the template!','delete and cut save the template!'),('en','etemplate','delete column','Delete Column'),('en','etemplate','delete index','Delete Index'),('en','etemplate','delete the spezified etemplate','Delete the spezified eTemplate'),('en','etemplate','delete this column','delete this column'),('en','etemplate','delete this etemplate','delete this eTemplate'),('en','etemplate','delete this file','Delete this file'),('en','etemplate','delete this row','delete this row'),('en','etemplate','delete whole column (can not be undone!!!)','delete whole column (can NOT be undone!!!)'),('en','etemplate','deletes the above spez. etemplate from the database, can not be undone','deletes the above spez. eTemplate from the database, can NOT be undone'),('en','etemplate','deletes the etemplate spez. above','deletes the eTemplate spez. above'),('en','etemplate','deletes this column','Deletes this column'),('en','etemplate','deletes this index','Deletes this index'),('en','etemplate','discard changes','discard changes'),('en','etemplate','displayed in front of input or input is inserted for a \'%s\' in the label (label of the submitbutton or image-filename)','displayed in front of input or input is inserted for a \'%s\' in the label (label of the Submitbutton or Image-filename)'),('en','etemplate','displayed in statusline of browser if input-field gets focus','displayed in statusline of browser if input-field gets focus'),('en','etemplate','displayed in the top line of the groupbox (legend)','displayed in the top line of the groupbox (legend)'),('en','etemplate','do you want to save the changes you made in table %s?','Do you want to save the changes you made in table %s?'),('en','etemplate','documentation','Documentation'),('en','etemplate','doesn\'t matter','doesn\'t matter'),('en','etemplate','drop a table - this can not be undone','Drop a table - this can NOT be undone'),('en','etemplate','drop table','Drop Table'),('en','etemplate','dump4setup','Dump4Setup'),('en','etemplate','duration','Duration'),('en','etemplate','edit','Edit'),('en','etemplate','edit embeded css styles or of the applications app.css file','edit embeded CSS styles or of the applications app.css file'),('en','etemplate','edit the etemplate spez. above','edit the eTemplate spez. above'),('en','etemplate','edit...','Edit...'),('en','etemplate','editable templates - db-tools','Editable Templates - DB-Tools'),('en','etemplate','editable templates - delete template','Editable Templates - Delete Template'),('en','etemplate','editable templates - editor','Editable Templates - Editor'),('en','etemplate','editable templates - search','Editable Templates - Search'),('en','etemplate','editable templates - show template','Editable Templates - Show Template'),('en','etemplate','embeded css styles, eg. \'.red { background: red; }\' (note the \'.\' before the class-name) or \'@import url(...)\' (class names are','embeded CSS styles, eg. \'.red { background: red; }\' (note the \'.\' before the class-name) or \'@import url(...)\' (class names are global for the whole page!)'),('en','etemplate','enable javascript onchange submit','enable JavaScript onChange submit'),('en','etemplate','enter \'\' for an empty default, nothing mean no default','enter \'\' for an empty default, nothing mean no default'),('en','etemplate','enter a search pattern','Enter a search pattern'),('en','etemplate','enter filename to upload and attach, use [browse...] to search for it','Enter filename to upload and attach, use [Browse...] to search for it'),('en','etemplate','enter the new version number here (> old_version), empty for no update-file','enter the new version number here (> old_version), empty for no update-file'),('en','etemplate','enter the new version number here (has to be > old_version)','enter the new version number here (has to be > old_version)'),('en','etemplate','entry saved','Entry saved'),('en','etemplate','error: template not found !!!','Error: Template not found !!!'),('en','etemplate','error: webserver is not allowed to write into \'%1\' !!!','Error: webserver is not allowed to write into \'%1\' !!!'),('en','etemplate','error: while saving !!!','Error: while saving !!!'),('en','etemplate','error: writing file (no write-permission for the webserver) !!!','Error: writing file (no write-permission for the webserver) !!!'),('en','etemplate','etemplate \'%1\' imported, use save to put it in the database','eTemplate \'%1\' imported, use Save to put it in the database'),('en','etemplate','etemplate \'%1\' written to \'%2\'','eTemplate \'%1\' written to \'%2\''),('en','etemplate','etemplate editor','eTemplate Editor'),('en','etemplate','etemplate reference','eTemplate Reference'),('en','etemplate','etemplate tutorial','eTemplate Tutorial'),('en','etemplate','exchange this row with the one above','exchange this row with the one above'),('en','etemplate','exchange this two columns','exchange this two columns'),('en','etemplate','export the loaded etemplate into a xml-file','export the loaded eTemplate into a xml-file'),('en','etemplate','export xml','Export XML'),('en','etemplate','extensions loaded:','Extensions loaded:'),('en','etemplate','field must not be empty !!!','Field must not be empty !!!'),('en','etemplate','file','File'),('en','etemplate','file contains more than one etemplate, last one is shown !!!','File contains more than one eTemplate, last one is shown !!!'),('en','etemplate','file writen','File writen'),('en','etemplate','fileupload','FileUpload'),('en','etemplate','first','First'),('en','etemplate','floating point','Floating Point'),('en','etemplate','foreign key','Foreign Key'),('en','etemplate','formatted text (html)','Formatted Text (HTML)'),('en','etemplate','go to the first entry','go to the first entry'),('en','etemplate','go to the last entry','go to the last entry'),('en','etemplate','go to the next page of entries','go to the next page of entries'),('en','etemplate','go to the previous page of entries','go to the previous page of entries'),('en','etemplate','grid','Grid'),('en','etemplate','grid column attributes','Grid column attributes'),('en','etemplate','grid row attributes','Grid row attributes'),('en','etemplate','groupbox','GroupBox'),('en','etemplate','hbox','HBox'),('en','etemplate','height','Height'),('en','etemplate','height of row (in % or pixel)','height of row (in % or pixel)'),('en','etemplate','height of row (in % or pixel), disable row: [! = not]<value>[=<check>] eg: \'!@data\' disable row if content of data is empty','height of row (in % or pixel), disable row: [! = not]<value>[=<check>] eg: \'!@data\' disable row if content of data is empty'),('en','etemplate','height of the table in % or pixels for the table-tag and (optional) div','Height of the table in % or pixels for the table-tag and (optional) div'),('en','etemplate','height, disabled','Height, Disabled'),('en','etemplate','help','Help'),('en','etemplate','horizontal rule','Horizontal Rule'),('en','etemplate','hour','Hour'),('en','etemplate','hours','hours'),('en','etemplate','how many entries should the list show','How many entries should the list show'),('en','etemplate','html','Html'),('en','etemplate','if field is disabled an empty table-cell is displayed, for (temporal) removement of a field/cell','if field is disabled an empty table-cell is displayed, for (temporal) removement of a field/cell'),('en','etemplate','image','Image'),('en','etemplate','import','Import'),('en','etemplate','import an etemplate from a xml-file','import an eTemplate from a xml-file'),('en','etemplate','import table-definitions from existing db-table','Import table-definitions from existing db-table'),('en','etemplate','import xml','Import XML'),('en','etemplate','increment version to not overwrite the existing template','increment version to not overwrite the existing template'),('en','etemplate','index/name of returned content (name of the template, link / method for image)','index/name of returned content (name of the Template, Link / Method for Image)'),('en','etemplate','indexed','Indexed'),('en','etemplate','indexoptions','Indexoptions'),('en','etemplate','insert a column before','insert a column before'),('en','etemplate','insert a column behind','insert a column behind'),('en','etemplate','insert a row above','insert a row above'),('en','etemplate','insert a row below','insert a row below'),('en','etemplate','insert a widget before','insert a widget before'),('en','etemplate','insert a widget behind','insert a widget behind'),('en','etemplate','insert new column behind this one','insert new column behind this one'),('en','etemplate','insert new column in front of all','insert new column in front of all'),('en','etemplate','insert new row after this one','insert new row after this one'),('en','etemplate','insert new row in front of first line','insert new row in front of first Line'),('en','etemplate','integer','Integer'),('en','etemplate','key','Key'),('en','etemplate','label','Label'),('en','etemplate','label:[bold][italic] text:[len][,max] numbers:[min][,[max][,len]] t.area:[rows][,cols] radiob.:value h.rule:[width] templ.:[inde','Label:[bold][italic] Text:[len][,max] Numbers:[min][,[max][,len]] T.area:[rows][,cols] Radiob.:value H.Rule:[width] Templ.:[IndexInContent] Select:[multiselect] Date:[values: eg. \'Y-m-d\']'),('en','etemplate','lang','Lang'),('en','etemplate','language-short (eg. \'en\' for english) for language-dependent template (\'\' reads your pref. languages or the default, us \'default','language-short (eg. \'en\' for english) for language-dependent template (\'\' reads your pref. languages or the default, us \'default\' to read the default template \'\')'),('en','etemplate','last','Last'),('en','etemplate','left','Left'),('en','etemplate','length for char+varchar, precisions int: 2, 4, 8 and float: 4, 8','length for char+varchar, precisions int: 2, 4, 8 and float: 4, 8'),('en','etemplate','link','Link'),('en','etemplate','linkentry','LinkEntry'),('en','etemplate','linklist','LinkList'),('en','etemplate','linkstring','LinkString'),('en','etemplate','linkto','LinkTo'),('en','etemplate','load this template into the editor','load this template into the editor'),('en','etemplate','middle','Middle'),('en','etemplate','minute','Minute'),('en','etemplate','minutes','Minutes'),('en','etemplate','month','Month'),('en','etemplate','multicolumn indices','Multicolumn Indices'),('en','etemplate','name','Name'),('en','etemplate','name of other table where column is a key from','name of other table where column is a key from'),('en','etemplate','name of phpgw-template set (e.g. verdilak): \'\' = default (will read pref. template, us \'default\' to read default template \'\')','name of phpgw-template set (e.g. verdilak): \'\' = default (will read pref. template, us \'default\' to read default template \'\')'),('en','etemplate','name of table to add','Name of table to add'),('en','etemplate','name of the etemplate, should be in form application.function[.subtemplate]','name of the eTemplate, should be in form application.function[.subTemplate]'),('en','etemplate','need to be unique in the table and no reseved word from sql, best prefix all with a common 2-digit short for the app, eg. \'et_\'','need to be unique in the table and no reseved word from SQL, best prefix all with a common 2-digit short for the app, eg. \'et_\''),('en','etemplate','new search','New search'),('en','etemplate','new table created','New table created'),('en','etemplate','newer version \'%1\' exists !!!','newer version \'%1\' exists !!!'),('en','etemplate','nextmatch','Nextmatch'),('en','etemplate','nextmatch accountfilter','Nextmatch Accountfilter'),('en','etemplate','nextmatch filterheader','Nextmatch Filterheader'),('en','etemplate','nextmatch sortheader','Nextmatch Sortheader'),('en','etemplate','no column to swap with !!!','no column to swap with !!!'),('en','etemplate','no file','no file'),('en','etemplate','no filename given or selected via browse...','no filename given or selected via Browse...'),('en','etemplate','no row to swap with !!!','no row to swap with !!!'),('en','etemplate','not null','NOT NULL'),('en','etemplate','nothing','nothing'),('en','etemplate','nothing found - try again !!!','Nothing found - try again !!!'),('en','etemplate','nothing in clipboard to paste !!!','nothing in clipboard to paste !!!'),('en','etemplate','nothing matched search criteria !!!','Nothing matched search criteria !!!'),('en','etemplate','number of colums the field/cell should span or \'all\' for the remaining columns, css-class name (for the td tag)','number of colums the field/cell should span or \'all\' for the remaining columns, CSS-class name (for the TD tag)'),('en','etemplate','number of rows/cols in a v/hbox, cellpadding, cellspacing','number of rows/cols in a V/HBox, Cellpadding, Cellspacing'),('en','etemplate','of','of'),('en','etemplate','onchange','onChange'),('en','etemplate','onclick','onClick'),('en','etemplate','only an other version found !!!','only an other Version found !!!'),('en','etemplate','open the online help.','Open the online help.'),('en','etemplate','operator','Operator'),('en','etemplate','optional note about the link','optional note about the Link'),('en','etemplate','options','Options'),('en','etemplate','order to navigating by tab key through the form','Order to navigating by tab key through the form'),('en','etemplate','overflow','Overflow'),('en','etemplate','padding','Padding'),('en','etemplate','parent is a \'%1\' !!!','parent is a \'%1\' !!!'),('en','etemplate','paste','Paste'),('en','etemplate','path','Path'),('en','etemplate','please enter table-name first !!!','Please enter table-name first !!!'),('en','etemplate','pm','pm'),('en','etemplate','popup','Popup'),('en','etemplate','precision','Precision'),('en','etemplate','primary key','Primary Key'),('en','etemplate','primary key for the table, gets automaticaly indexed','Primary key for the table, gets automaticaly indexed'),('en','etemplate','radiobutton','Radiobutton'),('en','etemplate','read','Read'),('en','etemplate','read a list of entries.','Read a list of entries.'),('en','etemplate','read a single entry by passing the id and fieldlist.','Read a single entry by passing the id and fieldlist.'),('en','etemplate','read etemplate from database (for the keys above)','read eTemplate from database (for the keys above)'),('en','etemplate','readonly','readonly'),('en','etemplate','remove row (can not be undone!!!)','remove Row (can NOT be undone!!!)'),('en','etemplate','remove this link (not the entry itself)','Remove this link (not the entry itself)'),('en','etemplate','returns savely, without deleting','returns savely, WITHOUT deleting'),('en','etemplate','right','Right'),('en','etemplate','row...','Row...'),('en','etemplate','save the changes made and close the window','Save the changes made and close the window'),('en','etemplate','save the etemplate under the above keys (name, ...), change them for a saveas','save the eTemplate under the above keys (name, ...), change them for a SaveAs'),('en','etemplate','saves changes to tables_current.inc.php','saves changes to tables_current.inc.php'),('en','etemplate','saves the template with given version number and closes the window','saves the template with given version number and closes the window'),('en','etemplate','scale','Scale'),('en','etemplate','scale for float','scale for float'),('en','etemplate','search','Search'),('en','etemplate','select a category','select a Category'),('en','etemplate','select a primary contact, to show in the list','Select a primary contact, to show in the list'),('en','etemplate','select access','Select Access'),('en','etemplate','select account','Select Account'),('en','etemplate','select an app first !!!','Select an app first !!!'),('en','etemplate','select an app to search in','Select an App to search in'),('en','etemplate','select an application','Select an application'),('en','etemplate','select an application, (*) = uninstalled','Select an application, (*) = uninstalled'),('en','etemplate','select an entry to link with','Select an entry to link with'),('en','etemplate','select an table of the application','Select an table of the application'),('en','etemplate','select application','Select Application'),('en','etemplate','select category','Select Category'),('en','etemplate','select country','Select Country'),('en','etemplate','select day','Select Day'),('en','etemplate','select day of week','select day of week'),('en','etemplate','select if content of field should not be translated (label gets always translated)','select if content of field should not be translated (label gets always translated)'),('en','etemplate','select month','Select Month'),('en','etemplate','select number','Select Number'),('en','etemplate','select one ...','Select One ...'),('en','etemplate','select percentage','Select Percentage'),('en','etemplate','select priority','Select Priority'),('en','etemplate','select state','Select State'),('en','etemplate','select the indexed columns in their desired order','Select the indexed columns in their desired order'),('en','etemplate','select this etemplate to delete it','select this eTemplate to delete it'),('en','etemplate','select which accounts to show','select which accounts to show'),('en','etemplate','select which values to show','select which values to show'),('en','etemplate','select year','Select Year'),('en','etemplate','selectbox','Selectbox'),('en','etemplate','sets today as date','sets today as date'),('en','etemplate','should the form be submitted or any custom javascript be executed','Should the form be submitted or any custom javascript be executed'),('en','etemplate','show','Show'),('en','etemplate','show (no save)','Show (no save)'),('en','etemplate','show values','Show Values'),('en','etemplate','showing','showing'),('en','etemplate','shows / allows you to enter values into the etemplate for testing','shows / allows you to enter values into the eTemplate for testing'),('en','etemplate','shows/displays etemplate for testing, does not save it before','shows/displays eTemplate for testing, does NOT save it before'),('en','etemplate','spacing','Spacing'),('en','etemplate','span','Span'),('en','etemplate','span, class','Span, Class'),('en','etemplate','stack','Stack'),('en','etemplate','start a new search, cancel this link','start a new search, cancel this link'),('en','etemplate','start new search for the above pattern','start new search for the above pattern'),('en','etemplate','submit form','submit form'),('en','etemplate','submitbutton','Submitbutton'),('en','etemplate','swap','swap'),('en','etemplate','swap widget with next one','swap widget with next one'),('en','etemplate','swap with next column','swap with next column'),('en','etemplate','swap with next row','swap with next row'),('en','etemplate','switch to a parent widget','switch to a parent widget'),('en','etemplate','switch to an other widgets of that container','switch to an other widgets of that container'),('en','etemplate','tabindex','Tabindex'),('en','etemplate','table unchanged, no write necessary !!!','Table unchanged, no write necessary !!!'),('en','etemplate','tablename','TableName'),('en','etemplate','tabs','Tabs'),('en','etemplate','template','Template'),('en','etemplate','template deleted','Template deleted'),('en','etemplate','template saved','Template saved'),('en','etemplate','text','Text'),('en','etemplate','textarea','Textarea'),('en','etemplate','this text gets displayed if the input-field is empty and has no focus (blur)','this text gets displayed if the input-field is empty and has no focus (blur)'),('en','etemplate','time','Time'),('en','etemplate','to disable: [! = not]<value>[=<check>] eg: \'!@data\' disables if content of data is empty','to disable: [! = not]<value>[=<check>] eg: \'!@data\' disables if content of data is empty'),('en','etemplate','to start the db-tools','to start the DB-Tools'),('en','etemplate','to start the etemplate editor','to start the eTemplate editor'),('en','etemplate','to start the search','to start the search'),('en','etemplate','today','Today'),('en','etemplate','top','Top'),('en','etemplate','type','Type'),('en','etemplate','type of the column','type of the column'),('en','etemplate','type of the field (select label if field should be empty)','type of the field (select Label if field should be empty)'),('en','etemplate','unique','Unique'),('en','etemplate','unlink','Unlink'),('en','etemplate','update a single entry by passing the fields.','Update a single entry by passing the fields.'),('en','etemplate','update from version \'%s\' to','Update from Version \'%s\' to'),('en','etemplate','upload','Upload'),('en','etemplate','valign','vAlign'),('en','etemplate','value','Value'),('en','etemplate','value has to be at least \'%1\' !!!','Value has to be at least \'%1\' !!!'),('en','etemplate','value has to be at maximum \'%1\' !!!','Value has to be at maximum \'%1\' !!!'),('en','etemplate','vbox','VBox'),('en','etemplate','version','Version'),('en','etemplate','version-number, should be in the form: major.minor.revision.number (eg. 0.9.13.001 all numbers filled up with zeros)','version-number, should be in the form: major.minor.revision.number (eg. 0.9.13.001 all numbers filled up with zeros)'),('en','etemplate','vertical alignment of row','vertical alignment of row'),('en','etemplate','view this etemplate','view this eTemplate'),('en','etemplate','view this linked entry in its application','view this linked entry in its application'),('en','etemplate','weekend','weekend'),('en','etemplate','what happens with overflowing content: visible (default), hidden, scroll, auto (browser decides)','what happens with overflowing content: visible (default), hidden, scroll, auto (browser decides)'),('en','etemplate','widget copied into clipboard','widget copied into clipboard'),('en','etemplate','width','Width'),('en','etemplate','width of col (in % or pixel), disable col: [! = not]<value>[=<check>] eg: \'!@data\' disable col if content of data is empty','width of col (in % or pixel), disable col: [! = not]<value>[=<check>] eg: \'!@data\' disable col if content of data is empty'),('en','etemplate','width of column (in % or pixel)','width of column (in % or pixel)'),('en','etemplate','width of the table in % or pixels for the table-tag and (optional) div','Width of the table in % or pixels for the table-tag and (optional) div'),('en','etemplate','width, disabled','Width, Disabled'),('en','etemplate','working days','working days'),('en','etemplate','write <app>/setup/tables_current.inc.php','Write <app>/setup/tables_current.inc.php'),('en','etemplate','write langfile','Write Langfile'),('en','etemplate','write tables','Write Tables'),('en','etemplate','writes a \'etemplates.inc.php\' file (for application in name) in the setup-dir of the app','writes a \'etemplates.inc.php\' file (for application in Name) in the setup-dir of the app'),('en','etemplate','xml-file to import','xml-file to import'),('en','etemplate','xslt template','XSLT Template'),('en','etemplate','year','Year'),('en','felamimail','(no subject)','(no subject)'),('en','felamimail','(only cc/bcc)','(only Cc/Bcc)'),('en','felamimail','(unknown sender)','(unknown sender)'),('en','felamimail','activate','Activate'),('en','felamimail','activate script','activate script'),('en','felamimail','add address','Add address'),('en','felamimail','add rule','Add Rule'),('en','felamimail','add script','Add Script'),('en','felamimail','add to %1','Add to %1'),('en','felamimail','add to address book','Add to address book'),('en','felamimail','add to addressbook','add to addressbook'),('en','felamimail','additional info','Additional info'),('en','felamimail','address book','Address Book'),('en','felamimail','address book search','Address Book Search'),('en','felamimail','after message body','After message body'),('en','felamimail','all address books','All address books'),('en','felamimail','all folders','All Folders'),('en','felamimail','all of','all of'),('en','felamimail','allways a new window','allways a new window'),('en','felamimail','always show html emails','Always show HTML emails'),('en','felamimail','any of','any of'),('en','felamimail','anyone','anyone'),('en','felamimail','as a subfolder of','as a subfolder of'),('en','felamimail','attachments','Attachments'),('en','felamimail','auto refresh folder list','Auto refresh folder list'),('en','felamimail','back to folder','Back to folder'),('en','felamimail','based upon given criteria, incoming messages can have different background colors in the message list.  this helps to easily dis','Based upon given criteria, incoming messages can have different background colors in the message list.  This helps to easily distinguish who the messages are from, especially for mailing lists.'),('en','felamimail','bcc','BCC'),('en','felamimail','before headers','Before headers'),('en','felamimail','between headers and message body','Between headers and message body'),('en','felamimail','body part','body part'),('en','felamimail','can\'t connect to inbox!!','can\'t connect to INBOX!!'),('en','felamimail','cc','CC'),('en','felamimail','change folder','Change folder'),('en','felamimail','check message against next rule also','check message against next rule also'),('en','felamimail','checkbox','Checkbox'),('en','felamimail','click here to log back in.','Click here to log back in.'),('en','felamimail','click here to return to %1','Click here to return to %1'),('en','felamimail','close all','close all'),('en','felamimail','close this page','close this page'),('en','felamimail','close window','Close window'),('en','felamimail','color','Color'),('en','felamimail','compose','Compose'),('en','felamimail','compress folder','Compress folder'),('en','felamimail','configuration','Configuration'),('en','felamimail','contains','contains'),('en','felamimail','could not add folder %1 (%2) !!!','Could not add folder %1 (%2) !!!'),('en','felamimail','could not delete folder %1 (%2) !!!','Could not delete folder %1 (%2) !!!'),('en','felamimail','could not rename folder %1 to %2 (%3) !!!','Could not rename folder %1 to %2 (%3) !!!'),('en','felamimail','create','Create'),('en','felamimail','create folder','Create Folder'),('en','felamimail','create sent','Create Sent'),('en','felamimail','create subfolder','Create subfolder'),('en','felamimail','create trash','Create Trash'),('en','felamimail','created folder successfully!','Created folder successfully!'),('en','felamimail','dark blue','Dark Blue'),('en','felamimail','dark cyan','Dark Cyan'),('en','felamimail','dark gray','Dark Gray'),('en','felamimail','dark green','Dark Green'),('en','felamimail','dark magenta','Dark Magenta'),('en','felamimail','dark yellow','Dark Yellow'),('en','felamimail','date(newest first)','Date (newest first)'),('en','felamimail','date(oldest first)','Date (oldest first)'),('en','felamimail','days','days'),('en','felamimail','deactivate script','deactivate script'),('en','felamimail','default sorting order','Default sorting order'),('en','felamimail','delete all','delete all'),('en','felamimail','delete folder','Delete Folder'),('en','felamimail','delete script','delete script'),('en','felamimail','delete selected','Delete selected'),('en','felamimail','delete selected messages','delete selected messages'),('en','felamimail','deleted','deleted'),('en','felamimail','deleted folder successfully!','Deleted folder successfully!'),('en','felamimail','disable','Disable'),('en','felamimail','discard message','discard message'),('en','felamimail','display messages in multiple windows','display messages in multiple windows'),('en','felamimail','display of html emails','Display of HTML emails'),('en','felamimail','display only when no plain text is available','Display only when no plain text is available'),('en','felamimail','display preferences','Display Preferences'),('en','felamimail','do it!','do it!'),('en','felamimail','do not use sent','Do not use Sent'),('en','felamimail','do not use trash','Do not use Trash'),('en','felamimail','do you really want to delete the \'%1\' folder?','Do you really want to delete the \'%1\' folder?'),('en','felamimail','does not contain','does not contain'),('en','felamimail','does not match','does not match'),('en','felamimail','does not match regexp','does not match regexp'),('en','felamimail','don\'t use sent','Don\'t use Sent'),('en','felamimail','don\'t use trash','Don\'t use Trash'),('en','felamimail','down','down'),('en','felamimail','download','download'),('en','felamimail','download this as a file','Download this as a file'),('en','felamimail','e-mail','E-Mail'),('en','felamimail','e-mail address','E-Mail address'),('en','felamimail','e-mail folders','E-Mail Folders'),('en','felamimail','edit email forwarding address','edit email forwarding address'),('en','felamimail','edit filter','Edit filter'),('en','felamimail','edit rule','edit rule'),('en','felamimail','edit selected','Edit selected'),('en','felamimail','edit vacation settings','edit vacation settings'),('en','felamimail','email address','E-Mail Address'),('en','felamimail','email forwarding address','email forwarding address'),('en','felamimail','email signature','Email signature'),('en','felamimail','empty trash','empty trash'),('en','felamimail','enable','enable'),('en','felamimail','error','ERROR'),('en','felamimail','error connecting to imap serv','Error connecting to IMAP serv'),('en','felamimail','error opening','Error opening'),('en','felamimail','every','every'),('en','felamimail','every %1 days','every %1 days'),('en','felamimail','expunge','Expunge'),('en','felamimail','file into','file into'),('en','felamimail','files','files'),('en','felamimail','filter active','filter active'),('en','felamimail','filter name','Filter name'),('en','felamimail','filter rules','filter rules'),('en','felamimail','first name','First name'),('en','felamimail','flagged','flagged'),('en','felamimail','flags','Flags'),('en','felamimail','folder acl','folder acl'),('en','felamimail','folder name','Folder name'),('en','felamimail','folder path','Folder Path'),('en','felamimail','folder preferences','Folder Preferences'),('en','felamimail','folder settings','Folder settings'),('en','felamimail','folder status','Folder status'),('en','felamimail','folderlist','Folderlist'),('en','felamimail','foldername','Folder name'),('en','felamimail','folders','Folders'),('en','felamimail','folders created successfully!','Folders created successfully!'),('en','felamimail','follow','follow'),('en','felamimail','for mail to be send - not functional yet','For mail to be send - not functional yet'),('en','felamimail','for received mail','For received mail'),('en','felamimail','forward','Forward'),('en','felamimail','forward to address','forward to address'),('en','felamimail','forwarding','Forwarding'),('en','felamimail','found','Found'),('en','felamimail','fri','Fri'),('en','felamimail','from','From'),('en','felamimail','from(a->z)','From (A->Z)'),('en','felamimail','from(z->a)','From (Z->A)'),('en','felamimail','full name','Full Name'),('en','felamimail','greater than','greater than'),('en','felamimail','have a look at <a href=\"http://www.felamimail.org\" target=\"_new\">www.felamimail.org</a> to learn more about squirrelmail.<br>','Have a look at <a href=\"http://www.felamimail.org\" target=\"_new\">www.felamimail.org</a> to learn more about Squirrelmail.<br>'),('en','felamimail','header lines','Header Lines'),('en','felamimail','hide header','hide header'),('en','felamimail','html','HTML'),('en','felamimail','icons and text','Icons and text'),('en','felamimail','icons only','Icons only'),('en','felamimail','identifying name','Identifying name'),('en','felamimail','if','IF'),('en','felamimail','if from contains','if from contains'),('en','felamimail','if mail header','if mail header'),('en','felamimail','if message size','if message size'),('en','felamimail','if subject contains','if subject contains'),('en','felamimail','if to contains','if to contains'),('en','felamimail','illegal folder name.  please select a different name.','Illegal folder name.  Please select a different name.'),('en','felamimail','imap','IMAP'),('en','felamimail','imap server','IMAP Server'),('en','felamimail','imap server address','IMAP Server Address'),('en','felamimail','imap server type','IMAP Server type'),('en','felamimail','imaps authentication','IMAPS Authentication'),('en','felamimail','imaps encryption only','IMAPS Encryption only'),('en','felamimail','in','in'),('en','felamimail','index order','Index Order'),('en','felamimail','info','Info'),('en','felamimail','invalid user name or password','Invalid user name or password'),('en','felamimail','javascript','JavaScript'),('en','felamimail','keep a copy of the message in your inbox','keep a copy of the message in your inbox'),('en','felamimail','keep local copy of email','keep local copy of email'),('en','felamimail','kilobytes','kilobytes'),('en','felamimail','language','Language'),('en','felamimail','last name','Last name'),('en','felamimail','left','Left'),('en','felamimail','less','less'),('en','felamimail','less than','less than'),('en','felamimail','light gray','Light Gray'),('en','felamimail','list all','List all'),('en','felamimail','location of buttons when composing','Location of buttons when composing'),('en','felamimail','mail settings','Mail Settings'),('en','felamimail','mainmessage','mainmessage'),('en','felamimail','mark as deleted','Mark as deleted'),('en','felamimail','mark messages as','Mark selected messages as'),('en','felamimail','mark selected as flagged','Mark selected as flagged'),('en','felamimail','mark selected as read','Mark selected as read'),('en','felamimail','mark selected as unflagged','Mark selected as unflagged'),('en','felamimail','mark selected as unread','Mark selected as unread'),('en','felamimail','match','Match'),('en','felamimail','matches','matches'),('en','felamimail','matches regexp','matches regexp'),('en','felamimail','message highlighting','Message Highlighting'),('en','felamimail','message list','Message List'),('en','felamimail','messages','messages'),('en','felamimail','mon','Mon'),('en','felamimail','move','move'),('en','felamimail','move messages','move messages'),('en','felamimail','move selected to','move selected to'),('en','felamimail','move to trash','Move to trash'),('en','felamimail','moving messages to','moving messages to'),('en','felamimail','name','Name'),('en','felamimail','never display html emails','Never display HTML emails'),('en','felamimail','new filter','New filter'),('en','felamimail','next','Next'),('en','felamimail','next message','next message'),('en','felamimail','no filter','No Filter'),('en','felamimail','no folders found','No folders found'),('en','felamimail','no folders were found to subscribe to!','No folders were found to subscribe to!'),('en','felamimail','no folders were found to unsubscribe from!','No folders were found to unsubscribe from!'),('en','felamimail','no highlighting is defined','No highlighting is defined'),('en','felamimail','no messages found...','no messages found...'),('en','felamimail','no messages were selected.','No messages were selected.'),('en','felamimail','no previous message','no previous Message'),('en','felamimail','no valid emailprofile selected!!','No Valid Email Profile Selected!!'),('en','felamimail','none','none'),('en','felamimail','on behalf of','on behalf of'),('en','felamimail','one address is not valid','One address is not valid'),('en','felamimail','only inbox','Only INBOX'),('en','felamimail','only one window','only one window'),('en','felamimail','only unseen','Only unseen'),('en','felamimail','open all','open all'),('en','felamimail','options','Options'),('en','felamimail','organisation','organisation'),('en','felamimail','organization','organization'),('en','felamimail','participants','Participants'),('en','felamimail','personal information','Personal Information'),('en','felamimail','please select a address','Please select a address'),('en','felamimail','please select the number of days to wait between responses','Please select the number of days to wait between responses'),('en','felamimail','please supply the message to send with auto-responses','Please supply the message to send with auto-responses'),('en','felamimail','posting','posting'),('en','felamimail','previous','Previous'),('en','felamimail','previous message','previous message'),('en','felamimail','print it','print it'),('en','felamimail','print this page','print this page'),('en','felamimail','quicksearch','Quicksearch'),('en','felamimail','read','read'),('en','felamimail','reading','reading'),('en','felamimail','recent','recent'),('en','felamimail','refresh time in minutes','Refresh time in minutes'),('en','felamimail','remove','remove'),('en','felamimail','remove immediately','Remove immediately'),('en','felamimail','rename','Rename'),('en','felamimail','rename a folder','Rename a Folder'),('en','felamimail','rename folder','Rename folder'),('en','felamimail','renamed successfully!','Renamed successfully!'),('en','felamimail','replied','replied'),('en','felamimail','reply','Reply'),('en','felamimail','reply all','Reply All'),('en','felamimail','reply to','Reply To'),('en','felamimail','replyto','ReplyTo'),('en','felamimail','respond','Respond'),('en','felamimail','respond to mail sent to','respond to mail sent to'),('en','felamimail','return','Return'),('en','felamimail','return to options page','Return to options page'),('en','felamimail','right','Right'),('en','felamimail','rule','Rule'),('en','felamimail','sat','Sat'),('en','felamimail','save','Save'),('en','felamimail','save changes','save changes'),('en','felamimail','script name','script name'),('en','felamimail','script status','script status'),('en','felamimail','search','Search'),('en','felamimail','search for','Search for'),('en','felamimail','select','Select'),('en','felamimail','select all','Select All'),('en','felamimail','select emailprofile','Select Email Profile'),('en','felamimail','select folder','select folder'),('en','felamimail','send','Send'),('en','felamimail','send a reject message','send a reject message'),('en','felamimail','sent folder','Sent Folder'),('en','felamimail','show header','show header'),('en','felamimail','show new messages on main screen','Show new messages on main screen'),('en','felamimail','signature','Signature'),('en','felamimail','simply click the target-folder','Simply click the target-folder'),('en','felamimail','site configuration','site configuration'),('en','felamimail','size','Size'),('en','felamimail','size of editor window','Size of editor window'),('en','felamimail','size(...->0)','Size (...->0)'),('en','felamimail','size(0->...)','Size (0->...)'),('en','felamimail','small view','small view'),('en','felamimail','subject','Subject'),('en','felamimail','subject(a->z)','Subject (A->Z)'),('en','felamimail','subject(z->a)','Subject (Z->A)'),('en','felamimail','submit','Submit'),('en','felamimail','subscribe','Subscribe'),('en','felamimail','subscribed','Subscribed'),('en','felamimail','subscribed successfully!','Subscribed successfully!'),('en','felamimail','sun','Sun'),('en','felamimail','table of contents','Table of Contents'),('en','felamimail','text only','Text only'),('en','felamimail','the connection to the imap server failed!!','The connection to the IMAP Server failed!!'),('en','felamimail','the mimeparser can not parse this message.','The mimeparser can not parse this message.'),('en','felamimail','then','THEN'),('en','felamimail','this folder is empty','THIS FOLDER IS EMPTY'),('en','felamimail','this php has no imap support compiled in!!','This PHP has no IMAP support compiled in!!'),('en','felamimail','thu','Thu'),('en','felamimail','to','To'),('en','felamimail','to mail sent to','to mail sent to'),('en','felamimail','translation preferences','Translation Preferences'),('en','felamimail','translation server','Translation server'),('en','felamimail','trash fold','Trash Fold'),('en','felamimail','trash folder','Trash Folder'),('en','felamimail','tue','Tue'),('en','felamimail','type','type'),('en','felamimail','unflagged','unflagged'),('en','felamimail','unknown err','Unknown err'),('en','felamimail','unknown error','Unknown error'),('en','felamimail','unknown sender','Unknown Sender'),('en','felamimail','unknown user or password incorrect.','Unknown user or password incorrect.'),('en','felamimail','unseen','Unseen'),('en','felamimail','unselect all','Unselect All'),('en','felamimail','unsubscribe','Unsubscribe'),('en','felamimail','unsubscribed','Unsubscribed'),('en','felamimail','unsubscribed successfully!','Unsubscribed successfully!'),('en','felamimail','up','up'),('en','felamimail','use <a href=\"%1\">emailadmin</a> to create profiles','use <a href=\"%1\">EmailAdmin</a> to create profiles'),('en','felamimail','use a signature','Use a signature'),('en','felamimail','use a signature?','Use a signature?'),('en','felamimail','use addresses','Use Addresses'),('en','felamimail','use custom settings','Use Custom Settings'),('en','felamimail','use javascript or html addressbook?','Use Javascript or HTML addressbook?'),('en','felamimail','use regular expressions','use regular expressions'),('en','felamimail','vacation notice','vacation notice'),('en','felamimail','view full header','View full header'),('en','felamimail','view message','View message'),('en','felamimail','viewing full header','Viewing full header'),('en','felamimail','viewing message','Viewing message'),('en','felamimail','viewing messages','Viewing messages'),('en','felamimail','wed','Wed'),('en','felamimail','welcome to %1\'s webmail system','Welcome to %1\'s WebMail system'),('en','felamimail','when deleting messages','When deleting messages'),('en','felamimail','with message','with message'),('en','felamimail','with message \"%1\"','with message \"%1\"'),('en','felamimail','wrap incoming text at','Wrap incoming text at'),('en','felamimail','writing','writing'),('en','felamimail','wrote','wrote'),('en','felamimail','you must login first.','You must login first.'),('en','filemanager','%1 already exists as a file','%1 already exists as a file'),('en','filemanager','application','Application'),('en','filemanager','back to file manager','Back to file manager'),('en','filemanager','cancel editing %1 without saving','Cancel editing %1 without saving'),('en','filemanager','cannot create directory because it begins or ends in a space','Cannot create directory because it begins or ends in a space'),('en','filemanager','cannot replace %1 because it is a directory','Cannot replace %1 because it is a directory'),('en','filemanager','command sucessfully run','Command sucessfully run'),('en','filemanager','comment','Comment'),('en','filemanager','comments cannot contain \"%1\"','Comments cannot contain \"%1\"'),('en','filemanager','copied %1 to %2','Copied %1 to %2'),('en','filemanager','copy to','Copy To'),('en','filemanager','copy to:','Copy to:'),('en','filemanager','could not copy %1 to %2','Could not copy %1 to %2'),('en','filemanager','could not copy file because no destination directory is given','Could not copy file because no destination directory is given'),('en','filemanager','could not create %1','Could not create %1'),('en','filemanager','could not create directory %1','Could not create directory %1'),('en','filemanager','could not delete %1','Could not delete %1'),('en','filemanager','could not move %1 to %2','Could not move %1 to %2'),('en','filemanager','could not move file because no destination directory is given','Could not move file because no destination directory is given'),('en','filemanager','could not rename %1 to %2','Could not rename %1 to %2'),('en','filemanager','could not save %1','Could not save %1'),('en','filemanager','create file','Create File'),('en','filemanager','create folder','Create Folder'),('en','filemanager','created','Created'),('en','filemanager','created %1','Created %1'),('en','filemanager','created %1,%2','Created %1,%2'),('en','filemanager','created by','Created by'),('en','filemanager','created directory %1','Created directory %1'),('en','filemanager','date','Date'),('en','filemanager','default number of upload fields to show','Default number of upload fields to show'),('en','filemanager','delete','Delete'),('en','filemanager','deleted %1','Deleted %1'),('en','filemanager','directory','Directory'),('en','filemanager','directory %1 already exists','Directory %1 already exists'),('en','filemanager','directory %1 does not exist','Directory %1 does not exist'),('en','filemanager','directory names cannot contain \"%1\"','Directory names cannot contain \"%1\"'),('en','filemanager','display attributes','Display attributes'),('en','filemanager','download','Download'),('en','filemanager','edit','Edit'),('en','filemanager','edit comments','Edit comments'),('en','filemanager','error running command','Error running command'),('en','filemanager','execute','Execute'),('en','filemanager','failed to create directory','failed to create directory'),('en','filemanager','fake base dir did not exist, egroupware created a new one.','Fake Base Dir did not exist, eGroupWare created a new one.'),('en','filemanager','file','File'),('en','filemanager','file %1 already exists. please edit it or delete it first.','File %1 already exists. Please edit it or delete it first.'),('en','filemanager','file %1 could not be created.','File %1 could not be created.'),('en','filemanager','file name','File Name'),('en','filemanager','file names cannot contain \"%1\"','File names cannot contain \"%1\"'),('en','filemanager','file names cannot contain \\ or /','File names cannot contain \\ or /'),('en','filemanager','filemanager preferences','FileManager preferences'),('en','filemanager','files','Files'),('en','filemanager','files in this directory','Files in this directory'),('en','filemanager','folder','Folder'),('en','filemanager','folder up','Folder Up'),('en','filemanager','go home','go home'),('en','filemanager','go to','Go To'),('en','filemanager','go to %1','Go to %1'),('en','filemanager','go to your home directory','Go to your home directory'),('en','filemanager','go to:','Go to:'),('en','filemanager','go up','go up'),('en','filemanager','home','Home'),('en','filemanager','location','Location'),('en','filemanager','locked','Locked'),('en','filemanager','mime type','MIME Type'),('en','filemanager','modified','Modified'),('en','filemanager','modified by','Modified by'),('en','filemanager','move to','Move To'),('en','filemanager','move to:','Move to:'),('en','filemanager','moved %1 to %2','Moved %1 to %2'),('en','filemanager','no files in this directory.','No files in this directory.'),('en','filemanager','no version history for this file/directory','No version history for this file/directory'),('en','filemanager','operation','Operation'),('en','filemanager','other settings','Other settings'),('en','filemanager','owner','Owner'),('en','filemanager','please select a file to delete.','Please select a file to delete.'),('en','filemanager','preview %1','Preview %1'),('en','filemanager','preview of %1','Preview of %1'),('en','filemanager','quick jump to','Quick jump to'),('en','filemanager','reload','reload'),('en','filemanager','rename','Rename'),('en','filemanager','renamed %1 to %2','Renamed %1 to %2'),('en','filemanager','replaced %1','Replaced %1'),('en','filemanager','save %1','Save %1'),('en','filemanager','save %1, and go back to file listing','Save %1, and go back to file listing'),('en','filemanager','save all','Save all'),('en','filemanager','save changes','Save changes'),('en','filemanager','saved %1','Saved %1'),('en','filemanager','show','Show'),('en','filemanager','show ..','Show ..'),('en','filemanager','show .files','Show .files'),('en','filemanager','show command line (experimental. dangerous.)','Show command line (EXPERIMENTAL. DANGEROUS.)'),('en','filemanager','show help','Show help'),('en','filemanager','size','Size'),('en','filemanager','sort by:','Sort by:'),('en','filemanager','the future filemanager, now for testing purposes only, please send bugreports','The future filemanager, now for TESTING PURPOSES ONLY, please send bugreports'),('en','filemanager','total files','Total Files'),('en','filemanager','unknown mime-type defaults to text/plain when viewing','Unknown MIME-type defaults to text/plain when viewing'),('en','filemanager','unused space','Unused space'),('en','filemanager','up','Up'),('en','filemanager','update','Update'),('en','filemanager','updated comment for %1','Updated comment for %1'),('en','filemanager','upload','Upload'),('en','filemanager','upload fields','upload fields'),('en','filemanager','upload files','Upload files'),('en','filemanager','use new experimental filemanager?','Use new experimental Filemanager?'),('en','filemanager','used space','Used Space'),('en','filemanager','users','Users'),('en','filemanager','version','Version'),('en','filemanager','view documents in new window','View documents in new window'),('en','filemanager','view documents on server (if available)','View documents on server (if available)'),('en','filemanager','who','Who'),('en','filemanager','you do not have access to %1','You do not have access to %1'),('en','filemanager','your home dir did not exist, egroupware created a new one.','Your Home Dir did not exist, eGroupWare created a new one.'),('en','infolog','%1 records imported','%1 records imported'),('en','infolog','%1 records read (not yet imported, you may go %2back%3 and uncheck test import)','%1 records read (not yet imported, you may go %2back%3 and uncheck Test Import)'),('en','infolog','- subprojects from','- Subprojects from'),('en','infolog','0%','0%'),('en','infolog','10%','10%'),('en','infolog','100%','100%'),('en','infolog','20%','20%'),('en','infolog','30%','30%'),('en','infolog','40%','40%'),('en','infolog','50%','50%'),('en','infolog','60%','60%'),('en','infolog','70%','70%'),('en','infolog','80%','80%'),('en','infolog','90%','90%'),('en','infolog','<b>file-attachments via symlinks</b> instead of uploads and retrieval via file:/path for direct lan-clients','<b>file-attachments via symlinks</b> instead of uploads and retrieval via file:/path for direct lan-clients'),('en','infolog','a short subject for the entry','a short subject for the entry'),('en','infolog','abort without deleting','Abort without deleting'),('en','infolog','accept','accept'),('en','infolog','action','Action'),('en','infolog','actual date and time','actual date and time'),('en','infolog','add','Add'),('en','infolog','add a file','Add a file'),('en','infolog','add a new entry','Add a new Entry'),('en','infolog','add a new note','Add a new Note'),('en','infolog','add a new phonecall','Add a new Phone Call'),('en','infolog','add a new sub-task, -note, -call to this entry','Add a new sub-task, -note, -call to this entry'),('en','infolog','add a new todo','Add a new ToDo'),('en','infolog','add file','Add file'),('en','infolog','add sub','add Sub'),('en','infolog','add timesheet entry','Add timesheet entry'),('en','infolog','add:','Add:'),('en','infolog','all','All'),('en','infolog','all links and attachments','all links and attachments'),('en','infolog','allows to set the status of an entry, eg. set a todo to done if it\'s finished (values depend on entry-typ)','allows to set the status of an entry, eg. set a ToDo to done if it\'s finished (values depend on entry-type)'),('en','infolog','apply the changes','Apply the changes'),('en','infolog','are you shure you want to delete this entry ?','Are you sure you want to delete this entry ?'),('en','infolog','attach a file','Attach a file'),('en','infolog','attach file','Attach file'),('en','infolog','back to main list','Back to main list'),('en','infolog','billed','billed'),('en','infolog','both','both'),('en','infolog','call','call'),('en','infolog','cancel','Cancel'),('en','infolog','cancelled','cancelled'),('en','infolog','categories','Categories'),('en','infolog','category','Category'),('en','infolog','change the status of an entry, eg. close it','Change the status of an entry, eg. close it'),('en','infolog','charset of file','Charset of file'),('en','infolog','check to set startday','check to set startday'),('en','infolog','click here to create the link','click here to create the Link'),('en','infolog','click here to start the search','click here to start the search'),('en','infolog','close','Close'),('en','infolog','comment','Comment'),('en','infolog','completed','Completed'),('en','infolog','configuration','Configuration'),('en','infolog','confirm','Confirm'),('en','infolog','contact','Contact'),('en','infolog','copy your changes to the clipboard, %1reload the entry%2 and merge them.','Copy your changes to the clipboard, %1reload the entry%2 and merge them.'),('en','infolog','create new links','Create new links'),('en','infolog','creates a new field','creates a new field'),('en','infolog','creates a new status with the given values','creates a new status with the given values'),('en','infolog','creates a new typ with the given name','creates a new type with the given name'),('en','infolog','creation','Creation'),('en','infolog','csv-fieldname','CSV-Fieldname'),('en','infolog','csv-filename','CSV-Filename'),('en','infolog','custom','Custom'),('en','infolog','custom contact-address, leave empty to use information from most recent link','Custom contact-address, leave empty to use information from most recent link'),('en','infolog','custom contact-information, leave emtpy to use information from most recent link','Custom contact-information, leave emtpy to use information from most recent link'),('en','infolog','custom fields','Custom Fields'),('en','infolog','custom regarding','Custom regarding'),('en','infolog','custom status for typ','Custom status for type'),('en','infolog','customfields','Customfields'),('en','infolog','date completed','Date completed'),('en','infolog','date completed (leave it empty to have it automatic set if status is done or billed)','Date completed (leave it empty to have it automatic set if status is done or billed)'),('en','infolog','datecreated','date created'),('en','infolog','dates, status, access','Dates, Status, Access'),('en','infolog','days','days'),('en','infolog','default filter for infolog','Default Filter for InfoLog'),('en','infolog','default status for a new log entry','default status for a new log entry'),('en','infolog','delegation','Delegation'),('en','infolog','delete','Delete'),('en','infolog','delete one record by passing its id.','Delete one record by passing its id.'),('en','infolog','delete the entry','Delete the entry'),('en','infolog','delete this entry','delete this entry'),('en','infolog','delete this entry and all listed sub-entries','Delete this entry and all listed sub-entries'),('en','infolog','deletes the selected typ','deletes the selected type'),('en','infolog','deletes this field','deletes this field'),('en','infolog','deletes this status','deletes this status'),('en','infolog','description','Description'),('en','infolog','determines the order the fields are displayed','determines the order the fields are displayed'),('en','infolog','disables a status without deleting it','disables a status without deleting it'),('en','infolog','do you want a confirmation of the responsible on: accepting, finishing the task or both','do you want a confirmation of the responsible on: accepting, finishing the task or both'),('en','infolog','don\'t show infolog','DON\'T show InfoLog'),('en','infolog','done','done'),('en','infolog','download','Download'),('en','infolog','duration','Duration'),('en','infolog','each value is a line like <id>[=<label>]','each value is a line like <id>[=<label>]'),('en','infolog','edit','Edit'),('en','infolog','edit or create categories for ingolog','Edit or create categories for IngoLog'),('en','infolog','edit rights (full edit rights incl. making someone else responsible!)','edit rights (full edit rights incl. making someone else responsible!)'),('en','infolog','edit status','Edit status'),('en','infolog','edit the entry','Edit the entry'),('en','infolog','edit this entry','Edit this entry'),('en','infolog','empty for all','empty for all'),('en','infolog','enddate','Due date'),('en','infolog','enddate can not be before startdate','Due date can not be before start date'),('en','infolog','enter a custom contact, leave empty if linked entry should be used','enter a custom contact, leave empty if linked entry should be used'),('en','infolog','enter a custom phone/email, leave empty if linked entry should be used','enter a custom phone/email, leave empty if linked entry should be used'),('en','infolog','enter a textual description of the log-entry','enter a textual description of the log-entry'),('en','infolog','enter the query pattern','Enter the query pattern'),('en','infolog','entry and all files','Entry and all files'),('en','infolog','error: saving the entry','Error: saving the entry'),('en','infolog','error: the entry has been updated since you opened it for editing!','Error: the entry has been updated since you opened it for editing!'),('en','infolog','existing links','Existing links'),('en','infolog','fax','Fax'),('en','infolog','fieldseparator','Fieldseparator'),('en','infolog','finish','finish'),('en','infolog','for which types should this field be used','for which types should this field be used'),('en','infolog','from','From'),('en','infolog','general','General'),('en','infolog','high','high'),('en','infolog','id','Id'),('en','infolog','if not set, the line with search and filters is hidden for less entries then \"max matches per page\" (as defined in your common p','If not set, the line with search and filters is hidden for less entries then \"max matches per page\" (as defined in your common preferences).'),('en','infolog','import','Import'),('en','infolog','import next set','import next set'),('en','infolog','infolog - delete','Info Log - Delete'),('en','infolog','infolog - edit','InfoLog - Edit'),('en','infolog','infolog - import csv-file','InfoLog - Import CSV-File'),('en','infolog','infolog - new','InfoLog - New'),('en','infolog','infolog - new subproject','InfoLog - New Subproject'),('en','infolog','infolog - subprojects from','InfoLog - Subprojects from'),('en','infolog','infolog entry deleted','InfoLog entry deleted'),('en','infolog','infolog entry saved','InfoLog entry saved'),('en','infolog','infolog filter for the main screen','InfoLog filter for the main screen'),('en','infolog','infolog list','InfoLog list'),('en','infolog','infolog-fieldname','Info Log-Fieldname'),('en','infolog','invalid filename','Invalid filename'),('en','infolog','label<br>helptext','Label<br>Helptext'),('en','infolog','last changed','Last changed'),('en','infolog','last modified','Last modified'),('en','infolog','leave it empty','leave it empty'),('en','infolog','leave without saveing the entry','leave without saveing the entry'),('en','infolog','leaves without saveing','leaves without saveing'),('en','infolog','length<br>rows','Length<br>Rows'),('en','infolog','link','Link'),('en','infolog','links','Links'),('en','infolog','links of this entry','Links of this entry'),('en','infolog','list all categories','List all categories'),('en','infolog','list no subs/childs','List no Subs/Childs'),('en','infolog','location','Location'),('en','infolog','longer textual description','longer textual description'),('en','infolog','low','low'),('en','infolog','max length of the input [, length of the inputfield (optional)]','max length of the input [, length of the inputfield (optional)]'),('en','infolog','name must not be empty !!!','Name must not be empty !!!'),('en','infolog','name of new type to create','name of new type to create'),('en','infolog','never hide search and filters','Never hide search and filters'),('en','infolog','new name','new name'),('en','infolog','new search','New search'),('en','infolog','no - cancel','No - Cancel'),('en','infolog','no describtion, links or attachments','no describtion, links or attachments'),('en','infolog','no details','no details'),('en','infolog','no entries found, try again ...','no entries found, try again ...'),('en','infolog','no filter','no Filter'),('en','infolog','no links or attachments','no links or attachments'),('en','infolog','none','None'),('en','infolog','normal','normal'),('en','infolog','not','not'),('en','infolog','not assigned','not assigned'),('en','infolog','not-started','not started'),('en','infolog','note','Note'),('en','infolog','number of records to read (%1)','Number of records to read (%1)'),('en','infolog','number of row for a multiline inputfield or line of a multi-select-box','number of row for a multiline inputfield or line of a multi-select-box'),('en','infolog','offer','offer'),('en','infolog','ongoing','ongoing'),('en','infolog','only for details','Only for details'),('en','infolog','only the attachments','only the attachments'),('en','infolog','only the links','only the links'),('en','infolog','open','open'),('en','infolog','optional note to the link','optional note to the Link'),('en','infolog','order','Order'),('en','infolog','overdue','overdue'),('en','infolog','own','own'),('en','infolog','own open','own open'),('en','infolog','own overdue','own overdue'),('en','infolog','own upcoming','own upcoming'),('en','infolog','path on (web-)serverside<br>eg. /var/samba/share','path on (web-)serverside<br>eg. /var/samba/Share'),('en','infolog','path to user and group files has to be outside of the webservers document-root!!!','Path to user and group files HAS TO BE OUTSIDE of the webservers document-root!!!'),('en','infolog','pattern for search in addressbook','pattern for search in Addressbook'),('en','infolog','pattern for search in projects','pattern for search in Projects'),('en','infolog','percent completed','Percent completed'),('en','infolog','permission denied','Permission denied'),('en','infolog','phone','Phone Call'),('en','infolog','phone/email','Phone/Email'),('en','infolog','phonecall','Phone Call'),('en','infolog','planned','planned'),('en','infolog','planned time','planned time'),('en','infolog','price','Price'),('en','infolog','priority','Priority'),('en','infolog','private','Private'),('en','infolog','project','Project'),('en','infolog','project settings: price, times','Project settings: price, times'),('en','infolog','re:','Re:'),('en','infolog','read one record by passing its id.','Read one record by passing its id.'),('en','infolog','read rights (default)','read rights (default)'),('en','infolog','reg. expr. for local ip\'s<br>eg. ^192\\.168\\.1\\.','reg. expr. for local IP\'s<br>eg. ^192\\.168\\.1\\.'),('en','infolog','remark','Remark'),('en','infolog','remove this link (not the entry itself)','Remove this link (not the entry itself)'),('en','infolog','responsible','responsible'),('en','infolog','responsible open','responsible open'),('en','infolog','responsible overdue','responsible overdue'),('en','infolog','responsible upcoming','responsible upcoming'),('en','infolog','responsible user, priority','responsible user, priority'),('en','infolog','returns a list / search for records.','Returns a list / search for records.'),('en','infolog','rights for the responsible','Rights for the responsible'),('en','infolog','save','Save'),('en','infolog','saves the changes made and leaves','saves the changes made and leaves'),('en','infolog','saves this entry','Saves this entry'),('en','infolog','search','Search'),('en','infolog','search for:','Search for:'),('en','infolog','select','Select'),('en','infolog','select a category for this entry','select a category for this entry'),('en','infolog','select a price','Select a price'),('en','infolog','select a priority for this task','select a priority for this task'),('en','infolog','select a project','Select a project'),('en','infolog','select a responsible user: a person you want to delegate this task','select a responsible user: a person you want to delegate this task'),('en','infolog','select a typ to edit it\'s status-values or delete it','select a type to edit it\'s status-values or delete it'),('en','infolog','select an app to search in','Select an App to search in'),('en','infolog','select an entry to link with','Select an entry to link with'),('en','infolog','select to filter by owner','select to filter by owner'),('en','infolog','select to filter by responsible','select to filter by responsible'),('en','infolog','sets the status of this entry and its subs to done','Sets the status of this entry and its subs to done'),('en','infolog','should infolog show subtasks, -calls or -notes in the normal view or not. you can always view the subs via there parent.','Should InfoLog show Subtasks, -calls or -notes in the normal view or not. You can always view the subs via their parent.'),('en','infolog','should infolog show the links to other applications and/or the file-attachments in the infolog list (normal view when you enter','Should InfoLog show the links to other applications and/or the file-attachments in the InfoLog list (normal view when you enter InfoLog).'),('en','infolog','should infolog show up on the main screen and with which filter. works only if you dont selected an application for the main scr','Should InfoLog show up on the main screen and with which filter. Works only if you dont selected an application for the main screen (in your preferences).'),('en','infolog','should infolog use full names (surname and familyname) or just the loginnames.','Should InfoLog use full names (surname and familyname) or just the loginnames.'),('en','infolog','should the infolog list show a unique numerical id, which can be used eg. as ticket id.','Should the Infolog list show a unique numerical Id, which can be used eg. as ticket Id.'),('en','infolog','should the infolog list show the column \"last modified\".','Should the Infolog list show the column \"last modified\".'),('en','infolog','should the infolog list show the percent done only for status ongoing or two separate icons.','Should the Infolog list show the percent done only for status ongoing or two separate icons.'),('en','infolog','should this entry only be visible to you and people you grant privat access via the acl','should this entry only be visible to you and people you grant privat access via the ACL'),('en','infolog','show a column for used and planned times in the list.','Show a column for used and planned times in the list.'),('en','infolog','show full usernames','Show full usernames'),('en','infolog','show in the infolog list','Show in the InfoLog list'),('en','infolog','show last modified','Show last modified'),('en','infolog','show status and percent done separate','Show status and percent done separate'),('en','infolog','show ticket id','Show ticket Id'),('en','infolog','show times','Show times'),('en','infolog','small view','small view'),('en','infolog','start a new search, cancel this link','start a new search, cancel this link'),('en','infolog','startdate','Start Date'),('en','infolog','startdate enddate','Start Date Due Date'),('en','infolog','startdate for new entries','Startdate for new entries'),('en','infolog','startrecord','Startrecord'),('en','infolog','status','Status'),('en','infolog','status ...','Status ...'),('en','infolog','sub','Sub'),('en','infolog','sub-entries become subs of the parent or main entries, if there\'s no parent','Sub-entries become subs of the parent or main entries, if there\'s no parent'),('en','infolog','subject','Subject'),('en','infolog','task','ToDo'),('en','infolog','test import (show importable records <u>only</u> in browser)','Test Import (show importable records <u>only</u> in browser)'),('en','infolog','the name used internaly (<= 10 chars), changeing it makes existing data unavailible','the name used internaly (<= 10 chars), changeing it makes existing data unavailible'),('en','infolog','the name used internaly (<= 20 chars), changeing it makes existing data unavailible','the name used internaly (<= 20 chars), changeing it makes existing data unavailible'),('en','infolog','the text displayed to the user','the text displayed to the user'),('en','infolog','this is the filter infolog uses when you enter the application. filters limit the entries to show in the actual view. there are','This is the filter InfoLog uses when you enter the application. Filters limit the entries to show in the actual view. There are filters to show only finished, still open or futures entries of yourself or all users.'),('en','infolog','til when should the todo or phonecall be finished','til when should the ToDo or Phone call be finished'),('en','infolog','times','Times'),('en','infolog','to many might exceed your execution-time-limit','to many might exceed your execution-time-limit'),('en','infolog','to what should the startdate of new entries be set.','To what should the startdate of new entries be set.'),('en','infolog','today','Today'),('en','infolog','todays date','todays date'),('en','infolog','todo','ToDo'),('en','infolog','translation','Translation'),('en','infolog','typ','Type'),('en','infolog','typ \'%1\' already exists !!!','Type \'%1\' already exists !!!'),('en','infolog','type','Type'),('en','infolog','type ...','Type ...'),('en','infolog','type of the log-entry: note, phonecall or todo','Type of the log-entry: Note, Phone call or ToDo'),('en','infolog','unlink','Unlink'),('en','infolog','upcoming','upcoming'),('en','infolog','urgency','urgency'),('en','infolog','urgent','urgent'),('en','infolog','used time','used time'),('en','infolog','valid path on clientside<br>eg. \\\\server\\share or e:\\','valid path on clientside<br>eg. \\\\Server\\Share or e:\\'),('en','infolog','values for selectbox','Values for selectbox'),('en','infolog','view all subs of this entry','View all subs of this entry'),('en','infolog','view other subs','view other Subs'),('en','infolog','view parent','View parent'),('en','infolog','view subs','view Subs'),('en','infolog','view the parent of this entry and all his subs','View the parent of this entry and all his subs'),('en','infolog','view this linked entry in its application','view this linked entry in its application'),('en','infolog','when should the todo or phonecall be started, it shows up from that date in the filter open or own open (startpage)','when should the ToDo or Phone call be started, it shows up from that date in the filter open or own open (startpage)'),('en','infolog','which additional fields should the responsible be allowed to edit without having edit rights?<br />status, percent and date comp','Which additional fields should the responsible be allowed to edit without having edit rights?<br />Status, percent and date completed are always allowed.'),('en','infolog','which implicit acl rights should the responsible get?','Which implicit ACL rights should the responsible get?'),('en','infolog','will-call','will call'),('en','infolog','write (add or update) a record by passing its fields.','Write (add or update) a record by passing its fields.'),('en','infolog','yes - delete','Yes - Delete'),('en','infolog','yes - delete including sub-entries','Yes - Delete including sub-entries'),('en','infolog','you can\'t delete one of the stock types !!!','You can\'t delete one of the stock types !!!'),('en','infolog','you have entered an invalid ending date','You have entered an invalid due date'),('en','infolog','you have entered an invalid starting date','You have entered an invalid starting date'),('en','infolog','you have to enter a name, to create a new typ!!!','You have to enter a name, to create a new type!!!'),('en','infolog','you must enter a subject or a description','You must enter a subject or a description'),('en','infolog','your database is not up to date (%1 vs. %2), please run %3setup%4 to update your database.','Your database is NOT up to date (%1 vs. %2), please run %3setup%4 to update your database.'),('en','manual','%1 manual page(s) added or updated','%1 manual page(s) added or updated'),('en','manual','download','download'),('en','manual','index','Index'),('en','manual','page(s) %1 not found !!!','Page(s) %1 not found !!!'),('en','manual','search for','Search for'),('en','manual','starting import from %1, this might take several minutes (specialy if you start it the first time) ...','Starting import from %1, this might take several minutes (specialy if you start it the first time) ...'),('en','manual','the search returned no result!','The search returned no result!'),('en','mydms','access mode','access mode'),('en','mydms','access rights','access rights'),('en','mydms','access_mode_all','All'),('en','mydms','access_mode_none','No access'),('en','mydms','access_mode_read','Read'),('en','mydms','access_mode_readwrite','Read+Write'),('en','mydms','acl get inherited','acl get inherited'),('en','mydms','add acl','add acl'),('en','mydms','add document','add document'),('en','mydms','add notification','add notification'),('en','mydms','add subfolder','add subfolder'),('en','mydms','admin-tools','administration Tools'),('en','mydms','all versions','all versions'),('en','mydms','comment','Kommentar'),('en','mydms','comment for current version','comment for current version'),('en','mydms','copy acl','copy acl'),('en','mydms','copy documents','copy documents'),('en','mydms','copy folder','copy folder'),('en','mydms','copy options','copy options'),('en','mydms','copy subfolders','copy subfolder'),('en','mydms','create empty acl','create empty acl'),('en','mydms','creation date','creation date'),('en','mydms','current acl','current acl'),('en','mydms','current version','current version'),('en','mydms','default access','default access'),('en','mydms','delete folder','delete folder'),('en','mydms','delete this notification','delete this notification'),('en','mydms','do you really want to delete this acl?','Do you really want to delete this acl?'),('en','mydms','do you really want to delete this document?','Do you really want to delete this document?'),('en','mydms','do you really want to delete this version of the document?','do you really want to delete this version of the document?'),('en','mydms','does not expire','does not expire'),('en','mydms','download','download'),('en','mydms','edit folder','edit folder'),('en','mydms','expires','expires'),('en','mydms','expires after','expires after'),('en','mydms','file size','file size'),('en','mydms','filename','file name'),('en','mydms','folder','folder'),('en','mydms','general information','general information'),('en','mydms','information about last update','information about last update'),('en','mydms','informations','Informations'),('en','mydms','inherit acl again','inherit acl again'),('en','mydms','last update','last update'),('en','mydms','linked documents','linked documents'),('en','mydms','lock status','lock status'),('en','mydms','mime type','Mime Type'),('en','mydms','move document','move document'),('en','mydms','move folder','move folder'),('en','mydms','notifications','notifications'),('en','mydms','permission','permission'),('en','mydms','select folder','select folder'),('en','mydms','select target folder','select target folder'),('en','mydms','target folder','target folder'),('en','mydms','this document gets locked by you!','this document gets locked by you!'),('en','mydms','this document gets unlocked by you.','this document gets unlocked by you.'),('en','mydms','this document is currently not locked.','this document is currently not locked.'),('en','mydms','this document is locked by <a href=\"mailto:%1\">%2</a>.','this document is locked by <a href=\"mailto:%1\">%2</a>.'),('en','mydms','update document','update document'),('en','mydms','upload date','upload date'),('en','mydms','uploaded by','uploaded by'),('en','mydms','view online','view online'),('en','news_admin','active','Active'),('en','news_admin','add new article','Add New Article'),('en','news_admin','add new news','Add new news'),('en','news_admin','add news item','Add news item'),('en','news_admin','all news','All news'),('en','news_admin','always','Always'),('en','news_admin','configuration','Configuration'),('en','news_admin','contains html','Contains HTML'),('en','news_admin','content','Content'),('en','news_admin','edit news item','Edit news item'),('en','news_admin','failed to add message','Failed to add new message'),('en','news_admin','format for links to items','Format for links to items'),('en','news_admin','format of export','Format of export'),('en','news_admin','from','From'),('en','news_admin','global categories','global categories'),('en','news_admin','global news','Global News'),('en','news_admin','global_news','Global_News'),('en','news_admin','image link','Image Link'),('en','news_admin','image title','Image Title'),('en','news_admin','image url','Image URL'),('en','news_admin','implies read permission','implies read permission'),('en','news_admin','item has been deleted','Item has been deleted'),('en','news_admin','item not found','Item not found'),('en','news_admin','link','Link'),('en','news_admin','main','Main'),('en','news_admin','maintain','Maintain'),('en','news_admin','message has been added','Message has been added'),('en','news_admin','more news','More news'),('en','news_admin','new item has been added','New item has been added'),('en','news_admin','news','News'),('en','news_admin','news admin','News Admin'),('en','news_admin','news administration','News Administration'),('en','news_admin','news item has been added','News item has been added'),('en','news_admin','news item has been updated','News item has been updated'),('en','news_admin','no entries found','no entries found'),('en','news_admin','no news','No News is Currently Available in the Category'),('en','news_admin','no rss export','No RSS export'),('en','news_admin','number of articles to display on the main screen','Number of articles to display on the main screen'),('en','news_admin','on','on'),('en','news_admin','please select a category','Please select a category'),('en','news_admin','publish date','Publish Date'),('en','news_admin','read news','Read news'),('en','news_admin','read permissions','Read permissions'),('en','news_admin','send mail to others','Send Mail to Others'),('en','news_admin','should news_admin display the latest article headlines on the main screen.','Should News Admin display the latest article headlines on the main screen.'),('en','news_admin','show latest news articles?','Show latest news articles?'),('en','news_admin','show news articles on main page?','Show news articles on main page?'),('en','news_admin','small view','small view'),('en','news_admin','teaser','Teaser'),('en','news_admin','the news content is missing','The news content is missing'),('en','news_admin','the number of articles to display on the main screen.','The number of articles to display on the main screen.'),('en','news_admin','the subject is missing','The subject is missing'),('en','news_admin','until','until'),('en','news_admin','view this category','View this category'),('en','news_admin','visible','Visible'),('en','news_admin','webpage news admin','Webpage news admin'),('en','news_admin','write','Write'),('en','news_admin','write permissions','Write permissions'),('en','phpbrain','/kb directory does not exist and could not be created, please ask the adminstrator to check the global configuration','/kb directory does not exist and could not be created, please ask the administrator to check the global configuration'),('en','phpbrain','action','Action'),('en','phpbrain','actions','Actions'),('en','phpbrain','add articles','Add articles'),('en','phpbrain','add link','Add link'),('en','phpbrain','add question','Add Question'),('en','phpbrain','added file %1','Added file %1'),('en','phpbrain','added link %1','Added link %1'),('en','phpbrain','added related articles %1','Added related articles %1'),('en','phpbrain','advanced search','Advanced Search'),('en','phpbrain','all articles','All articles'),('en','phpbrain','answer','answer'),('en','phpbrain','anytime','anytime'),('en','phpbrain','anywhere in the article','Anywhere in the article'),('en','phpbrain','article','Article'),('en','phpbrain','article added to database, you can now attach files or links, or relate to other articles','Article added to database, you can now attach files or links, or relate to other articles'),('en','phpbrain','article created','Article created'),('en','phpbrain','article deleted','Article deleted'),('en','phpbrain','article deleted successfully','Article deleted successfully'),('en','phpbrain','article edited','Article edited'),('en','phpbrain','article has been published','Article has been published'),('en','phpbrain','article id','Article ID'),('en','phpbrain','articles added','Articles added'),('en','phpbrain','articles deleted successfully','Articles deleted successfully'),('en','phpbrain','articles have been published','Articles have been published'),('en','phpbrain','articles in %1','Articles in %1'),('en','phpbrain','articles in %1 and all its subcategories','Articles in %1 and all its subcategories'),('en','phpbrain','articles not classified under any category','Articles not classified under any category'),('en','phpbrain','ascendent','Ascendent'),('en','phpbrain','attach file','Attach File'),('en','phpbrain','attached files','Attached Files'),('en','phpbrain','average rating','Average rating'),('en','phpbrain','base directory does not exist, please ask the adminstrator to check the global configuratio','Base directory does not exist, please ask the administrator to check the global configuration'),('en','phpbrain','before submiting a question, please search in the knowledge base first','Before submiting a question, please search in the knowledge base first'),('en','phpbrain','by answering this question you will help to get the answer quicker the next time','By answering this question you will help to get the answer quicker the next time'),('en','phpbrain','comment','comment'),('en','phpbrain','comment and rating have been published','Comment and rating have been published'),('en','phpbrain','comment could not be inserted in the database','Comment could not be inserted in the database'),('en','phpbrain','comment has been deleted','Comment has been deleted'),('en','phpbrain','comment has been published','Comment has been published'),('en','phpbrain','comment has been submited for revision','Comment has been submited for revision'),('en','phpbrain','comment has been submited for revision and rating will be published','Comment has been submited for revision and rating will be published'),('en','phpbrain','comments','Comments'),('en','phpbrain','configuration','Configuration'),('en','phpbrain','create a new article to answer the question asked by %1 in %2','Create a new article to answer the question asked by %1 in %2'),('en','phpbrain','created by %1 on %2','Created by %1 on %2'),('en','phpbrain','creation','creation'),('en','phpbrain','creation date','Creation date'),('en','phpbrain','delete article','Delete article'),('en','phpbrain','delete selected','Delete selected'),('en','phpbrain','deleted relation to  article %1','Deleted relation to  article %1'),('en','phpbrain','deleted relation to article %1','Deleted relation to article %1'),('en','phpbrain','descendent','Descendent'),('en','phpbrain','details','Details'),('en','phpbrain','e-groupware knowledge base article attached','E-GroupWare Knowledge Base article attached'),('en','phpbrain','e-mail has been sent','e-mail has been sent'),('en','phpbrain','edit article','Edit article'),('en','phpbrain','enter one or two words describing the issue, or type the article number if you know it','Enter one or two words describing the issue, or type the article number if you know it'),('en','phpbrain','error deleting article from database','Error deleting article from database'),('en','phpbrain','error deleting link','Error deleting link'),('en','phpbrain','error downloading file','Error downloading file'),('en','phpbrain','error locating files directory','Error locating files directory'),('en','phpbrain','error moving file to directory','Error moving file to directory'),('en','phpbrain','error publishing comment','Error publishing comment'),('en','phpbrain','error retrieving article','Error retrieving article'),('en','phpbrain','error trying to delete comment','Error trying to delete comment'),('en','phpbrain','error trying to delete question','Error trying to delete question'),('en','phpbrain','error trying to edit article','Error trying to edit article'),('en','phpbrain','error trying to publish article','Error trying to publish article'),('en','phpbrain','error: file doesn\'t exist in the database','Error: file doesn\'t exist in the database'),('en','phpbrain','excellent','Excellent'),('en','phpbrain','failure trying to delete the file','Failure trying to delete the file'),('en','phpbrain','file could be deleted from server but not from database','File coud be deleted from server but not from database'),('en','phpbrain','file has been successfully uploaded','File has been successfully uploaded'),('en','phpbrain','file was already missing from server, and was deleted from the database','File was already missing from server, and was deleted from the database'),('en','phpbrain','file was deleted successfully','File was deleted successfully'),('en','phpbrain','file wasn\'t in server and it couldn\'t be deleted from the database','File wasn\'t in server and it couldn\'t be deleted from the database'),('en','phpbrain','find results','Find results'),('en','phpbrain','global categories','Global Categories'),('en','phpbrain','history','History'),('en','phpbrain','if you can\'t find answers to your problem in the knowledge base, describe it below','If you can\'t find answers to your problem in the knowledge base, describe it below'),('en','phpbrain','if you wish, you can comment this article here','If you wish, you can comment this article here'),('en','phpbrain','in %1','in %1'),('en','phpbrain','in the text','in the text'),('en','phpbrain','in the title','in the title'),('en','phpbrain','in the topic','in the topic'),('en','phpbrain','include subcategories','Include subcategories'),('en','phpbrain','keywords','Keywords'),('en','phpbrain','knowledge base article #%1','Knowledge Base article #%1'),('en','phpbrain','last modification by %1 on %2','Last modification by %1 on %2'),('en','phpbrain','last modified','Last Modified'),('en','phpbrain','latest','Latest'),('en','phpbrain','latest comments','Latest comments'),('en','phpbrain','leave empty to automatically generate an id','Leave empty to automatically generate an ID'),('en','phpbrain','link could not be added','Link could not be added'),('en','phpbrain','link deleted successfully','Link deleted successfully'),('en','phpbrain','link has been added','Link has been added'),('en','phpbrain','links','Links'),('en','phpbrain','links & files','Links & Files'),('en','phpbrain','mail article','Mail article'),('en','phpbrain','main view','Main View'),('en','phpbrain','maintain articles','Maintain Articles'),('en','phpbrain','maintain questions','Maintain Questions'),('en','phpbrain','maximum number of comments to show:','Maximum number of comments to show:'),('en','phpbrain','maximum number of most popular articles, latest articles and unanswered questions to show in the main view:','Maximum number of most popular articles, latest articles and unanswered questions to show in the main view:'),('en','phpbrain','modification date','Modification date'),('en','phpbrain','most viewed','Most viewed'),('en','phpbrain','new article','New Article'),('en','phpbrain','nobody has rated this article so far','Nobody has rated this article so far'),('en','phpbrain','nothing was uploaded!','Nothing was uploaded!'),('en','phpbrain','number of results per page','Number of results'),('en','phpbrain','ocurrences','Ocurrences'),('en','phpbrain','or browse the categories','Or browse the categories'),('en','phpbrain','order results by','Order results by'),('en','phpbrain','outstanding published questions','Outstanding published questions'),('en','phpbrain','past %1 months','past %1 months'),('en','phpbrain','past year','past year'),('en','phpbrain','people have rated this article','people have rated this article'),('en','phpbrain','please rate the pertinence and quality of this article','Please rate the pertinence and quality of this article'),('en','phpbrain','please try again','Please try again'),('en','phpbrain','poor','Poor'),('en','phpbrain','printer view','Printer view'),('en','phpbrain','problem relating articles','Problem relating articles'),('en','phpbrain','publication date','Publication date'),('en','phpbrain','publish','Publish'),('en','phpbrain','publish selected','Publish selected'),('en','phpbrain','published','Published'),('en','phpbrain','question deleted successfully','Question deleted successfully'),('en','phpbrain','questions deleted successfully','Questions deleted successfully'),('en','phpbrain','rating has been submited','Rating has been submited'),('en','phpbrain','rating invalid','Rating invalid'),('en','phpbrain','recipient','Recipient'),('en','phpbrain','related articles in the knowledge base','Related Articles in the Knowledge Base'),('en','phpbrain','relation with article was removed successfully','Relation with article was removes successfully'),('en','phpbrain','removed file %1','Removed file %1'),('en','phpbrain','removed link %1','Removed link %1'),('en','phpbrain','reply-to','Reply-to'),('en','phpbrain','search in all the knowledge base','Search in all the Knowledge Base'),('en','phpbrain','search results','Search results'),('en','phpbrain','see more questions','See more questions'),('en','phpbrain','see more questions...','See more questions...'),('en','phpbrain','select articles','Select articles'),('en','phpbrain','show all comments','Show all comments'),('en','phpbrain','show articles belonging to:','Show articles belonging to:'),('en','phpbrain','show messages in category','Show messages in category'),('en','phpbrain','submit comment','Submit comment'),('en','phpbrain','submit comment and rating','Submit comment and rating'),('en','phpbrain','suggested category','Suggested category'),('en','phpbrain','summary','Summary'),('en','phpbrain','that file already exists','That file already exists'),('en','phpbrain','the article id must be a number','The article ID must be a number'),('en','phpbrain','the article is empty','The article is empty'),('en','phpbrain','the file was already missing in the server','The file was already missing in the server'),('en','phpbrain','the following errors occurred','The following errors occurred'),('en','phpbrain','the mail server returned:','The mail server returned:'),('en','phpbrain','the present category and all subcategories under it','The present category and all subcategories under it'),('en','phpbrain','the present category only','The present category only'),('en','phpbrain','there are no articles','There are no articles'),('en','phpbrain','there are no articles available','There are no articles available'),('en','phpbrain','this article hasn\'t yet been published in the knowledge base','This article hasn\'t yet been published in the Knowledge Base'),('en','phpbrain','title','Title'),('en','phpbrain','to create categories, press \'edit categories\' in the preferences menu','To create categories, press \'Edit Categories\' in the preferences menu'),('en','phpbrain','topic','Topic'),('en','phpbrain','unable to add rating to database','Unable to add rating to database'),('en','phpbrain','unanswered questions','Unanswered questions'),('en','phpbrain','unpublish','Unpublish'),('en','phpbrain','unpublished','unpublished'),('en','phpbrain','user preferences','User preferences'),('en','phpbrain','views','views'),('en','phpbrain','was it easy to find this article using the above search string?','Was it easy to find this article using the above search string?'),('en','phpbrain','when navigating through categories, choose whether the list of articles shown corresponds only to the present category, or the p','When navigating through categories, choose whether the list of articles shown corresponds only to the present category, or the present category and all categories under it.'),('en','phpbrain','with all the words','With all the words'),('en','phpbrain','with at least one of the words','With at least one of the words'),('en','phpbrain','with the exact phrase','With the exact phrase'),('en','phpbrain','without the words','Without the words'),('en','phpbrain','you are in %1','You are in %1'),('en','phpbrain','you have already qualified this article','You have already qualified this article'),('en','phpbrain','you have not the proper permissions to do that','You have not the proper permissions to do that'),('en','phpbrain','you must enter a title','You must enter a title'),('en','phpbrain','you must enter a topic','You must enter a topic'),('en','phpbrain','your message could not be sent!','Your message could not be sent!'),('en','phpbrain','your question will be posted, but only will be published after approval by a user with publishing rights','Your question will be posted, but only will be published after approval by a user with publishing rights'),('en','phpbrain','your question will be published immediately','Your question will be published immediately'),('en','jscalendar','(shift-)click or drag to change value','(Shift-)Click or drag to change value'),('en','jscalendar','- click on any of the time parts to increase it','- Click on any of the time parts to increase it'),('en','jscalendar','- hold mouse button on any of the above buttons for faster selection.','- Hold mouse button on any of the above buttons for faster selection.'),('en','jscalendar','- or click and drag for faster selection.','- or click and drag for faster selection.'),('en','jscalendar','- or shift-click to decrease it','- or Shift-click to decrease it'),('en','jscalendar','- use the %1, %2 buttons to select month','- Use the %1, %2 buttons to select month'),('en','jscalendar','- use the %1, %2 buttons to select year','- Use the %1, %2 buttons to select year'),('en','jscalendar','3 number of chars for day-shortcut','3 number of chars for day-shortcut'),('en','jscalendar','3 number of chars for month-shortcut','3 number of chars for month-shortcut'),('en','jscalendar','about the calendar','About the calendar'),('en','jscalendar','date selection:','Date selection:'),('en','jscalendar','display %s first','Display %s first'),('en','jscalendar','drag to move','Drag to move'),('en','jscalendar','go today','Go Today'),('en','jscalendar','next month (hold for menu)','Next month (hold for menu)'),('en','jscalendar','next year (hold for menu)','Next year (hold for menu)'),('en','jscalendar','prev. month (hold for menu)','Prev. month (hold for menu)'),('en','jscalendar','prev. year (hold for menu)','Prev. year (hold for menu)'),('en','jscalendar','time selection:','Time selection:'),('en','jscalendar','toggle first day of week','Toggle first day of week'),('en','jscalendar','wk','wk'),('en','htmlarea-HtmlTidy','\\n tidying up the html source, please wait...','\\n Tidying up the HTML source, please wait...'),('en','htmlarea-HtmlTidy','html tidy','HTML Tidy'),('en','htmlarea-ContextMenu','_delete row','_Delete Row'),('en','htmlarea-ContextMenu','_image properties...','_Image Properties...'),('en','htmlarea-ContextMenu','_modify link...','_Modify Link...'),('en','htmlarea-ContextMenu','_remove link...','_Remove Link...'),('en','htmlarea-ContextMenu','_table properties...','_Table Properties...'),('en','htmlarea-ContextMenu','c_ell properties...','C_ell Properties...'),('en','htmlarea-ContextMenu','chec_k link...','Chec_k Link...'),('en','htmlarea-ContextMenu','create a link','Create a link'),('en','htmlarea-ContextMenu','current url is','Current URL is'),('en','htmlarea-ContextMenu','cut','Cut'),('en','htmlarea-ContextMenu','de_lete column','De_lete Column'),('en','htmlarea-ContextMenu','delete the current column','Delete the current column'),('en','htmlarea-ContextMenu','delete the current row','Delete the current row'),('en','htmlarea-ContextMenu','element...','Element...'),('en','htmlarea-ContextMenu','how did you get here? (please report!)','How did you get here? (Please report!)'),('en','htmlarea-ContextMenu','i_nsert row before','I_nsert Row Before'),('en','htmlarea-ContextMenu','in_sert row after','In_sert Row After'),('en','htmlarea-ContextMenu','insert _column before','Insert _Column Before'),('en','htmlarea-ContextMenu','insert a new column after the current one','Insert a new column after the current one'),('en','htmlarea-ContextMenu','insert a new column before the current one','Insert a new column before the current one'),('en','htmlarea-ContextMenu','insert a new row after the current one','Insert a new row after the current one'),('en','htmlarea-ContextMenu','insert a new row before the current one','Insert a new row before the current one'),('en','htmlarea-ContextMenu','insert c_olumn after','Insert C_olumn After'),('en','htmlarea-ContextMenu','link points to:','Link points to:'),('en','htmlarea-ContextMenu','make lin_k...','Make lin_k...'),('en','htmlarea-ContextMenu','modify url','Modify URL'),('en','htmlarea-ContextMenu','opens this link in a new window','Opens this link in a new window'),('en','htmlarea-ContextMenu','paste','Paste'),('en','htmlarea-ContextMenu','please confirm that you want to remove this element:','Please confirm that you want to remove this element:'),('en','htmlarea-ContextMenu','please confirm that you want to unlink this element.','Please confirm that you want to unlink this element.'),('en','htmlarea-ContextMenu','remove the','Remove the'),('en','htmlarea-ContextMenu','remove this node from the document','Remove this node from the document'),('en','htmlarea-ContextMenu','ro_w properties...','Ro_w Properties...'),('en','htmlarea-ContextMenu','show the image properties dialog','Show the image properties dialog'),('en','htmlarea-ContextMenu','show the table cell properties dialog','Show the Table Cell Properties dialog'),('en','htmlarea-ContextMenu','show the table properties dialog','Show the Table Properties dialog'),('en','htmlarea-ContextMenu','show the table row properties dialog','Show the Table Row Properties dialog'),('en','htmlarea-ContextMenu','unlink the current element','Unlink the current element'),('en','tinymce','a editor instance must be focused before using this command.','A editor instance must be focused before using this command.'),('en','tinymce','align center','Align center'),('en','tinymce','align full','Align full'),('en','tinymce','align left','Align left'),('en','tinymce','align right','Align right'),('en','tinymce','alignment','Alignment'),('en','tinymce','all occurrences of the search string was replaced.','All occurrences of the search string was replaced.'),('en','tinymce','alternative image','Alternative image'),('en','tinymce','bg color','Bg color'),('en','tinymce','border color','Border color'),('en','tinymce','cellpadding','Cellpadding'),('en','tinymce','cellspacing','Cellspacing'),('en','tinymce','center','Center'),('en','tinymce','choose directory to move selected folders and files to.','Choose directory to move selected folders and files to.'),('en','tinymce','class','Class'),('en','tinymce','cleanup messy code','Cleanup messy code'),('en','tinymce','columns','Columns'),('en','tinymce','comment','Comment'),('en','tinymce','configuration problem','Configuration problem'),('en','tinymce','copy table row','Copy table row'),('en','tinymce','copy/cut/paste is not available in mozilla and firefox.\\ndo you want more information about this issue?','Copy/Cut/Paste is not available in Mozilla and Firefox.\\nDo you want more information about this issue?'),('en','tinymce','cut table row','Cut table row'),('en','tinymce','date modified','Date Modified'),('en','tinymce','default','Default'),('en','tinymce','direction','Direction'),('en','tinymce','direction right to left','Direction right to left'),('en','tinymce','directory','Directory'),('en','tinymce','do you want to use the wysiwyg mode for this textarea?','Do you want to use the WYSIWYG mode for this textarea?'),('en','tinymce','down','Down'),('en','tinymce','emotions','Emotions'),('en','tinymce','file already exists. file was not uploaded.','File already exists. File was not uploaded.'),('en','tinymce','file exceeds the size limit','File exceeds the size limit'),('en','tinymce','file manager','File manager'),('en','tinymce','file not found.','File not found.'),('en','tinymce','file was not uploaded.','File was not uploaded.'),('en','tinymce','file with specified new name already exists. file was not renamed/moved.','File with specified new name already exists. File was not renamed/moved.'),('en','tinymce','file(s)','file(s)'),('en','tinymce','file:','File:'),('en','tinymce','files with this extension are not allowed.','Files with this extension are not allowed.'),('en','tinymce','find','Find'),('en','tinymce','find again','Find again'),('en','tinymce','find what','Find what'),('en','tinymce','find&nbsp;next','Find&nbsp;next'),('en','tinymce','find/replace','Find/Replace'),('en','tinymce','flash files','Flash files'),('en','tinymce','flash properties','Flash properties'),('en','tinymce','flash-file (.swf)','Flash-File (.swf)'),('en','tinymce','folder','Folder'),('en','tinymce','folder name missing.','Folder name missing.'),('en','tinymce','folder not found.','Folder not found.'),('en','tinymce','folder with specified new name already exists. folder was not renamed/moved.','Folder with specified new name already exists. Folder was not renamed/moved.'),('en','tinymce','folder(s)','folder(s)'),('en','tinymce','for mouse out','for mouse out'),('en','tinymce','for mouse over','for mouse over'),('en','tinymce','image description','Image description'),('en','tinymce','image title','Image title'),('en','tinymce','indent','Indent'),('en','tinymce','insert','Insert'),('en','tinymce','insert / edit flash movie','Insert / edit Flash Movie'),('en','tinymce','insert / edit horizontale rule','Insert / edit Horizontale Rule'),('en','tinymce','insert date','Insert date'),('en','tinymce','insert emotion','Insert emotion'),('en','tinymce','insert file','Insert File'),('en','tinymce','insert link to file','Insert link to file'),('en','tinymce','insert time','Insert time'),('en','tinymce','insert/edit image','Insert/edit image'),('en','tinymce','insert/edit link','Insert/edit link'),('en','tinymce','insert/modify table','Insert/Modify table'),('en','tinymce','inserts a new table','Inserts a new table'),('en','tinymce','js-popup','JS-Popup'),('en','tinymce','keep linebreaks','Keep linebreaks'),('en','tinymce','link url','Link URL'),('en','tinymce','loading files','Loading files'),('en','tinymce','make window resizable','Make window resizable'),('en','tinymce','match case','Match case'),('en','tinymce','merge table cells','Merge table cells'),('en','tinymce','mkdir failed.','Mkdir failed.'),('en','tinymce','move','Move'),('en','tinymce','new file name missing!','New file name missing!'),('en','tinymce','new file name:','New file name:'),('en','tinymce','new folder','New folder'),('en','tinymce','new folder name missing!','New folder name missing!'),('en','tinymce','new folder name:','New folder name:'),('en','tinymce','no files...','No files...'),('en','tinymce','no permission to create folder.','No permission to create folder.'),('en','tinymce','no permission to delete file.','No permission to delete file.'),('en','tinymce','no permission to move files and folders.','No permission to move files and folders.'),('en','tinymce','no permission to rename files and folders.','No permission to rename files and folders.'),('en','tinymce','no permission to upload.','No permission to upload.'),('en','tinymce','no shadow','No shadow'),('en','tinymce','only files with extensions are permited, e.g. \"imagefile.jpg\".','Only files with extensions are permited, e.g. \"imagefile.jpg\".'),('en','tinymce','open file in new window','Open file in new window'),('en','tinymce','open in new window','Open in new window'),('en','tinymce','open in parent window / frame','Open in parent window / frame'),('en','tinymce','open in the window','Open in the window'),('en','tinymce','open in this window / frame','Open in this window / frame'),('en','tinymce','open in top frame (replaces all frames)','Open in top frame (replaces all frames)'),('en','tinymce','open link in a new window','Open link in a new window'),('en','tinymce','open link in the same window','Open link in the same window'),('en','tinymce','outdent','Outdent'),('en','tinymce','paste as plain text','Paste as Plain Text'),('en','tinymce','paste from word','Paste from Word'),('en','tinymce','paste table row after','Paste table row after'),('en','tinymce','paste table row before','Paste table row before'),('en','tinymce','path not found.','Path not found.'),('en','tinymce','please enter the caption text','Please enter the caption text'),('en','tinymce','please insert a name for the target or choose another option.','Please insert a name for the target or choose another option.'),('en','tinymce','popup url','Popup URL'),('en','tinymce','position (x/y)','Position (X/Y)'),('en','tinymce','preview','Preview'),('en','tinymce','redo','Redo'),('en','tinymce','refresh','Refresh'),('en','tinymce','remove col','Remove col'),('en','tinymce','rename failed','Rename failed'),('en','tinymce','replace&nbsp;all','Replace&nbsp;all'),('en','tinymce','rmdir failed.','Rmdir failed.'),('en','tinymce','rows','Rows'),('en','tinymce','run spell checking','Run spell checking'),('en','tinymce','select all','Select All'),('en','tinymce','show locationbar','Show locationbar'),('en','tinymce','show menubar','Show menubar'),('en','tinymce','show scrollbars','Show scrollbars'),('en','tinymce','show statusbar','Show statusbar'),('en','tinymce','show toolbars','Show toolbars'),('en','tinymce','size','Size'),('en','tinymce','split table cells','Split table cells'),('en','tinymce','striketrough','Striketrough'),('en','tinymce','table cell properties','Table cell properties'),('en','tinymce','table row properties','Table row properties'),('en','tinymce','target','Target'),('en','tinymce','the search has been compleated. the search string could not be found.','The search has been compleated. The search string could not be found.'),('en','tinymce','this is just a template button','This is just a template button'),('en','tinymce','this is just a template popup','This is just a template popup'),('en','tinymce','toggle fullscreen mode','Toggle fullscreen mode'),('en','tinymce','undo','Undo'),('en','tinymce','unlink','Unlink'),('en','tinymce','unlink failed.','Unlink failed.'),('en','tinymce','unordered list','Unordered list'),('en','tinymce','up','Up'),('en','tinymce','uploading...','Uploading...'),('en','tinymce','use ctrl and/or shift to select multiple items.','Use Ctrl and/or Shift to select multiple items.'),('en','tinymce','use ctrl+v on your keyboard to paste the text into the window.','Use CTRL+V on your keyboard to paste the text into the window.'),('en','tinymce','vertical alignment','Vertical alignment'),('en','tinymce','warning!\\n renaming or moving folders and files will break existing links in your documents. continue?','Warning!\\n Renaming or moving folders and files will break existing links in your documents. Continue?'),('en','tinymce','window name','Window name'),('en','tinymce','you must enter the url','You must enter the URL'),('en','htmlarea','about this editor','About this editor'),('en','htmlarea','background color','Background Color'),('en','htmlarea','bulleted list','Bulleted List'),('en','htmlarea','copy selection','Copy selection'),('en','htmlarea','current style','Current style'),('en','htmlarea','cut selection','Cut selection'),('en','htmlarea','decrease indent','Decrease Indent'),('en','htmlarea','enlarge editor','Enlarge Editor'),('en','htmlarea','font color','Font Color'),('en','htmlarea','help using editor','Help using editor'),('en','htmlarea','horizontal rule','Horizontal Rule'),('en','htmlarea','increase indent','Increase Indent'),('en','htmlarea','insert image','Insert Image'),('en','htmlarea','insert table','Insert Table'),('en','htmlarea','insert web link','Insert Web Link'),('en','htmlarea','paste from clipboard','Paste from clipboard'),('en','htmlarea','path','Path'),('en','htmlarea','redoes your last action','Redoes your last action'),('en','htmlarea','strikethrough','Strikethrough'),('en','htmlarea','subscript','Subscript'),('en','htmlarea','superscript','Superscript'),('en','htmlarea','toggle html source','Toggle HTML Source'),('en','htmlarea','undoes your last action','Undoes your last action'),('en','htmlarea','you are in text mode.  use the [<>] button to switch back to wysiwig.','You are in TEXT MODE.  Use the [<>] button to switch back to WYSIWIG.'),('en','htmlarea-TableOperations','align','Align'),('en','htmlarea-TableOperations','all four sides','All four sides'),('en','htmlarea-TableOperations','background','Background'),('en','htmlarea-TableOperations','baseline','Baseline'),('en','htmlarea-TableOperations','borders','Borders'),('en','htmlarea-TableOperations','cell properties','Cell Properties'),('en','htmlarea-TableOperations','char','Char'),('en','htmlarea-TableOperations','collapsed borders','Collapsed borders'),('en','htmlarea-TableOperations','color','Color'),('en','htmlarea-TableOperations','delete cell','Delete cell'),('en','htmlarea-TableOperations','delete column','Delete column'),('en','htmlarea-TableOperations','fg color','FG Color'),('en','htmlarea-TableOperations','float','Float'),('en','htmlarea-TableOperations','frames','Frames'),('en','htmlarea-TableOperations','how many columns would you like to merge?','How many columns would you like to merge?'),('en','htmlarea-TableOperations','how many rows would you like to merge?','How many rows would you like to merge?'),('en','htmlarea-TableOperations','htmlarea cowardly refuses to delete the last cell in row.','HTMLArea cowardly refuses to delete the last cell in row.'),('en','htmlarea-TableOperations','htmlarea cowardly refuses to delete the last column in table.','HTMLArea cowardly refuses to delete the last column in table.'),('en','htmlarea-TableOperations','htmlarea cowardly refuses to delete the last row in table.','HTMLArea cowardly refuses to delete the last row in table.'),('en','htmlarea-TableOperations','insert cell after','Insert cell after'),('en','htmlarea-TableOperations','insert cell before','Insert cell before'),('en','htmlarea-TableOperations','justify','Justify'),('en','htmlarea-TableOperations','layout','Layout'),('en','htmlarea-TableOperations','margin','Margin'),('en','htmlarea-TableOperations','merge cells','Merge cells'),('en','htmlarea-TableOperations','middle','Middle'),('en','htmlarea-TableOperations','no rules','No rules'),('en','htmlarea-TableOperations','no sides','No sides'),('en','htmlarea-TableOperations','padding','Padding'),('en','htmlarea-TableOperations','percent','percent'),('en','htmlarea-TableOperations','pixels','pixels'),('en','htmlarea-TableOperations','please click into some cell','Please click into some cell'),('en','htmlarea-TableOperations','row properties','Row Properties'),('en','htmlarea-TableOperations','rules','Rules'),('en','htmlarea-TableOperations','rules will appear between all rows and columns','Rules will appear between all rows and columns'),('en','htmlarea-TableOperations','rules will appear between columns only','Rules will appear between columns only'),('en','htmlarea-TableOperations','rules will appear between rows only','Rules will appear between rows only'),('en','htmlarea-TableOperations','spacing','Spacing'),('en','htmlarea-TableOperations','spacing and padding','Spacing and padding'),('en','htmlarea-TableOperations','split cell','Split cell'),('en','htmlarea-TableOperations','split column','Split column'),('en','htmlarea-TableOperations','split row','Split row'),('en','htmlarea-TableOperations','style [css]','Style [CSS]'),('en','htmlarea-TableOperations','summary','Summary'),('en','htmlarea-TableOperations','text align','Text align'),('en','htmlarea-TableOperations','the bottom side only','The bottom side only'),('en','htmlarea-TableOperations','the left-hand side only','The left-hand side only'),('en','htmlarea-TableOperations','the right and left sides only','The right and left sides only'),('en','htmlarea-TableOperations','the right-hand side only','The right-hand side only'),('en','htmlarea-TableOperations','the top and bottom sides only','The top and bottom sides only'),('en','htmlarea-TableOperations','the top side only','The top side only'),('en','htmlarea-TableOperations','unset color','Unset color'),('en','htmlarea-TableOperations','vertical align','Vertical align'),('en','htmlarea-ListType','choose list style type (for ordered lists)','Choose list style type (for ordered lists)'),('en','htmlarea-ListType','decimal numbers','Decimal numbers'),('en','htmlarea-ListType','lower greek letters','Lower greek letters'),('en','htmlarea-ListType','lower latin letters','Lower latin letters'),('en','htmlarea-ListType','lower roman numbers','Lower roman numbers'),('en','htmlarea-ListType','upper latin letters','Upper latin letters'),('en','htmlarea-ListType','upper roman numbers','Upper roman numbers'),('en','htmlarea-SpellChecker','dictionary','Dictionary'),('en','htmlarea-SpellChecker','finished list of mispelled words','Finished list of mispelled words'),('en','htmlarea-SpellChecker','i will open it in a new page.','I will open it in a new page.'),('en','htmlarea-SpellChecker','ignore','Ignore'),('en','htmlarea-SpellChecker','ignore all','Ignore all'),('en','htmlarea-SpellChecker','no mispelled words found with the selected dictionary.','No mispelled words found with the selected dictionary.'),('en','htmlarea-SpellChecker','original word','Original word'),('en','htmlarea-SpellChecker','please confirm that you want to open this link','Please confirm that you want to open this link'),('en','htmlarea-SpellChecker','please wait.  calling spell checker.','Please wait.  Calling spell checker.'),('en','htmlarea-SpellChecker','please wait: changing dictionary to','Please wait: changing dictionary to'),('en','htmlarea-SpellChecker','pliz weit ;-)','pliz weit ;-)'),('en','htmlarea-SpellChecker','re-check','Re-check'),('en','htmlarea-SpellChecker','replace all','Replace all'),('en','htmlarea-SpellChecker','revert','Revert'),('en','htmlarea-SpellChecker','spell check complete, didn\'t find any mispelled words.  closing now...','Spell check complete, didn\'t find any mispelled words.  Closing now...'),('en','htmlarea-SpellChecker','spell-check','Spell-check'),('en','htmlarea-SpellChecker','suggestions','Suggestions'),('en','htmlarea-SpellChecker','this will drop changes and quit spell checker.  please confirm.','This will drop changes and quit spell checker.  Please confirm.'),('en','login','sorry, your login has expired','Sorry, your login has expired'),('en','login','you have been successfully logged out','You have been successfully logged out'),('en','login','your session could not be verified.','Your session could not be verified.'),('en','login','lost login id','Lost login id'),('en','login','lost password','Lost password'),('en','login','not a user yet? register now','Not a user yet? Register now'),('en','htmlarea-UploadImage','upload image','Upload Image'),('en','polls','actions','actions'),('en','polls','add answer to poll','Add answer to poll'),('en','polls','add answers','Add answers'),('en','polls','add new poll question','Add new poll question'),('en','polls','add questions','Add questions'),('en','polls','allow users to vote more then once','Allow users to vote more than once'),('en','polls','answer','Answer'),('en','polls','answer has been added to poll','Answer has been added to poll'),('en','polls','answer has been updated','Answer has been updated'),('en','polls','answers','Answers'),('en','polls','are you sure want to delete this answer ?','Are you sure want to delete this answer ?'),('en','polls','are you sure want to delete this question ?','Are you sure want to delete this question ?'),('en','polls','current poll','Current Poll'),('en','polls','edit answer','Edit answer'),('en','polls','edit poll question','Edit poll question'),('en','polls','enter poll question','Enter poll question'),('en','polls','new poll has been added.  you should now add some answers for this poll','New poll has been added.  You should now add some answers for this poll'),('en','polls','poll question','Poll question'),('en','polls','question has been updated','Question has been updated'),('en','polls','select current poll','Select current poll'),('en','polls','settings','Settings'),('en','polls','settings updated','Settings updated'),('en','polls','show answers','Show answers'),('en','polls','total votes','Total'),('en','polls','view poll','View poll'),('en','polls','view results','View Results'),('en','polls','vote','Vote'),('en','polls','voting booth administration','Voting Booth Administration'),('en','polls','which poll','Which poll'),('en','projectmanager','%1 element(s) updated','%1 element(s) updated'),('en','projectmanager','%1 new project-elements imported','%1 new project-elements imported'),('en','projectmanager','%1 projects deleted','%1 projects deleted'),('en','projectmanager','%1 times permission denied, %2 projects deleted','%1 times permission denied, %2 projects deleted'),('en','projectmanager','- planned','- planned'),('en','projectmanager','0ngoing (0 < % < 100)','0ngoing (0 < % < 100)'),('en','projectmanager','a describtive title for the project, must not be empty','a describtive title for the project, must not be empty'),('en','projectmanager','accounting','Accounting'),('en','projectmanager','accounting options','Accounting options'),('en','projectmanager','accounting type','Accounting type'),('en','projectmanager','actions','Actions'),('en','projectmanager','activity','Activity'),('en','projectmanager','add a new milestone','Add a new milestone'),('en','projectmanager','add a new project','Add a new project'),('en','projectmanager','add element','Add element'),('en','projectmanager','add existing','Add existing'),('en','projectmanager','add milestone','Add milestone'),('en','projectmanager','add or edit roles and their acl','Add or edit roles and their ACL'),('en','projectmanager','add price','Add price'),('en','projectmanager','add project','Add project'),('en','projectmanager','add project-elements','Add project-elements'),('en','projectmanager','add this role','Add this role'),('en','projectmanager','allow users to change their working times','Allow users to change their working times'),('en','projectmanager','allowed accounting types','Allowed accounting types'),('en','projectmanager','allowed units','Allowed units'),('en','projectmanager','anonymous public','Anonymous public'),('en','projectmanager','app.','App.'),('en','projectmanager','apply the changes','Apply the changes'),('en','projectmanager','archive','Archive'),('en','projectmanager','assistant','Assistant'),('en','projectmanager','at which time do you start working on the given day.','At which time do you start working on the given day.'),('en','projectmanager','availible','Availible'),('en','projectmanager','billable','billable'),('en','projectmanager','bookable','bookable'),('en','projectmanager','budget','Budget'),('en','projectmanager','budget (no pricelist)','Budget (no pricelist)'),('en','projectmanager','budget and pricelist','Budget and pricelist'),('en','projectmanager','by','by'),('en','projectmanager','calculate budget by quantity (eg. time) and price','Calculate budget by quantity (eg. time) and price'),('en','projectmanager','check all','Check all'),('en','projectmanager','close the window, discard the changes made','Close the window, discard the changes made'),('en','projectmanager','constraints','Constraints'),('en','projectmanager','conversation between days and hours, default 8','conversation between days and hours, default 8'),('en','projectmanager','coordinator','Coordinator'),('en','projectmanager','cost per time','Cost per Time'),('en','projectmanager','create a new empty project or use a template','Create a new empty project or use a template'),('en','projectmanager','create new links','Create new links'),('en','projectmanager','created','created'),('en','projectmanager','created a ganttchart from the checked projects','Created a ganttchart from the checked projects'),('en','projectmanager','custom fields','Custom fields'),('en','projectmanager','customer title','Customer title'),('en','projectmanager','datasource','Datasource'),('en','projectmanager','dates','Dates'),('en','projectmanager','default all and a selectbox to choose','default all and a selectbox to choose'),('en','projectmanager','delete all checked projects','Delete all checked projects'),('en','projectmanager','delete this milestone','Delete this milestone'),('en','projectmanager','delete this price','Delete this price'),('en','projectmanager','delete this project','Delete this project'),('en','projectmanager','delete this project-element, does not remove the linked entry','Delete this project-element, does NOT remove the linked entry'),('en','projectmanager','delete this role','Delete this role'),('en','projectmanager','depth of display','Depth of display'),('en','projectmanager','do not use that entry as project-element','do not use that entry as project-element'),('en','projectmanager','done (100%)','Done (100%)'),('en','projectmanager','edit access, incl. editing budget and elements','edit access, incl. editing budget and elements'),('en','projectmanager','edit budget','Edit budget'),('en','projectmanager','edit milestone','Edit milestone'),('en','projectmanager','edit price','Edit price'),('en','projectmanager','edit project','Edit project'),('en','projectmanager','edit project-elements','Edit project-elements'),('en','projectmanager','edit this milestone','Edit this milestone'),('en','projectmanager','edit this price','Edit this price'),('en','projectmanager','edit this project','Edit this project'),('en','projectmanager','edit this project-element','Edit this project-element'),('en','projectmanager','edit this role','Edit this role'),('en','projectmanager','elementlist','Elementlist'),('en','projectmanager','elements of elements','Elements of elements'),('en','projectmanager','elements that can\'t start before this one is finished','Elements that can\'t start before this one is finished'),('en','projectmanager','elements which have to be finished before this can start','Elements which have to be finished before this can start'),('en','projectmanager','empty','Empty'),('en','projectmanager','end before','End before'),('en','projectmanager','enddate','Enddate'),('en','projectmanager','error: deleting price !!!','Error: deleting price !!!'),('en','projectmanager','error: deleting project !!!','Error: deleting project !!!'),('en','projectmanager','error: deleting project-element !!!','Error: deleting project-element !!!'),('en','projectmanager','error: deleting role !!!','Error: deleting role !!!'),('en','projectmanager','error: project-id already exist, choose an other one or have one generated by leaving it emtpy !!!','Error: project-ID already exist, choose an other one or have one generated by leaving it emtpy !!!'),('en','projectmanager','error: saving milestone','Error: saving milestone'),('en','projectmanager','error: saving role !!!','Error: saving role !!!'),('en','projectmanager','error: saving the price (%1) !!!','Error: saving the price (%1) !!!'),('en','projectmanager','error: saving the project (%1) !!!','Error: saving the project (%1) !!!'),('en','projectmanager','error: saving the project-element (%1) !!!','Error: saving the project-element (%1) !!!'),('en','projectmanager','everything recursive','Everything recursive'),('en','projectmanager','existing links','Existing links'),('en','projectmanager','exit without saving','Exit without saving'),('en','projectmanager','free descriptiv text','free descriptiv text'),('en','projectmanager','from %1 to %2','from %1 to %2'),('en','projectmanager','full access','full access'),('en','projectmanager','ganttchart','Ganttchart'),('en','projectmanager','ganttchart parameter','Ganttchart parameter'),('en','projectmanager','general','General'),('en','projectmanager','general availibility','General availibility'),('en','projectmanager','general pricelist','General pricelist'),('en','projectmanager','h','h'),('en','projectmanager','health','Health'),('en','projectmanager','hours','hours'),('en','projectmanager','hours per workday','Hours per workday'),('en','projectmanager','how long do you work on the given day.','How long do you work on the given day.'),('en','projectmanager','ignore that entry','ignore that entry'),('en','projectmanager','ignored','ignored'),('en','projectmanager','last modified','last modified'),('en','projectmanager','leave it empty if you dont need a different customer title','leave it empty if you dont need a different customer title'),('en','projectmanager','leave it empty to have one generated','leave it empty to have one generated'),('en','projectmanager','leave it empty, if identitcal to the time','leave it empty, if identitcal to the time'),('en','projectmanager','linked elements','Linked elements'),('en','projectmanager','links','Links'),('en','projectmanager','mainproject only','Mainproject only'),('en','projectmanager','mainprojects','Mainprojects'),('en','projectmanager','members','Members'),('en','projectmanager','milestone deleted','Milestone deleted'),('en','projectmanager','milestone saved','Milestone saved'),('en','projectmanager','milestones','Milestones'),('en','projectmanager','milestones before this element has to be finished','Milestones before this element has to be finished'),('en','projectmanager','modified','Modified'),('en','projectmanager','modified by','modified by'),('en','projectmanager','necessary for project-elements doing that not automatic','necessary for project-elements doing that not automatic'),('en','projectmanager','necessary php extentions %1 not loaded and can\'t be loaded !!!','Necessary PHP extentions %1 not loaded and can\'t be loaded !!!'),('en','projectmanager','new','new'),('en','projectmanager','no accounting, only status','No accounting, only status'),('en','projectmanager','no accounting, only times and status','No accounting, only times and status'),('en','projectmanager','no details','no details'),('en','projectmanager','no read access to the datasource: removing overwritten values will just empty them !!!','No READ access to the datasource: removing overwritten values will just empty them !!!'),('en','projectmanager','no save necessary','no save necessary'),('en','projectmanager','nonactive','Nonactive'),('en','projectmanager','not started (0%)','Not started (0%)'),('en','projectmanager','not working','not working'),('en','projectmanager','only this project','Only this project'),('en','projectmanager','overwrite the datasource','Overwrite the datasource'),('en','projectmanager','percentage the member is availible for projects','Percentage the member is availible for projects'),('en','projectmanager','percentage the member is availible for this project','Percentage the member is availible for this project'),('en','projectmanager','permission denied !!!','Permission denied !!!'),('en','projectmanager','planned','planned'),('en','projectmanager','planned times','Planned times'),('en','projectmanager','please download a recent version from %1 and install it in %2.','Please download a recent version from %1 and install it in %2.'),('en','projectmanager','price','Price'),('en','projectmanager','price / unit','Price / Unit'),('en','projectmanager','price deleted','Price deleted'),('en','projectmanager','price saved','Price saved'),('en','projectmanager','pricelist','Pricelist'),('en','projectmanager','project availibility','Project availibility'),('en','projectmanager','project deleted','Project deleted'),('en','projectmanager','project id','Project ID'),('en','projectmanager','project members and roles','Project members and roles'),('en','projectmanager','project overview','project overview'),('en','projectmanager','project saved','Project saved'),('en','projectmanager','project specific title, prices, ...','Project specific title, prices, ...'),('en','projectmanager','project-element deleted','Project-Element deleted'),('en','projectmanager','project-element saved','Project-Element saved'),('en','projectmanager','project-elements','Project-Elements'),('en','projectmanager','projectlist','Projectlist'),('en','projectmanager','projectmember','Projectmember'),('en','projectmanager','quantity','Quantity'),('en','projectmanager','read access, incl. budget and adding elements','read access, incl. budget and adding elements'),('en','projectmanager','read access, no budget','read access, no budget'),('en','projectmanager','real end','Real end'),('en','projectmanager','real start','Real start'),('en','projectmanager','resources','Resources'),('en','projectmanager','role','Role'),('en','projectmanager','role deleted','Role deleted'),('en','projectmanager','role saved','Role saved'),('en','projectmanager','roles','Roles'),('en','projectmanager','save the changes made','Save the changes made'),('en','projectmanager','save this project element','Save this project element'),('en','projectmanager','select a project','select a project'),('en','projectmanager','select an activity if you want to calculate costs by quantity (time) and price','select an activity if you want to calculate costs by quantity (time) and price'),('en','projectmanager','select multiple projects for a further action','Select multiple projects for a further action'),('en','projectmanager','select the accounting types visible for users of projectmanager','select the accounting types visible for users of projectmanager'),('en','projectmanager','select this project and show it\'s elements','Select this project and show it\'s elements'),('en','projectmanager','share','Share'),('en','projectmanager','share on the whole project','Share on the whole project'),('en','projectmanager','share on the whole project in hours or percent, defaults to planned time','Share on the whole project in hours or percent, defaults to planned time'),('en','projectmanager','should projectmanager display the status icons of the datasource (eg. infolog) or just a progressbar with the numerical status (','Should ProjectManager display the status icons of the datasource (eg. InfoLog) or just a progressbar with the numerical status (faster).'),('en','projectmanager','show constraints and milestones','Show constraints and milestones'),('en','projectmanager','show planned times instead of the real times','Show planned times instead of the real times'),('en','projectmanager','show status icons of the datasources','Show status icons of the datasources'),('en','projectmanager','site configuration saved','Site configuration saved'),('en','projectmanager','start after','Start after'),('en','projectmanager','start working on %1','Start working on %1'),('en','projectmanager','start, end, category, ...','Start, End, Category, ...'),('en','projectmanager','start- & enddate','Start- & Enddate'),('en','projectmanager','startdate','Startdate'),('en','projectmanager','state','State'),('en','projectmanager','status filter','Status filter'),('en','projectmanager','subprojects','Subprojects'),('en','projectmanager','synchronise all','Synchronise all'),('en','projectmanager','template','Template'),('en','projectmanager','template including elment-tree saved as new project','Template including elment-tree saved as new project'),('en','projectmanager','time','Time'),('en','projectmanager','times','Times'),('en','projectmanager','title must not be empty','Title must not be empty'),('en','projectmanager','unit','Unit'),('en','projectmanager','unitprice','Unitprice'),('en','projectmanager','used','used'),('en','projectmanager','valid since','Valid since'),('en','projectmanager','view ganttchart of this project','View ganttchart of this project'),('en','projectmanager','view milestone','View milestone'),('en','projectmanager','view price','View price'),('en','projectmanager','view project','View project'),('en','projectmanager','view project-elements','View project-elements'),('en','projectmanager','view this element in %1','View this element in %1'),('en','projectmanager','view this milestone','View this milestone'),('en','projectmanager','view this price','View this price'),('en','projectmanager','view this project','View this project'),('en','projectmanager','view this project-element','View this project-element'),('en','projectmanager','working duration on %1','Working duration on %1'),('en','projectmanager','you are using the old version of jpgraph, bundled with egroupware. it has only limited functionality.','You are using the old version of JPGraph, bundled with eGroupWare. It has only limited functionality.'),('en','projectmanager','you can leave the date of the first price empty','you can leave the date of the first price empty'),('en','projectmanager','you need to select a project first','You need to select a project first'),('en','projectmanager','your database is not up to date (%1 vs. %2), please run %3setup%4 to update your database.','Your database is NOT up to date (%1 vs. %2), please run %3setup%4 to update your database.'),('en','registration','<br>please contact the site administrator.','<br>Please Contact the site administrator.'),('en','registration','[unknown first name]','[unknown first name]'),('en','registration','[unknown last name]','[unknown last name]'),('en','registration','account $account_lid record could not be found, report to site administrator','Account $account_lid record could not be found, report to site administrator'),('en','registration','account password retrieval','Account password retrieval'),('en','registration','account registration','Account registration'),('en','registration','address','Address'),('en','registration','after you enter your email address, the user accounts associated with this email address will be mailed to that address.','After you enter your email address, the user accounts associated with this email address will be mailed to that address.'),('en','registration','after you enter your username, instructions to change your password will be sent to you by e-mail to the address you gave when y','After you enter your username, instructions to change your password will be sent to you by e-mail to the address you gave when you registered.'),('en','registration','an error occured. please contact our technical support and let them know.','An error occured. Please contact our technical support and let them know.'),('en','registration','birthday','Birthday'),('en','registration','challenge question','Challenge Question'),('en','registration','change password for user','Change password for user'),('en','registration','checkbox','Checkbox'),('en','registration','choose language','Choose Language'),('en','registration','choose your language','Choose your language'),('en','registration','city','City'),('en','registration','close window','Close Window'),('en','registration','country','Country'),('en','registration','current fields:','Current fields:'),('en','registration','dropdown','Dropdown'),('en','registration','email address','email address'),('en','registration','enter your new password','Enter your new password'),('en','registration','female','Female'),('en','registration','gender','Gender'),('en','registration','hi','Hi'),('en','registration','i have read the terms and conditions and agree by them.','I have read the terms and conditions and agree by them.'),('en','registration','if you did not request this account, simply ignore this message.','If you did not request this account, simply ignore this message.'),('en','registration','if you did not request this change, simply ignore this message.','If you did not request this change, simply ignore this message.'),('en','registration','lost user account retrieval','Lost User account retrieval'),('en','registration','lost user id','Lost User Id'),('en','registration','lost_user_id_message','Here are the user accounts assoicated with this mail account:'),('en','registration','male','Male'),('en','registration','name (blank unless text, textarea, dropdown, checkbox; else alphanumeric only)','Name (blank unless Text, Textarea, Dropdown, Checkbox; else alphanumeric only)'),('en','registration','on-line registration is not activated. please contact the site administrator for more information about registration.','On-line registration is not activated. Please contact the site administrator for more information about registration.'),('en','registration','order','Order'),('en','registration','phone','Phone'),('en','registration','problem sending email:','Problem Sending Email:'),('en','registration','re-enter password','Re-enter password'),('en','registration','re-enter your password','Re-enter your password'),('en','registration','remove','Remove'),('en','registration','report all problems and abuse to','Report all problems and abuse to'),('en','registration','required','Required'),('en','registration','response','Response'),('en','registration','sorry, no account exists for','Sorry, no account exists for'),('en','registration','sorry, that username does not exist.','Sorry, that username does not exist.'),('en','registration','sorry, that username is already taken.','Sorry, that username is already taken.'),('en','registration','sorry, we are having a problem activating your account. note that links sent by e-mail are only valid during two hours. if you t','Sorry, we are having a problem activating your account. Note that links sent by e-mail are only valid during two hours. If you think this delay was expired, just retry. Otherwise, please contact the site administrator.'),('en','registration','state','State'),('en','registration','terms of service','Terms of Service'),('en','registration','text','Text'),('en','registration','textarea','Textarea'),('en','registration','the passwords you entered don\'t match','The passwords you entered don\'t match'),('en','registration','the two passwords are not the same','The two passwords are not the same'),('en','registration','this is a confirmation email for your new account.  click on the following link to finish activating your account. this link wil','This is a confirmation email for your new account.  Click on the following link to finish activating your account. This link will expire in 2 hours.'),('en','registration','type','Type'),('en','registration','unable to send mail, contact your administrator','Unable to send mail, contact your administration.'),('en','registration','unknown first name','Unknown first name'),('en','registration','unknown last name','Unknown last name'),('en','registration','update/add','Update/Add'),('en','registration','values (for dropdown only; comma separated)','Values (For Dropdown only; comma separated)'),('en','registration','we have sent a confirmation email to your email address. you must click on the link within 2 hours. if you do not, it may take a','We have sent a confirmation email to your email address. You must click on the link within 2 hours. If you do not, it may take a few days until your loginid will become available again.'),('en','registration','we have sent a mail to your email account: %s with your lost user ids.','We have sent a mail to your email account: %s with your lost user ids.'),('en','registration','we have sent a mail with instructions to change your password. you should follow the included link within two hours. if you do n','We have sent a mail with instructions to change your password. You should follow the included link within two hours. If you do not, you will have to go to the lost password screen again.'),('en','registration','wrong session','Wrong session'),('en','registration','you have entered an invalid birthday','You have entered an invalid birthday'),('en','registration','you have entered an invalid email address','You have entered an invalid email address'),('en','registration','you must enter a password','You must enter a password'),('en','registration','you must enter a username','You must enter a username'),('en','registration','you must enter an email account','You must enter an email account'),('en','registration','you must fill in all of the required fields','You must fill in all of the required fields'),('en','registration','you requested to change your password. please follow the url below to do so. this url will expire in two hours. after this delay','You requested to change your password. Please follow the URL below to do so. This URL will expire in two hours. After this delay you should go thru the lost password procedure again.'),('en','registration','you specified a value for %1 that is not a choice','You specified a value for %1 that is not a choice'),('en','registration','your account is now active!  click <a href=\"%s\">here</a> to log into your account.','Your account is now active!  Click <a href=\"%s\">here</a> to log into your account.'),('en','registration','your password was changed. you can go back to the <a href=\"%1\">login</a> page.','Your password was changed. You can go back to the <a href=\"%1\">login</a> page.'),('en','registration','zip/postal','ZIP/Postal'),('en','resources','accessories of','accessories of'),('en','resources','accessories:','Accessories:'),('en','resources','actions','Actions'),('en','resources','add accessory','Add accessory'),('en','resources','add resource','add resource'),('en','resources','add resources','Add resources'),('en','resources','administrator','Administrator'),('en','resources','all categories','all categories'),('en','resources','book','Book'),('en','resources','book selected resources','book selected resources'),('en','resources','book this resource','Book this resource'),('en','resources','bookable','Bookable'),('en','resources','buy this article','Buy this article'),('en','resources','buy this resource','Buy this resource'),('en','resources','buyable','Buyable'),('en','resources','categories admin','Categories admin'),('en','resources','category:','Category:'),('en','resources','check all','Check all'),('en','resources','choose categories admin','choose categories admin'),('en','resources','clear selection','clear selection'),('en','resources','configure access permissions','Configure Access Permissions'),('en','resources','create new accessory for this resource','Create new accessory for this resource'),('en','resources','create new links','Create new links'),('en','resources','delete selected resources','delete selected resources'),('en','resources','delete this entry','Delete this entry'),('en','resources','description (short)','Description (short)'),('en','resources','direct booking permissions','Direct booking permissions'),('en','resources','don\'t use vfs (this will need a symlink --> see readme)','Don\'t use vfs (this will need a symlink --> see README)'),('en','resources','edit this entry','Edit this entry'),('en','resources','existing links','Existing links'),('en','resources','general','General'),('en','resources','general informations about resource','General informations about resource'),('en','resources','gernal resource','gernal resource'),('en','resources','how many of the resources are useable?','How many of the resources are useable?'),('en','resources','how many of them are useable?','How many of them are useable?'),('en','resources','how many of this resource are usable','How many of this resource are usable'),('en','resources','how many of this resource exists','How many of this resource exists'),('en','resources','implies booking permission','implies booking permission'),('en','resources','implies read permission','implies read permission'),('en','resources','information about storage','Information about storage'),('en','resources','informations about the location of resource','Informations about the location of resource'),('en','resources','inventory number','Inventory number'),('en','resources','inventory number:','Inventory number:'),('en','resources','is resource bookable?','Is resource bookable?'),('en','resources','is resource buyable?','Is resource buyable?'),('en','resources','is this resource bookable?','Is this resource bookable?'),('en','resources','is this resource buyable?','Is this resource buyable?'),('en','resources','links','Links'),('en','resources','location','Location'),('en','resources','location of resource','Location of resource'),('en','resources','location:','Location:'),('en','resources','name of resource','Name of resource'),('en','resources','name:','Name:'),('en','resources','no description available','no description available'),('en','resources','no resources selected','No resources selected'),('en','resources','notify your administrator to correct this situation','Notify your administrator to correct this situation'),('en','resources','picture','Picture'),('en','resources','picture source','picture source'),('en','resources','picture type is not supported, sorry!','Picture type is not supported, sorry!'),('en','resources','pictures or resource','Pictures or resource'),('en','resources','planer','planer'),('en','resources','prizeing information for booking or buying','Prizeing information for booking or buying'),('en','resources','quantity','Quantity'),('en','resources','quantity of resource','Quantity of resource'),('en','resources','quantity:','Quantity:'),('en','resources','read calendar permissions','Read Calendar permissions'),('en','resources','read permissions','Read permissions'),('en','resources','related links','Related links'),('en','resources','resources list','resources list'),('en','resources','responsible:','Responsible:'),('en','resources','saves entry and exits','Saves entry and exits'),('en','resources','select a category','Select a category'),('en','resources','select resource','select resource'),('en','resources','select/deselect all','select/deselect all'),('en','resources','short description','Short description'),('en','resources','short description of resource','Short description of resource'),('en','resources','show calendar of resource','Show calendar of resource'),('en','resources','something went wrong by deleting resource','Something went wrong by deleting resource'),('en','resources','something went wrong by saving resource','Something went wrong by saving resource'),('en','resources','storage inforation','Storage Inforation'),('en','resources','storage information','Storage information'),('en','resources','storage information:','Storage information:'),('en','resources','the calendar of this resource','The Calendar of this resource'),('en','resources','this module displays the resources app','This module displays the resources app'),('en','resources','use general resources icon','Use general resources icon'),('en','resources','use own picture','Use own picture'),('en','resources','use the category\'s icon','Use the category\'s icon'),('en','resources','useable','useable'),('en','resources','useable:','Useable:'),('en','resources','view accessories for this resource','View accessories for this resource'),('en','resources','view this entry','View this entry'),('en','resources','web-page of resource','Web-Page of resource'),('en','resources','web-site for this resource','Web-Site for this resource'),('en','resources','where to find this resource?','Where to find this resource?'),('en','resources','which category does this resource belong to?','Which category does this resource belong to?'),('en','resources','write permissions','Write permissions'),('en','resources','you are not permitted to edit this reource!','You are not permitted to edit this reource!'),('en','resources','you are not permitted to get information about this resource!','You are not permitted to get information about this resource!'),('en','resources','you chose more resources than available','You chose more resources than available'),('en','sambaadmin','%1 - %2 of %3','%1 - %2 of %3'),('en','sambaadmin','add workstation','add workstation'),('en','sambaadmin','displayname','displayname'),('en','sambaadmin','do you really want to delete selected workstation accounts?','Do you really want to delete selected workstation accounts?'),('en','sambaadmin','homepath','homepath'),('en','sambaadmin','participants','Participants'),('en','sambaadmin','samba config','samba config'),('en','sambaadmin','workstation account for','workstation account for'),('en','sambaadmin','workstation configuration','workstation configuration'),('en','sambaadmin','workstation list','workstation list'),('en','sambaadmin','workstation name','workstation name'),('en','sambaadmin','workstationaccount active','workstationaccount active'),('en','sambaadmin','workstations','workstations'),('en','sitemgr','%1 content manager','%1 content manager'),('en','sitemgr','%1 module manager','%1 module manager'),('en','sitemgr','\'%1\' is no valid sitemgr-site directory !!!','\'%1\' is no valid sitemgr-site directory !!!'),('en','sitemgr','(do not put spaces or punctuation in the name field.)','(Do not put spaces or punctuation in the Name field.)'),('en','sitemgr','(leave blank to allow insecure logins)','(leave blank to allow insecure logins)'),('en','sitemgr','(only used in case of single file)','(only used in case of single file)'),('en','sitemgr','<b>autoregistration is not enabled / configured in the registration app !!!</b><br>you need to do so, to get the autoregistratio','<b>Autoregistration is not enabled / configured in the registration app !!!</b><br>You need to do so, to get the autoregistration link working.'),('en','sitemgr','<b>want more templates?</b><br />just download one from the template gallery at %1www.egroupware.org%2 or use a %3mambo open sou','<b>Want more templates?</b><br />Just download one from the template gallery at %1www.eGroupWare.org%2 or use a %3Mambo Open Source%4 Version 4.5 compatible template eg. from %5. Unpack the downloaded template in your templates directory (%6).'),('en','sitemgr','a simple picture galery','A simple picture galery'),('en','sitemgr','actif','Actif'),('en','sitemgr','add a category','Add a category'),('en','sitemgr','add a new application','Add a new application'),('en','sitemgr','add a new guestbook','Add a new guestbook'),('en','sitemgr','add block ...','Add block ...'),('en','sitemgr','add block to content area %1','Add block to content area %1'),('en','sitemgr','add category','Add Category'),('en','sitemgr','add new page to this category','Add new page to this category'),('en','sitemgr','add page','Add Page'),('en','sitemgr','add page to category','Add page to category'),('en','sitemgr','add website','Add Website'),('en','sitemgr','administration','Administration'),('en','sitemgr','administrative menu','Administrative Menu'),('en','sitemgr','administrators','administrators'),('en','sitemgr','all categories','All categories'),('en','sitemgr','all forums in category %1','All forums in category %1'),('en','sitemgr','all languages','all languages'),('en','sitemgr','allignment of navigation elements','Allignment of navigation elements'),('en','sitemgr','allow posting of questions','Allow posting of questions'),('en','sitemgr','amazon','Amazon'),('en','sitemgr','amazon server (without www), eg. amazon.com','Amazon server (without www), eg. amazon.com'),('en','sitemgr','an application directory','An application directory'),('en','sitemgr','anonymous','anonymous'),('en','sitemgr','anonymous user login domain','Anonymous user login domain'),('en','sitemgr','anonymous user\'s password','Anonymous user\'s password'),('en','sitemgr','anonymous user\'s username','Anonymous user\'s username'),('en','sitemgr','applet','Applet'),('en','sitemgr','application','Application'),('en','sitemgr','application \'%1\' is not installed !!!<br>please install it, to be able to use the block.','Application \'%1\' is not installed !!!<br>Please install it, to be able to use the block.'),('en','sitemgr','application sitemgr_module_guestbook must be installed as a egroupware application for this module to run','Application sitemgr_module_guestbook must be installed as a eGroupWare application for this module to run'),('en','sitemgr','apply permissions also to subcategories?','Apply permissions also to subcategories?'),('en','sitemgr','archived','archived'),('en','sitemgr','archived content','Archived content'),('en','sitemgr','are contributors allowed to define new guestbooks?','Are contributors allowed to define new guestbooks?'),('en','sitemgr','are you sure you want to delete site %1 and all its content? you cannot retrieve it if you continue.','Are you sure you want to delete site %1 and all its content? You cannot retrieve it if you continue.'),('en','sitemgr','are you sure you want to delete the category %1 and all of its associated pages?  you cannot retrieve the deleted pages if you c','Are you sure you want to delete the category %1 and all of its associated pages?  You cannot retrieve the deleted pages if you continue.'),('en','sitemgr','asin[=title] pairs (title is optional)','ASIN[=title] pairs (title is optional)'),('en','sitemgr','attempt to access information outside current website','Attempt to access information outside current website'),('en','sitemgr','attempt to edit non-editable block','Attempt to edit non-editable block'),('en','sitemgr','automatic index','Automatic index'),('en','sitemgr','automatically generated notification','Automatically generated notification'),('en','sitemgr','back to module manager','Back to module manager'),('en','sitemgr','back to the list of languages','Back to the list of languages'),('en','sitemgr','basic settings','Basic Settings'),('en','sitemgr','before the public web site can be viewed, you must configure the various locations and preferences.  please go to the sitemgr se','Before the public web site can be viewed, you must configure the various locations and preferences.  Please go to the sitemgr setup page by following this link:'),('en','sitemgr','block not found.','Block not found.'),('en','sitemgr','block reloaded','Block reloaded'),('en','sitemgr','block returned no content.','Block returned no content.'),('en','sitemgr','block saved','Block saved'),('en','sitemgr','bookmarks','Bookmarks'),('en','sitemgr','buy at %1','Buy at %1'),('en','sitemgr','calendar','Calendar'),('en','sitemgr','can\'t open an url or execute a script, because allow_url_fopen is not set in your php.ini !!!','Can\'t open an URL or execute a script, because allow_url_fopen is not set in your php.ini !!!'),('en','sitemgr','cancel the delete','Cancel the delete'),('en','sitemgr','cannot move page until it has been saved.','Cannot move page until it has been saved.'),('en','sitemgr','category','Category'),('en','sitemgr','category description','Category Description'),('en','sitemgr','category manager','Category Manager'),('en','sitemgr','category name','Category Name'),('en','sitemgr','category saved','Category saved'),('en','sitemgr','changes saved.','Changes saved.'),('en','sitemgr','check here after every upgrade','check here after every upgrade'),('en','sitemgr','check to hide from condensed site index.','Check to hide from condensed site index.'),('en','sitemgr','choose a category','Choose a category'),('en','sitemgr','choose a format','Choose a format'),('en','sitemgr','choose a guestbook','Choose a guestbook'),('en','sitemgr','choose language','Choose language'),('en','sitemgr','choose news layout','Choose news layout'),('en','sitemgr','choose template','Choose template'),('en','sitemgr','choose the categories to display','Choose the categories to display'),('en','sitemgr','choose the valid html type (note: not all icons are available):','Choose the VALID HTML type (note: not all icons are available):'),('en','sitemgr','choose your site\'s theme or template.  note that if you changed the above checkbox you need to save before choosing a theme or t','Choose your site\'s theme or template.  Note that if you changed the above checkbox you need to save before choosing a theme or template.'),('en','sitemgr','click here to login through a safe connection.','Click here to login through a safe connection.'),('en','sitemgr','code file','Code file'),('en','sitemgr','codebase url','Codebase URL'),('en','sitemgr','collapse threads','Collapse Threads'),('en','sitemgr','commit changes','Commit changes'),('en','sitemgr','common prefix of the image-name (a number starting with 1 will be appended)','common prefix of the image-name (a number starting with 1 will be appended)'),('en','sitemgr','complete news','Complete News'),('en','sitemgr','configure module properties','Configure module properties'),('en','sitemgr','configure sitemgr','Configure SiteMgr'),('en','sitemgr','configure website','Configure Website'),('en','sitemgr','contact the administrator.','Contact the administrator.'),('en','sitemgr','content areas','Content areas'),('en','sitemgr','content blocks','Content blocks'),('en','sitemgr','content blocks for category','Content blocks for category'),('en','sitemgr','content manager','Content Manager'),('en','sitemgr','contentarea','Contentarea'),('en','sitemgr','contributor menu','Contributor Menu'),('en','sitemgr','copyright','Copyright'),('en','sitemgr','create new version','Create new version'),('en','sitemgr','css styles','CSS styles'),('en','sitemgr','current section','Current Section'),('en','sitemgr','custom','custom'),('en','sitemgr','default','Default'),('en','sitemgr','default home page id number','Default home page ID number'),('en','sitemgr','delete block','Delete block'),('en','sitemgr','delete category','Delete category'),('en','sitemgr','delete page','Delete page'),('en','sitemgr','delete this application','Delete this application'),('en','sitemgr','delete this block','Delete this block'),('en','sitemgr','delete this guestbook','Delete this guestbook'),('en','sitemgr','delete version','Delete Version'),('en','sitemgr','deleting all data for %1','Deleting all data for %1'),('en','sitemgr','details for language %1 (%2)','Details for language %1 (%2)'),('en','sitemgr','directory for uploads (images etc.)','Directory for uploads (images etc.)'),('en','sitemgr','directory is not writeable by webserver. please correct this situation!','Directory is not writeable by webserver. Please correct this situation!'),('en','sitemgr','discussions','Discussions'),('en','sitemgr','display link to autoregistration below login form?','Display link to autoregistration below login form?'),('en','sitemgr','do you realy want to delete the selected categories (including all pages), pages and blocks?','Do you realy want to delete the selected Categories (including all pages), Pages and Blocks?'),('en','sitemgr','do you realy want to delete this block?','Do you realy want to delete this block?'),('en','sitemgr','do you realy want to delete this page?','Do you realy want to delete this page?'),('en','sitemgr','do you want to delete them?','Do you want to delete them?'),('en','sitemgr','do you want to publish a rss feed for this news category','Do you want to publish a RSS feed for this news category'),('en','sitemgr','documentation','Documentation'),('en','sitemgr','domain-name (offical dns-name eg. www.egroupware.org) if you want to give the user a choice between searching this site or the w','Domain-name (offical DNS-name eg. www.eGroupWare.org) if you want to give the user a choice between searching this site or the whole web. Leaving it empty allows to search the web only.'),('en','sitemgr','don\'t have an account?','Don\'t have an account?'),('en','sitemgr','done','Done'),('en','sitemgr','download as zip-archiv','download as ZIP-archiv'),('en','sitemgr','downloaded','downloaded'),('en','sitemgr','draft','draft'),('en','sitemgr','draft mode','Draft mode'),('en','sitemgr','edit category','Edit Category'),('en','sitemgr','edit mode','Edit mode'),('en','sitemgr','edit page','Edit Page'),('en','sitemgr','edit properties of module %1 for %2 with scope %3','Edit properties of module %1 for %2 with scope %3'),('en','sitemgr','edit site','Edit Site'),('en','sitemgr','edit this block','Edit this block'),('en','sitemgr','edit website','Edit Website'),('en','sitemgr','egw users','egw users'),('en','sitemgr','element successfully deleted.','Element successfully deleted.'),('en','sitemgr','enter a name','Enter a name'),('en','sitemgr','enter the block content here','Enter the block content here'),('en','sitemgr','enter the email to be notified about changes of the website.','Enter the email to be notified about changes of the website.'),('en','sitemgr','enter the email to be notified about changes of the website:','Enter the email to be notified about changes of the website:'),('en','sitemgr','enter the page content here','Enter the page content here'),('en','sitemgr','enterprise knowledge articles repository','Enterprise Knowledge articles repository'),('en','sitemgr','entry duplicated.','Entry duplicated.'),('en','sitemgr','entry saved.','Entry saved.'),('en','sitemgr','error deleting the element.','Error deleting the element.'),('en','sitemgr','error writing to the database.','Error writing to the database.'),('en','sitemgr','error writing to the database: %1.','Error writing to the database: %1.'),('en','sitemgr','everybody','everybody'),('en','sitemgr','expand current category','Expand current category'),('en','sitemgr','file %1 is not readable by the webserver !!!','File %1 is not readable by the webserver !!!'),('en','sitemgr','file %1 is outside the docroot of the webserver !!!<br>this module does not allow - for security reasons - to open files outside','File %1 is outside the docroot of the webserver !!!<br>This module does NOT allow - for security reasons - to open files outside the docroot.'),('en','sitemgr','file contents','File contents'),('en','sitemgr','file download','File download'),('en','sitemgr','filename','Filename'),('en','sitemgr','filesystem path of the directory where xml files are stored','Filesystem path of the directory where XML files are stored'),('en','sitemgr','filesystem path of the image-directory','Filesystem path of the image-directory'),('en','sitemgr','filesystem path to sitemgr-site directory','Filesystem path to sitemgr-site directory'),('en','sitemgr','fill in permissions from parent category? if you check this, below values will be ignored','Fill in permissions from parent category? If you check this, below values will be ignored'),('en','sitemgr','following new modules registed: %1','Following new modules registed: %1'),('en','sitemgr','footer editor','Footer Editor'),('en','sitemgr','forum','Forum'),('en','sitemgr','full path of the xslt file that should be applied to the xml files','Full path of the XSLT file that should be applied to the XML files'),('en','sitemgr','galerie','Galerie'),('en','sitemgr','gallery plus chooser','Gallery plus chooser'),('en','sitemgr','gallery plus chooser and download','Gallery plus chooser and download'),('en','sitemgr','gallery plus download','Gallery plus download'),('en','sitemgr','go back to page manager','Go back to Page Manager'),('en','sitemgr','go back to the category manager.','Go back to the category manager.'),('en','sitemgr','go to','Go to'),('en','sitemgr','go to page manager','Go to Page Manager'),('en','sitemgr','google','Google'),('en','sitemgr','google search','Google Search'),('en','sitemgr','group access permissions','Group Access Permissions'),('en','sitemgr','group name','Group Name'),('en','sitemgr','header editor','Header Editor'),('en','sitemgr','headlines','Headlines'),('en','sitemgr','hello','Hello'),('en','sitemgr','hello world','Hello world'),('en','sitemgr','helps you respect html/xhtml standards.','Helps you respect HTML/XHTML standards.'),('en','sitemgr','horizontal','Horizontal'),('en','sitemgr','html frame','HTML Frame'),('en','sitemgr','html module','HTML module'),('en','sitemgr','i\'m sorry, you do not have write permissions for any site categories.','I\'m sorry, you do not have write permissions for any site categories.'),('en','sitemgr','if nonsecure redirect to:','If nonsecure redirect to:'),('en','sitemgr','if you haven\'t done so already, create a user that will be used for public viewing of the site.  recommended name: anonymous.','If you haven\'t done so already, create a user that will be used for public viewing of the site.  Recommended name: anonymous.'),('en','sitemgr','image type','image type'),('en','sitemgr','implies read permission','implies read permission'),('en','sitemgr','index','Index'),('en','sitemgr','individual access permission','Individual Access Permission'),('en','sitemgr','individual access permissions','Individual Access Permissions'),('en','sitemgr','interface to google website','Interface to google website'),('en','sitemgr','invalid template directory \'%1\' !!!','Invalid template directory \'%1\' !!!'),('en','sitemgr','knowledge base','Knowledge Base'),('en','sitemgr','languages the site user can choose from','Languages the site user can choose from'),('en','sitemgr','last entries to the guestbook','Last entries to the guestbook'),('en','sitemgr','latest reply','Latest Reply'),('en','sitemgr','list of permitted modules specific to content area %1','List of permitted modules specific to content area %1'),('en','sitemgr','loged in as:','Loged in as:'),('en','sitemgr','login','Login'),('en','sitemgr','login name','Login Name'),('en','sitemgr','main content','Main content'),('en','sitemgr','mains','Mains'),('en','sitemgr','manage archived content','Manage archived content'),('en','sitemgr','manage categories','Manage Categories'),('en','sitemgr','manage categories and pages','Manage categories and pages'),('en','sitemgr','manage category wide content','Manage category wide content'),('en','sitemgr','manage category wide module properties','Manage category wide module properties'),('en','sitemgr','manage content','Manage Content'),('en','sitemgr','manage modules','Manage Modules'),('en','sitemgr','manage page specific content','Manage page specific content'),('en','sitemgr','manage site content','Manage Site Content'),('en','sitemgr','manage site-wide content','Manage site-wide content'),('en','sitemgr','manage site-wide module properties','Manage site-wide module properties'),('en','sitemgr','manage translations','Manage Translations'),('en','sitemgr','master list of permitted modules','Master list of permitted modules'),('en','sitemgr','messages are defined for all site languages.','Messages are defined for all site languages.'),('en','sitemgr','migrating data for %1 to %2','Migrating data for %1 to %2'),('en','sitemgr','module %1 is not permitted in this context!','Module %1 is not permitted in this context!'),('en','sitemgr','module manager','Module manager'),('en','sitemgr','module: %1, scope: %2, contentarea: %3, viewable: %4','Module: %1, Scope: %2, Contentarea: %3, Viewable: %4'),('en','sitemgr','more news','More news'),('en','sitemgr','move block down (increase sort order)','Move block down (increase sort order)'),('en','sitemgr','move block up (decrease sort order)','Move block up (decrease sort order)'),('en','sitemgr','move to','Move to'),('en','sitemgr','name','Name'),('en','sitemgr','name has been translated to lower case','Name has been translated to lower case'),('en','sitemgr','new application','New application'),('en','sitemgr','new guestbook','New guestbook'),('en','sitemgr','new sitemgr site','New sitemgr site'),('en','sitemgr','news module','News module'),('en','sitemgr','no additional arguments required','No additional arguments required'),('en','sitemgr','no anonymous user accounts installed.  notify the administrator.','NO ANONYMOUS USER ACCOUNTS INSTALLED.  NOTIFY THE ADMINISTRATOR.'),('en','sitemgr','no content areas found in selected template','No content areas found in selected template'),('en','sitemgr','no content found','No content found'),('en','sitemgr','no groups defined.','No groups defined.'),('en','sitemgr','no link to full index','No link to full index'),('en','sitemgr','no matching news item','No matching news item'),('en','sitemgr','no modules permitted for this content area/category','No modules permitted for this content area/category'),('en','sitemgr','no new modules found !!!','No new modules found !!!'),('en','sitemgr','no options available.','No options available.'),('en','sitemgr','no pages available','No pages available'),('en','sitemgr','no sitelanguages configured','No sitelanguages configured'),('en','sitemgr','no template file found.','No template file found.'),('en','sitemgr','no templates found.','No templates found.'),('en','sitemgr','no thumbnail availible','No thumbnail availible'),('en','sitemgr','no users defined.','No users defined.'),('en','sitemgr','no websites defined','No websites defined'),('en','sitemgr','no, chooser only (for side-areas)','No, chooser only (for side-areas)'),('en','sitemgr','no, chooser with preview','No, chooser with preview'),('en','sitemgr','not yet translated','not yet translated'),('en','sitemgr','note that you may get this message if your preferences are incorrect.  for example, if config.inc.php is not found in the direct','Note that you may get this message if your preferences are incorrect.  For example, if config.inc.php is not found in the directory that you specified.'),('en','sitemgr','note, this directory has to be writeable by webserver!','Note, this directory has to be writeable by webserver!'),('en','sitemgr','number of news items to be displayed on page','Number of news items to be displayed on page'),('en','sitemgr','on all pages','on all pages'),('en','sitemgr','only gallery','Only gallery'),('en','sitemgr','only on the first page','only on the first page'),('en','sitemgr','or enter the title for a new guestbook','or enter the title for a new guestbook'),('en','sitemgr','other websites','Other websites'),('en','sitemgr','overview of all available categories','Overview of all available categories'),('en','sitemgr','overview of one specific category','Overview of one specific category'),('en','sitemgr','own amazon partner-id or empty to donate to the egroupware project','Own Amazon partner-id or empty to donate to the eGroupWare project'),('en','sitemgr','page','Page'),('en','sitemgr','page content','Page Content'),('en','sitemgr','page manager','Page Manager'),('en','sitemgr','page name','Page Name'),('en','sitemgr','page saved','Page saved'),('en','sitemgr','page saved.','Page saved.'),('en','sitemgr','page subtitle','Page Subtitle'),('en','sitemgr','page title','Page Title'),('en','sitemgr','pages','Pages'),('en','sitemgr','pages:','Pages:'),('en','sitemgr','parent','Parent'),('en','sitemgr','parent directory','parent directory'),('en','sitemgr','parent section:','Parent Section:'),('en','sitemgr','password','Password'),('en','sitemgr','password that you assigned for the anonymous user account.','Password that you assigned for the anonymous user account.'),('en','sitemgr','path to image-directory \'%1\' is not valid or readable by the webserver !!!','Path to image-directory \'%1\' is not valid or readable by the webserver !!!'),('en','sitemgr','path to zip binary if not in path of the webserver','Path to zip binary if not in path of the webserver'),('en','sitemgr','percentage','Percentage'),('en','sitemgr','phrases in total','Phrases in total'),('en','sitemgr','please enter a name for that site !','Please enter a name for that site !'),('en','sitemgr','please sign the guestbook','Please sign the guestbook'),('en','sitemgr','post a message to this thread','Post A Message To This Thread'),('en','sitemgr','prepublished','prepublished'),('en','sitemgr','preunpublished','preunpublished'),('en','sitemgr','previous','Previous'),('en','sitemgr','production mode','Production mode'),('en','sitemgr','published','published'),('en','sitemgr','reactivate content','Reactivate content'),('en','sitemgr','read permission','Read Permission'),('en','sitemgr','redirection','Redirection'),('en','sitemgr','refresh','Refresh'),('en','sitemgr','register for one now.','Register for one now.'),('en','sitemgr','register new modules','Register new modules'),('en','sitemgr','reload','Reload'),('en','sitemgr','replies','Replies'),('en','sitemgr','required fields','Required Fields'),('en','sitemgr','reset','Reset'),('en','sitemgr','return to forums','Return to forums'),('en','sitemgr','return to main menu.','Return to main menu.'),('en','sitemgr','return to message list','Return to message list'),('en','sitemgr','root site index','Root Site Index'),('en','sitemgr','save','Save'),('en','sitemgr','save block','Save block'),('en','sitemgr','saved','Saved'),('en','sitemgr','scope','Scope'),('en','sitemgr','seen by','Seen by'),('en','sitemgr','select a category','Select a category'),('en','sitemgr','select a forum','Select a forum'),('en','sitemgr','select allowed modules','Select allowed modules'),('en','sitemgr','select persons and groups that are entitled to configure the website.','Select persons and groups that are entitled to configure the website.'),('en','sitemgr','select the templates the user is allowed to see','Select the templates the user is allowed to see'),('en','sitemgr','select type of navigation','Select type of Navigation'),('en','sitemgr','selected template %1 does not exist.','Selected template %1 does not exist.'),('en','sitemgr','selected theme %1 does not exist.','Selected theme %1 does not exist.'),('en','sitemgr','should the file be viewed in the browser or downloaded','Should the file be viewed in the browser or downloaded'),('en','sitemgr','show a template-gallery (thumbnail and informations)','Show a template-gallery (thumbnail and informations)'),('en','sitemgr','show contents of a directory','Show contents of a directory'),('en','sitemgr','show contents of a directory with subdirectories','Show contents of a directory with subdirectories'),('en','sitemgr','show details for the applications','Show details for the applications'),('en','sitemgr','show only (in the next field) selected templates','Show only (in the next field) selected templates'),('en','sitemgr','show only headers containing links for complete news','show only headers containing links for complete news'),('en','sitemgr','show path?','show path?'),('en','sitemgr','show searchbox','Show searchbox'),('en','sitemgr','show site index','Show Site Index'),('en','sitemgr','show subcategories','Show subcategories'),('en','sitemgr','show the title of the wiki page','Show the title of the wiki page'),('en','sitemgr','single file download','Single file download'),('en','sitemgr','site','Site'),('en','sitemgr','site %1 has been added, you need to %2configure the site%3 now','Site %1 has been added, you need to %2configure the site%3 now'),('en','sitemgr','site %1 has been updated','Site %1 has been updated'),('en','sitemgr','site administrators','Site administrators'),('en','sitemgr','site description','Site description'),('en','sitemgr','site format manager','Site Format Manager'),('en','sitemgr','site index','Site Index'),('en','sitemgr','site name','Site name'),('en','sitemgr','site tree menu','Site Tree Menu'),('en','sitemgr','site wide','Site wide'),('en','sitemgr','sitemgr manual','SiteMgr Manual'),('en','sitemgr','sitemgr options','SiteMgr Options'),('en','sitemgr','sitemgr setup instructions','SiteMgr Setup Instructions'),('en','sitemgr','sitemgr setup page','sitemgr setup page'),('en','sitemgr','sitemgr websites','Sitemgr Websites'),('en','sitemgr','sort order','Sort Order'),('en','sitemgr','state','State'),('en','sitemgr','strip html from block content?','Strip HTML from block content?'),('en','sitemgr','subcategories','Subcategories'),('en','sitemgr','subsections:','Subsections:'),('en','sitemgr','subtext for image %1','Subtext for image %1'),('en','sitemgr','subtitle','Subtitle'),('en','sitemgr','summary of one forum','Summary of one forum'),('en','sitemgr','suppress link to index (show all)','Suppress link to index (show all)'),('en','sitemgr','suppress link to parent category','Suppress link to parent category'),('en','sitemgr','suppress the current page','Suppress the current page'),('en','sitemgr','table of contents','Table of Contents'),('en','sitemgr','template based navigation module','Template based navigation module'),('en','sitemgr','template select','Template select'),('en','sitemgr','text allignment','Text allignment'),('en','sitemgr','textarea','textarea'),('en','sitemgr','the category to display, 0 for complete table of contents','The category to display, 0 for complete table of contents'),('en','sitemgr','the complete url or path to a file to be included','The complete URL or path to a file to be included'),('en','sitemgr','the config.inc.php file needs to be edited to point to the egroupware directory. copy the config.inc.php.template file to config','The config.inc.php file needs to be edited to point to the eGroupWare directory. Copy the config.inc.php.template file to config.inc.php and then edit it.'),('en','sitemgr','the file to be downloaded','The file to be downloaded'),('en','sitemgr','the filesystem path to your sitemgr-site directory \'%1\' is probably wrong. go to sitemgr --> define websites and edit/fix the co','The filesystem path to your sitemgr-site directory \'%1\' is probably wrong. Go to SiteMgr --> Define Websites and edit/fix the concerned Site.'),('en','sitemgr','the first directory to think about is sitemgr-link.  if you move this to the parent directory of sitemgr (your egroupware root d','The first directory to think about is sitemgr-link.  If you move this to the parent directory of sitemgr (your egroupware root directory) then you can use setup to install the app and everyone with access to the app will get an icon on their navbar that links them directly to the public web site.  If you don\'t want this icon, there\'s no reason to ever bother with the directory.'),('en','sitemgr','the name field cannot contain punctuation or spaces (field modified).','The Name field cannot contain punctuation or spaces (field modified).'),('en','sitemgr','the page name must be unique.','The page name must be unique.'),('en','sitemgr','the page was successfully saved.','The page was successfully saved.'),('en','sitemgr','the path to the file to be downloaded','The path to the file to be downloaded'),('en','sitemgr','the person to say hello to','The person to say hello to'),('en','sitemgr','the second directory is the sitemgr-site directory.  this can be moved <i>anywhere</i>.  it can also be named <i>anything</i>.','The second directory is the sitemgr-site directory.  This can be moved <i>anywhere</i>.  It can also be named <i>anything</i>.  Wherever it winds up, when you point a web browser to it, you will get the generated website.  Assuming, of course, that you\'ve accurately completed the setup fields below and also <b><i>edited the config.inc.php</i></b> file.'),('en','sitemgr','the text for the link, if empty the module returns the raw url (without a link)','The text for the link, if empty the module returns the raw URL (without a link)'),('en','sitemgr','the url can be relative or absolute.  name must end in a slash.','The URL can be relative or absolute.  Name must end in a slash.'),('en','sitemgr','the url must be absolute and end in a slash, for example http://mydomain.com/mysite/','The URL must be absolute and end in a slash, for example http://mydomain.com/mysite/'),('en','sitemgr','the url to display','The URL to display'),('en','sitemgr','the url to redirect to','The URL to redirect to'),('en','sitemgr','the web','the web'),('en','sitemgr','the website has changed. too see the change, follow this url: $url.','The website has changed. Too see the change, follow this URL: $URL.'),('en','sitemgr','the whole page','the whole page'),('en','sitemgr','the xml files\' common name','the XML files\' common name'),('en','sitemgr','theme or template select','Theme or template select'),('en','sitemgr','there are %1 elements in the list.','There are %1 elements in the list.'),('en','sitemgr','there are no categories','There are no categories'),('en','sitemgr','there are no forums in this category','There are no forums in this category'),('en','sitemgr','there are no pages in this section','There are no pages in this section'),('en','sitemgr','there are no properties defined for this module','There are no properties defined for this module'),('en','sitemgr','there are no sections available to you.','There are no sections available to you.'),('en','sitemgr','there are two subdirectories off of your sitemgr directory that you should move before you do anything else.  you don\'t <i>have<','There are two subdirectories off of your sitemgr directory that you should move before you do anything else.  You don\'t <i>have</i> to move either of these directories, although you will probably want to.'),('en','sitemgr','there can only be one version in (pre(un))published state, with the one exeption that one prepublished version can coexist with','There can only be one version in (pre(un))published state, with the one exeption that one prepublished version can coexist with one preunpublished version'),('en','sitemgr','there is no website configured for url %1.  notify the administrator.','THERE IS NO WEBSITE CONFIGURED FOR URL %1.  NOTIFY THE ADMINISTRATOR.'),('en','sitemgr','there is nothing to list.','There is nothing to list.'),('en','sitemgr','there was an error writing to the database.','There was an error writing to the database.'),('en','sitemgr','this block displays a javascript based tree menu','This block displays a javascript based tree menu'),('en','sitemgr','this block displays the current section\'s table of contents','This block displays the current section\'s table of contents'),('en','sitemgr','this category has no pages.','This category has no pages.'),('en','sitemgr','this is a simple sample module','This is a simple sample module'),('en','sitemgr','this is only used as an internal name for the website.','This is only used as an internal name for the website.'),('en','sitemgr','this is used chiefly for meta data and the title bar. if you change the site languages below you have to save before being able','This is used chiefly for meta data and the title bar. If you change the site languages below you have to save before being able to set this preference for a new language.'),('en','sitemgr','this is used chiefly for meta data. if you change the site languages below you have to save before being able to set this prefer','This is used chiefly for meta data. If you change the site languages below you have to save before being able to set this preference for a new language.'),('en','sitemgr','this module create a link for downloading a file from the vfs','This module create a link for downloading a file from the VFS'),('en','sitemgr','this module create a link for downloading a file(s) from the vfs','This module create a link for downloading a file(s) from the VFS'),('en','sitemgr','this module demonstrates how handling data stored in xml and building an interacvite interface from it','This module demonstrates how handling data stored in XML and building an interacvite interface from it'),('en','sitemgr','this module displays a login form','This module displays a login form'),('en','sitemgr','this module displays any kind of navigation element.','This module displays any kind of navigation element.'),('en','sitemgr','this module displays bookmarks in a javascript based tree','This module displays bookmarks in a javascript based tree'),('en','sitemgr','this module displays the current month','This module displays the current month'),('en','sitemgr','this module displays the egw forums on the web site','This module displays the eGW forums on the web site'),('en','sitemgr','this module displays the root categories in one block each, with pages and subcategories (incl. their pages if activated).','This module displays the root categories in one block each, with pages and subcategories (incl. their pages if activated).'),('en','sitemgr','this module displays the root categories, its pages and evtl. subcategories. it is meant for side areas','This module displays the root categories, its pages and evtl. subcategories. It is meant for side areas'),('en','sitemgr','this module includes the contents of an url or file (readable by the webserver and in its docroot !)','This module includes the contents of an URL or file (readable by the webserver and in its docroot !)'),('en','sitemgr','this module is a customisable navigation element','This module is a customisable navigation element'),('en','sitemgr','this module is a selectbox to change the mode (production, draft or edit) plus a link back to sitemgr and to log out. it is mean','This module is a selectbox to change the mode (production, draft or edit) plus a link back to SiteMgr and to log out. It is meant for registered users only'),('en','sitemgr','this module is a simple html editor','This module is a simple HTML editor'),('en','sitemgr','this module lets the users choose a template or shows a template gallery','This module lets the users choose a template or shows a template gallery'),('en','sitemgr','this module lets users choose language','This module lets users choose language'),('en','sitemgr','this module lets you define pages that redirect to another url, if you use it, there should be no other block defined for the pa','This module lets you define pages that redirect to another URL, if you use it, there should be no other block defined for the page'),('en','sitemgr','this module lets you include an applet into the page.','This module lets you include an applet into the page.'),('en','sitemgr','this module lets you show a given url inside an iframe in the page.','This module lets you show a given URL inside an IFRAME in the page.'),('en','sitemgr','this module permits browsing through xml files stored in a directory, and transformed by xslt','This module permits browsing through XML files stored in a directory, and transformed by XSLT'),('en','sitemgr','this module provides a complete table of contents, it is automatically used by the toc and category_id get parameters','This module provides a complete table of contents, it is automatically used by the toc and category_id GET parameters'),('en','sitemgr','this module provides a condensed table of contents, meant for side areas','This module provides a condensed table of contents, meant for side areas'),('en','sitemgr','this module provides the path to the element currently shown','This module provides the path to the element currently shown'),('en','sitemgr','this module provides the site index, it is automatically used by the index get parameter','This module provides the site index, it is automatically used by the index GET parameter'),('en','sitemgr','this module publishes news from the news_admin application on your website. be aware of news_admin\'s acl restrictions.','This module publishes news from the news_admin application on your website. Be aware of news_admin\'s ACL restrictions.'),('en','sitemgr','this module show the status / percentage of the translation of egw','This module show the status / percentage of the translation of eGW'),('en','sitemgr','this must be an absolute directory location.  <b>no trailing slash</b>.','This must be an absolute directory location.  <b>No trailing slash</b>.'),('en','sitemgr','this should be a comma-separated list of language-codes.','This should be a comma-separated list of language-codes.'),('en','sitemgr','this should be a page that is readable by everyone. if you leave this blank, the site index will be shown by default.','This should be a page that is readable by everyone. If you leave this blank, the site index will be shown by default.'),('en','sitemgr','this site','this site'),('en','sitemgr','title','Title'),('en','sitemgr','topic','Topic'),('en','sitemgr','translate','Translate'),('en','sitemgr','translate category','Translate Category'),('en','sitemgr','translate page','Translate Page'),('en','sitemgr','translate site-wide content blocks','Translate site-wide content blocks'),('en','sitemgr','translation manager','Translation Manager'),('en','sitemgr','translation status','Translation Status'),('en','sitemgr','unsubscribe','Unsubscribe'),('en','sitemgr','up to parent','Up to parent'),('en','sitemgr','up to table of contents','Up to table of contents'),('en','sitemgr','update notification','Update Notification'),('en','sitemgr','updating to new category system','Updating to new category system'),('en','sitemgr','url of directory for uploads (images etc.)','URL of directory for uploads (images etc.)'),('en','sitemgr','url pointing to the image-directory','URL pointing to the image-directory'),('en','sitemgr','url to sitemgr-site','URL to sitemgr-site'),('en','sitemgr','use phpnuke themes instead of templates','Use phpNuke themes instead of templates'),('en','sitemgr','use this module for displaying book ads for the amazon web site','Use this module for displaying book ads for the amazon web site'),('en','sitemgr','use this module for displaying wiki-pages','Use this module for displaying wiki-pages'),('en','sitemgr','user name','User Name'),('en','sitemgr','validator','Validator'),('en','sitemgr','vertical','Vertical'),('en','sitemgr','view administrative menu','View Administrative Menu'),('en','sitemgr','view full index','View full index'),('en','sitemgr','view generated site','View Generated Site'),('en','sitemgr','view template on this site','View template on this site'),('en','sitemgr','view threads','View Threads'),('en','sitemgr','viewed','viewed'),('en','sitemgr','web content manager administration','Web Content Manager Administration'),('en','sitemgr','web site manager','Web Site Manager'),('en','sitemgr','website','Website'),('en','sitemgr','week','week'),('en','sitemgr','what do you want to do with existing translations of categories and pages for this language?','What do you want to do with existing translations of categories and pages for this language?'),('en','sitemgr','which application should be executed after login?','Which application should be executed after login?'),('en','sitemgr','wiki','Wiki'),('en','sitemgr','wiki startpage','Wiki startpage'),('en','sitemgr','with which view should the module be displayed in the beginning?','With which view should the module be displayed in the beginning?'),('en','sitemgr','write permission','Write Permission'),('en','sitemgr','xml browser','XML browser'),('en','sitemgr','yes, please delete it','Yes, please delete it'),('en','sitemgr','you are not entitled to change the scope of block %1 to cat %2 and page %3','You are not entitled to change the scope of block %1 to Cat %2 and Page %3'),('en','sitemgr','you are not entitled to create module %1 on this scope','You are not entitled to create module %1 on this scope'),('en','sitemgr','you are not entitled to edit block %1','You are not entitled to edit block %1'),('en','sitemgr','you can choose the modules that can be used on the site. the first list is a sort of master list, that is consulted if you do no','You can choose the modules that can be used on the site. The first list is a sort of master list, that is consulted if you do not configure lists specific to contentareas or (sub)categories. Then you can choose lists specific to each content area. In the category manager these lists can be overriden for each (sub)category.'),('en','sitemgr','you can either migrate them to a new language or delete them','You can either migrate them to a new language or delete them'),('en','sitemgr','you can override each content blocks default title. be aware that not in all content areas the block title will be visible.','You can override each content blocks default title. Be aware that not in all content areas the block title will be visible.'),('en','sitemgr','you did not choose a module.','You did not choose a module.'),('en','sitemgr','you do not have access to any content on this site.','You do not have access to any content on this site.'),('en','sitemgr','you do not have write permissions for any site categories.','You do not have write permissions for any site categories.'),('en','sitemgr','you don\'t have permission to write in the category','You don\'t have permission to write in the category'),('en','sitemgr','you don\'t have permission to write to that category.','You don\'t have permission to write to that category.'),('en','sitemgr','you failed to fill in one or more required fields.','You failed to fill in one or more required fields.'),('en','sitemgr','you have no rights to view wiki content or the wiki is not installed at all !!!','You have no rights to view wiki content or the wiki is not installed at all !!!'),('en','sitemgr','you may have deinstalled the used template \'%1\'. reinstall it or go to sitemgr --> configure website and select an other one.','You may have deinstalled the used template \'%1\'. Reinstall it or go to SiteMgr --> Configure Website and select an other one.'),('en','sitemgr','you must be an admin to edit categories.','You must be an admin to edit categories.'),('en','sitemgr','you must be an admin to edit the site header and footer.','You must be an admin to edit the site header and footer.'),('en','sitemgr','you must be an admin to manage module properties.','You must be an admin to manage module properties.'),('en','sitemgr','you must be an administrator to setup the site manager.','You must be an administrator to setup the Site Manager.'),('en','sitemgr','you removed one ore more languages from your site languages.','You removed one ore more languages from your site languages.'),('en','sitemgr','your administrator has not yet setup the web content manager for public viewing.  go bug your administrator to get their butt in','Your administrator has not yet setup the web content manager for public viewing.  Go bug your administrator to get their butt in gear.'),('en','sitemgr','your calendar','Your Calendar'),('en','sitemgr','your comment','Your comment'),('en','sitemgr','your connection is not safe.','Your connection is not safe.'),('en','sitemgr','your name','Your name'),('en','sitemgr-link','you need to make sure the sitemgr-link app is in the egroupware directory.  if you made a symbolic link... it isn\'t working.','You need to make sure the sitemgr-link app is in the egroupware directory.  If you made a symbolic link... it isn\'t working.'),('en','sitemgr-link','before the public web site can be viewed, you must configure the various locations and preferences.  please go to the sitemgr se','Before the public web site can be viewed, you must configure the various locations and preferences.  Please go to the sitemgr setup page by following this link:'),('en','sitemgr-link','sitemgr setup page','sitemgr setup page'),('en','sitemgr-link','note that you may get this message if your preferences are incorrect.  for example, if config.inc.php is not found in the direct','Note that you may get this message if your preferences are incorrect.  For example, if config.inc.php is not found in the directory that you specified.'),('en','sitemgr-link','your administrator has not yet setup the web content manager for public viewing.  go bug your administrator to get their butt in','Your administrator has not yet setup the web content manager for public viewing.  Go bug your administrator to get their butt in gear.'),('en','timesheet','2 month ago','2 month ago'),('en','timesheet','2 years ago','2 years ago'),('en','timesheet','3 years ago','3 years ago'),('en','timesheet','actions','Actions'),('en','timesheet','by','by'),('en','timesheet','create new links','Create new links'),('en','timesheet','delete this entry','Delete this entry'),('en','timesheet','edit this entry','Edit this entry'),('en','timesheet','empty if identical to duration','empty if identical to duration'),('en','timesheet','end','End'),('en','timesheet','entry deleted','Entry deleted'),('en','timesheet','entry saved','Entry saved'),('en','timesheet','error deleting the entry!!!','Error deleting the entry!!!'),('en','timesheet','error saving the entry!!!','Error saving the entry!!!'),('en','timesheet','existing links','Existing links'),('en','timesheet','general','General'),('en','timesheet','last modified','Last modified'),('en','timesheet','last month','Last month'),('en','timesheet','last week','Last week'),('en','timesheet','last year','Last year'),('en','timesheet','leave it empty for a full week','Leave it empty for a full week'),('en','timesheet','links','Links'),('en','timesheet','no details','no details'),('en','timesheet','permission denied!!!','Permission denied!!!'),('en','timesheet','price','Price'),('en','timesheet','quantity','Quantity'),('en','timesheet','save & new','Save & New'),('en','timesheet','saves the changes made','Saves the changes made'),('en','timesheet','saves this entry and add a new one','Saves this entry and add a new one'),('en','timesheet','select a price','Select a price'),('en','timesheet','select a project','Select a project'),('en','timesheet','start','Start'),('en','timesheet','sum %1:','Sum %1:'),('en','timesheet','this month','This month'),('en','timesheet','this week','This week'),('en','timesheet','this year','This year'),('en','timesheet','unitprice','Unitprice'),('en','timesheet','view this entry','View this entry'),('en','timesheet','week','Week'),('en','timesheet','yesterday','Yesterday'),('en','timesheet','your database is not up to date (%1 vs. %2), please run %3setup%4 to update your database.','Your database is NOT up to date (%1 vs. %2), please run %3setup%4 to update your database.'),('en','wiki','<em>but</em> display at least this many entries in recentchanges and other subscription lists:','<em>But</em> display at least this many entries in RecentChanges and other subscription lists:'),('en','wiki','add document to category','Add document to category'),('en','wiki','added','Added'),('en','wiki','administration features are disabled for this wiki.','Administration features are disabled for this wiki.'),('en','wiki','admins','admins'),('en','wiki','block','Block'),('en','wiki','blocked ip address ranges','Blocked IP address ranges'),('en','wiki','cancel without saving','Cancel without saving'),('en','wiki','changed','Changed'),('en','wiki','changes by last author','Changes by last author'),('en','wiki','choose your current time here, so the server may figure out what time zone you are in.','Choose your current time here, so the server may figure out what time zone you are in.'),('en','wiki','columns','Columns'),('en','wiki','compute difference','Compute Difference'),('en','wiki','converts the page to richtext','Converts the page to richtext'),('en','wiki','current version','Current Version'),('en','wiki','deleted','Deleted'),('en','wiki','deletes this page','Deletes this page'),('en','wiki','difference between versions','Difference between versions'),('en','wiki','differences in','Differences in'),('en','wiki','different languages can have different titles','different languages can have different titles'),('en','wiki','document last modified','Document last modified'),('en','wiki','edit box','Edit box'),('en','wiki','edit this <em>archive version</em> of this document','Edit this <em>ARCHIVE VERSION</em> of this document'),('en','wiki','edit this document','Edit this document'),('en','wiki','editing','Editing'),('en','wiki','enter here the maximum number of entries to display in a document\'s history list.','Enter here the maximum number of entries to display in a document\'s history list.'),('en','wiki','enter here the number of days of edits to display on recentchanges or any other subscription list.  set this to zero if you wish','Enter here the number of days of edits to display on RecentChanges or any other subscription list.  Set this to zero if you wish to see all pages in RecentChanges, regardless of how recently they were edited.'),('en','wiki','enter ip address range in form <tt>12.*</tt>, <tt>34.56.*</tt>, or <tt>78.90.123.*</tt>','Enter IP address range in form <tt>12.*</tt>, <tt>34.56.*</tt>, or <tt>78.90.123.*</tt>'),('en','wiki','error creating temporary file.','Error creating temporary file.'),('en','wiki','error writing to temporary file.','Error writing to temporary file.'),('en','wiki','everyone','everyone'),('en','wiki','find','Find'),('en','wiki','history','history'),('en','wiki','history display should show <em>all</em> changes made by the latest author.  otherwise, show only the last change made.','History display should show <em>all</em> changes made by the latest author.  Otherwise, show only the last change made.'),('en','wiki','history lists','History lists'),('en','wiki','history of','History of'),('en','wiki','invalid page name.','Invalid page name.'),('en','wiki','load','Load'),('en','wiki','loads the named page in the given language, all change so far get lost !!!','Loads the named page in the given language, all change so far get lost !!!'),('en','wiki','locked','Locked'),('en','wiki','newer','Newer'),('en','wiki','not set','not set'),('en','wiki','older','Older'),('en','wiki','on all pages','on all pages'),('en','wiki','only on the first page','only on the first page'),('en','wiki','page \'%1\' not found !!!','Page \'%1\' not found !!!'),('en','wiki','please contact the %1administrator%2 for assistance.','Please contact the %1Administrator%2 for assistance.'),('en','wiki','preview','Preview'),('en','wiki','preview of current version','Preview of Current Version'),('en','wiki','rate control / ip blocking disabled','Rate control / IP blocking disabled'),('en','wiki','readable by','Readable by'),('en','wiki','recent changes','Recent Changes'),('en','wiki','renames page to the given name and language','Renames page to the given name and language'),('en','wiki','richtext','Richtext'),('en','wiki','rows','Rows'),('en','wiki','save the changes and exit','Save the changes and exit'),('en','wiki','saves and continues editing','Saves and continues editing'),('en','wiki','search for','Search for'),('en','wiki','see complete list (%1 entries)','See complete list (%1 entries)'),('en','wiki','show a search','Show a search'),('en','wiki','show the title of the wiki page','Show the title of the wiki page'),('en','wiki','site configuration','Site Configuration'),('en','wiki','summary','Summary'),('en','wiki','summary of change','Summary of change'),('en','wiki','the search returned no result!','The search returned no result!'),('en','wiki','this page can not be edited.','This page can not be edited.'),('en','wiki','twin pages','Twin pages'),('en','wiki','unblock','Unblock'),('en','wiki','updates the preview','Updates the preview'),('en','wiki','use this module for displaying wiki-pages','Use this module for displaying wiki-pages'),('en','wiki','users','users'),('en','wiki','view document history','View document history'),('en','wiki','visit %1 to set your user name','Visit %1 to set your user name'),('en','wiki','warning: since you started editing, this document has been changed by someone else.  please merge your edits into the current ve','Warning: since you started editing, this document has been changed by someone else.  Please merge your edits into the current version of this document.'),('en','wiki','who should be able to edit this page','who should be able to edit this page'),('en','wiki','who should be able to read this page','who should be able to read this page'),('en','wiki','wiki administration','Wiki Administration'),('en','wiki','wiki menu','Wiki Menu'),('en','wiki','wiki startpage','Wiki startpage'),('en','wiki','writable by','Writable by'),('en','wiki','you have been denied access to this site.','You have been denied access to this site.'),('en','wiki','you have entered an invalid user name.','You have entered an invalid user name.'),('en','wiki','you have exeeded the number of pages you are allowed to visit in a given period of time. please return later.','You have exeeded the number of pages you are allowed to visit in a given period of time. Please return later.'),('en','wiki','you have no rights to view wiki content !!!','You have no rights to view wiki content !!!'),('en','wiki','your changes','Your changes'),('en','wiki','your user name is \"%1\".','Your user name is \"%1\".'),('en','workflow','#','#'),('en','workflow','%1 aborted','%1 aborted'),('en','workflow','%1 active','%1 active'),('en','workflow','%1 completed','%1 completed'),('en','workflow','%1 configuration','%1 Configuration'),('en','workflow','%1 days, %2:%3:%4','%1 days, %2:%3:%4'),('en','workflow','%1 exception','%1 exception'),('en','workflow','%1 menu','%1 Menu'),('en','workflow','%1 monitoring','%1 Monitoring'),('en','workflow','%1 processes (%2 active) (%3 being_run)','%1 processes (%2 active) (%3 being_run)'),('en','workflow','<strong>%owner%</strong> is the instance owner email','<strong>%owner%</strong> is the instance owner email'),('en','workflow','<strong>%property_xx%</strong> is the content of the instance\'s property xx','<strong>%property_XX%</strong> is the content of the instance\'s property XX'),('en','workflow','<strong>%role_xx%</strong> are all the emails of all users mapped to the role xx','<strong>%role_XX%</strong> are all the emails of all users mapped to the role XX'),('en','workflow','<strong>%roles%</strong> are the emails of all users mapped to any role on this activity','<strong>%roles%</strong> are the emails of all users mapped to any role on this activity'),('en','workflow','<strong>%signature%</strong> is the agent signature defined in the process configuration','<strong>%signature%</strong> is the agent signature defined in the process configuration'),('en','workflow','<strong>%user%</strong> is the instance user email','<strong>%user%</strong> is the instance user email'),('en','workflow','<strong>%user_xx%</strong> is the email of the acount xx','<strong>%user_XX%</strong> is the email of the acount XX'),('en','workflow','abort instance','abort instance'),('en','workflow','abort this instance','Abort this instance'),('en','workflow','aborted','aborted'),('en','workflow','access denied for user %1 on activity %2, no role','Access denied for user %1 on activity %2, no role'),('en','workflow','act','act'),('en','workflow','act. status','Act. Status'),('en','workflow','act. status:','Act. status:'),('en','workflow','action %1 is impossible if we have no activity and no instance designated for it!','Action %1 is impossible if we have no activity and no instance designated for it!'),('en','workflow','action %1 is impossible, another user is already in place','Action %1 is impossible, another user is already in place'),('en','workflow','action %1 is impossible, there are no user assigned to this activity for this instance','Action %1 is impossible, there are no user assigned to this activity for this instance'),('en','workflow','action %1 needs an activity and activity %2 does not exists','Action %1 needs an activity and activity %2 does not exists'),('en','workflow','action %1 needs an instance and instance %2 does not exists','Action %1 needs an instance and instance %2 does not exists'),('en','workflow','actions','Actions'),('en','workflow','activate','activate'),('en','workflow','active','Active'),('en','workflow','active:','active:'),('en','workflow','activities','Activities'),('en','workflow','activities selection','Activities selection'),('en','workflow','activities updated','Activities updated'),('en','workflow','activity','activity'),('en','workflow','activity  status','Activity Status'),('en','workflow','activity %1','activity %1'),('en','workflow','activity %1 (#%2) is associated with a non-existent process (#%3)','Activity %1 (#%2) is associated with a non-existent process (#%3)'),('en','workflow','activity %1 code is not avaible','activity %1 code is not avaible'),('en','workflow','activity %1 is interactive but has no role assigned','Activity %1 is interactive but has no role assigned'),('en','workflow','activity %1 is interactive so it must use the $instance->complete() method','Activity %1 is interactive so it must use the $instance->complete() method'),('en','workflow','activity %1 is non-interactive and non-autorouted but has no role assigned','Activity %1 is non-interactive and non-autorouted but has no role assigned'),('en','workflow','activity %1 is non-interactive so it must not use the $instance->complete() method','Activity %1 is non-interactive so it must not use the $instance->complete() method'),('en','workflow','activity %1 is standalone and is using the $instance object','Activity %1 is standalone and is using the $instance object'),('en','workflow','activity %1 is standalone but has transitions','Activity %1 is standalone but has transitions'),('en','workflow','activity %1 is standalone or view but has transitions','Activity %1 is standalone or view but has transitions'),('en','workflow','activity %1 is switch so it must use $instance->setnextactivity($actname) method','Activity %1 is switch so it must use $instance->setNextActivity($actname) method'),('en','workflow','activity %1 is view and is using the $instance object in write mode','Activity %1 is view and is using the $instance object in write mode'),('en','workflow','activity agent removed','Activity agent removed'),('en','workflow','activity completed','Activity completed'),('en','workflow','activity failure','activity failure'),('en','workflow','activity in inexistent process','Activity in inexistent process'),('en','workflow','activity is waiting for pending transitions','activity is waiting for pending transitions'),('en','workflow','activity name already exists','Activity name already exists'),('en','workflow','activity role #%1 removed','Activity role #%1 removed'),('en','workflow','activity role removed','Activity role removed'),('en','workflow','activity saved','Activity saved'),('en','workflow','activity start not avaible, no corresponding activity was found.','activity start not avaible, no corresponding activity was found.'),('en','workflow','activity start not set, no corresponding activity was found.','activity start not set, no corresponding activity was found.'),('en','workflow','activity status not avaible, no corresponding activity was found.','activity status not avaible, no corresponding activity was found.'),('en','workflow','activity:','activity:'),('en','workflow','add a transition','Add a transition'),('en','workflow','add aborted instances','Add aborted instances'),('en','workflow','add advanced actions','Add advanced actions'),('en','workflow','add agent','Add agent'),('en','workflow','add completed instances','Add completed instances'),('en','workflow','add instances in exception','Add instances in exception'),('en','workflow','add new','add new'),('en','workflow','add new role','Add new role'),('en','workflow','add or edit a process','Add or edit a process'),('en','workflow','add or edit a role','Add or edit a rol'),('en','workflow','add or edit an activity','Add or edit an activity'),('en','workflow','add property','Add property'),('en','workflow','add role','Add role'),('en','workflow','add role to process','Add role to process'),('en','workflow','add transition','add transition'),('en','workflow','add transitions','Add transitions'),('en','workflow','add transitions from','Add transitions from'),('en','workflow','add transitions to','Add transitions to'),('en','workflow','admin instance','Admin Instance'),('en','workflow','admin process activities','Admin Process Activities'),('en','workflow','admin process roles','Admin Process Roles'),('en','workflow','admin processes','Admin Processes'),('en','workflow','admin processes sources','Admin Processes Sources'),('en','workflow','agent #%1 of type %2 is associated to an inexistent activity #%3','Agent #%1 of type %2 is associated to an inexistent activity #%3'),('en','workflow','agent #%1 of type %2 is not linked with an activity','Agent #%1 of type %2 is not linked with an activity'),('en','workflow','agent associated with inexistent activity','Agent associated with inexistent activity'),('en','workflow','agent without activity','Agent without activity'),('en','workflow','agents assigned to this activity','Agents assigned to this activity'),('en','workflow','all','All'),('en','workflow','always show advanced actions','Always show advanced actions'),('en','workflow','always show advanced mode','Always show advanced mode'),('en','workflow','assign me this activity','Assign me this activity'),('en','workflow','at least one email address cannot be validated.','at least one email address cannot be validated.'),('en','workflow','auto routed','Auto routed'),('en','workflow','automatic','Automatic'),('en','workflow','autorouted activities does not need to be sent by any user after their execution','Autorouted activities do not need to be sent by any user after their execution'),('en','workflow','bad parameter for setagents, the parameter should be an array','bad parameter for setAgents, the parameter should be an array'),('en','workflow','bad role type','Bad role type'),('en','workflow','bad user','Bad user'),('en','workflow','bcc:','Bcc:'),('en','workflow','be carefull with interactive activity, end and start of theses activities are multiple.','Be carefull with interactive activity, end and start of theses activities are multiple.'),('en','workflow','being run','being run'),('en','workflow','by running theses links you will create new instances of the related process.','by running theses links you will create new instances of the related process.'),('en','workflow','cannot add transition only split or switch activities can have more than one outbound transition','Cannot add transition only split or switch activities can have more than one outbound transition'),('en','workflow','cannot add transition. only split activities can have more than one outbound transition','Cannot add transition. Only split activities can have more than one outbound transition'),('en','workflow','cannot create compiled file %1','cannot create compiled file %1'),('en','workflow','cannot retrieve the user running the security check','Cannot retrieve the user running the security check'),('en','workflow','cannot run the activity','Cannot run the activity'),('en','workflow','cannot run the activity without her process','Cannot run the activity without her process'),('en','workflow','cannot run the activity without instance','Cannot run the activity without instance'),('en','workflow','cannot run unknown activity','Cannot run unknown activity'),('en','workflow','cc:','Cc:'),('en','workflow','circular reference found some activity has a transition leading to itself','Circular reference found some activity has a transition leading to itself'),('en','workflow','circular reference found. some activity has a transition leading to itself','Circular reference found. Some activity has a transition leading to itself'),('en','workflow','cleanup actions','cleanup actions'),('en','workflow','close and get back later','Close and get back later'),('en','workflow','close printer friendly mode','Close Printer friendly mode'),('en','workflow','code','code'),('en','workflow','column activity status in instance lists','Column activity status in instance lists'),('en','workflow','column category in instance lists','Column category in instance lists'),('en','workflow','column instance id in instance lists','Column instance id in instance lists'),('en','workflow','column instance name in instance lists','Column instance name in instance lists'),('en','workflow','column instance status in instance lists','Column instance status in instance lists'),('en','workflow','column owner in instance lists','Column owner in instance lists'),('en','workflow','column priority in instance lists','Column priority in instance lists'),('en','workflow','column process name in instance lists','Column process name in instance lists'),('en','workflow','column start date in instance lists','Column start date in instance lists'),('en','workflow','compilation','Compilation'),('en','workflow','compiling activity %1 : %2','compiling activity %1 : %2'),('en','workflow','complete','Complete'),('en','workflow','complete cleanup of aborted instances done','complete cleanup of aborted instances done'),('en','workflow','complete cleanup of all instances done','complete cleanup of all instances done'),('en','workflow','completed','completed'),('en','workflow','confirm delete','Confirm Delete'),('en','workflow','consult %1 to get the default values:','Consult %1 to get the default values:'),('en','workflow','couldn\'t add transition','Couldn\'t add transition'),('en','workflow','create','create'),('en','workflow','created','Created'),('en','workflow','date:','date:'),('en','workflow','default config values','Default config values'),('en','workflow','default next user','Default next user'),('en','workflow','default owner','Default owner'),('en','workflow','default user','Default User'),('en','workflow','delete selected','Delete selected'),('en','workflow','delete transition','delete transition'),('en','workflow','deletion successful','Deletion successful'),('en','workflow','delition successful','Delition successful'),('en','workflow','description','Description'),('en','workflow','do you want the activity status on instances lists. most of the time it is \"running\" but if you use non-autorouted transitions y','Do you want the activity status on instances lists. Most of the time it is \"running\" but if you use non-autorouted transitions you will have some completed activities.'),('en','workflow','do you want the category column on instances lists, if yout instances use categories you should use it','Do you want the category column on instances lists, if yout instances use categories you should use it'),('en','workflow','do you want the category name column on instances lists, if your instances use categories you should use it','Do you want the category name column on instances lists, if your instances use categories you should use it'),('en','workflow','do you want the category name column on instances lists. if your instances use categories you should use this','Do you want the category name column on instances lists. If your instances use categories you should use this'),('en','workflow','do you want the instance id column on instances lists. this is the unique identifier of an instance','Do you want the instance id column on instances lists. This is the unique identifier of an instance'),('en','workflow','do you want the instance name column on instances lists. if your instances have name you should really use this','Do you want the instance name column on instances lists. If your instances have name you should really use this'),('en','workflow','do you want the instance status on instances lists. the instance status is usefull to disting beteween aborted, completed, excep','Do you want the instance status on instances lists. The instance status is usefull to disting beteween aborted, completed, exception or active instances'),('en','workflow','do you want the owner column on instances lists. this will show you the actual owner, especially usefull if ownership is defined','Do you want the owner column on instances lists. This will show you the actual owner, especially usefull if ownership is defined with special rights'),('en','workflow','do you want the priority column on instances lists. priority can be set with activities forms','Do you want the priority column on instances lists. Priority can be set with activities forms'),('en','workflow','do you want the process column on instances lists. usefull if you have different processes and/or versions of theses processes','Do you want the process column on instances lists. Usefull if you have different processes and/or versions of theses processes'),('en','workflow','do you want the search instance button in the last row of instances list.','Do you want the search instance button in the last row of instances list.'),('en','workflow','do you want the started date column on instances lists.','Do you want the started date column on instances lists.'),('en','workflow','don\'t move','Don\'t move'),('en','workflow','duration','Duration'),('en','workflow','empty agent type','empty agent type'),('en','workflow','end','end'),('en','workflow','end activity is not reachable from start activity','End activity is not reachable from start activity'),('en','workflow','ended','ended'),('en','workflow','enter an activity name','Enter an activity name'),('en','workflow','error: nextactivity does not match any candidate in autorouting switch activity','Error: nextActivity does not match any candidate in autorouting switch activity'),('en','workflow','error: non-deterministic decision for autorouting activity','Error: non-deterministic decision for autorouting activity'),('en','workflow','error: removing was not done','error: removing was not done'),('en','workflow','error: trying to send an instance to an activity but it was impossible to get this activity','Error: trying to send an instance to an activity but it was impossible to get this activity'),('en','workflow','error: trying to send an instance to an activity but no transition found','Error: trying to send an instance to an activity but no transition found'),('en','workflow','exception','exception'),('en','workflow','exception instance','exception instance'),('en','workflow','exception raised by %1 %2: %3','exception raised by %1 %2: %3'),('en','workflow','exception resumed by %1 %2: %3','exception resumed by %1 %2: %3'),('en','workflow','exception this instance','Exception this instance'),('en','workflow','exceptions','exceptions'),('en','workflow','execute this activity','Execute this activity'),('en','workflow','export','Export'),('en','workflow','failed to create workitem','failed to create workitem'),('en','workflow','failed to execute automatic activity','failed to execute automatic activity'),('en','workflow','failed to obtain lock on %1 table','failed to obtain lock on %1 table'),('en','workflow','failed to obtain lock on instances table','failed to obtain lock on instances table'),('en','workflow','failed to obtain lock on instances_activities table','failed to obtain lock on instances_activities table'),('en','workflow','failed to record instance properties','failed to record instance properties'),('en','workflow','failed to synchronize instance data with the database','failed to synchronize instance data with the database'),('en','workflow','failure','failure'),('en','workflow','fatal error: nextactivity does not match any candidate in autorouting switch activity','Fatal error: nextActivity does not match any candidate in autorouting switch activity'),('en','workflow','fatal error: non-deterministic decision for autorouting activity','Fatal error: non-deterministic decision for autorouting activity'),('en','workflow','fatal error: setting next activity to an unexisting activity','Fatal error: setting next activity to an unexisting activity'),('en','workflow','fatal error: trying to send an instance to an activity but no transition found','Fatal error: trying to send an instance to an activity but no transition found'),('en','workflow','filter','Filter'),('en','workflow','filter instance by id','filter instance by id'),('en','workflow','finally you have links with <strong>%link_xx|yy%</strong> syntax, xx is the address part, yy the text part.','finally you have links with <strong>%link_XX|YY%</strong> syntax, XX is the address part, YY the text part.'),('en','workflow','fix','Fix'),('en','workflow','fix concistency for selected rows','Fix Concistency for selected rows'),('en','workflow','font size','Font size'),('en','workflow','from','From'),('en','workflow','from:','From:'),('en','workflow','get back to global activities','get back to global activities'),('en','workflow','get back to instance creation','get back to instance creation'),('en','workflow','get property','Get property'),('en','workflow','global activities','Global activities'),('en','workflow','global workflow preferences','Global Workflow Preferences'),('en','workflow','go','go'),('en','workflow','go to same activities for other instances of this process','go to same activities for other instances of this process'),('en','workflow','go to same process activities','go to same process activities'),('en','workflow','go to the actual state of this instance','go to the actual state of this instance'),('en','workflow','grab instance','grab instance'),('en','workflow','graph','Graph'),('en','workflow','group','Group'),('en','workflow','id','Id'),('en','workflow','if not in debug mail_smtp agent would have sent this email:','if not in debug mail_smtp agent would have sent this email:'),('en','workflow','if:setnextact','If:SetNextact'),('en','workflow','import aborted','Import aborted'),('en','workflow','import successfull','Import successfull'),('en','workflow','in role mappings user #%1 is specified as a \"%2\" but is maybe a \"%3\"','In role mappings user #%1 is specified as a \"%2\" but is MAYBE a \"%3\"'),('en','workflow','inactive','Inactive'),('en','workflow','inst.','Inst.'),('en','workflow','inst. status','Inst. Status'),('en','workflow','instance','Instance'),('en','workflow','instance %1','instance %1'),('en','workflow','instance %1 is in %2 state, action %3 is impossible.','Instance %1 is in %2 state, action %3 is impossible.'),('en','workflow','instance %1 is in exception, action %2 is not possible.','Instance %1 is in exception, action %2 is not possible.'),('en','workflow','instance %1 is not associated with activity %2, action %3 is impossible.','Instance %1 is not associated with activity %2, action %3 is impossible.'),('en','workflow','instance history','Instance History'),('en','workflow','instance properties','Instance properties'),('en','workflow','instance:','instance:'),('en','workflow','instance: %1 (process: %2)','Instance: %1 (Process: %2)'),('en','workflow','instance: unable to modify %1 [%2], someone has changed it before us','Instance: unable to modify %1 [%2], someone has changed it before us'),('en','workflow','instance: unable to modify %1, someone has changed it before us','Instance: unable to modify %1, someone has changed it before us'),('en','workflow','instances','Instances'),('en','workflow','instances selection','Instances selection'),('en','workflow','int.','Int.'),('en','workflow','interactive','Interactive'),('en','workflow','interactive activities show form before being executed','Interactive activities show form before being executed'),('en','workflow','interactive instances should not call the complete() method','interactive instances should not call the complete() method'),('en','workflow','interactive:','interactive:'),('en','workflow','interactivity','Interactivity'),('en','workflow','invalid','invalid'),('en','workflow','invalid process','Invalid Process'),('en','workflow','invalid role name','Invalid role name'),('en','workflow','is active','is active'),('en','workflow','it seems this activity for this instance is not assigned to you anymore.','It seems this activity for this instance is not assigned to you anymore.'),('en','workflow','it was impossible to complete, no activity was given.','it was impossible to complete, no activity was given.'),('en','workflow','it was impossible to complete, no corresponding activity was found.','it was impossible to complete, no corresponding activity was found.'),('en','workflow','join','join'),('en','workflow','link addresses are considered local if not containing <strong>http://</strong>. they will get appended the configured local pref','Link addresses are considered local if not containing <strong>http://</strong>. They will get appended the configured local prefix and scanned by egroupware link engine'),('en','workflow','list of activities','List of activities'),('en','workflow','list of all activities with, for each,  counters of instances by status','list of all activities with, for each,  counters of instances by status'),('en','workflow','list of all history items made by instances while they travel in the workflow with information about duration and date','list of all history items made by instances while they travel in the workflow with information about duration and date'),('en','workflow','list of all instances with info about current status and activities and link to administration of theses instances','list of all instances with info about current status and activities and link to administration of theses instances'),('en','workflow','list of instances','List of instances'),('en','workflow','list of mappings','List of mappings'),('en','workflow','list of monitors','List of monitors'),('en','workflow','list of processes','List of processes'),('en','workflow','list of processes (%1)','List of processes (%1)'),('en','workflow','list of processes with status and validity and, for each, counters of instances by status','list of processes with status and validity and, for each, counters of instances by status'),('en','workflow','list of transitions','List of transitions'),('en','workflow','list of workitems','List of workitems'),('en','workflow','mail automatically sent by mail smtp agent for egroupware\'s workflow','Mail automatically sent by Mail SMTP Agent for eGroupware\'s Workflow'),('en','workflow','mail smtp agent','Mail Smtp Agent'),('en','workflow','mails can be sent at the begining or at the end of the activity, for interactive activities only it can be sent after completion','Mails can be sent at the begining or at the end of the activity, For interactive activities only it can be sent after completion.'),('en','workflow','manual','Manual'),('en','workflow','map','map'),('en','workflow','map users/groups to roles','Map users/groups to roles'),('en','workflow','mapping to inexistent role','Mapping to inexistent role'),('en','workflow','mappings deleted','Mappings deleted'),('en','workflow','message:','Message:'),('en','workflow','monitor activities','Monitor Activities'),('en','workflow','monitor instance','monitor instance'),('en','workflow','monitor instances','Monitor Instances'),('en','workflow','monitor processes','Monitor Processes'),('en','workflow','monitor this instance','Monitor this instance'),('en','workflow','monitor work items','Monitor Work Items'),('en','workflow','monitor workitems','Monitor workitems'),('en','workflow','monitors','Monitors'),('en','workflow','more options?','more options?'),('en','workflow','my activities','My Activities'),('en','workflow','my instances','My Instances'),('en','workflow','my processes','My Processes'),('en','workflow','name','Name'),('en','workflow','new instance','New Instance'),('en','workflow','new major','New major'),('en','workflow','new major version created','new major version created'),('en','workflow','new mapping added','New mapping added'),('en','workflow','new minor','New minor'),('en','workflow','new minor version created','new minor version created'),('en','workflow','new status not set, no corresponding activity was found.','new status not set, no corresponding activity was found.'),('en','workflow','new transition added','New transition added'),('en','workflow','next activity','next activity'),('en','workflow','next user:','Next user:'),('en','workflow','no action avaible because no activity and no instance are given!','no action avaible because no activity and no instance are given!'),('en','workflow','no activites','No activites'),('en','workflow','no activity indicated','No activity indicated'),('en','workflow','no agents associated with this activity','No agents associated with this activity'),('en','workflow','no circular transitions allowed.','No circular transitions allowed.'),('en','workflow','no corresponding activity was found.','no corresponding activity was found.'),('en','workflow','no inbound for start activity','No inbound for start activity'),('en','workflow','no inconcistency detected','no inconcistency detected'),('en','workflow','no instance avaible','no instance avaible'),('en','workflow','no instance given, nothing to show','no instance given, nothing to show'),('en','workflow','no instance indicated','No instance indicated'),('en','workflow','no outbound for end activity','No outbound for end activity'),('en','workflow','no process indicated','No process indicated'),('en','workflow','no properties defined','No properties defined'),('en','workflow','no roles','no roles'),('en','workflow','no roles asociated with this activity','No roles asociated with this activity'),('en','workflow','no routage','no routage'),('en','workflow','no scan done','no scan done'),('en','workflow','no transitions allowed for standalone or view activities','No transitions allowed for standalone or view activities'),('en','workflow','no work item indicated','No work item indicated'),('en','workflow','nobody','Nobody'),('en','workflow','not defined','not defined'),('en','workflow','or import a process','Or import a process'),('en','workflow','owner','Owner'),('en','workflow','owner:','Owner:'),('en','workflow','please wait, task in progress ...','Please wait, task in progress ...'),('en','workflow','post activity %1 code is not avaible','post activity %1 code is not avaible'),('en','workflow','post shared code is not avaible','post shared code is not avaible'),('en','workflow','post-agent %1 code is not avaible','post-agent %1 code is not avaible'),('en','workflow','pr.','Pr.'),('en','workflow','pre-activity %1 code is not avaible','pre-activity %1 code is not avaible'),('en','workflow','pre-agent %1 code is not avaible','pre-agent %1 code is not avaible'),('en','workflow','pre-shared code is not avaible','pre-shared code is not avaible'),('en','workflow','printer friendly','Printer friendly'),('en','workflow','priority level:','Priority level:'),('en','workflow','process','Process'),('en','workflow','process %1','process %1'),('en','workflow','process %1 %2 is not active, action %3 is impossible','Process %1 %2 is not active, action %3 is impossible'),('en','workflow','process %1 v%2 as no related activity','Process %1 v%2 as no related activity'),('en','workflow','process %d has been activated','Process %d has been activated'),('en','workflow','process %d has been deactivated','Process %d has been deactivated'),('en','workflow','process %s %s already exists, the import process was aborted','Process %s %s already exists, the import process was aborted'),('en','workflow','process %s %s imported','Process %s %s imported'),('en','workflow','process %s has been created','Process %s has been created'),('en','workflow','process %s has been updated','Process %s has been updated'),('en','workflow','process %s removed','Process %s removed'),('en','workflow','process activities','Process activities'),('en','workflow','process alone','Process alone'),('en','workflow','process does not have a start activity','Process does not have a start activity'),('en','workflow','process does not have exactly one end activity','Process does not have exactly one end activity'),('en','workflow','process form','Process form'),('en','workflow','process name','Process Name'),('en','workflow','process name already exists','Process name already exists'),('en','workflow','process roles','Process roles'),('en','workflow','process saved','Process saved'),('en','workflow','process transitions','Process transitions'),('en','workflow','process version:','process version:'),('en','workflow','process:','process:'),('en','workflow','processes','Processes'),('en','workflow','properties','Properties'),('en','workflow','property','Property'),('en','workflow','property %1 already exists','property %1 already exists'),('en','workflow','property %1 not found','property %1 not found'),('en','workflow','quit without saving','Quit Without Saving'),('en','workflow','read-only','read-only'),('en','workflow','release access to this activity','Release access to this activity'),('en','workflow','release activity for this instance','release activity for this instance'),('en','workflow','release instance','release instance'),('en','workflow','reload filter','Reload filter'),('en','workflow','remove active instances','Remove active instances'),('en','workflow','remove all instances for this process','remove all instances for this process'),('en','workflow','remove selected roles','remove selected roles'),('en','workflow','removing instances and workitems for aborted instances on all processes','removing instances and workitems for aborted instances on all processes'),('en','workflow','removing instances and workitems for aborted instances on process #%1','removing instances and workitems for aborted instances on process #%1'),('en','workflow','removing instances and workitems for all instances on process #%1','removing instances and workitems for all instances on process #%1'),('en','workflow','replyto:','ReplyTo:'),('en','workflow','restart','restart'),('en','workflow','restart activity','restart activity'),('en','workflow','resume this exception instance','Resume this exception instance'),('en','workflow','role','Role'),('en','workflow','role #%1 in process %2 has different process (%3) in mapping with user #%4','Role #%1 in process %2 has different process (%3) in mapping with user #%4'),('en','workflow','role %1 (#%2) is associated with a non-existent process (#%3)','Role %1 (#%2) is associated with a non-existent process (#%3)'),('en','workflow','role %1 is associated in a mapping with user #%2 with a non-existent process (%3)','Role %1 is associated in a mapping with user #%2 with a non-existent process (%3)'),('en','workflow','role %1 is not mapped','Role %1 is not mapped'),('en','workflow','role added to activity','Role added to activity'),('en','workflow','role added to process','Role added to process'),('en','workflow','role in inexistent process','Role in inexistent process'),('en','workflow','role mapping in inexistent process','Role Mapping in inexistent process'),('en','workflow','role name','Role Name'),('en','workflow','role not saved (maybe a name collision)','Role not saved (maybe a name collision)'),('en','workflow','role process inconcistency in mappings','Role Process inconcistency in mappings'),('en','workflow','role saved','Role saved'),('en','workflow','roles','Roles'),('en','workflow','roles assigned to this activity','Roles assigned to this activity'),('en','workflow','roles deleted','Roles deleted'),('en','workflow','routing','Routing'),('en','workflow','routing:','routing:'),('en','workflow','run','run'),('en','workflow','run activity','run activity'),('en','workflow','run instance','run instance'),('en','workflow','running','running'),('en','workflow','running activity','Running Activity'),('en','workflow','scan activities','Scan activities'),('en','workflow','scan agents','Scan agents'),('en','workflow','scan instances','Scan instances'),('en','workflow','scan processes','Scan processes'),('en','workflow','scan roles','Scan roles'),('en','workflow','scan transitions','Scan transitions'),('en','workflow','search instance filter in the bottom of instance lists','Search instance filter in the bottom of instance lists'),('en','workflow','search:','search:'),('en','workflow','security check: cannot understand asked action','Security check: Cannot understand asked action'),('en','workflow','see as well <strong>%instance_name%</strong>, <strong>%activity_name%</strong>, <strong>%process_name%</strong>,<strong>%process','see as well <strong>%instance_name%</strong>, <strong>%activity_name%</strong>, <strong>%process_name%</strong>,<strong>%process_version%</strong>, <strong>%instance_id%</strong>, <strong>%activity_id%</strong> and <strong>%process_id%</strong>'),('en','workflow','select a transition to remove','Select a transition to remove'),('en','workflow','select source','select source'),('en','workflow','send after interactive activity is completed','send after interactive activity is completed'),('en','workflow','send all to','Send all to'),('en','workflow','send an email','Send an email'),('en','workflow','send instance','send instance'),('en','workflow','send this instance to the next activity','Send this instance to the next activity'),('en','workflow','send transition','send transition'),('en','workflow','send when the activity is ending','send when the activity is ending'),('en','workflow','send when the activity is starting','send when the activity is starting'),('en','workflow','send when wf_agent_mail_smtp[\'submit_send\'] is posted','send when wf_agent_mail_smtp[\'submit_send\'] is posted'),('en','workflow','set next act','Set Next act'),('en','workflow','set next user','Set next user'),('en','workflow','set property','Set property'),('en','workflow','setnextuser directives can override it','setNextUser directives can override it'),('en','workflow','setting next activity to an unexisting activity','setting next activity to an unexisting activity'),('en','workflow','shared code','Shared code'),('en','workflow','should we always give you the advanced search row on instances lists?','Should we always give you the advanced search row on instances lists?'),('en','workflow','show code','show code'),('en','workflow','show template','show template'),('en','workflow','smtp agent has detected some errors when sending email after completion of the activity','Smtp Agent has detected some errors when sending email after completion of the activity'),('en','workflow','smtp agent has detected some errors when sending email at the beginning of the activity','Smtp Agent has detected some errors when sending email at the beginning of the activity'),('en','workflow','smtp agent has detected some errors when sending email at the end of this activity','Smtp Agent has detected some errors when sending email at the end of this activity'),('en','workflow','smtp agent has detected some errors when sending email on demand whith this activity','Smtp Agent has detected some errors when sending email on demand whith this activity'),('en','workflow','something was wrong while creating the new major version','something was wrong while creating the new major version'),('en','workflow','something was wrong while creating the new minor version','something was wrong while creating the new minor version'),('en','workflow','source code file for activity %1 is not avaible','source code file for activity %1 is not avaible'),('en','workflow','source code for activity %1 is not avaible','source code for activity %1 is not avaible'),('en','workflow','source saved','Source saved'),('en','workflow','special known values for local links address are <strong>userinstance</strong>, <strong>viewinstance</strong>, <strong>viewnicei','Special known values for local links address are <strong>userinstance</strong>, <strong>viewinstance</strong>, <strong>viewniceinstance</strong> and <strong>admininstance</strong>.'),('en','workflow','split','split'),('en','workflow','standalone','standalone'),('en','workflow','start','Start'),('en','workflow','start activities must be autorouted','start activities must be autorouted'),('en','workflow','start activities must be interactive','start activities must be interactive'),('en','workflow','start activity','Start activity'),('en','workflow','start process','start process'),('en','workflow','started','Started'),('en','workflow','started:','started:'),('en','workflow','starting page','Starting page'),('en','workflow','status','Status'),('en','workflow','status:','status:'),('en','workflow','stop','stop'),('en','workflow','subject:','Subject:'),('en','workflow','switch','switch'),('en','workflow','switch construct','Switch construct'),('en','workflow','template','template'),('en','workflow','test concistency','Test Concistency'),('en','workflow','test consistency of datas in the database','Test Consistency of datas in the database'),('en','workflow','test local installation','Test local installation'),('en','workflow','the activity was not completed','The activity was not completed'),('en','workflow','the default user will only be set if he is mapped to a role on the activity','The default user will only be set if he is mapped to a role on the activity'),('en','workflow','the following items must be corrected to be able to activate this process','The following items must be corrected to be able to activate this process'),('en','workflow','the label you want','the label you want'),('en','workflow','the smtp configuration cannot be loaded by the mail_smtp workflow agent','The SMTP configuration cannot be loaded by the mail_smtp workflow agent'),('en','workflow','there are no activities available','There are no activities available'),('en','workflow','there are no config value defined','There are no config value defined'),('en','workflow','there are no instances available','There are no instances available'),('en','workflow','there are no mappings defined for this process','There are no mappings defined for this process'),('en','workflow','there are no process available','There are no process available'),('en','workflow','there are no processes','There are no processes'),('en','workflow','there are no processes available','There are no processes available'),('en','workflow','there are no processes defined','There are no processes defined'),('en','workflow','there are no processes with the current filter','There are no processes with the current filter'),('en','workflow','there are no properties available','There are no properties available'),('en','workflow','there are no roles defined for this process','There are no roles defined for this process'),('en','workflow','there are no transitions defined','There are no transitions defined'),('en','workflow','there are no user activites available','There are no user activites available'),('en','workflow','there are no workitems available','There are no workitems available'),('en','workflow','there are some undefined preferences associated with this form : %1','there are some undefined preferences associated with this form : %1'),('en','workflow','there is an unknown user or group #%1 in role mappings','There is an unknown user or group #%1 in role mappings'),('en','workflow','they were problems at the compilation of the source:','They were problems at the compilation of the source:'),('en','workflow','this activity for this instance is actually avaible for you.','This activity for this instance is actually avaible for you.'),('en','workflow','this activity for this instance is actually only avaible for you.','This activity for this instance is actually only avaible for you.'),('en','workflow','this activity for this instance is not specifically assigned to you.','This activity for this instance is not specifically assigned to you.'),('en','workflow','this agent gives the activity the possibility to send an smtp message (mail)','This agent gives the activity the possibility to send an SMTP message (mail)'),('en','workflow','this form will test your local workflow installation to detect potential issues','This form will test your local workflow installation to detect potential issues'),('en','workflow','this is the first screen shown when you click on the workflow application icon','This is the first screen shown when you click on the workflow application icon'),('en','workflow','this process has a view activity. access in view mode is granted only for this view activty.','This process has a view activity. Access in view mode is granted only for this view activty.'),('en','workflow','this process has no end activity','this process has no end activity'),('en','workflow','to','To'),('en','workflow','to:','To:'),('en','workflow','transition','transition'),('en','workflow','transition mode','transition mode'),('en','workflow','transition to %1','transition to %1'),('en','workflow','transition waiting for human interaction','transition waiting for human interaction'),('en','workflow','transitions','transitions'),('en','workflow','transitions removed successfully','Transitions removed successfully'),('en','workflow','type','type'),('en','workflow','type:','type:'),('en','workflow','unknow fix instruction :%1','unknow fix instruction :%1'),('en','workflow','unknown instruction from the workflow engine: %1','unknown instruction from the workflow engine: %1'),('en','workflow','unknown status','unknown status'),('en','workflow','update','update'),('en','workflow','upload file','Upload file'),('en','workflow','use <a href=\"%1\">emailadmin</a> to create mail profiles','Use <a href=\"%1\">EmailAdmin</a> to create mail profiles'),('en','workflow','use default','Use Default'),('en','workflow','use existing roles','Use existing roles'),('en','workflow','user','User'),('en','workflow','user #%1 is associated with a non-existent role #%2','User #%1 is associated with a non-existent role #%2'),('en','workflow','user activities','User Activities'),('en','workflow','user instances','User Instances'),('en','workflow','user instances form: columns','User Instances form: columns'),('en','workflow','user instances form: filters and actions','User Instances form: filters and actions'),('en','workflow','user is not authorized to delete aborted instances','user is not authorized to delete aborted instances'),('en','workflow','user is not authorized to delete instances','user is not authorized to delete instances'),('en','workflow','user processes','User Processes'),('en','workflow','user/group','User/Group'),('en','workflow','user:','user:'),('en','workflow','users can act on activity before its execution with form and after by sending it to the next activity','Users can act on activity before its execution with form and after by sending it to the next activity'),('en','workflow','users/groups','Users/Groups'),('en','workflow','valid','Valid'),('en','workflow','valid process','Valid Process'),('en','workflow','valid:','valid:'),('en','workflow','validity:','Validity:'),('en','workflow','value','Value'),('en','workflow','version','Version'),('en','workflow','view details','view details'),('en','workflow','view this instance','View this instance'),('en','workflow','view workitem','View Workitem'),('en','workflow','warning this filter override all others filters','warning this filter override all others filters'),('en','workflow','warning: by using this button you will definitively remove all aborted instances and their history (workitems) for the selected','warning: by using this button you will definitively remove all aborted instances AND their history (workitems) for the selected process.'),('en','workflow','warning: by using this button you will definitively remove all instances and their history (workitems) for the selected process,','warning: by using this button you will definitively remove all instances AND their history (workitems) for the selected process, whatever the state they are.'),('en','workflow','we cannot run this activity, maybe this instance or this activity do not exists anymore.','We cannot run this activity, maybe this instance or this activity do not exists anymore.'),('en','workflow','we were not able to build the message','We were not able to build the message'),('en','workflow','when in advanced mode, should we show you advanced actions by default (resume, exception, grab, etc.)?','When in advanced mode, should we show you advanced actions by default (resume, exception, grab, etc.)?'),('en','workflow','when to send the message:','When to send the Message:'),('en','workflow','workflow navigation','Workflow navigation'),('en','workflow','workflow preferences','Workflow Preferences'),('en','workflow','workflow site configuration','Workflow Site Configuration'),('en','workflow','workflow.ui_useractivities','workflow.ui_useractivities'),('en','workflow','workitem information','Workitem information'),('en','workflow','workitems','Workitems'),('en','workflow','you are not allowed to abort instance %1','You are not allowed to abort instance %1'),('en','workflow','you are not allowed to exception instance %1','You are not allowed to exception instance %1'),('en','workflow','you are not allowed to grab instance %1','You are not allowed to grab instance %1'),('en','workflow','you are not allowed to release instance %1','You are not allowed to release instance %1'),('en','workflow','you are not allowed to restart instance %1','You are not allowed to restart instance %1'),('en','workflow','you are not allowed to resume instance %1','You are not allowed to resume instance %1'),('en','workflow','you are not allowed to send instance %1','You are not allowed to send instance %1'),('en','workflow','you can use special values with this mail agent:','You can use special values with this mail agent:'),('en','workflow','you do not have the right to run this activity anymore, maybe a concurrent access problem, refresh your datas.','You do not have the right to run this activity anymore, maybe a concurrent access problem, refresh your datas.'),('en','workflow','you don\'t have the rights necessary to exception instance %1','You don\'t have the rights necessary to exception instance %1'),('en','workflow','you have not permission to execute this activity','You have not permission to execute this activity'),('en','workflow','you were not allowed to complete the activity','you were not allowed to complete the activity');
CREATE TABLE `egw_languages` (
  `lang_id` varchar(5) NOT NULL default '',
  `lang_name` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`lang_id`)
) TYPE=MyISAM;
INSERT INTO `egw_languages` VALUES ('aa','Afar'),('ab','Abkhazian'),('af','Afrikaans'),('am','Amharic'),('ar','Arabic'),('as','Assamese'),('ay','Aymara'),('az','Azerbaijani'),('ba','Bashkir'),('be','Byelorussian'),('bg','Bulgarian'),('bh','Bihari'),('bi','Bislama'),('bn','Bengali / Bangla'),('bo','Tibetan'),('br','Breton'),('ca','Catalan'),('co','Corsican'),('cs','Czech'),('cy','Welsh'),('da','Danish'),('de','German'),('dz','Bhutani'),('el','Greek'),('en','English / US'),('eo','Esperanto'),('es-es','Espa&ntilde;ol'),('et','Estonian'),('eu','Basque'),('fa','Persian'),('fi','Finnish'),('fj','Fiji'),('fo','Faeroese'),('fr','French'),('fy','Frisian'),('ga','Irish'),('gd','Gaelic / Scots Gaelic'),('gl','Galician'),('gn','Guarani'),('gu','Gujarati'),('ha','Hausa'),('hi','Hindi'),('hr','Croatian'),('hu','Hungarian'),('hy','Armenian'),('ia','Interlingua'),('ie','Interlingue'),('ik','Inupiak'),('in','Indonesian'),('is','Icelandic'),('it','Italian'),('iw','Hebrew'),('ja','Japanese'),('ji','Yiddish'),('jw','Javanese'),('ka','Georgian'),('kk','Kazakh'),('kl','Greenlandic'),('km','Cambodian'),('kn','Kannada'),('ko','Korean'),('ks','Kashmiri'),('ku','Kurdish'),('ky','Kirghiz'),('la','Latin'),('ln','Lingala'),('lo','Laothian'),('lt','Lithuanian'),('lv','Latvian / Lettish'),('mg','Malagasy'),('mi','Maori'),('mk','Macedonian'),('ml','Malayalam'),('mn','Mongolian'),('mo','Moldavian'),('mr','Marathi'),('ms','Malay'),('mt','Maltese'),('my','Burmese'),('na','Nauru'),('ne','Nepali'),('nl','Dutch'),('no','Norwegian'),('oc','Occitan'),('om','Oromo / Afan'),('or','Oriya'),('pa','Punjabi'),('pl','Polish'),('ps','Pashto / Pushto'),('pt','Portuguese'),('pt-br','Brazil'),('qu','Quechua'),('rm','Rhaeto-Romance'),('rn','Kirundi'),('ro','Romanian'),('ru','Russian'),('rw','Kinyarwanda'),('sa','Sanskrit'),('sd','Sindhi'),('sg','Sangro'),('sh','Serbo-Croatian'),('si','Singhalese'),('sk','Slovak'),('sl','Slovenian'),('sm','Samoan'),('sn','Shona'),('so','Somali'),('sq','Albanian'),('sr','Serbian'),('ss','Siswati'),('st','Sesotho'),('su','Sudanese'),('sv','Swedish'),('sw','Swahili'),('ta','Tamil'),('te','Tegulu'),('tg','Tajik'),('th','Thai'),('ti','Tigrinya'),('tk','Turkmen'),('tl','Tagalog'),('tn','Setswana'),('to','Tonga'),('tr','Turkish'),('ts','Tsonga'),('tt','Tatar'),('tw','Twi'),('uk','Ukrainian'),('ur','Urdu'),('uz','Uzbek'),('vi','Vietnamese'),('vo','Volapuk'),('wo','Wolof'),('xh','Xhosa'),('yo','Yoruba'),('zh','Chinese(simplified)'),('zh-tw','Chinese(Taiwan)'),('zu','Zulu');
CREATE TABLE `egw_links` (
  `link_id` int(11) NOT NULL auto_increment,
  `link_app1` varchar(25) NOT NULL default '',
  `link_id1` varchar(50) NOT NULL default '',
  `link_app2` varchar(25) NOT NULL default '',
  `link_id2` varchar(50) NOT NULL default '',
  `link_remark` varchar(100) default NULL,
  `link_lastmod` int(11) NOT NULL default '0',
  `link_owner` int(11) NOT NULL default '0',
  PRIMARY KEY  (`link_id`),
  KEY `egw_links_app1_id1_lastmod` (`link_app1`,`link_id1`,`link_lastmod`),
  KEY `egw_links_app2_id2_lastmod` (`link_app2`,`link_id2`,`link_lastmod`)
) TYPE=MyISAM;
CREATE TABLE `egw_log` (
  `log_id` int(11) NOT NULL auto_increment,
  `log_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `log_user` int(11) NOT NULL default '0',
  `log_app` varchar(50) NOT NULL default '',
  `log_severity` char(1) NOT NULL default '',
  PRIMARY KEY  (`log_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_log_msg` (
  `log_msg_log_id` int(11) NOT NULL default '0',
  `log_msg_seq_no` int(11) NOT NULL default '0',
  `log_msg_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `log_msg_tx_fid` varchar(4) default NULL,
  `log_msg_tx_id` varchar(4) default NULL,
  `log_msg_severity` char(1) NOT NULL default '',
  `log_msg_code` varchar(30) NOT NULL default '',
  `log_msg_msg` text,
  `log_msg_parms` text,
  `log_msg_file` varchar(255) NOT NULL default '',
  `log_msg_line` int(11) NOT NULL default '0',
  PRIMARY KEY  (`log_msg_log_id`,`log_msg_seq_no`)
) TYPE=MyISAM;
CREATE TABLE `egw_news` (
  `news_id` int(11) NOT NULL auto_increment,
  `news_date` bigint(20) default NULL,
  `news_subject` varchar(255) default NULL,
  `news_submittedby` varchar(255) default NULL,
  `news_content` longblob,
  `news_begin` bigint(20) NOT NULL default '0',
  `news_end` bigint(20) default NULL,
  `news_cat` int(11) default NULL,
  `news_teaser` varchar(255) default NULL,
  `is_html` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`news_id`),
  KEY `egw_news_date` (`news_date`),
  KEY `egw_news_subject` (`news_subject`)
) TYPE=MyISAM;
CREATE TABLE `egw_news_export` (
  `cat_id` int(11) NOT NULL default '0',
  `export_type` smallint(6) default NULL,
  `export_itemsyntax` smallint(6) default NULL,
  `export_title` varchar(255) default NULL,
  `export_link` varchar(255) default NULL,
  `export_description` text,
  `export_img_title` varchar(255) default NULL,
  `export_img_url` varchar(255) default NULL,
  `export_img_link` varchar(255) default NULL,
  PRIMARY KEY  (`cat_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_nextid` (
  `id` int(11) default NULL,
  `appname` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`appname`)
) TYPE=MyISAM;
CREATE TABLE `egw_pm_constraints` (
  `pm_id` int(11) NOT NULL default '0',
  `pe_id_end` int(11) NOT NULL default '0',
  `pe_id_start` int(11) NOT NULL default '0',
  `ms_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pm_id`,`pe_id_end`,`pe_id_start`,`ms_id`),
  KEY `egw_pm_constraints_id_pe_id_start` (`pm_id`,`pe_id_start`),
  KEY `egw_pm_constraints_id_ms_id` (`pm_id`,`ms_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_pm_elements` (
  `pm_id` int(11) NOT NULL default '0',
  `pe_id` int(11) NOT NULL default '0',
  `pe_title` varchar(255) NOT NULL default '',
  `pe_completion` smallint(6) default NULL,
  `pe_planned_time` int(11) default NULL,
  `pe_used_time` int(11) default NULL,
  `pe_planned_budget` decimal(20,2) default NULL,
  `pe_used_budget` decimal(20,2) default NULL,
  `pe_planned_start` bigint(20) default NULL,
  `pe_real_start` bigint(20) default NULL,
  `pe_planned_end` bigint(20) default NULL,
  `pe_real_end` bigint(20) default NULL,
  `pe_overwrite` int(11) NOT NULL default '0',
  `pl_id` int(11) NOT NULL default '0',
  `pe_synced` bigint(20) default NULL,
  `pe_modified` bigint(20) NOT NULL default '0',
  `pe_modifier` int(11) NOT NULL default '0',
  `pe_status` varchar(8) NOT NULL default 'new',
  `pe_unitprice` decimal(20,2) default NULL,
  `cat_id` int(11) NOT NULL default '0',
  `pe_share` int(11) default NULL,
  `pe_health` smallint(6) default NULL,
  `pe_resources` varchar(255) default NULL,
  `pe_details` text,
  `pe_planned_quantity` double default NULL,
  `pe_used_quantity` double default NULL,
  PRIMARY KEY  (`pm_id`,`pe_id`),
  KEY `egw_pm_elements_id_pe_status` (`pm_id`,`pe_status`)
) TYPE=MyISAM;
CREATE TABLE `egw_pm_extra` (
  `pm_id` int(11) NOT NULL default '0',
  `pm_extra_name` varchar(40) NOT NULL default '',
  `pm_extra_value` text,
  PRIMARY KEY  (`pm_id`,`pm_extra_name`)
) TYPE=MyISAM;
CREATE TABLE `egw_pm_members` (
  `pm_id` int(11) NOT NULL default '0',
  `member_uid` int(11) NOT NULL default '0',
  `role_id` int(11) default '0',
  `member_availibility` double default '100',
  PRIMARY KEY  (`pm_id`,`member_uid`)
) TYPE=MyISAM;
CREATE TABLE `egw_pm_milestones` (
  `ms_id` int(11) NOT NULL auto_increment,
  `pm_id` int(11) NOT NULL default '0',
  `ms_date` bigint(20) NOT NULL default '0',
  `ms_title` varchar(255) default NULL,
  `ms_description` text,
  PRIMARY KEY  (`ms_id`),
  KEY `egw_pm_milestones_id` (`pm_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_pm_pricelist` (
  `pl_id` int(11) NOT NULL auto_increment,
  `pl_title` varchar(255) NOT NULL default '',
  `pl_description` text,
  `cat_id` int(11) NOT NULL default '0',
  `pl_unit` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`pl_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_pm_prices` (
  `pm_id` int(11) NOT NULL default '0',
  `pl_id` int(11) NOT NULL default '0',
  `pl_validsince` bigint(20) NOT NULL default '0',
  `pl_price` double default NULL,
  `pl_modifier` int(11) NOT NULL default '0',
  `pl_modified` bigint(20) NOT NULL default '0',
  `pl_customertitle` varchar(255) default NULL,
  `pl_billable` smallint(6) default '1',
  PRIMARY KEY  (`pm_id`,`pl_id`,`pl_validsince`)
) TYPE=MyISAM;
CREATE TABLE `egw_pm_projects` (
  `pm_id` int(11) NOT NULL auto_increment,
  `pm_number` varchar(64) NOT NULL default '',
  `pm_title` varchar(255) NOT NULL default '',
  `pm_description` text,
  `pm_creator` int(11) NOT NULL default '0',
  `pm_created` bigint(20) NOT NULL default '0',
  `pm_modifier` int(11) default NULL,
  `pm_modified` bigint(20) default NULL,
  `pm_planned_start` bigint(20) default NULL,
  `pm_planned_end` bigint(20) default NULL,
  `pm_real_start` bigint(20) default NULL,
  `pm_real_end` bigint(20) default NULL,
  `cat_id` int(11) default '0',
  `pm_access` varchar(7) default 'public',
  `pm_priority` smallint(6) default '1',
  `pm_status` varchar(9) default 'active',
  `pm_completion` smallint(6) default '0',
  `pm_used_time` int(11) default NULL,
  `pm_planned_time` int(11) default NULL,
  `pm_used_budget` decimal(20,2) default NULL,
  `pm_planned_budget` decimal(20,2) default NULL,
  `pm_overwrite` int(11) default '0',
  `pm_accounting_type` varchar(10) default 'times',
  PRIMARY KEY  (`pm_id`),
  UNIQUE KEY `egw_pm_projects_number` (`pm_number`),
  KEY `egw_pm_projects_title` (`pm_title`)
) TYPE=MyISAM;
CREATE TABLE `egw_pm_roles` (
  `role_id` int(11) NOT NULL auto_increment,
  `pm_id` int(11) default '0',
  `role_title` varchar(80) NOT NULL default '',
  `role_description` varchar(255) default NULL,
  `role_acl` int(11) NOT NULL default '0',
  PRIMARY KEY  (`role_id`),
  KEY `egw_pm_roles_id` (`pm_id`)
) TYPE=MyISAM AUTO_INCREMENT=5;
INSERT INTO `egw_pm_roles` VALUES (1,0,'Coordinator','full access',65535),(2,0,'Accounting','edit access, incl. editing budget and elements',199),(3,0,'Assistant','read access, incl. budget and adding elements',67),(4,0,'Projectmember','read access, no budget',1);
CREATE TABLE `egw_preferences` (
  `preference_owner` int(11) NOT NULL default '0',
  `preference_app` varchar(25) NOT NULL default '',
  `preference_value` text,
  PRIMARY KEY  (`preference_owner`,`preference_app`)
) TYPE=MyISAM;
INSERT INTO `egw_preferences` VALUES (-2,'common','a:12:{s:9:\"maxmatchs\";s:2:\"15\";s:12:\"template_set\";s:5:\"idots\";s:5:\"theme\";s:5:\"idots\";s:13:\"navbar_format\";s:5:\"icons\";s:9:\"tz_offset\";s:1:\"0\";s:10:\"dateformat\";s:5:\"Y/m/d\";s:10:\"timeformat\";s:2:\"24\";s:4:\"lang\";s:2:\"en\";s:11:\"default_app\";s:8:\"calendar\";s:8:\"currency\";s:1:\"$\";s:9:\"show_help\";s:1:\"1\";s:9:\"max_icons\";s:2:\"12\";}'),(-2,'calendar','a:21:{s:13:\"workdaystarts\";s:1:\"9\";s:11:\"workdayends\";s:2:\"17\";s:13:\"weekdaystarts\";s:6:\"Monday\";s:15:\"defaultcalendar\";s:3:\"day\";s:24:\"planner_start_with_group\";s:2:\"-1\";s:21:\"mainscreen_showevents\";s:1:\"0\";s:7:\"summary\";s:2:\"no\";s:15:\"receive_updates\";s:2:\"no\";s:13:\"update_format\";s:8:\"extended\";s:11:\"notifyAdded\";s:99:\"Calendar Event - $$action$$: $$startdate$$ $$title$$\nYou have a meeting scheduled for $$startdate$$\";s:14:\"notifyCanceled\";s:111:\"Calendar Event - $$action$$: $$startdate$$ $$title$$\nYour meeting scheduled for $$startdate$$ has been canceled\";s:14:\"notifyModified\";s:143:\"Calendar Event - $$action$$: $$startdate$$ $$title$$\nYour meeting that had been scheduled for $$olddate$$ has been rescheduled to $$startdate$$\";s:16:\"notifyDisinvited\";s:111:\"Calendar Event - $$action$$: $$startdate$$ $$title$$\nYou have been disinvited from the meeting at $$startdate$$\";s:14:\"notifyResponse\";s:127:\"Calendar Event - $$action$$: $$startdate$$ $$title$$\nOn $$date$$ $$fullname$$ $$action$$ your meeting request for $$startdate$$\";s:11:\"notifyAlarm\";s:82:\"Alarm for $$title$$ at $$startdate$$ in $$location$$\nHere is your requested alarm.\";s:13:\"show_rejected\";s:1:\"0\";s:14:\"display_status\";s:1:\"1\";s:8:\"interval\";s:2:\"30\";s:13:\"defaultlength\";s:2:\"60\";s:13:\"defaultfilter\";s:3:\"all\";s:15:\"default_private\";s:1:\"0\";}');
CREATE TABLE `egw_reg_accounts` (
  `reg_id` varchar(32) NOT NULL default '',
  `reg_lid` varchar(255) NOT NULL default '',
  `reg_info` text,
  `reg_dla` int(11) NOT NULL default '0'
) TYPE=MyISAM;
CREATE TABLE `egw_reg_fields` (
  `field_name` varchar(255) NOT NULL default '',
  `field_text` text,
  `field_type` varchar(255) NOT NULL default '',
  `field_values` text,
  `field_required` char(1) NOT NULL default '',
  `field_order` int(11) NOT NULL default '0'
) TYPE=MyISAM;
INSERT INTO `egw_reg_fields` VALUES ('bday','Birthday','birthday','','Y',1),('email','E-Mail','email','','Y',2),('n_given','First Name','first_name','','Y',3),('n_family','Last Name','last_name','','Y',4),('adr_one_street','Address','address','','Y',5),('adr_one_locality','City','city','','Y',6),('adr_one_region','State','state','','Y',7),('adr_one_postalcode','ZIP/Postal','zip','','Y',8),('adr_one_countryname','Country','country','','Y',9),('tel_work','Phone','phone','','N',10),('gender','Gender','gender','','N',11),('challenge_question_1','Challenge1','challenge1','','N',100),('challenge_question_2','Challenge2','challenge2','','N',100),('challenge_question_3','Challenge3','challenge3','','N',100);
CREATE TABLE `egw_resources` (
  `res_id` int(11) NOT NULL auto_increment,
  `name` varchar(100) default NULL,
  `short_description` varchar(100) default NULL,
  `cat_id` int(11) NOT NULL default '0',
  `quantity` int(11) default '1',
  `useable` int(11) default '1',
  `location` varchar(100) default NULL,
  `bookable` char(1) default NULL,
  `buyable` char(1) default NULL,
  `prize` varchar(200) default NULL,
  `long_description` longtext,
  `picture_src` varchar(20) default NULL,
  `accessory_of` int(11) default '-1',
  `storage_info` varchar(200) default NULL,
  `inventory_number` varchar(20) default NULL,
  PRIMARY KEY  (`res_id`)
) TYPE=MyISAM AUTO_INCREMENT=4;
INSERT INTO `egw_resources` VALUES (1,'Meeting room 1',NULL,1,1,1,NULL,'1',NULL,NULL,NULL,'cat_src',-1,NULL,NULL),(2,'Meeting room 2',NULL,1,1,1,NULL,'1',NULL,NULL,NULL,'cat_src',-1,NULL,NULL),(3,'Fixed Beamer',NULL,1,1,1,NULL,'0',NULL,NULL,NULL,'cat_src',2,NULL,NULL);
CREATE TABLE `egw_resources_extra` (
  `extra_id` int(11) NOT NULL default '0',
  `extra_name` varchar(40) NOT NULL default '',
  `extra_owner` int(11) NOT NULL default '-1',
  `extra_value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`extra_id`,`extra_name`,`extra_owner`)
) TYPE=MyISAM;
CREATE TABLE `egw_sessions` (
  `session_id` varchar(128) NOT NULL default '',
  `session_lid` varchar(128) default NULL,
  `session_ip` varchar(40) default NULL,
  `session_logintime` bigint(20) default NULL,
  `session_dla` bigint(20) default NULL,
  `session_action` varchar(255) default NULL,
  `session_flags` char(2) default NULL,
  PRIMARY KEY  (`session_id`),
  KEY `egw_sessions_session_flags_session_dla` (`session_flags`,`session_dla`)
) TYPE=MyISAM;
CREATE TABLE `egw_sitemgr_active_modules` (
  `area` varchar(50) NOT NULL default '',
  `cat_id` int(11) NOT NULL default '0',
  `module_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`area`,`cat_id`,`module_id`)
) TYPE=MyISAM;
INSERT INTO `egw_sitemgr_active_modules` VALUES ('footer',2,3),('footer',2,8),('footer',2,12),('header',2,3),('header',2,8),('left',2,1),('left',2,3),('left',2,4),('left',2,8),('left',2,9),('left',2,10),('left',2,11),('left',2,15),('left',2,16),('left',2,17),('left',2,21),('left',2,25),('right',2,1),('right',2,3),('right',2,4),('right',2,8),('right',2,9),('right',2,10),('right',2,11),('right',2,15),('right',2,16),('right',2,17),('right',2,21),('right',2,25),('__PAGE__',2,1),('__PAGE__',2,3),('__PAGE__',2,7),('__PAGE__',2,8),('__PAGE__',2,13),('__PAGE__',2,14),('__PAGE__',2,16),('__PAGE__',2,18),('__PAGE__',2,25),('__PAGE__',2,26);
CREATE TABLE `egw_sitemgr_blocks` (
  `block_id` int(11) NOT NULL auto_increment,
  `area` varchar(50) default NULL,
  `cat_id` int(11) default NULL,
  `page_id` int(11) default NULL,
  `module_id` int(11) NOT NULL default '0',
  `sort_order` int(11) default NULL,
  `viewable` int(11) default NULL,
  PRIMARY KEY  (`block_id`)
) TYPE=MyISAM AUTO_INCREMENT=12;
INSERT INTO `egw_sitemgr_blocks` VALUES (1,'left',2,0,25,0,0),(2,'left',2,0,1,1,0),(3,'right',2,0,25,2,0),(4,'right',2,0,21,3,2),(5,'right',2,0,4,4,0),(6,'right',2,0,10,5,1),(7,'right',2,0,9,7,3),(8,'right',2,0,15,8,0),(9,'header',2,0,3,9,0),(10,'footer',2,0,3,10,0),(11,'center',4,1,3,11,0);
CREATE TABLE `egw_sitemgr_blocks_lang` (
  `block_id` int(11) NOT NULL default '0',
  `lang` varchar(5) NOT NULL default '',
  `title` varchar(255) default NULL,
  PRIMARY KEY  (`block_id`,`lang`)
) TYPE=MyISAM;
INSERT INTO `egw_sitemgr_blocks_lang` VALUES (1,'en','Root Site Index'),(2,'en','Choose template'),(3,'en','Current Section'),(4,'en','Administration'),(5,'en','Select language'),(6,'en','Calendar'),(7,'en','Login'),(8,'en',''),(9,'en','HTML Module'),(10,'en','HTML Module'),(11,'en','HTML Module');
CREATE TABLE `egw_sitemgr_categories_lang` (
  `cat_id` int(11) NOT NULL default '0',
  `lang` varchar(5) NOT NULL default '',
  `name` varchar(100) default NULL,
  `description` varchar(255) default NULL,
  PRIMARY KEY  (`cat_id`,`lang`)
) TYPE=MyISAM;
INSERT INTO `egw_sitemgr_categories_lang` VALUES (3,'en','other','one more'),(4,'en','sample','sample category'),(5,'en','sub-sample','just a sub for sample');
CREATE TABLE `egw_sitemgr_categories_state` (
  `cat_id` int(11) NOT NULL default '0',
  `state` smallint(6) default NULL,
  `index_page_id` int(11) default '0',
  PRIMARY KEY  (`cat_id`),
  KEY `egw_sitemgr_categories_state_cat_id_state` (`cat_id`,`state`)
) TYPE=MyISAM;
INSERT INTO `egw_sitemgr_categories_state` VALUES (3,2,0),(4,2,0),(5,2,0);
CREATE TABLE `egw_sitemgr_content` (
  `version_id` int(11) NOT NULL auto_increment,
  `block_id` int(11) NOT NULL default '0',
  `arguments` text,
  `state` smallint(6) default NULL,
  PRIMARY KEY  (`version_id`)
) TYPE=MyISAM AUTO_INCREMENT=12;
INSERT INTO `egw_sitemgr_content` VALUES (1,1,'a:2:{s:8:\"sub_cats\";s:2:\"on\";s:8:\"nav_type\";i:3;}',2),(2,2,'a:2:{s:4:\"show\";i:8;s:3:\"zip\";s:3:\"zip\";}',2),(3,3,'a:1:{s:8:\"nav_type\";i:1;}',2),(4,4,NULL,2),(5,5,NULL,2),(6,6,NULL,2),(7,7,NULL,2),(8,8,'a:1:{s:6:\"search\";i:1;}',2),(9,9,NULL,2),(10,10,NULL,2),(11,11,NULL,2);
CREATE TABLE `egw_sitemgr_content_lang` (
  `version_id` int(11) NOT NULL default '0',
  `lang` varchar(5) NOT NULL default '',
  `arguments_lang` text,
  PRIMARY KEY  (`version_id`,`lang`)
) TYPE=MyISAM;
INSERT INTO `egw_sitemgr_content_lang` VALUES (8,'en','s:10:\"Amazon.com\";'),(9,'en','a:1:{s:11:\"htmlcontent\";s:21:\"<h1>SiteMgr Demo</h1>\";}'),(10,'en','a:1:{s:11:\"htmlcontent\";s:252:\"Powered by eGroupWare\'s <b>SiteMgr</b>. Please visit our Homepage <a href=\"http://www.egroupware.org\" target=\"_blank\">www.eGroupWare.org</a> and our <a href=\"http://www.sourceforge.net/projects/egroupware/\" target=\"_blank\">Sourceforge Project page</a>.\";}'),(11,'en','a:1:{s:11:\"htmlcontent\";s:35:\"some sample <b>HTML</b> content ...\";}');
CREATE TABLE `egw_sitemgr_modules` (
  `module_id` int(11) NOT NULL auto_increment,
  `module_name` varchar(25) default NULL,
  `description` varchar(255) default NULL,
  PRIMARY KEY  (`module_id`)
) TYPE=MyISAM AUTO_INCREMENT=27;
INSERT INTO `egw_sitemgr_modules` VALUES (1,'template','This module lets the users choose a template or shows a template gallery'),(2,'forum','This module displays the eGW forums on the web site'),(3,'html','This module is a simple HTML editor'),(4,'lang_block','This module lets users choose language'),(5,'translation_status','This module show the status / percentage of the translation of eGW'),(6,'applet','This module lets you include an applet into the page.'),(7,'phpbrain','Enterprise Knowledge articles repository'),(8,'filecontents','This module includes the contents of an URL or file (readable by the webserver and in its docroot !)'),(9,'login','This module displays a login form'),(10,'calendar','This module displays the current month'),(11,'notify','Enter the email to be notified about changes of the website.'),(12,'validator','Helps you respect HTML/XHTML standards.'),(13,'download','This module create a link for downloading a file(s) from the VFS'),(14,'redirect','This module lets you define pages that redirect to another URL, if you use it, there should be no other block defined for the page'),(15,'amazon','Use this module for displaying book ads for the amazon web site'),(16,'news','This module publishes news from the news_admin application on your website. Be aware of news_admin\'s ACL restrictions.'),(17,'google','Interface to Google website'),(18,'frame','This module lets you show a given URL inside an IFRAME in the page.'),(19,'bookmarks','This module displays bookmarks in a javascript based tree'),(20,'galerie','A simple picture galery'),(21,'administration','This module is a selectbox to change the mode (production, draft or edit) plus a link back to SiteMgr and to log out. It is meant for registered users only'),(22,'xml','This module permits browsing through XML files stored in a directory, and transformed by XSLT'),(23,'appdir','This module demonstrates how handling data stored in XML and building an interacvite interface from it'),(24,'hello','This is a simple sample module'),(25,'navigation',''),(26,'wiki','Use this module for displaying wiki-pages');
CREATE TABLE `egw_sitemgr_notifications` (
  `notification_id` int(11) NOT NULL auto_increment,
  `site_id` int(11) NOT NULL default '0',
  `site_language` char(3) NOT NULL default 'all',
  `cat_id` int(11) NOT NULL default '0',
  `email` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`notification_id`),
  KEY `egw_sitemgr_notifications_email` (`email`)
) TYPE=MyISAM;
CREATE TABLE `egw_sitemgr_notify_messages` (
  `message_id` int(11) NOT NULL auto_increment,
  `site_id` int(11) NOT NULL default '0',
  `language` char(3) default NULL,
  `message` text,
  `subject` text,
  PRIMARY KEY  (`message_id`),
  UNIQUE KEY `egw_sitemgr_notify_messages_id_language` (`site_id`,`language`)
) TYPE=MyISAM;
CREATE TABLE `egw_sitemgr_pages` (
  `page_id` int(11) NOT NULL auto_increment,
  `cat_id` int(11) default NULL,
  `sort_order` int(11) default NULL,
  `hide_page` int(11) default NULL,
  `name` varchar(100) default NULL,
  `state` smallint(6) default NULL,
  PRIMARY KEY  (`page_id`),
  KEY `egw_sitemgr_pages_cat_id` (`cat_id`),
  KEY `egw_sitemgr_pages_state_cat_id_sort_order` (`state`,`cat_id`,`sort_order`),
  KEY `egw_sitemgr_pages_name_cat_id` (`name`,`cat_id`)
) TYPE=MyISAM AUTO_INCREMENT=2;
INSERT INTO `egw_sitemgr_pages` VALUES (1,4,0,0,'sample-page',2);
CREATE TABLE `egw_sitemgr_pages_lang` (
  `page_id` int(11) NOT NULL default '0',
  `lang` varchar(5) NOT NULL default '',
  `title` varchar(255) default NULL,
  `subtitle` varchar(255) default NULL,
  PRIMARY KEY  (`page_id`,`lang`)
) TYPE=MyISAM;
INSERT INTO `egw_sitemgr_pages_lang` VALUES (1,'en','Sample page','just a sample');
CREATE TABLE `egw_sitemgr_properties` (
  `area` varchar(50) NOT NULL default '',
  `cat_id` int(11) NOT NULL default '0',
  `module_id` int(11) NOT NULL default '0',
  `properties` text,
  PRIMARY KEY  (`area`,`cat_id`,`module_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_sitemgr_sites` (
  `site_id` int(11) NOT NULL default '0',
  `site_name` varchar(255) default NULL,
  `site_url` varchar(255) default NULL,
  `site_dir` varchar(255) default NULL,
  `themesel` varchar(50) default NULL,
  `site_languages` varchar(50) default NULL,
  `home_page_id` int(11) default NULL,
  `anonymous_user` varchar(50) default NULL,
  `anonymous_passwd` varchar(50) default NULL,
  `upload_dir` varchar(255) default NULL,
  `upload_url` varchar(255) default NULL,
  PRIMARY KEY  (`site_id`),
  KEY `egw_sitemgr_sites_url` (`site_url`)
) TYPE=MyISAM;
INSERT INTO `egw_sitemgr_sites` VALUES (2,'Default Website','/@@BASE_URL_PATH@@/sitemgr/sitemgr-site/','@@ROOT_DIR@@/sitemgr/sitemgr-site','idots','en,de',0,'anonymous','anonymous',NULL,NULL);
CREATE TABLE `egw_syncmldevinfo` (
  `dev_id` varchar(255) NOT NULL default '',
  `dev_dtdversion` varchar(10) NOT NULL default '',
  `dev_numberofchanges` tinyint(4) NOT NULL default '0',
  `dev_largeobjs` tinyint(4) NOT NULL default '0',
  `dev_swversion` varchar(100) NOT NULL default '',
  `dev_oem` varchar(100) NOT NULL default '',
  `dev_model` varchar(100) NOT NULL default '',
  `dev_manufacturer` varchar(100) NOT NULL default '',
  `dev_devicetype` varchar(100) NOT NULL default '',
  `dev_deviceid` varchar(100) NOT NULL default '',
  `dev_datastore` text,
  PRIMARY KEY  (`dev_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_syncmlsummary` (
  `dev_id` varchar(255) NOT NULL default '',
  `sync_path` varchar(100) NOT NULL default '',
  `sync_serverts` varchar(20) NOT NULL default '',
  `sync_clientts` varchar(20) NOT NULL default ''
) TYPE=MyISAM;
CREATE TABLE `egw_timesheet` (
  `ts_id` int(11) NOT NULL auto_increment,
  `ts_project` varchar(80) default NULL,
  `ts_title` varchar(80) NOT NULL default '',
  `ts_description` text,
  `ts_start` bigint(20) NOT NULL default '0',
  `ts_duration` bigint(20) NOT NULL default '0',
  `ts_quantity` double NOT NULL default '0',
  `ts_unitprice` double default NULL,
  `cat_id` int(11) default '0',
  `ts_owner` int(11) NOT NULL default '0',
  `ts_modified` bigint(20) NOT NULL default '0',
  `ts_modifier` int(11) NOT NULL default '0',
  `pl_id` int(11) default '0',
  PRIMARY KEY  (`ts_id`),
  KEY `egw_timesheet_ts_project` (`ts_project`),
  KEY `egw_timesheet_ts_owner` (`ts_owner`)
) TYPE=MyISAM;
CREATE TABLE `egw_vfs` (
  `vfs_file_id` int(11) NOT NULL auto_increment,
  `vfs_owner_id` int(11) NOT NULL default '0',
  `vfs_createdby_id` int(11) default NULL,
  `vfs_modifiedby_id` int(11) default NULL,
  `vfs_created` date NOT NULL default '1970-01-01',
  `vfs_modified` date default NULL,
  `vfs_size` int(11) default NULL,
  `vfs_mime_type` varchar(64) default NULL,
  `vfs_deleteable` char(1) default 'Y',
  `vfs_comment` varchar(255) default NULL,
  `vfs_app` varchar(25) default NULL,
  `vfs_directory` varchar(233) default NULL,
  `vfs_name` varchar(100) NOT NULL default '',
  `vfs_link_directory` varchar(255) default NULL,
  `vfs_link_name` varchar(128) default NULL,
  `vfs_version` varchar(30) NOT NULL default '0.0.0.0',
  `vfs_content` text,
  PRIMARY KEY  (`vfs_file_id`),
  KEY `egw_vfs_directory_name` (`vfs_directory`,`vfs_name`)
) TYPE=MyISAM AUTO_INCREMENT=3;
INSERT INTO `egw_vfs` VALUES (1,0,0,0,'1970-01-01',NULL,NULL,'Directory','Y',NULL,NULL,'/','',NULL,NULL,'0.0.0.0',NULL),(2,0,0,0,'1970-01-01',NULL,NULL,'Directory','Y',NULL,NULL,'/','home',NULL,NULL,'0.0.0.0',NULL);
CREATE TABLE `egw_wf_activities` (
  `wf_activity_id` int(11) NOT NULL auto_increment,
  `wf_name` varchar(80) default NULL,
  `wf_normalized_name` varchar(80) default NULL,
  `wf_p_id` int(11) NOT NULL default '0',
  `wf_type` varchar(25) default NULL,
  `wf_is_autorouted` char(1) default NULL,
  `wf_flow_num` int(11) default NULL,
  `wf_is_interactive` char(1) default NULL,
  `wf_last_modif` int(11) default NULL,
  `wf_description` text,
  `wf_default_user` varchar(200) default '*',
  PRIMARY KEY  (`wf_activity_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_activity_agents` (
  `wf_activity_id` int(11) NOT NULL default '0',
  `wf_agent_id` int(11) NOT NULL default '0',
  `wf_agent_type` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`wf_activity_id`,`wf_agent_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_activity_roles` (
  `wf_activity_id` int(11) NOT NULL default '0',
  `wf_role_id` int(11) NOT NULL default '0',
  `wf_readonly` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`wf_activity_id`,`wf_role_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_agent_mail_smtp` (
  `wf_agent_id` int(11) NOT NULL auto_increment,
  `wf_to` varchar(255) NOT NULL default '%roles%',
  `wf_cc` varchar(255) default NULL,
  `wf_bcc` varchar(255) default NULL,
  `wf_from` varchar(255) default '%user%',
  `wf_replyTo` varchar(255) default '%user%',
  `wf_subject` varchar(255) default NULL,
  `wf_message` text,
  `wf_send_mode` int(11) default '0',
  PRIMARY KEY  (`wf_agent_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_instance_activities` (
  `wf_instance_id` int(11) NOT NULL default '0',
  `wf_activity_id` int(11) NOT NULL default '0',
  `wf_started` int(11) NOT NULL default '0',
  `wf_ended` int(11) default NULL,
  `wf_user` varchar(200) default NULL,
  `wf_status` varchar(25) default NULL,
  PRIMARY KEY  (`wf_instance_id`,`wf_activity_id`),
  KEY `egw_wf_instance_activities_activity_id` (`wf_activity_id`),
  KEY `egw_wf_instance_activities_id` (`wf_instance_id`),
  KEY `egw_wf_instance_activities_user` (`wf_user`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_instance_supplements` (
  `wf_supplement_id` int(11) NOT NULL auto_increment,
  `wf_supplement_type` varchar(50) default NULL,
  `wf_supplement_name` varchar(100) default NULL,
  `wf_supplement_value` text,
  `wf_workitem_id` int(11) default NULL,
  `wf_supplement_blob` longblob,
  PRIMARY KEY  (`wf_supplement_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_instances` (
  `wf_instance_id` int(11) NOT NULL auto_increment,
  `wf_p_id` int(11) NOT NULL default '0',
  `wf_started` int(11) default NULL,
  `wf_owner` varchar(200) default NULL,
  `wf_next_activity` longblob,
  `wf_next_user` varchar(200) default NULL,
  `wf_ended` int(11) default NULL,
  `wf_status` varchar(25) default NULL,
  `wf_priority` int(11) default '0',
  `wf_properties` longblob,
  `wf_name` varchar(120) default NULL,
  `wf_category` int(11) default NULL,
  PRIMARY KEY  (`wf_instance_id`),
  KEY `egw_wf_instances_owner` (`wf_owner`),
  KEY `egw_wf_instances_status` (`wf_status`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_process_config` (
  `wf_p_id` int(11) NOT NULL default '0',
  `wf_config_name` varchar(255) NOT NULL default '',
  `wf_config_value` text,
  `wf_config_value_int` int(11) default NULL,
  PRIMARY KEY  (`wf_p_id`,`wf_config_name`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_processes` (
  `wf_p_id` int(11) NOT NULL auto_increment,
  `wf_name` varchar(80) default NULL,
  `wf_is_valid` char(1) default NULL,
  `wf_is_active` char(1) default NULL,
  `wf_version` varchar(12) default NULL,
  `wf_description` text,
  `wf_last_modif` int(11) default NULL,
  `wf_normalized_name` varchar(80) default NULL,
  PRIMARY KEY  (`wf_p_id`),
  KEY `egw_wf_processes_id_is_active` (`wf_p_id`,`wf_is_active`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_roles` (
  `wf_role_id` int(11) NOT NULL auto_increment,
  `wf_p_id` int(11) NOT NULL default '0',
  `wf_last_modif` int(11) default NULL,
  `wf_name` varchar(80) default NULL,
  `wf_description` text,
  PRIMARY KEY  (`wf_role_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_transitions` (
  `wf_p_id` int(11) NOT NULL default '0',
  `wf_act_from_id` int(11) NOT NULL default '0',
  `wf_act_to_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`wf_act_from_id`,`wf_act_to_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_user_roles` (
  `wf_role_id` int(11) NOT NULL auto_increment,
  `wf_p_id` int(11) NOT NULL default '0',
  `wf_user` varchar(200) NOT NULL default '',
  `wf_account_type` char(1) NOT NULL default 'u',
  PRIMARY KEY  (`wf_role_id`,`wf_user`,`wf_account_type`)
) TYPE=MyISAM;
CREATE TABLE `egw_wf_workitems` (
  `wf_item_id` int(11) NOT NULL auto_increment,
  `wf_instance_id` int(11) NOT NULL default '0',
  `wf_order_id` int(11) NOT NULL default '0',
  `wf_properties` longblob,
  `wf_activity_id` int(11) NOT NULL default '0',
  `wf_started` int(11) default NULL,
  `wf_ended` int(11) default NULL,
  `wf_user` varchar(200) default NULL,
  `wf_note` text,
  `wf_action` text,
  PRIMARY KEY  (`wf_item_id`)
) TYPE=MyISAM;
CREATE TABLE `egw_wiki_interwiki` (
  `wiki_id` int(11) NOT NULL default '0',
  `interwiki_prefix` varchar(80) NOT NULL default '',
  `wiki_name` varchar(80) NOT NULL default '',
  `wiki_lang` varchar(5) NOT NULL default '',
  `interwiki_url` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`wiki_id`,`interwiki_prefix`)
) TYPE=MyISAM;
CREATE TABLE `egw_wiki_links` (
  `wiki_id` smallint(6) NOT NULL default '0',
  `wiki_name` varchar(80) NOT NULL default '',
  `wiki_lang` varchar(5) NOT NULL default '',
  `wiki_link` varchar(80) NOT NULL default '',
  `wiki_count` int(11) NOT NULL default '0',
  PRIMARY KEY  (`wiki_id`,`wiki_name`,`wiki_lang`,`wiki_link`)
) TYPE=MyISAM;
CREATE TABLE `egw_wiki_pages` (
  `wiki_id` smallint(6) NOT NULL default '0',
  `wiki_name` varchar(80) NOT NULL default '',
  `wiki_lang` varchar(5) NOT NULL default '',
  `wiki_version` int(11) NOT NULL default '1',
  `wiki_time` int(11) default NULL,
  `wiki_supercede` int(11) default NULL,
  `wiki_readable` int(11) NOT NULL default '0',
  `wiki_writable` int(11) NOT NULL default '0',
  `wiki_username` varchar(80) default NULL,
  `wiki_hostname` varchar(80) NOT NULL default '',
  `wiki_comment` varchar(80) NOT NULL default '',
  `wiki_title` varchar(80) default NULL,
  `wiki_body` text,
  PRIMARY KEY  (`wiki_id`,`wiki_name`,`wiki_lang`,`wiki_version`),
  KEY `egw_wiki_pages_title` (`wiki_title`),
  FULLTEXT KEY `egw_wiki_pages_body` (`wiki_body`)
) TYPE=MyISAM;
INSERT INTO `egw_wiki_pages` VALUES (0,'RecentChanges','en',1,1155704667,1155704667,0,0,'setup','localhost','added by setup','RecentChanges','[[! *]]'),(0,'eGroupWare','en',1,1155704667,1155704667,0,0,'setup','localhost','added by setup','eGroupWare','Welcome to \'\'\'Wiki\'\'\' - the eGroupWare Version of \'\'\'WikkiTikkiTavi\'\'\'. Wikis are a revolutionary new form of collaboration and online community.\n\n\'\'\'eGroupWare\'\'\' is the groupware suite you are useing right now. For further information see http://www.eGroupWare.org'),(0,'WikkiTikkiTavi','en',1,1155704667,1155704667,0,0,'setup','localhost','added by setup','WikkiTikkiTavi','= WikkiTikkiTavi =\n\nWikkiTikkiTavi is the original version of this documentation system. Their [http://tavi.sourceforge.net documentation] is usable for the eGroupWare \'\'\'Wiki\'\'\' too.\n\n\'\'\'Learn about Wiki formatting:\'\'\'\n----\nSmashWordsTogether to create a page link.  Click on the ? to edit the new page.\n\nYou can also create ((free links)) that aren\'t WordsSmashedTogether.  Type them like this: {{```((free links))```}}.  \n----\n{{```\'\'italic text\'\'```}} becomes \'\'italic text\'\'\n----\n{{```\'\'\'bold text\'\'\'```}} becomes \'\'\'bold text\'\'\'\n----\n{{```{{monospace text}}```}} becomes {{monospace text}}\n----\n{{```----```}} becomes a horizontal rule:\n----\nCreate a remote link simply by typing its URL: http://www.egroupware.org\n\nIf you like, enclose it in brackets to create a numbered reference and avoid cluttering the page; {{```[http://www.php.net]```}} becomes [http://www.php.net].\n\nOr you can have a description instead of a numbered reference; {{```[http://www.php.net/manual/en/ PHP Manual]```}} becomes [http://www.php.net/manual/en/ PHP Manual]\n----\nYou can put a picture in a page by typing the URL to the picture (it must end in gif, jpg, or png).  For example, {{```http://www.egroupware.org/egroupware/phpgwapi/templates/idots/images/logo.png```}} becomes\nhttp://www.egroupware.org/egroupware/phpgwapi/templates/idots/images/logo.png\n----\nThere are 2 possibilities for \'\'\'code formatting\'\'\':\n{{\'\'\'{{$is_admin = $GLOBALS[\'phpgw_info\'][\'user\'][\'apps\'][\'admin\'];}}\'\'\'}}\nor\n{{<code>}}\nif ($_POST[\'add\'])\n{\n   do_something();\n}\n{{</code>}}\nbecomes\n\n{{$GLOBALS[\'phpgw_info\'][\'user\'][\'apps\'][\'admin\']}}\nor\n<code>\nif ($_POST[\'add\'])\n{\n   do_something();\n}\n</code>\n----\nYou can indent by starting a paragraph with one or more colons.\n\n{{```:Indent me!```}}\n{{```::Me too!```}}\nbecomes\n\n:Indent me\n::Me too!\n----\nYou can create bullet lists by starting a paragraph with one or more asterisks.\n\n{{```*Bullet one```}}\n{{```**Sub-bullet```}} \nbecomes\n\n*Bullet one\n**Sub-bullet\n----\nYou can create a description list by starting a paragraph with the following syntax \n\n{{```*;Item 1: Something```}}\n{{```*;Item 2: Something else```}}\n\nwhich gives\n\n*;Item 1: Something\n*;Item 2: Something else\n----\nSimilarly, you can create numbered lists by starting a paragraph with one or more hashes.\n\n{{```#Numero uno```}}\n{{```#Number two```}}\n{{```##Sub-item```}}\nbecomes\n\n#Numero uno\n#Number two\n##Sub-item\n----\nYou can mix and match list types:\n\n<code>\n#Number one\n#*Bullet\n#Number two\n</code>\n#Number one\n#*Bullet\n#Number two\n----\nYou can make various levels of heading by putting = signs before and after the text =\n= Level 1 heading =\n== Level 2 heading ==\n=== Level 3 heading ===\n==== Level 4 heading ====\n===== Level 5 heading =====\n====== Level 6 heading ======\n<code>\n= Level 1 heading =\n== Level 2 heading ==\n=== Level 3 heading ===\n==== Level 4 heading ====\n===== Level 5 heading =====\n====== Level 6 heading ======\n</code>\n----\nYou can create tables using pairs of vertical bars:\n\n||cell one || cell two ||\n|||| big ol\' line ||\n|| cell four || cell five ||\n|| cell six || here\'s a very long cell ||\n\n<code>\n||cell one || cell two ||\n|||| big ol\' line ||\n|| cell four || cell five ||\n|| cell six || here\'s a very long cell ||\n</code>\n');
CREATE TABLE `egw_wiki_rate` (
  `wiki_rate_ip` varchar(20) NOT NULL default '',
  `wiki_rate_time` int(11) default NULL,
  `wiki_rate_viewLimit` smallint(6) default NULL,
  `wiki_rate_searchLimit` smallint(6) default NULL,
  `wiki_rate_editLimit` smallint(6) default NULL,
  PRIMARY KEY  (`wiki_rate_ip`)
) TYPE=MyISAM;
CREATE TABLE `egw_wiki_remote_pages` (
  `wiki_remote_page` varchar(80) NOT NULL default '',
  `wiki_remote_site` varchar(80) NOT NULL default '',
  PRIMARY KEY  (`wiki_remote_page`,`wiki_remote_site`)
) TYPE=MyISAM;
CREATE TABLE `egw_wiki_sisterwiki` (
  `wiki_id` int(11) NOT NULL default '0',
  `sisterwiki_prefix` varchar(80) NOT NULL default '',
  `wiki_name` varchar(80) NOT NULL default '',
  `wiki_lang` varchar(5) NOT NULL default '',
  `sisterwiki_url` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`wiki_id`,`sisterwiki_prefix`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_kb_articles` (
  `art_id` int(11) NOT NULL auto_increment,
  `q_id` bigint(20) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `topic` varchar(255) NOT NULL default '',
  `text` text,
  `cat_id` int(11) NOT NULL default '0',
  `published` smallint(6) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `views` int(11) NOT NULL default '0',
  `created` int(11) default NULL,
  `modified` int(11) default NULL,
  `modified_user_id` int(11) NOT NULL default '0',
  `votes_1` int(11) NOT NULL default '0',
  `votes_2` int(11) NOT NULL default '0',
  `votes_3` int(11) NOT NULL default '0',
  `votes_4` int(11) NOT NULL default '0',
  `votes_5` int(11) NOT NULL default '0',
  PRIMARY KEY  (`art_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_kb_comment` (
  `comment_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `comment` text,
  `entered` int(11) default NULL,
  `art_id` int(11) NOT NULL default '0',
  `published` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`comment_id`),
  KEY `phpgw_kb_comment_art_id` (`art_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_kb_files` (
  `art_id` int(11) NOT NULL default '0',
  `art_file` varchar(255) NOT NULL default '',
  `art_file_comments` varchar(255) default NULL,
  PRIMARY KEY  (`art_id`,`art_file`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_kb_questions` (
  `question_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `summary` text,
  `details` text,
  `cat_id` int(11) NOT NULL default '0',
  `creation` int(11) default NULL,
  `published` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`question_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_kb_ratings` (
  `user_id` int(11) NOT NULL default '0',
  `art_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`user_id`,`art_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_kb_related_art` (
  `art_id` int(11) NOT NULL default '0',
  `related_art_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`art_id`,`related_art_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_kb_search` (
  `keyword` varchar(30) NOT NULL default '',
  `art_id` int(11) NOT NULL default '0',
  `score` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`keyword`,`art_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_kb_urls` (
  `art_id` int(11) NOT NULL default '0',
  `art_url` varchar(255) NOT NULL default '',
  `art_url_title` varchar(255) default NULL,
  PRIMARY KEY  (`art_id`,`art_url`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_ACLs` (
  `id` int(11) NOT NULL auto_increment,
  `target` int(11) NOT NULL default '0',
  `targetType` smallint(6) NOT NULL default '0',
  `userID` int(11) NOT NULL default '-1',
  `groupID` int(11) NOT NULL default '-1',
  `mode` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_DocumentContent` (
  `id` int(11) NOT NULL auto_increment,
  `document` int(11) default '0',
  `version` smallint(6) default '0',
  `comment` text,
  `date` bigint(20) default '0',
  `createdBy` int(11) default '0',
  `dir` varchar(10) NOT NULL default '',
  `orgFileName` varchar(150) NOT NULL default '',
  `fileType` varchar(10) NOT NULL default '',
  `mimeType` varchar(70) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_DocumentLinks` (
  `id` int(11) NOT NULL auto_increment,
  `document` int(11) NOT NULL default '0',
  `target` int(11) NOT NULL default '0',
  `userID` int(11) NOT NULL default '0',
  `public` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_Documents` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(150) default NULL,
  `comment` text,
  `date` bigint(20) default '0',
  `expires` bigint(20) default '0',
  `owner` int(11) default '0',
  `folder` int(11) default '0',
  `inheritAccess` tinyint(4) NOT NULL default '1',
  `defaultAccess` smallint(6) NOT NULL default '0',
  `locked` int(11) NOT NULL default '-1',
  `keywords` text,
  `sequence` double NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_Folders` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(70) default NULL,
  `parent` int(11) default '0',
  `comment` text,
  `owner` int(11) default '0',
  `inheritAccess` tinyint(4) NOT NULL default '1',
  `defaultAccess` smallint(6) NOT NULL default '0',
  `sequence` double NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=2;
INSERT INTO `phpgw_mydms_Folders` VALUES (1,'Root-Folder',0,'no comment',1,0,2,0);
CREATE TABLE `phpgw_mydms_GroupMembers` (
  `id` int(11) NOT NULL auto_increment,
  `groupID` int(11) NOT NULL default '0',
  `userID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_Groups` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `comment` text,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_KeywordCategories` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `owner` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_Keywords` (
  `id` int(11) NOT NULL auto_increment,
  `category` int(11) NOT NULL default '0',
  `keywords` text,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_Notify` (
  `id` int(11) NOT NULL auto_increment,
  `target` int(11) NOT NULL default '0',
  `targetType` int(11) NOT NULL default '0',
  `userID` int(11) NOT NULL default '-1',
  `groupID` int(11) NOT NULL default '-1',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_Sessions` (
  `id` varchar(50) NOT NULL default '',
  `userID` int(11) NOT NULL default '0',
  `lastAccess` int(11) NOT NULL default '0',
  `theme` varchar(30) NOT NULL default '',
  `language` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_UserImages` (
  `id` int(11) NOT NULL auto_increment,
  `userID` int(11) NOT NULL default '0',
  `image` longblob,
  `mimeType` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_mydms_Users` (
  `id` int(11) NOT NULL auto_increment,
  `login` varchar(50) default NULL,
  `pwd` varchar(50) default NULL,
  `fullName` varchar(100) default NULL,
  `email` varchar(70) default NULL,
  `comment` text,
  `isAdmin` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_polls_data` (
  `poll_id` int(11) NOT NULL default '0',
  `option_text` varchar(100) NOT NULL default '',
  `option_count` int(11) NOT NULL default '0',
  `vote_id` int(11) NOT NULL default '0'
) TYPE=MyISAM;
CREATE TABLE `phpgw_polls_desc` (
  `poll_id` int(11) NOT NULL auto_increment,
  `poll_title` varchar(100) NOT NULL default '',
  `poll_timestamp` int(11) NOT NULL default '0',
  PRIMARY KEY  (`poll_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_polls_settings` (
  `setting_name` varchar(255) default NULL,
  `setting_value` varchar(255) default NULL
) TYPE=MyISAM;
CREATE TABLE `phpgw_polls_user` (
  `poll_id` int(11) NOT NULL default '0',
  `vote_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `vote_timestamp` int(11) default NULL
) TYPE=MyISAM;
CREATE TABLE `phpgw_vfs2_customfields` (
  `customfield_id` int(11) NOT NULL auto_increment,
  `customfield_name` varchar(60) NOT NULL default '',
  `customfield_description` varchar(255) default NULL,
  `customfield_type` varchar(20) NOT NULL default '',
  `customfield_precision` int(11) default NULL,
  `customfield_active` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`customfield_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_vfs2_customfields_data` (
  `file_id` int(11) NOT NULL default '0',
  `customfield_id` int(11) NOT NULL default '0',
  `data` longtext,
  PRIMARY KEY  (`file_id`,`customfield_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_vfs2_files` (
  `file_id` int(11) NOT NULL auto_increment,
  `mime_id` int(11) default NULL,
  `owner_id` int(11) NOT NULL default '0',
  `createdby_id` int(11) default NULL,
  `modifiedby_id` int(11) default NULL,
  `created` datetime NOT NULL default '1970-01-01 00:00:00',
  `modified` datetime default NULL,
  `size` bigint(20) default NULL,
  `deleteable` char(1) default 'Y',
  `comment` varchar(255) default NULL,
  `app` varchar(25) default NULL,
  `directory` varchar(255) default NULL,
  `name` varchar(64) NOT NULL default '',
  `link_directory` varchar(255) default NULL,
  `link_name` varchar(128) default NULL,
  `version` varchar(30) NOT NULL default '0.0.0.0',
  `content` longtext,
  `is_backup` char(1) NOT NULL default 'N',
  `shared` char(1) NOT NULL default 'N',
  `proper_id` varchar(45) default NULL,
  PRIMARY KEY  (`file_id`),
  KEY `phpgw_vfs2_files_directory_name` (`directory`,`name`)
) TYPE=MyISAM AUTO_INCREMENT=2;
INSERT INTO `phpgw_vfs2_files` VALUES (1,148,0,0,NULL,'1970-01-01 00:00:00',NULL,4096,'Y',NULL,NULL,'/','',NULL,NULL,'0.0.0.0',NULL,'N','N',NULL);
CREATE TABLE `phpgw_vfs2_mimetypes` (
  `mime_id` int(11) NOT NULL auto_increment,
  `extension` varchar(10) NOT NULL default '',
  `mime` varchar(50) NOT NULL default '',
  `mime_magic` varchar(255) default NULL,
  `friendly` varchar(50) NOT NULL default '',
  `image` longblob,
  `proper_id` varchar(4) default NULL,
  PRIMARY KEY  (`mime_id`)
) TYPE=MyISAM AUTO_INCREMENT=149;
INSERT INTO `phpgw_vfs2_mimetypes` VALUES (1,'dwf','image/VND.DWF',NULL,'Autocad Tekening','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\n\0,\0\0\0\0\0\0\0~\0H@\"4(@&Xh@ć\ZQ\"\0\nZLpl<H@TIТ`Zɒ\0H!\Z\0AQ\r\0̕FID+Ԏ`+ȳgBUve@\0\0;',NULL),(2,'jpg','image/jpeg',NULL,'JPEG image','GIF89a\0\0\0\0i]b|=}<ztŖÂbȓ䢳\0DE\0ef|=\Z}=\ZL,E=L/7gguEZ;:ײÃ`c2+mNI?PJ\Z@\0d<2(}-U_\0(	\Z\nHPo>7em{J\nz{p_=}Xn>{X!!b;2\0=\0\"\"\0c;^w\0ZC\0\01`ihw8@ayairqդ̺2bR`\0a\0yIo	F)A)cU(H0]y(0N.\r=-;\00 ?7fη]8NGaopuK,\0D%*,tMl\0Q)iȱL-M-\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0\0\0,\0\0\0\0\0\0\0\0h)P\0,X hpH\'A$0E0IL\'\": THH\"\0\0@ Dt\0A#F,C;BÈVxPsCKDܰĘP`8KV!OXm\Zgȉ@IRBxцd%`Li%Jĩ$^8_PE\"\r}<>0`\0˞E\Z\n%J \"--ʎ]6\0;',NULL),(3,'doc','application/msword',NULL,'Microsoft Word document','GIF89a\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0q\0@A !C\0H\"\0#qƎ*H2\0(	haҤJ*YRƉ/qã9.DɔiRH΄*TQUش+ʭA-Z\0;',NULL),(4,'txt','text/plain',NULL,'Platte tekst','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0LI	sdFNiLӽmR%:g@\\zbP#Cu+sqiݎ/⌶b\"\0;',NULL),(5,'xls','application/vnd.ms-excel',NULL,'Excel Workbook','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0s\0\r@A\r(!\0p\"\0# `\"ǋ\r-jɓh\"/UL\0\'ceʔ̩?4%LL,:IP:ܺt ѯA  \0;',NULL),(6,'mp3','audio/mpeg',NULL,'MP3 audio','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0i\0\r8\0\0	\0@@B\0@(apLč#H\0$\0F˘	1e5\rLhcHD<3BC-\ZPzSφV$\0;',NULL),(7,'gif','image/gif',NULL,'GIF afbeelding','GIF89a\0\0\0\0i]b|=}<ztŖÂbȓ䢳\0DE\0ef|=\Z}=\ZL,E=L/7gguEZ;:ײÃ`c2+mNI?PJ\Z@\0d<2(}-U_\0(	\Z\nHPo>7em{J\nz{p_=}Xn>{X!!b;2\0=\0\"\"\0c;^w\0ZC\0\01`ihw8@ayairqդ̺2bR`\0a\0yIo	F)A)cU(H0]y(0N.\r=-;\00 ?7fη]8NGaopuK,\0D%*,tMl\0Q)iȱL-M-\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0\0\0,\0\0\0\0\0\0\0\0h)P\0,X hpH\'A$0E0IL\'\": THH\"\0\0@ Dt\0A#F,C;BÈVxPsCKDܰĘP`8KV!OXm\Zgȉ@IRBxцd%`Li%Jĩ$^8_PE\"\r}<>0`\0˞E\Z\n%J \"--ʎ]6\0;',NULL),(8,'pdf','application/pdf',NULL,'PDF document','GIF89a\0\0\0\0\0\0\01\0!\0\0\0,\0\0\0\0\0\0@j\0@A\0(\0\Z hE\0$\"ĆCfPqぅ\rDԨ!U0@,9,@!@G*`Γ	<\0L*&ͪ;\'*,j0 \0;',NULL),(9,'bmp','image/bmp',NULL,'Bitmap image','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0RRRcccsss\0\0\0\0c\0\0\0!\0\0\0,\0\0\0\0\0\0\0\01h@\0L(\0\0\0b`P\0<` <V@@\0	02T@\0%$xq`  mЙ\'PPҚ/^0AHZ0!bٳi׊vڭmp-]h}H\0\0;',NULL),(10,'wav','audio/WAV',NULL,'Wave audio','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0i\0\r8\0\0	\0@@B\0@(apLč#H\0$\0F˘	1e5\rLhcHD<3BC-\ZPzSφV$\0;',NULL),(11,'dwg','image/VND.DWG',NULL,'Autocad tekening','GIF89a\0\0\0\0f3\0̙f3\0f3\0ffffff3f\03333f333\0\0\0\0\0f\03\0\0f3\0̙f3\0̙̙̙̙f̙3̙\0ffffff3f\03333f333\0\0\0\0\0f\03\0\0̙f3\0̙̙f3\0̙f3\0ff̙ffff3f\033̙33f333\0\0\0̙\0\0f\03\0\0ffffff3f\0fff̙fff3f\0ffffff3f\0fffffffffff3ff\0f3f3f3f3ff33f3\0f\0f\0f\0f\0ff\03f\0\03333f333\0333̙3f333\03333f333\03f3f3f3ff3f33f\033333333f33333\03\03\03\03\0f3\033\0\0\0\0\0\0f\03\0\0\0\0\0̙\0f\03\0\0\0\0\0\0f\03\0\0\0f\0f\0f\0ff\0f3\0f\0\03\03\03\03f\033\03\0\0\0\0\0\0\0\0\0f\0\03\0\0\0&.y\r	&IPovFW5L@<C+@7QVNλs*(#W!ϭqNJE@vsI$$!\0\0\0,\0\0\0\0\0\0\0\0	H~XgΜBV\nحw|ۭGvM߹G`ö&#3<\nle۷[pټm4QlT`pݼ=j\'n*6nZ{?{eH6ߵvf}+@Ab7mdq7nܼқ߶֍mALׯKw_@۶\rLli#H^۠\0;',NULL),(12,'exe','application/octet-stream',NULL,'Application','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0KI+C8덏\0AhzJ<\0gǣNAB\"n7X`\0]Q8,%͖zvhe=\0\0;',NULL),(13,'url','application/octet-stream',NULL,'Hyperlink','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\r\0,\0\0\0\0\0\0\0XIDkxAmf02ÒD\\sܮ<9\rQ1(m:`\0#RzR 1|Ƙ﯐^\0;',NULL),(14,'zip','application/x-zip-compressed',NULL,'Winzip archive','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0KɀRpPtUud2,PZY|Ƴozb0uJt\Zg	ep!Xf#1\r\0\0;',NULL),(15,'html','text/HTML',NULL,'HTML pagina','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\n\0,\0\0\0\0\0\0\0~\0H@\"4(@&Xh@ć\ZQ\"\0\nZLpl<H@TIТ`Zɒ\0H!\Z\0AQ\r\0̕FID+Ԏ`+ȳgBUve@\0\0;',NULL),(16,'htm','text/HTML',NULL,'HTML page','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\n\0,\0\0\0\0\0\0\0~\0H@\"4(@&Xh@ć\ZQ\"\0\nZLpl<H@TIТ`Zɒ\0H!\Z\0AQ\r\0̕FID+Ԏ`+ȳgBUve@\0\0;',NULL),(17,'tar','application/X-TAR',NULL,'Tarbal archief','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0j\0\rA\0\Z\00@@Ç\Z\\x\0\0 \0Ǐ\01@ł!/.Ȳ$ǐ#ّ!Ɩ8k0eM{nԉI\n:\\0bR\n. 5Ċ0 \0;',NULL),(18,'reg','application/octet-stream',NULL,'Windows register file','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0S9=12YUHۢ_~8h\ZC#8oQm*TTyȨHɸ[\\߲sNoK\"\0;',NULL),(19,'psd','application/octet-stream',NULL,'Adobe photoshop image','GIF89a\0\0\0\0\0\0\01\0!\0\0\0,\0\0\0\0\0\0@j\0@A\0(\0\Z hE\0$\"ĆCfPqぅ\rDԨ!U0@,9,@!@G*`Γ	<\0L*&ͪ;\'*,j0 \0;',NULL),(20,'csv','application/octet-stream',NULL,'Comma Separated Values','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(21,'mpe','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0{\0<@A@!\n\\aVd#\0-0b#\0Q\n8&3\0Ǜ8oD)Peͣ3Gx@\0\0#?;N*ICv-Yٳ`f]\0;',NULL),(22,'mpg','application/OCTET-STREAM',NULL,'MPEG Video Clip','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0{\0<@A@!\n\\aVd#\0-0b#\0Q\n8&3\0Ǜ8oD)Peͣ3Gx@\0\0#?;N*ICv-Yٳ`f]\0;',NULL),(23,'PCX','application/octet-stream',NULL,'PCX image','GIF89a\0\0\0\0i]b|=}<ztŖÂbȓ䢳\0DE\0ef|=\Z}=\ZL,E=L/7gguEZ;:ײÃ`c2+mNI?PJ\Z@\0d<2(}-U_\0(	\Z\nHPo>7em{J\nz{p_=}Xn>{X!!b;2\0=\0\"\"\0c;^w\0ZC\0\01`ihw8@ayairqդ̺2bR`\0a\0yIo	F)A)cU(H0]y(0N.\r=-;\00 ?7fη]8NGaopuK,\0D%*,tMl\0Q)iȱL-M-\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0\0\0,\0\0\0\0\0\0\0\0h)P\0,X hpH\'A$0E0IL\'\": THH\"\0\0@ Dt\0A#F,C;BÈVxPsCKDܰĘP`8KV!OXm\Zgȉ@IRBxцd%`Li%Jĩ$^8_PE\"\r}<>0`\0˞E\Z\n%J \"--ʎ]6\0;',NULL),(24,'tif','application/octet-stream',NULL,'TIF afbeelding','GIF89a\0\0\0\0i]b|=}<ztŖÂbȓ䢳\0DE\0ef|=\Z}=\ZL,E=L/7gguEZ;:ײÃ`c2+mNI?PJ\Z@\0d<2(}-U_\0(	\Z\nHPo>7em{J\nz{p_=}Xn>{X!!b;2\0=\0\"\"\0c;^w\0ZC\0\01`ihw8@ayairqդ̺2bR`\0a\0yIo	F)A)cU(H0]y(0N.\r=-;\00 ?7fη]8NGaopuK,\0D%*,tMl\0Q)iȱL-M-\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0\0\0,\0\0\0\0\0\0\0\0h)P\0,X hpH\'A$0E0IL\'\": THH\"\0\0@ Dt\0A#F,C;BÈVxPsCKDܰĘP`8KV!OXm\Zgȉ@IRBxцd%`Li%Jĩ$^8_PE\"\r}<>0`\0˞E\Z\n%J \"--ʎ]6\0;',NULL),(25,'pps','application/VND.MS-POWERPOINT',NULL,'Powerpoint presentation','GIF89a\0\0B\0typppǦޞk\0Gߞ~jPBC<<<GW;jBIrrrqqqׯ֛J,ƧL#f6nM``brrYǨaac   W7(gG8WWWI+___b`\0hNBK%HHe```g\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0B\0,\0\0\0\0\0\0\0BBA/%AA\ZB70) \r>;;>:@A\'.B:>99#:\n\n-69;(\"4><<*;9=A>2Պ3!&		\0\08+5@$=Ja(Sk*K(D/ÑǏ\0;',NULL),(26,'mpeg','application/OCTET-STREAM',NULL,'MPEG Video Clip','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0{\0<@A@!\n\\aVd#\0-0b#\0Q\n8&3\0Ǜ8oD)Peͣ3Gx@\0\0#?;N*ICv-Yٳ`f]\0;',NULL),(27,'avi','application/OCTET-STREAM',NULL,'AVI Video Clip','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0p\0	$A(a\n\\萡Vd#\0-H0ȂdrdG00<ʜ	̏a\n&\0bޤY%PPr@UNժ@`\0;',NULL),(28,'tgz','application/X-GZIP-COMPRESSED',NULL,'Tarbal gecomprimeerd archief','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0j\0\rA\0\Z\00@@Ç\Z\\x\0\0 \0Ǐ\01@ł!/.Ȳ$ǐ#ّ!Ɩ8k0eM{nԉI\n:\\0bR\n. 5Ċ0 \0;',NULL),(29,'asf','application/OCTET-STREAM',NULL,'ASF video clip','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0p\0	$A(a\n\\萡Vd#\0-H0ȂdrdG00<ʜ	̏a\n&\0bޤY%PPr@UNժ@`\0;',NULL),(30,'php','text/PLAIN',NULL,'PHP web page','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0\0xAP@$$萡Å\n$*XG\01*@@!(@H@$`$a\Zi\0\07q	 \0 	FE\Z`; ɣQ(\0GP\ZX1ɧRz$IѢw~8pĄ\0;',NULL),(31,'bas','text/plain',NULL,'text/plain','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(32,'scr','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(33,'vcf','text/PLAIN',NULL,'text/PLAIN','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(34,'sim','text/plain',NULL,'text/plain','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(35,'sh','text/PLAIN',NULL,'text/PLAIN','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(36,'jpeg','application/OCTET-STREAM',NULL,'JPEG image','GIF89a\0\0\0\0i]b|=}<ztŖÂbȓ䢳\0DE\0ef|=\Z}=\ZL,E=L/7gguEZ;:ײÃ`c2+mNI?PJ\Z@\0d<2(}-U_\0(	\Z\nHPo>7em{J\nz{p_=}Xn>{X!!b;2\0=\0\"\"\0c;^w\0ZC\0\01`ihw8@ayairqդ̺2bR`\0a\0yIo	F)A)cU(H0]y(0N.\r=-;\00 ?7fη]8NGaopuK,\0D%*,tMl\0Q)iȱL-M-\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0\0\0,\0\0\0\0\0\0\0\0h)P\0,X hpH\'A$0E0IL\'\": THH\"\0\0@ Dt\0A#F,C;BÈVxPsCKDܰĘP`8KV!OXm\Zgȉ@IRBxцd%`Li%Jĩ$^8_PE\"\r}<>0`\0˞E\Z\n%J \"--ʎ]6\0;',NULL),(37,'xkr','application/octet-stream',NULL,'application/octet-stream','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(38,'dat','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(39,'wmv','video/X-MS-WMV',NULL,'Windows Media Video','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0{\0<@A@!\n\\aVd#\0-0b#\0Q\n8&3\0Ǜ8oD)Peͣ3Gx@\0\0#?;N*ICv-Yٳ`f]\0;',NULL),(40,'inc','text/plain',NULL,'PHP inclusion','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(41,'sql','text/plain',NULL,'SQL file','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0LI	sdFNiLӽmR%:g@\\zbP#Cu+sqiݎ/⌶b\"\0;',NULL),(42,'ppt','application/vnd.ms-powerpoint',NULL,'Powerpoint presentation','GIF89a\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0p\0\r@A\r(!C\r\ZlpB\rdq!\0I@Ȋd)I\0Ajt$ɚ#oHK\04fRG.Y2T`\0;',NULL),(43,'','',NULL,'Onbekend','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(44,'db','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0x\0\r@A\r(!C\0aÅ\0\09F C202F4d91@\00W8 ʔX\"(GA#YNKEztΘUD\nUE]lT!ɳh\0;',NULL),(45,'tpl','application/OCTET-STREAM',NULL,'Template file','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(46,'css','text/css',NULL,'Custom Style Sheet','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(47,'lock','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(48,'cfg','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(49,'conf','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(50,'deny','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(51,'misc','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(52,'pal','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(53,'save','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(54,'net','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(55,'defs','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(56,'rc','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(57,'jar','Array',NULL,'Java source file','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(58,'png','image/png',NULL,'image/png','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0RRRcccsss\0\0\0\0c\0\0\0!\0\0\0,\0\0\0\0\0\0\0\01h@\0L(\0\0\0b`P\0<` <V@@\0	02T@\0%$xq`  mЙ\'PPҚ/^0AHZ0!bٳi׊vڭmp-]h}H\0\0;',NULL),(59,'cnf','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(60,'bak','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(61,'ini','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(62,'old','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(63,'key','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(64,'cron','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(65,'xterm','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(66,'login','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(67,'modes','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(68,'cshrc','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(69,'allow','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(70,'cache','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(71,'perms','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(72,'types','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(73,'users','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(74,'local','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(75,'js','application/x-javascript',NULL,'application/x-javascript','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(76,'exp','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(77,'xml','text/xml',NULL,'XML file','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\01c1c1\0111!\0\0\0,\0\0\0\0\0\0\0\0HP@XȰa6\\\0 &hcE\0 lt\", R!@P \0%[H@A*l	a(ɊѣՊMGʕ+UXZtڵWa:VdȷpC>\0;',NULL),(78,'pl','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(79,'jpe','image/jpeg',NULL,'JPEG image','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0RRRcccsss\0\0\0\0c\0\0\0!\0\0\0,\0\0\0\0\0\0\0\01h@\0L(\0\0\0b`P\0<` <V@@\0	02T@\0%$xq`  mЙ\'PPҚ/^0AHZ0!bٳi׊vڭmp-]h}H\0\0;',NULL),(80,'lnk','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(81,'wmf','application/OCTET-STREAM',NULL,'Windows Media File','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0p\0	$A(a\n\\萡Vd#\0-H0ȂdrdG00<ʜ	̏a\n&\0bޤY%PPr@UNժ@`\0;',NULL),(82,'JOB','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(83,'jof','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(84,'pm4','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(85,'dxf','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(86,'dft','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(87,'asm','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(88,'par','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(89,'dmp','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(90,'frm','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(91,'frx','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(92,'cls','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(93,'PDM','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(94,'vbp','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(95,'vbw','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(96,'ICO','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(97,'SCC','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(98,'log','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(99,'tlb','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(100,'dll','application/octet-stream',NULL,'application/octet-stream','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(101,'OCX','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(102,'BAT','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(103,'DDF','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(104,'Lst','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(105,'CAB','application/OCTET-STREAM',NULL,'Windows cabinet archive','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(106,'mdb','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0x\0\r@A\r(!C\0aÅ\0\09F C202F4d91@\00W8 ʔX\"(GA#YNKEztΘUD\nUE]lT!ɳh\0;',NULL),(107,'dist','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(108,'hist','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(109,'rar','application/OCTET-STREAM',NULL,'WinRAR archive','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0j\0\rA\0\Z\00@@Ç\Z\\x\0\0 \0Ǐ\01@ł!/.Ȳ$ǐ#ّ!Ɩ8k0eM{nԉI\n:\\0bR\n. 5Ċ0 \0;',NULL),(110,'fla','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(111,'swf','application/x-shockwave-flash',NULL,'application/x-shockwave-flash','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(112,'en','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(113,'jis','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(114,'fig','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(115,'tsv','text/tab-separated-values',NULL,'text/tab-separated-values','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(116,'wml','text/vnd.wap.wml',NULL,'text/vnd.wap.wml','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(117,'cgi','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(118,'fr','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(119,'mov','application/OCTET-STREAM',NULL,'Movie clip','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0p\0	$A(a\n\\萡Vd#\0-H0ȂdrdG00<ʜ	̏a\n&\0bޤY%PPr@UNժ@`\0;',NULL),(120,'gz','application/x-gzip',NULL,'Gzip compressed archive','GIF89a\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0j\0\rA\0\Z\00@@Ç\Z\\x\0\0 \0Ǐ\01@ł!/.Ȳ$ǐ#ّ!Ɩ8k0eM{nԉI\n:\\0bR\n. 5Ċ0 \0;',NULL),(121,'rpm','application/x-rpm',NULL,'RPM Package','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(122,'ai','application/postscript',NULL,'Adobe Illustrator file','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(123,'eml','message/RFC822',NULL,'message/RFC822','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0@7 d)@\nlC,t[9\0!`ӵXr\\ނa\Z%L+vuzwQ\0;',NULL),(124,'aspx','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(125,'cs','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(126,'resx','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(127,'ascx','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(128,'err','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(129,'ils','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(130,'xdp','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(131,'trc','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(132,'sam','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(133,'rtf','text/RICHTEXT',NULL,'Rich text format','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(134,'rnd','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(135,'map','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(136,'ja','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(137,'0','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(138,'h','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(139,'b','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(140,'img','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(141,'pif','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(142,'abw','application/ABIWORD',NULL,'application/ABIWORD','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(143,'ps','application/POSTSCRIPT',NULL,'application/POSTSCRIPT','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(144,'dir','application/x-director',NULL,'application/x-director','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(145,'adr','application/octet-stream',NULL,'application/octet-stream','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(146,'sxw','application/OCTET-STREAM',NULL,'application/OCTET-STREAM','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(147,'plt','Array',NULL,'Array','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL),(148,'(n/a)','Directory',NULL,'Directory','GIF89a\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0!\0\0\0,\0\0\0\0\0\0\0RI+b{?@y\ZB@JVu1x[Po	\0GsTăC h\nDE._UnB̈\0\0;',NULL);
CREATE TABLE `phpgw_vfs2_prefixes` (
  `prefix_id` int(11) NOT NULL auto_increment,
  `prefix` varchar(8) NOT NULL default '',
  `owner_id` int(11) NOT NULL default '0',
  `prefix_description` varchar(30) default NULL,
  `prefix_type` char(1) NOT NULL default 'p',
  PRIMARY KEY  (`prefix_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_vfs2_quota` (
  `account_id` int(11) NOT NULL default '0',
  `quota` int(11) NOT NULL default '0',
  PRIMARY KEY  (`account_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_vfs2_shares` (
  `account_id` int(11) NOT NULL default '0',
  `file_id` int(11) NOT NULL default '0',
  `acl_rights` int(11) NOT NULL default '0',
  PRIMARY KEY  (`account_id`,`file_id`)
) TYPE=MyISAM;
CREATE TABLE `phpgw_vfs2_versioning` (
  `version_id` int(11) NOT NULL auto_increment,
  `file_id` int(11) NOT NULL default '0',
  `operation` int(11) NOT NULL default '0',
  `modifiedby_id` int(11) NOT NULL default '0',
  `modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `version` varchar(30) NOT NULL default '',
  `comment` varchar(255) default NULL,
  `backup_file_id` int(11) default NULL,
  `backup_content` longtext,
  `src` varchar(255) default NULL,
  `dest` varchar(255) default NULL,
  PRIMARY KEY  (`version_id`)
) TYPE=MyISAM;
